package MMS::Parser::WorkHorse;
use Parse::RecDescent;
{ my $ERRORS;


package Parse::RecDescent::MMS::Parser::WorkHorse;
use strict;
use vars qw($skip $AUTOLOAD  );
@Parse::RecDescent::MMS::Parser::WorkHorse::ISA = ();
$skip = '';

   {
      my %parameter_name_for = (
         0x80 => 'q',
         0x81 => 'charset',
         0x82 => 'level',
         0x83 => 'type',
         0x85 => 'name',
         0x86 => 'filename',
         0x87 => 'differences',
         0x88 => 'padding',
         0x89 => 'type',
         0x8a => 'start',
         0x8b => 'start_info',
         0x8c => 'comment',
         0x8d => 'domain',
         0x8e => 'max_age',
         0x8f => 'path',
         0x90 => 'secure',
         0x91 => 'SEC',
         0x92 => 'MAC',
         0x93 => 'creation_date',
         0x94 => 'modification_date',
         0x95 => 'read_date',
         0x96 => 'size',
         0x97 => 'name',
         0x98 => 'filename',
         0x99 => 'start',
         0x9a => 'start_info',
         0x9b => 'comment',
         0x9c => 'domain',
         0x9d => 'path',
      );

      sub build_parameter {
         my ($rulename, $code, $value, $encoding) = @_;
         return {
            name     => $parameter_name_for{ord $code},
            value    => $value,
            encoding => $encoding,
         };
      } ## end sub build_parameter
   }

   {
      my %media_type_for = (
         0x00 => '*/*',
         0x01 => 'text/*',
         0x02 => 'text/html',
         0x03 => 'text/plain',
         0x04 => 'text/x-hdml',
         0x05 => 'text/x-ttml',
         0x06 => 'text/x-vCalendar',
         0x07 => 'text/x-vCard',
         0x08 => 'text/vnd.wap.wml',
         0x09 => 'text/vnd.wap.wmlscript',
         0x0A => 'text/vnd.wap.wta-event',
         0x0B => 'multipart/*',
         0x0C => 'multipart/mixed',
         0x0D => 'multipart/form-data',
         0x0E => 'multipart/byterantes',
         0x0F => 'multipart/alternative',
         0x10 => 'application/*',
         0x11 => 'application/java-vm',
         0x12 => 'application/x-www-form-urlencoded',
         0x13 => 'application/x-hdmlc',
         0x14 => 'application/vnd.wap.wmlc',
         0x15 => 'application/vnd.wap.wmlscriptc',
         0x16 => 'application/vnd.wap.wta-eventc',
         0x17 => 'application/vnd.wap.uaprof',
         0x18 => 'application/vnd.wap.wtls-ca-certificate',
         0x19 => 'application/vnd.wap.wtls-user-certificate',
         0x1A => 'application/x-x509-ca-cert',
         0x1B => 'application/x-x509-user-cert',
         0x1C => 'image/*',
         0x1D => 'image/gif',
         0x1E => 'image/jpeg',
         0x1F => 'image/tiff',
         0x20 => 'image/png',
         0x21 => 'image/vnd.wap.wbmp',
         0x22 => 'application/vnd.wap.multipart.*',
         0x23 => 'application/vnd.wap.multipart.mixed',
         0x24 => 'application/vnd.wap.multipart.form-data',
         0x25 => 'application/vnd.wap.multipart.byteranges',
         0x26 => 'application/vnd.wap.multipart.alternative',
         0x27 => 'application/xml',
         0x28 => 'text/xml',
         0x29 => 'application/vnd.wap.wbxml',
         0x2A => 'application/x-x968-cross-cert',
         0x2B => 'application/x-x968-ca-cert',
         0x2C => 'application/x-x968-user-cert',
         0x2D => 'text/vnd.wap.si',
         0x2E => 'application/vnd.wap.sic',
         0x2F => 'text/vnd.wap.sl',
         0x30 => 'application/vnd.wap.slc',
         0x31 => 'text/vnd.wap.co',
         0x32 => 'application/vnd.wap.coc',
         0x33 => 'application/vnd.wap.multipart.related',
         0x34 => 'application/vnd.wap.sia',
         0x35 => 'text/vnd.wap.connectivity-xml',
         0x36 => 'application/vnd.wap.connectivity-wbxml',
         0x37 => 'application/pkcs7-mime',
         0x38 => 'application/vnd.wap.hashed-certificate',
         0x39 => 'application/vnd.wap.signed-certificate',
         0x3A => 'application/vnd.wap.cert-response',
         0x3B => 'application/xhtml+xml',
         0x3C => 'application/wml+xml',
         0x3D => 'text/css',
         0x3E => 'application/vnd.wap.mms-message',
         0x3F => 'application/vnd.wap.rollover-certificate',
         0x40 => 'application/vnd.wap.locc+wbxml',
         0x41 => 'application/vnd.wap.loc+xml',
         0x42 => 'application/vnd.syncml.dm+wbxml',
         0x43 => 'application/vnd.syncml.dm+xml',
         0x44 => 'application/vnd.syncml.notification',
         0x45 => 'application/vnd.wap.xhtml+xml',
         0x46 => 'application/vnd.wv.csp.cir',
         0x47 => 'application/vnd.oma.dd+xml',
         0x48 => 'application/vnd.oma.drm.message',
         0x49 => 'application/vnd.oma.drm.content',
         0x4A => 'application/vnd.oma.drm.rights+xml',
         0x4B => 'application/vnd.oma.drm.rights+wbxml',
         0x4C => 'application/vnd.wv.csp+xml',
         0x4D => 'application/vnd.wv.csp+wbxml',
         0x4E => 'application/vnd.syncml.ds.notification',
         0x4F => 'audio/*',
         0x50 => 'video/*',
      );

      sub media_type_for { return $media_type_for{$_[0]}; }
   }

   sub _quote {
      my ($s) = @_;
      $s =~ s/([\\"])/\\$1/g;
      return '"' . $s . '"';
   }

   sub param_encode {    # FIXME

      #   return _is_token($_[0]) ? $_[0] : _quote($_[0]);
      return $_[0];
   }
;


{
local $SIG{__WARN__} = sub {0};
# PRETEND TO BE IN Parse::RecDescent NAMESPACE
*Parse::RecDescent::MMS::Parser::WorkHorse::AUTOLOAD   = sub
{
    no strict 'refs';

    ${"AUTOLOAD"} =~ s/^Parse::RecDescent::MMS::Parser::WorkHorse/Parse::RecDescent/;
    goto &{${"AUTOLOAD"}};
}
}

push @Parse::RecDescent::MMS::Parser::WorkHorse::ISA, 'Parse::RecDescent';
# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::content_type_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"content_type_head"};

    Parse::RecDescent::_trace(q{Trying rule: [content_type_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{content_type_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x84'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x84' content_type_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{content_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{content_type_head});
        %item = (__RULE__ => q{content_type_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x84']},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x84"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [content_type_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{content_type_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{content_type_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_type_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_type_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{content_type_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_type_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_type_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x84' content_type_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{content_type_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{content_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{content_type_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{content_type_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::multipart_header
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multipart_header"};

    Parse::RecDescent::_trace(q{Trying rule: [multipart_header]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{multipart_header},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uintvar});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uintvar]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{multipart_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multipart_header});
        %item = (__RULE__ => q{multipart_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uintvar]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uintvar($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uintvar]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uintvar]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uintvar}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uintvar]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{multipart_header},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{multipart_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multipart_header},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{multipart_header},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_id_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_id_head"};

    Parse::RecDescent::_trace(q{Trying rule: [message_id_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_id_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8b'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8b' message_id_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_id_head});
        %item = (__RULE__ => q{message_id_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8b']},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8b"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [message_id_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_id_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{message_id_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_id_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_id_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_id_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_id_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_id_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8b' message_id_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_id_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_id_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_id_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::value_length
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_length"};

    Parse::RecDescent::_trace(q{Trying rule: [value_length]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_length},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{short_length, or long_length});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [short_length]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_length});
        %item = (__RULE__ => q{value_length});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [short_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_length},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_length},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [short_length]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [long_length]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_length});
        %item = (__RULE__ => q{value_length});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [long_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_length},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::long_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [long_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_length},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [long_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{long_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [long_length]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_length},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_length},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_length},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::start_info_related_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"start_info_related_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [start_info_related_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{start_info_related_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x9a'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x9a' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{start_info_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{start_info_related_parameter});
        %item = (__RULE__ => q{start_info_related_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x9a']},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x9a"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{start_info_related_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{start_info_related_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x9a' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{start_info_related_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{start_info_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{start_info_related_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{start_info_related_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_mixed_time_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_mixed_time_value"};

    Parse::RecDescent::_trace(q{Trying rule: [_mixed_time_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_mixed_time_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value_length});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value_length _mtv_token long_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_mixed_time_value});
        %item = (__RULE__ => q{_mixed_time_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_mixed_time_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::value_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_mixed_time_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [_mtv_token]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_mixed_time_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{_mtv_token})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_mtv_token($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_mtv_token]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_mixed_time_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_mtv_token]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_mtv_token}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [long_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_mixed_time_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{long_integer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::long_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [long_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_mixed_time_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [long_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{long_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { 
   $return = { type => $item{_mtv_token}, value => $item{long_integer} };
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value_length _mtv_token long_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_mixed_time_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_mixed_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_mixed_time_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_mixed_time_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::field_name
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"field_name"};

    Parse::RecDescent::_trace(q{Trying rule: [field_name]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{field_name},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{token_text, or well_known_field_name});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [token_text]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{field_name});
        %item = (__RULE__ => q{field_name});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [token_text]},
                  Parse::RecDescent::_tracefirst($text),
                  q{field_name},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::token_text($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [token_text]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{field_name},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [token_text]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{token_text}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [token_text]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [well_known_field_name]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{field_name});
        %item = (__RULE__ => q{field_name});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [well_known_field_name]},
                  Parse::RecDescent::_tracefirst($text),
                  q{field_name},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::well_known_field_name($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [well_known_field_name]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{field_name},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [well_known_field_name]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{well_known_field_name}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [well_known_field_name]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{field_name},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{field_name},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{field_name},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_address_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_address_value"};

    Parse::RecDescent::_trace(q{Trying rule: [_address_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_address_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{encoded_string_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [encoded_string_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_address_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_address_value});
        %item = (__RULE__ => q{_address_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [encoded_string_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_address_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::encoded_string_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [encoded_string_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_address_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [encoded_string_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_address_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{encoded_string_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_address_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   # Will make more formal later
   my %return = %{$item[1]};
   my $v = $item[1]{text};
   if ($v =~ m{\A (.+) /TYPE= (\w+) \z}mxs) {
      $return{address} = $1;
      $return{TYPE}    = $2;
   }
   else { # email
      $return{address} = $v;
   }
   $return = \%return;
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [encoded_string_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_address_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_address_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_address_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_address_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_address_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::from_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"from_head"};

    Parse::RecDescent::_trace(q{Trying rule: [from_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{from_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x89'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x89' from_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{from_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{from_head});
        %item = (__RULE__ => q{from_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x89']},
                      Parse::RecDescent::_tracefirst($text),
                      q{from_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x89"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [from_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{from_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{from_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::from_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [from_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{from_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [from_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{from_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{from_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{from_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x89' from_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{from_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{from_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{from_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{from_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{from_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Resume
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Resume"};

    Parse::RecDescent::_trace(q{Trying rule: [Resume]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Resume},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x09'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x09']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Resume},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Resume});
        %item = (__RULE__ => q{Resume});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x09']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Resume},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x09"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Resume},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x09']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Resume},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Resume},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Resume},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Resume},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Resume},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::EXPIRED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"EXPIRED"};

    Parse::RecDescent::_trace(q{Trying rule: [EXPIRED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{EXPIRED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{EXPIRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{EXPIRED});
        %item = (__RULE__ => q{EXPIRED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{EXPIRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{EXPIRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{EXPIRED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{EXPIRED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{EXPIRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{EXPIRED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{EXPIRED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::differences_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"differences_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [differences_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{differences_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x87'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x87' field_name]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{differences_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{differences_parameter});
        %item = (__RULE__ => q{differences_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x87']},
                      Parse::RecDescent::_tracefirst($text),
                      q{differences_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x87"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [field_name]},
                  Parse::RecDescent::_tracefirst($text),
                  q{differences_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{field_name})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::field_name($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [field_name]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{differences_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [field_name]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{differences_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{field_name}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{differences_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x87' field_name]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{differences_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{differences_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{differences_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{differences_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{differences_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::level_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"level_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [level_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{level_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82' version_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{level_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{level_parameter});
        %item = (__RULE__ => q{level_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{level_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [version_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{level_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{version_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::version_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [version_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{level_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [version_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{level_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{version_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{level_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82' version_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{level_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{level_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{level_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{level_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{level_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::path_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"path_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [path_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{path_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8f'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8f' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{path_deprecated_parameter});
        %item = (__RULE__ => q{path_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8f']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8f"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.3'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8f' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{path_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{path_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{path_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{path_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::MMS_header
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"MMS_header"};

    Parse::RecDescent::_trace(q{Trying rule: [MMS_header]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{bcc_head, or cc_head, or content_location_head, or date_head, or delivery_report_head, or delivery_time_head, or expiry_head, or from_head, or message_class_head, or message_id_head, or message_type_head, or message_size_head, or MMS_version_head, or priority_head, or read_reply_head, or report_allowed_head, or response_status_head, or response_text_head, or sender_visibility_head, or status_head, or subject_head, or to_head});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [bcc_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [bcc_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::bcc_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [bcc_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [bcc_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{bcc_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [bcc_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [cc_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [cc_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::cc_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [cc_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [cc_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{cc_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [cc_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [content_location_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [content_location_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_location_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_location_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_location_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_location_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [content_location_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [date_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [date_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::date_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [date_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [date_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{date_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [date_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [delivery_report_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [delivery_report_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::delivery_report_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [delivery_report_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [delivery_report_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{delivery_report_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [delivery_report_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [delivery_time_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [delivery_time_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::delivery_time_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [delivery_time_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [delivery_time_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{delivery_time_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [delivery_time_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [expiry_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [expiry_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::expiry_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [expiry_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [expiry_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expiry_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [expiry_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [from_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [from_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::from_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [from_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [from_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{from_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [from_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_class_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_class_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_class_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_class_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_class_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_class_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [message_class_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_id_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_id_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_id_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_id_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_id_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_id_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [message_id_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_type_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_type_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [message_type_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_size_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[11];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_size_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_size_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_size_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_size_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_size_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [message_size_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [MMS_version_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[12];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [MMS_version_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_version_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_version_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_version_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [MMS_version_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [priority_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[13];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [priority_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::priority_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [priority_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [priority_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{priority_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [priority_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [read_reply_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[14];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [read_reply_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::read_reply_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [read_reply_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [read_reply_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{read_reply_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [read_reply_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [report_allowed_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[15];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [report_allowed_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::report_allowed_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [report_allowed_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [report_allowed_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{report_allowed_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [report_allowed_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [response_status_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[16];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [response_status_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::response_status_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [response_status_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [response_status_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{response_status_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [response_status_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [response_text_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[17];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [response_text_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::response_text_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [response_text_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [response_text_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{response_text_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [response_text_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [sender_visibility_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[18];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [sender_visibility_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::sender_visibility_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [sender_visibility_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [sender_visibility_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{sender_visibility_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [sender_visibility_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [status_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[19];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [status_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::status_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [status_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [status_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{status_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [status_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [subject_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[20];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [subject_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::subject_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [subject_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [subject_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{subject_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [subject_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [to_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[21];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_header});
        %item = (__RULE__ => q{MMS_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [to_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::to_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [to_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [to_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{to_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [to_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{MMS_header},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{MMS_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{MMS_header},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{MMS_header},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Reserved
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Reserved"};

    Parse::RecDescent::_trace(q{Trying rule: [Reserved]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Reserved},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x00\\x81-\\xff]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x00\\x81-\\xff]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Reserved},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Reserved});
        %item = (__RULE__ => q{Reserved});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x00\\x81-\\xff]/]}, Parse::RecDescent::_tracefirst($text),
                      q{Reserved},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x00\x81-\xff])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Reserved},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x00\\x81-\\xff]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Reserved},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Reserved},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Reserved},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Reserved},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Reserved},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::start_related_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"start_related_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [start_related_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{start_related_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8a'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8a' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{start_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{start_related_deprecated_parameter});
        %item = (__RULE__ => q{start_related_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8a']},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8a"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{start_related_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{start_related_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.2'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8a' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{start_related_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{start_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{start_related_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{start_related_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::uri_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"uri_value"};

    Parse::RecDescent::_trace(q{Trying rule: [uri_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{uri_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{text_string});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{uri_value});
        %item = (__RULE__ => q{uri_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uri_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uri_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{uri_value});
        %item = (__RULE__ => q{uri_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uri_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uri_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{uri_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{uri_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{uri_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{uri_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::subject_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"subject_value"};

    Parse::RecDescent::_trace(q{Trying rule: [subject_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{subject_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{encoded_string_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [encoded_string_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{subject_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{subject_value});
        %item = (__RULE__ => q{subject_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [encoded_string_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{subject_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::encoded_string_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [encoded_string_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{subject_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [encoded_string_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{subject_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{encoded_string_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [encoded_string_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{subject_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{subject_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{subject_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{subject_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{subject_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::comment_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"comment_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [comment_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{comment_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8c'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8c' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{comment_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{comment_deprecated_parameter});
        %item = (__RULE__ => q{comment_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8c']},
                      Parse::RecDescent::_tracefirst($text),
                      q{comment_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8c"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{comment_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{comment_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{comment_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{comment_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.3'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8c' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{comment_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{comment_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{comment_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{comment_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{comment_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::charset_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"charset_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [charset_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{charset_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81' well_known_charset]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{charset_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{charset_parameter});
        %item = (__RULE__ => q{charset_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{charset_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [well_known_charset]},
                  Parse::RecDescent::_tracefirst($text),
                  q{charset_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{well_known_charset})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::well_known_charset($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [well_known_charset]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{charset_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [well_known_charset]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{charset_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{well_known_charset}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{charset_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81' well_known_charset]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{charset_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{charset_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{charset_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{charset_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{charset_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_mtv_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_mtv_token"};

    Parse::RecDescent::_trace(q{Trying rule: [_mtv_token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_mtv_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{absolute_token, or relative_token});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [absolute_token]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_mtv_token});
        %item = (__RULE__ => q{_mtv_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [absolute_token]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_mtv_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::absolute_token($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [absolute_token]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_mtv_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [absolute_token]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{absolute_token}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [absolute_token]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [relative_token]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{_mtv_token});
        %item = (__RULE__ => q{_mtv_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [relative_token]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_mtv_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::relative_token($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [relative_token]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_mtv_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [relative_token]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relative_token}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [relative_token]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_mtv_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_mtv_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_mtv_token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_mtv_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::read_reply_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"read_reply_head"};

    Parse::RecDescent::_trace(q{Trying rule: [read_reply_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{read_reply_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x90'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x90' read_reply_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{read_reply_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{read_reply_head});
        %item = (__RULE__ => q{read_reply_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x90']},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x90"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [read_reply_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{read_reply_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{read_reply_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::read_reply_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [read_reply_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{read_reply_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [read_reply_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{read_reply_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x90' read_reply_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{read_reply_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{read_reply_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{read_reply_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{read_reply_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::name_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"name_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [name_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{name_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x97'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x97' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{name_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{name_parameter});
        %item = (__RULE__ => q{name_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x97']},
                      Parse::RecDescent::_tracefirst($text),
                      q{name_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x97"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{name_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{name_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{name_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{name_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x97' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{name_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{name_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{name_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{name_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{name_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ConnectReply
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ConnectReply"};

    Parse::RecDescent::_trace(q{Trying rule: [ConnectReply]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ConnectReply},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x02'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x02']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ConnectReply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ConnectReply});
        %item = (__RULE__ => q{ConnectReply});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x02']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ConnectReply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x02"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ConnectReply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x02']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ConnectReply},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ConnectReply},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ConnectReply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ConnectReply},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ConnectReply},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"MMS_version_head"};

    Parse::RecDescent::_trace(q{Trying rule: [MMS_version_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{MMS_version_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8d'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8d' MMS_version_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_version_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_version_head});
        %item = (__RULE__ => q{MMS_version_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8d']},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_version_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8d"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [MMS_version_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_version_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{MMS_version_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_version_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_version_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_version_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_version_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_version_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_version_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8d' MMS_version_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_version_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{MMS_version_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{MMS_version_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{MMS_version_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{MMS_version_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"transaction_id_value"};

    Parse::RecDescent::_trace(q{Trying rule: [transaction_id_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{transaction_id_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{text_string});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{transaction_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{transaction_id_value});
        %item = (__RULE__ => q{transaction_id_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{transaction_id_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{transaction_id_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{transaction_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{transaction_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{transaction_id_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{transaction_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{transaction_id_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{transaction_id_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Delete_GetPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Delete_GetPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Delete_GetPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Delete_GetPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x43'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x43']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Delete_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Delete_GetPDU});
        %item = (__RULE__ => q{Delete_GetPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x43']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Delete_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x43"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Delete_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x43']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Delete_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Delete_GetPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Delete_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Delete_GetPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Delete_GetPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::version_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"version_value"};

    Parse::RecDescent::_trace(q{Trying rule: [version_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{version_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_short_integer_version, or text_string});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_short_integer_version]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{version_value});
        %item = (__RULE__ => q{version_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_short_integer_version]},
                  Parse::RecDescent::_tracefirst($text),
                  q{version_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_short_integer_version($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_short_integer_version]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{version_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_short_integer_version]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_short_integer_version}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_short_integer_version]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{version_value});
        %item = (__RULE__ => q{version_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{version_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{version_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{version_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{version_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{version_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::DEFERRED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"DEFERRED"};

    Parse::RecDescent::_trace(q{Trying rule: [DEFERRED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{DEFERRED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x83'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x83']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{DEFERRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{DEFERRED});
        %item = (__RULE__ => q{DEFERRED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x83']},
                      Parse::RecDescent::_tracefirst($text),
                      q{DEFERRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x83"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{DEFERRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x83']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{DEFERRED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{DEFERRED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{DEFERRED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{DEFERRED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{DEFERRED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ct_constrained_media
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ct_constrained_media"};

    Parse::RecDescent::_trace(q{Trying rule: [ct_constrained_media]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ct_constrained_media},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{constrained_media});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [constrained_media]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ct_constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ct_constrained_media});
        %item = (__RULE__ => q{ct_constrained_media});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [constrained_media]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ct_constrained_media},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::constrained_media($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [constrained_media]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ct_constrained_media},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [constrained_media]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ct_constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constrained_media}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ct_constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = { text => $item[1], media_type => $item[1], parameters => {} };
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [constrained_media]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ct_constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ct_constrained_media},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ct_constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ct_constrained_media},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ct_constrained_media},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::q_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"q_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [q_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{q_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80' q_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{q_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{q_parameter});
        %item = (__RULE__ => q{q_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{q_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [q_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{q_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{q_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::q_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [q_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{q_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [q_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{q_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{q_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{q_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80' q_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{q_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{q_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{q_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{q_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{q_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::response_status_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"response_status_head"};

    Parse::RecDescent::_trace(q{Trying rule: [response_status_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{response_status_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x92'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x92' response_status_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_head});
        %item = (__RULE__ => q{response_status_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x92']},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x92"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [response_status_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{response_status_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::response_status_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [response_status_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [response_status_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{response_status_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x92' response_status_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{response_status_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{response_status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{response_status_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{response_status_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::sender_visibility_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"sender_visibility_value"};

    Parse::RecDescent::_trace(q{Trying rule: [sender_visibility_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{sender_visibility_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{HIDE, or SHOW});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HIDE]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{sender_visibility_value});
        %item = (__RULE__ => q{sender_visibility_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [HIDE]},
                  Parse::RecDescent::_tracefirst($text),
                  q{sender_visibility_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::HIDE($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [HIDE]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{sender_visibility_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [HIDE]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HIDE}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [HIDE]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [SHOW]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{sender_visibility_value});
        %item = (__RULE__ => q{sender_visibility_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [SHOW]},
                  Parse::RecDescent::_tracefirst($text),
                  q{sender_visibility_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::SHOW($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [SHOW]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{sender_visibility_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [SHOW]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{SHOW}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [SHOW]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{sender_visibility_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{sender_visibility_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{sender_visibility_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{sender_visibility_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::text_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"text_value"};

    Parse::RecDescent::_trace(q{Trying rule: [text_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{text_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{no_value, or token_text, or quoted_string});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [no_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{text_value});
        %item = (__RULE__ => q{text_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [no_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{text_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::no_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [no_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{text_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [no_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{no_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [no_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [token_text]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{text_value});
        %item = (__RULE__ => q{text_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [token_text]},
                  Parse::RecDescent::_tracefirst($text),
                  q{text_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::token_text($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [token_text]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{text_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [token_text]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{token_text}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [token_text]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [quoted_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{text_value});
        %item = (__RULE__ => q{text_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [quoted_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{text_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::quoted_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [quoted_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{text_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [quoted_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{quoted_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [quoted_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{text_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{text_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{text_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::read_reply_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"read_reply_value"};

    Parse::RecDescent::_trace(q{Trying rule: [read_reply_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{read_reply_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{YES, or NO});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [YES]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{read_reply_value});
        %item = (__RULE__ => q{read_reply_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [YES]},
                  Parse::RecDescent::_tracefirst($text),
                  q{read_reply_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::YES($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [YES]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{read_reply_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [YES]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{YES}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [YES]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [NO]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{read_reply_value});
        %item = (__RULE__ => q{read_reply_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [NO]},
                  Parse::RecDescent::_tracefirst($text),
                  q{read_reply_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::NO($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [NO]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{read_reply_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [NO]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{NO}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [NO]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{read_reply_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{read_reply_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{read_reply_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{read_reply_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::AUTO
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"AUTO"};

    Parse::RecDescent::_trace(q{Trying rule: [AUTO]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{AUTO},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x83'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x83']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{AUTO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{AUTO});
        %item = (__RULE__ => q{AUTO});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x83']},
                      Parse::RecDescent::_tracefirst($text),
                      q{AUTO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x83"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{AUTO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x83']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{AUTO},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{AUTO},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{AUTO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{AUTO},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{AUTO},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::long_length
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"long_length"};

    Parse::RecDescent::_trace(q{Trying rule: [long_length]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{long_length},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{length_quote});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [length_quote length_]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{long_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{long_length});
        %item = (__RULE__ => q{long_length});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [length_quote]},
                  Parse::RecDescent::_tracefirst($text),
                  q{long_length},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::length_quote($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [length_quote]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{long_length},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [length_quote]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{long_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{length_quote}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [length_]},
                  Parse::RecDescent::_tracefirst($text),
                  q{long_length},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{length_})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::length_($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [length_]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{long_length},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [length_]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{long_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{length_}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [length_quote length_]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{long_length},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{long_length},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{long_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{long_length},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{long_length},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::delivery_time_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"delivery_time_head"};

    Parse::RecDescent::_trace(q{Trying rule: [delivery_time_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{delivery_time_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x87'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x87' delivery_time_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{delivery_time_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{delivery_time_head});
        %item = (__RULE__ => q{delivery_time_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x87']},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_time_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x87"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [delivery_time_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{delivery_time_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{delivery_time_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::delivery_time_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [delivery_time_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{delivery_time_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [delivery_time_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_time_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{delivery_time_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_time_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x87' delivery_time_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_time_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{delivery_time_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{delivery_time_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{delivery_time_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{delivery_time_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::delta_seconds_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"delta_seconds_value"};

    Parse::RecDescent::_trace(q{Trying rule: [delta_seconds_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{delta_seconds_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{integer_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{delta_seconds_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{delta_seconds_value});
        %item = (__RULE__ => q{delta_seconds_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{delta_seconds_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{delta_seconds_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{delta_seconds_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{delta_seconds_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{delta_seconds_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{delta_seconds_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{delta_seconds_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{delta_seconds_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ExtendedMethod_PostPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ExtendedMethod_PostPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [ExtendedMethod_PostPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ExtendedMethod_PostPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x70-\\x7f]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x70-\\x7f]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ExtendedMethod_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ExtendedMethod_PostPDU});
        %item = (__RULE__ => q{ExtendedMethod_PostPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x70-\\x7f]/]}, Parse::RecDescent::_tracefirst($text),
                      q{ExtendedMethod_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x70-\x7f])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ExtendedMethod_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x70-\\x7f]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ExtendedMethod_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ExtendedMethod_PostPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ExtendedMethod_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ExtendedMethod_PostPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ExtendedMethod_PostPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::untyped_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"untyped_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [untyped_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{untyped_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{token_text});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [token_text untyped_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{untyped_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{untyped_parameter});
        %item = (__RULE__ => q{untyped_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [token_text]},
                  Parse::RecDescent::_tracefirst($text),
                  q{untyped_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::token_text($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [token_text]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{untyped_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [token_text]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{token_text}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [untyped_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{untyped_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{untyped_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::untyped_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [untyped_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{untyped_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [untyped_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{untyped_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = { name => $item[1], value => $item[2] };
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [token_text untyped_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{untyped_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{untyped_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{untyped_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{untyped_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_size_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_size_head"};

    Parse::RecDescent::_trace(q{Trying rule: [message_size_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_size_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8e'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8e' message_size_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_size_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_size_head});
        %item = (__RULE__ => q{message_size_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8e']},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_size_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8e"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [message_size_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_size_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{message_size_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_size_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_size_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_size_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_size_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_size_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_size_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_size_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8e' message_size_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_size_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_size_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_size_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_size_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_size_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_class_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_class_value"};

    Parse::RecDescent::_trace(q{Trying rule: [message_class_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_class_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{class_identifier, or token_text});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [class_identifier]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_class_value});
        %item = (__RULE__ => q{message_class_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [class_identifier]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_class_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::class_identifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [class_identifier]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_class_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [class_identifier]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{class_identifier}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [class_identifier]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [token_text]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_class_value});
        %item = (__RULE__ => q{message_class_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [token_text]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_class_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::token_text($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [token_text]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_class_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [token_text]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{token_text}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [token_text]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_class_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_class_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_class_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_class_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head_code
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_type_head_code"};

    Parse::RecDescent::_trace(q{Trying rule: [message_type_head_code]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_type_head_code},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8c'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8c']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_head_code},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_head_code});
        %item = (__RULE__ => q{message_type_head_code});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8c']},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head_code},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8c"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head_code},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[1]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8c']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head_code},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_type_head_code},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_type_head_code},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_type_head_code},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_type_head_code},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::from_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"from_value"};

    Parse::RecDescent::_trace(q{Trying rule: [from_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value_length});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value_length address_present_token, or insert_address_token]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{from_value});
        %item = (__RULE__ => q{from_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::value_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{from_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [_alternation_1_of_production_1_of_rule_from_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{address_present_token, or insert_address_token})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_from_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_alternation_1_of_production_1_of_rule_from_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{from_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_alternation_1_of_production_1_of_rule_from_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_from_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = $item[2];
   defined($return) || undef;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value_length address_present_token, or insert_address_token]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{from_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{from_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{from_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Head_GetPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Head_GetPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Head_GetPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Head_GetPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x42'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x42']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Head_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Head_GetPDU});
        %item = (__RULE__ => q{Head_GetPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x42']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Head_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x42"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Head_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x42']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Head_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Head_GetPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Head_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Head_GetPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Head_GetPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::integer_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"integer_value"};

    Parse::RecDescent::_trace(q{Trying rule: [integer_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{integer_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{short_integer, or long_integer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [short_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{integer_value});
        %item = (__RULE__ => q{integer_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [short_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{integer_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{integer_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [short_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [long_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{integer_value});
        %item = (__RULE__ => q{integer_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [long_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{integer_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::long_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [long_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{integer_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [long_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{long_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [long_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{integer_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{integer_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{integer_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{integer_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::end_of_string
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"end_of_string"};

    Parse::RecDescent::_trace(q{Trying rule: [end_of_string]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{end_of_string},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x00'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x00']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{end_of_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{end_of_string});
        %item = (__RULE__ => q{end_of_string});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x00']},
                      Parse::RecDescent::_tracefirst($text),
                      q{end_of_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x00"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x00']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{end_of_string},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{end_of_string},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{end_of_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{end_of_string},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{end_of_string},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::bcc_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"bcc_value"};

    Parse::RecDescent::_trace(q{Trying rule: [bcc_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{bcc_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_address_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_address_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{bcc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{bcc_value});
        %item = (__RULE__ => q{bcc_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_address_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{bcc_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_address_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_address_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{bcc_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_address_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{bcc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_address_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_address_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{bcc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{bcc_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{bcc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{bcc_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{bcc_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::well_known_charset
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"well_known_charset"};

    Parse::RecDescent::_trace(q{Trying rule: [well_known_charset]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{well_known_charset},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{any_charset, or _well_known_charset_wcode});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [any_charset]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{well_known_charset});
        %item = (__RULE__ => q{well_known_charset});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [any_charset]},
                  Parse::RecDescent::_tracefirst($text),
                  q{well_known_charset},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::any_charset($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [any_charset]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{well_known_charset},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [any_charset]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{any_charset}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [any_charset]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_well_known_charset_wcode]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{well_known_charset});
        %item = (__RULE__ => q{well_known_charset});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_well_known_charset_wcode]},
                  Parse::RecDescent::_tracefirst($text),
                  q{well_known_charset},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_well_known_charset_wcode($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_well_known_charset_wcode]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{well_known_charset},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_well_known_charset_wcode]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_well_known_charset_wcode}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_well_known_charset_wcode]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{well_known_charset},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{well_known_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{well_known_charset},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{well_known_charset},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::well_known_field_name
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"well_known_field_name"};

    Parse::RecDescent::_trace(q{Trying rule: [well_known_field_name]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{well_known_field_name},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{short_integer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [short_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{well_known_field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{well_known_field_name});
        %item = (__RULE__ => q{well_known_field_name});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [short_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{well_known_field_name},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{well_known_field_name},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [short_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{well_known_field_name},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{well_known_field_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{well_known_field_name},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{well_known_field_name},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::CRLF
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"CRLF"};

    Parse::RecDescent::_trace(q{Trying rule: [CRLF]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{CRLF},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{CR});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [CR LF]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{CRLF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{CRLF});
        %item = (__RULE__ => q{CRLF});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [CR]},
                  Parse::RecDescent::_tracefirst($text),
                  q{CRLF},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::CR($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [CR]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{CRLF},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [CR]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{CRLF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CR}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [LF]},
                  Parse::RecDescent::_tracefirst($text),
                  q{CRLF},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{LF})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::LF($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [LF]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{CRLF},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [LF]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{CRLF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{LF}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{CRLF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = "\r\n"; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [CR LF]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{CRLF},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{CRLF},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{CRLF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{CRLF},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{CRLF},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::M_Notification_Ind_message
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"M_Notification_Ind_message"};

    Parse::RecDescent::_trace(q{Trying rule: [M_Notification_Ind_message]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{M_Notification_Ind_message},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{message_type_head_code});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_type_head_code m_notification_ind transaction_id_head MMS_version_head header]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{M_Notification_Ind_message});
        %item = (__RULE__ => q{M_Notification_Ind_message});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_type_head_code]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Notification_Ind_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head_code($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_head_code]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Notification_Ind_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_head_code]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_head_code}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [m_notification_ind]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Notification_Ind_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{m_notification_ind})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_notification_ind($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_notification_ind]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Notification_Ind_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_notification_ind]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_notification_ind}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [transaction_id_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Notification_Ind_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{transaction_id_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [transaction_id_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Notification_Ind_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [transaction_id_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{transaction_id_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [MMS_version_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Notification_Ind_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{MMS_version_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_version_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Notification_Ind_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_version_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_version_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Notification_Ind_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{header})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::header, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Notification_Ind_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [header]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{header(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my %retval;
   $retval{message_type_head} = 'm_notification_ind';
   foreach my $header (@item[3,4], @{$item[5]}) {
      next unless ref($header) eq 'ARRAY';
      my ($name, $value) = @$header;
      $name =~ s/_head\z//;
      $retval{$name} = $value;
   }
   $return = \%retval;
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [message_type_head_code m_notification_ind transaction_id_head MMS_version_head header]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{M_Notification_Ind_message},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{M_Notification_Ind_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{M_Notification_Ind_message},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{M_Notification_Ind_message},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::untyped_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"untyped_value"};

    Parse::RecDescent::_trace(q{Trying rule: [untyped_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{untyped_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{integer_value, or text_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{untyped_value});
        %item = (__RULE__ => q{untyped_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{untyped_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{untyped_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{untyped_value});
        %item = (__RULE__ => q{untyped_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{untyped_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{untyped_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{untyped_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{untyped_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{untyped_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{untyped_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::HEX
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"HEX"};

    Parse::RecDescent::_trace(q{Trying rule: [HEX]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{HEX},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[a-fA-F0-9]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[a-fA-F0-9]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{HEX},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{HEX});
        %item = (__RULE__ => q{HEX});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[a-fA-F0-9]/]}, Parse::RecDescent::_tracefirst($text),
                      q{HEX},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[a-fA-F0-9])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[a-fA-F0-9]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{HEX},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{HEX},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{HEX},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{HEX},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{HEX},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Trace_GetPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Trace_GetPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Trace_GetPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Trace_GetPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x44'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x44']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Trace_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Trace_GetPDU});
        %item = (__RULE__ => q{Trace_GetPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x44']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Trace_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x44"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Trace_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x44']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Trace_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Trace_GetPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Trace_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Trace_GetPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Trace_GetPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::M_Retrieve_Conf_message
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"M_Retrieve_Conf_message"};

    Parse::RecDescent::_trace(q{Trying rule: [M_Retrieve_Conf_message]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{message_type_head_code});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_type_head_code m_retrieve_conf transaction_id_head MMS_version_head header content_type_head multipart]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{M_Retrieve_Conf_message});
        %item = (__RULE__ => q{M_Retrieve_Conf_message});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_type_head_code]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head_code($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_head_code]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_head_code]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_head_code}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [m_retrieve_conf]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{m_retrieve_conf})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_retrieve_conf($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_retrieve_conf]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_retrieve_conf]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_retrieve_conf}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [transaction_id_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{transaction_id_head})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_head, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [transaction_id_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [transaction_id_head]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{transaction_id_head(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [MMS_version_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{MMS_version_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_version_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_version_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_version_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{header})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::header, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [header]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{header(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [content_type_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{content_type_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_type_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_type_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_type_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_type_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [multipart]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Retrieve_Conf_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{multipart})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::multipart($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [multipart]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Retrieve_Conf_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [multipart]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multipart}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my %headers;
   $headers{message_type_head} = 'm_retrieve_conf';
   foreach my $header (@item[4,6], @{$item[3]}, @{$item[5]}) {
      my ($name, $value) = @$header;
      $headers{$name} = $value;
   }
   $return = {
      headers => \%headers,
      body    => $item{multipart},
   };
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [message_type_head_code m_retrieve_conf transaction_id_head MMS_version_head header content_type_head multipart]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{M_Retrieve_Conf_message},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{M_Retrieve_Conf_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{M_Retrieve_Conf_message},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{M_Retrieve_Conf_message},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Reply
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Reply"};

    Parse::RecDescent::_trace(q{Trying rule: [Reply]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Reply},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x04'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x04']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Reply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Reply});
        %item = (__RULE__ => q{Reply});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x04']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Reply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x04"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Reply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x04']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Reply},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Reply},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Reply},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Reply},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Reply},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::constrained_media
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"constrained_media"};

    Parse::RecDescent::_trace(q{Trying rule: [constrained_media]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{constrained_media},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{constrained_encoding});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [constrained_encoding]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{constrained_media});
        %item = (__RULE__ => q{constrained_media});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [constrained_encoding]},
                  Parse::RecDescent::_tracefirst($text),
                  q{constrained_media},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::constrained_encoding($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [constrained_encoding]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{constrained_media},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [constrained_encoding]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constrained_encoding}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [constrained_encoding]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{constrained_media},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{constrained_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{constrained_media},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{constrained_media},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::delivery_report_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"delivery_report_head"};

    Parse::RecDescent::_trace(q{Trying rule: [delivery_report_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{delivery_report_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x86'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x86' delivery_report_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{delivery_report_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{delivery_report_head});
        %item = (__RULE__ => q{delivery_report_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x86']},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x86"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [delivery_report_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{delivery_report_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{delivery_report_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::delivery_report_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [delivery_report_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{delivery_report_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [delivery_report_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{delivery_report_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x86' delivery_report_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{delivery_report_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{delivery_report_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{delivery_report_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{delivery_report_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::SHOW
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"SHOW"};

    Parse::RecDescent::_trace(q{Trying rule: [SHOW]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{SHOW},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{SHOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{SHOW});
        %item = (__RULE__ => q{SHOW});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{SHOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{SHOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{SHOW},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{SHOW},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{SHOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{SHOW},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{SHOW},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::cc_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"cc_value"};

    Parse::RecDescent::_trace(q{Trying rule: [cc_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{cc_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_address_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_address_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{cc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{cc_value});
        %item = (__RULE__ => q{cc_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_address_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{cc_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_address_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_address_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{cc_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_address_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{cc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_address_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_address_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{cc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{cc_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{cc_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{cc_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{cc_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::start_related_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"start_related_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [start_related_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{start_related_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x99'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x99' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{start_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{start_related_parameter});
        %item = (__RULE__ => q{start_related_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x99']},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x99"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{start_related_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{start_related_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x99' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{start_related_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{start_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{start_related_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{start_related_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Get
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Get"};

    Parse::RecDescent::_trace(q{Trying rule: [Get]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Get},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x40'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x40']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Get},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Get});
        %item = (__RULE__ => q{Get});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x40']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Get},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x40"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Get},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x40']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Get},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Get},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Get},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Get},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Get},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::INFORMATIONAL
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"INFORMATIONAL"};

    Parse::RecDescent::_trace(q{Trying rule: [INFORMATIONAL]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{INFORMATIONAL},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{INFORMATIONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{INFORMATIONAL});
        %item = (__RULE__ => q{INFORMATIONAL});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{INFORMATIONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{INFORMATIONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{INFORMATIONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{INFORMATIONAL},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{INFORMATIONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{INFORMATIONAL},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{INFORMATIONAL},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::priority_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"priority_head"};

    Parse::RecDescent::_trace(q{Trying rule: [priority_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{priority_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8f'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8f' priority_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{priority_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{priority_head});
        %item = (__RULE__ => q{priority_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8f']},
                      Parse::RecDescent::_tracefirst($text),
                      q{priority_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8f"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [priority_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{priority_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{priority_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::priority_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [priority_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{priority_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [priority_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{priority_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{priority_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{priority_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8f' priority_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{priority_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{priority_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{priority_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{priority_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{priority_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_type_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_type_value"};

    Parse::RecDescent::_trace(q{Trying rule: [message_type_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{m_send_req, or m_send_conf, or m_notification_ind, or m_notifyresp_ind, or m_retrieve_conf, or m_acknowledge_ind, or m_delivery_ind});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_send_req]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_send_req]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_send_req($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_send_req]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_send_req]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_send_req}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_send_req]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_send_conf]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_send_conf]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_send_conf($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_send_conf]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_send_conf]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_send_conf}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_send_conf]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_notification_ind]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_notification_ind]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_notification_ind($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_notification_ind]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_notification_ind]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_notification_ind}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_notification_ind]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_notifyresp_ind]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_notifyresp_ind]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_notifyresp_ind($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_notifyresp_ind]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_notifyresp_ind]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_notifyresp_ind}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_notifyresp_ind]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_retrieve_conf]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_retrieve_conf]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_retrieve_conf($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_retrieve_conf]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_retrieve_conf]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_retrieve_conf}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_retrieve_conf]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_acknowledge_ind]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_acknowledge_ind]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_acknowledge_ind($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_acknowledge_ind]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_acknowledge_ind]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_acknowledge_ind}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_acknowledge_ind]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [m_delivery_ind]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_value});
        %item = (__RULE__ => q{message_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [m_delivery_ind]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_delivery_ind($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_delivery_ind]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_delivery_ind]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_delivery_ind}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [m_delivery_ind]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_type_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_type_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_type_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::multipart_data_len
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multipart_data_len"};

    Parse::RecDescent::_trace(q{Trying rule: [multipart_data_len]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{multipart_data_len},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uintvar});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uintvar]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{multipart_data_len},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multipart_data_len});
        %item = (__RULE__ => q{multipart_data_len});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uintvar]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart_data_len},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uintvar($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uintvar]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart_data_len},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uintvar]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_data_len},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uintvar}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uintvar]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_data_len},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{multipart_data_len},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{multipart_data_len},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multipart_data_len},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{multipart_data_len},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::LWS
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"LWS"};

    Parse::RecDescent::_trace(q{Trying rule: [LWS]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{LWS},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{CRLF});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [CRLF SP, or HT]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{LWS});
        %item = (__RULE__ => q{LWS});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [CRLF]},
                  Parse::RecDescent::_tracefirst($text),
                  q{LWS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::CRLF, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [CRLF]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{LWS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [CRLF]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CRLF(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying repeated subrule: [SP, or HT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{LWS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{SP, or HT})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_LWS, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [SP, or HT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{LWS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_LWS]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_LWS(1..)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = join '', @{$item[1]}, @{$item[2]};
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [CRLF SP, or HT]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{LWS},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{LWS},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{LWS},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::uintvar_integer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"uintvar_integer"};

    Parse::RecDescent::_trace(q{Trying rule: [uintvar_integer]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{uintvar_integer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uintvar});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uintvar]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uintvar_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{uintvar_integer});
        %item = (__RULE__ => q{uintvar_integer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uintvar]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uintvar_integer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uintvar($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uintvar]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uintvar_integer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uintvar]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{uintvar_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uintvar}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uintvar]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uintvar_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{uintvar_integer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{uintvar_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{uintvar_integer},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{uintvar_integer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_trans_well_known_media
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_trans_well_known_media"};

    Parse::RecDescent::_trace(q{Trying rule: [_trans_well_known_media]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_trans_well_known_media},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{well_known_media});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [well_known_media]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_trans_well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_trans_well_known_media});
        %item = (__RULE__ => q{_trans_well_known_media});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [well_known_media]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_trans_well_known_media},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::well_known_media($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [well_known_media]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_trans_well_known_media},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [well_known_media]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_trans_well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{well_known_media}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_trans_well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   # media_type_for() defined in g-startup.pl
   $return = media_type_for($item{well_known_media});
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [well_known_media]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_trans_well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_trans_well_known_media},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_trans_well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_trans_well_known_media},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_trans_well_known_media},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::priority_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"priority_value"};

    Parse::RecDescent::_trace(q{Trying rule: [priority_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{priority_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{LOW, or NORMAL, or HIGH});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [LOW]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{priority_value});
        %item = (__RULE__ => q{priority_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [LOW]},
                  Parse::RecDescent::_tracefirst($text),
                  q{priority_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::LOW($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [LOW]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{priority_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [LOW]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{LOW}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [LOW]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [NORMAL]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{priority_value});
        %item = (__RULE__ => q{priority_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [NORMAL]},
                  Parse::RecDescent::_tracefirst($text),
                  q{priority_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::NORMAL($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [NORMAL]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{priority_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [NORMAL]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{NORMAL}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [NORMAL]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HIGH]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{priority_value});
        %item = (__RULE__ => q{priority_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [HIGH]},
                  Parse::RecDescent::_tracefirst($text),
                  q{priority_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::HIGH($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [HIGH]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{priority_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [HIGH]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HIGH}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [HIGH]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{priority_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{priority_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{priority_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{priority_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::typed_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"typed_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [typed_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{q_parameter, or charset_parameter, or level_parameter, or type_parameter, or name_deprecated_parameter, or filename_deprecated_parameter, or differences_parameter, or padding_parameter, or type_related_parameter, or start_related_deprecated_parameter, or start_info_related_deprecated_parameter, or comment_deprecated_parameter, or domain_deprecated_parameter, or max_age_parameter, or path_deprecated_parameter, or secure_parameter, or SEC_wbxml_parameter, or MAC_wbxml_parameter, or creation_date_parameter, or modification_date_parameter, or read_date_parameter, or size_parameter, or name_parameter, or filename_parameter, or start_related_parameter, or start_info_related_parameter, or comment_parameter, or domain_parameter, or path_parameter});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [q_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [q_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::q_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [q_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [q_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{q_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [q_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [charset_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [charset_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::charset_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [charset_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [charset_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{charset_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [charset_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [level_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [level_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::level_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [level_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [level_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{level_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [level_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [type_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [type_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::type_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [type_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [type_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [type_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [name_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [name_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::name_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [name_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [name_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{name_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [name_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [filename_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [filename_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::filename_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [filename_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [filename_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{filename_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [filename_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [differences_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [differences_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::differences_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [differences_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [differences_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{differences_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [differences_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [padding_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [padding_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::padding_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [padding_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [padding_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{padding_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [padding_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [type_related_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [type_related_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::type_related_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [type_related_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [type_related_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type_related_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [type_related_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [start_related_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [start_related_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::start_related_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [start_related_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [start_related_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{start_related_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [start_related_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [start_info_related_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [start_info_related_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::start_info_related_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [start_info_related_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [start_info_related_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{start_info_related_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [start_info_related_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [comment_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[11];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [comment_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::comment_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [comment_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [comment_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{comment_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [comment_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [domain_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[12];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [domain_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::domain_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [domain_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [domain_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{domain_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [domain_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [max_age_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[13];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [max_age_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::max_age_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [max_age_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [max_age_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{max_age_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [max_age_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [path_deprecated_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[14];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [path_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::path_deprecated_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [path_deprecated_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [path_deprecated_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{path_deprecated_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [path_deprecated_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [secure_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[15];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [secure_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::secure_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [secure_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [secure_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{secure_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [secure_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [SEC_wbxml_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[16];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [SEC_wbxml_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::SEC_wbxml_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [SEC_wbxml_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [SEC_wbxml_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{SEC_wbxml_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [SEC_wbxml_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [MAC_wbxml_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[17];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [MAC_wbxml_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MAC_wbxml_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MAC_wbxml_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MAC_wbxml_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MAC_wbxml_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [MAC_wbxml_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [creation_date_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[18];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [creation_date_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::creation_date_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [creation_date_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [creation_date_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{creation_date_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [creation_date_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [modification_date_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[19];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [modification_date_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::modification_date_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [modification_date_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [modification_date_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{modification_date_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [modification_date_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [read_date_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[20];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [read_date_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::read_date_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [read_date_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [read_date_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{read_date_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [read_date_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [size_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[21];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [size_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::size_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [size_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [size_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{size_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [size_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [name_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[22];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [name_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::name_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [name_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [name_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{name_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [name_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [filename_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[23];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [filename_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::filename_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [filename_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [filename_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{filename_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [filename_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [start_related_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[24];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [start_related_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::start_related_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [start_related_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [start_related_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{start_related_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [start_related_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [start_info_related_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[25];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [start_info_related_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::start_info_related_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [start_info_related_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [start_info_related_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{start_info_related_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [start_info_related_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [comment_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[26];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [comment_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::comment_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [comment_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [comment_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{comment_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [comment_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [domain_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[27];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [domain_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::domain_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [domain_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [domain_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{domain_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [domain_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [path_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[28];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_parameter});
        %item = (__RULE__ => q{typed_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [path_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::path_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [path_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [path_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{path_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [path_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{typed_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{typed_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{typed_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{typed_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_notifyresp_ind
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_notifyresp_ind"};

    Parse::RecDescent::_trace(q{Trying rule: [m_notifyresp_ind]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_notifyresp_ind},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x83'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x83']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_notifyresp_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_notifyresp_ind});
        %item = (__RULE__ => q{m_notifyresp_ind});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x83']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_notifyresp_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x83"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_notifyresp_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x83']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_notifyresp_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_notifyresp_ind},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_notifyresp_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_notifyresp_ind},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_notifyresp_ind},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::LOW
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"LOW"};

    Parse::RecDescent::_trace(q{Trying rule: [LOW]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{LOW},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{LOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{LOW});
        %item = (__RULE__ => q{LOW});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{LOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{LOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{LOW},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{LOW},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{LOW},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{LOW},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{LOW},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::status_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"status_head"};

    Parse::RecDescent::_trace(q{Trying rule: [status_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{status_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x95'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x95' status_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{status_head});
        %item = (__RULE__ => q{status_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x95']},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x95"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [status_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{status_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{status_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::status_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [status_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{status_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [status_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{status_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x95' status_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{status_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{status_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{status_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{status_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::NORMAL
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"NORMAL"};

    Parse::RecDescent::_trace(q{Trying rule: [NORMAL]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{NORMAL},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{NORMAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{NORMAL});
        %item = (__RULE__ => q{NORMAL});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{NORMAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{NORMAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{NORMAL},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{NORMAL},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{NORMAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{NORMAL},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{NORMAL},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::HT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"HT"};

    Parse::RecDescent::_trace(q{Trying rule: [HT]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{HT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x09'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x09']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{HT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{HT});
        %item = (__RULE__ => q{HT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x09']},
                      Parse::RecDescent::_tracefirst($text),
                      q{HT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x09"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x09']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{HT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{HT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{HT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{HT},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{HT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::domain_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"domain_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [domain_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{domain_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x9c'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x9c' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{domain_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{domain_parameter});
        %item = (__RULE__ => q{domain_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x9c']},
                      Parse::RecDescent::_tracefirst($text),
                      q{domain_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x9c"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{domain_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{domain_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{domain_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{domain_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x9c' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{domain_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{domain_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{domain_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{domain_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{domain_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::TEXT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"TEXT"};

    Parse::RecDescent::_trace(q{Trying rule: [TEXT]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{TEXT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_non_CTL, or LWS});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_non_CTL, or LWS]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{TEXT});
        %item = (__RULE__ => q{TEXT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [_non_CTL, or LWS]},
                  Parse::RecDescent::_tracefirst($text),
                  q{TEXT},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_TEXT, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [_non_CTL, or LWS]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{TEXT},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_TEXT]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_TEXT(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = join '', @{$item[1]};
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [_non_CTL, or LWS]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{TEXT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{TEXT},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{TEXT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::to_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"to_value"};

    Parse::RecDescent::_trace(q{Trying rule: [to_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{to_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_address_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_address_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{to_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{to_value});
        %item = (__RULE__ => q{to_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_address_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{to_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_address_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_address_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{to_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_address_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{to_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_address_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_address_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{to_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{to_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{to_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{to_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{to_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_CONTENT_NOT_ACCEPTED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_CONTENT_NOT_ACCEPTED"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_CONTENT_NOT_ACCEPTED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_CONTENT_NOT_ACCEPTED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x87'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x87']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_CONTENT_NOT_ACCEPTED});
        %item = (__RULE__ => q{ERROR_CONTENT_NOT_ACCEPTED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x87']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x87"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x87']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_CONTENT_NOT_ACCEPTED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_CONTENT_NOT_ACCEPTED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::PERSONAL
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"PERSONAL"};

    Parse::RecDescent::_trace(q{Trying rule: [PERSONAL]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{PERSONAL},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PERSONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{PERSONAL});
        %item = (__RULE__ => q{PERSONAL});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{PERSONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{PERSONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PERSONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{PERSONAL},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{PERSONAL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{PERSONAL},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{PERSONAL},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::content_type_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"content_type_value"};

    Parse::RecDescent::_trace(q{Trying rule: [content_type_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{content_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{ct_constrained_media, or content_general_form});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ct_constrained_media]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{content_type_value});
        %item = (__RULE__ => q{content_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ct_constrained_media]},
                  Parse::RecDescent::_tracefirst($text),
                  q{content_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ct_constrained_media($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ct_constrained_media]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{content_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ct_constrained_media]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ct_constrained_media}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ct_constrained_media]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [content_general_form]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{content_type_value});
        %item = (__RULE__ => q{content_type_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [content_general_form]},
                  Parse::RecDescent::_tracefirst($text),
                  q{content_type_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_general_form($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_general_form]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{content_type_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_general_form]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_general_form}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [content_general_form]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{content_type_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{content_type_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{content_type_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{content_type_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::DataFragmentPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"DataFragmentPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [DataFragmentPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{DataFragmentPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{DataFragmentPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{DataFragmentPDU});
        %item = (__RULE__ => q{DataFragmentPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{DataFragmentPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{DataFragmentPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{DataFragmentPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{DataFragmentPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{DataFragmentPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{DataFragmentPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{DataFragmentPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::max_age_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"max_age_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [max_age_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{max_age_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8e'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8e' delta_seconds_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{max_age_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{max_age_parameter});
        %item = (__RULE__ => q{max_age_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8e']},
                      Parse::RecDescent::_tracefirst($text),
                      q{max_age_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8e"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [delta_seconds_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{max_age_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{delta_seconds_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::delta_seconds_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [delta_seconds_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{max_age_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [delta_seconds_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{max_age_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{delta_seconds_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{max_age_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.3'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8e' delta_seconds_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{max_age_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{max_age_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{max_age_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{max_age_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{max_age_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_UNSPECIFIED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_UNSPECIFIED"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_UNSPECIFIED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_UNSPECIFIED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_UNSPECIFIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_UNSPECIFIED});
        %item = (__RULE__ => q{ERROR_UNSPECIFIED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_UNSPECIFIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_UNSPECIFIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_UNSPECIFIED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_UNSPECIFIED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_UNSPECIFIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_UNSPECIFIED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_UNSPECIFIED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::date_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"date_value"};

    Parse::RecDescent::_trace(q{Trying rule: [date_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{date_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{long_integer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [long_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{date_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{date_value});
        %item = (__RULE__ => q{date_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [long_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{date_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::long_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [long_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{date_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [long_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{date_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{long_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [long_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{date_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{date_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{date_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{date_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{date_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::UPALPHA
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"UPALPHA"};

    Parse::RecDescent::_trace(q{Trying rule: [UPALPHA]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{UPALPHA},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[A-Z]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[A-Z]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{UPALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{UPALPHA});
        %item = (__RULE__ => q{UPALPHA});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[A-Z]/]}, Parse::RecDescent::_tracefirst($text),
                      q{UPALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[A-Z])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[A-Z]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{UPALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{UPALPHA},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{UPALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{UPALPHA},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{UPALPHA},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{address_present_token});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [address_present_token _address_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [address_present_token]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::address_present_token($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [address_present_token]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [address_present_token]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{address_present_token}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [_address_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{_address_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_address_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_address_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_address_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_address_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [address_present_token _address_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"MMS_version_value"};

    Parse::RecDescent::_trace(q{Trying rule: [MMS_version_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{MMS_version_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_short_integer_version});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_short_integer_version]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_version_value});
        %item = (__RULE__ => q{MMS_version_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_short_integer_version]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_version_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_short_integer_version($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_short_integer_version]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_version_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_short_integer_version]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_short_integer_version}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_short_integer_version]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{MMS_version_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{MMS_version_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{MMS_version_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{MMS_version_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::SP
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"SP"};

    Parse::RecDescent::_trace(q{Trying rule: [SP]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{SP},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x20'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x20']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{SP},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{SP});
        %item = (__RULE__ => q{SP});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x20']},
                      Parse::RecDescent::_tracefirst($text),
                      q{SP},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x20"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x20']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{SP},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{SP},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{SP},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{SP},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{SP},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::TID
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"TID"};

    Parse::RecDescent::_trace(q{Trying rule: [TID]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{TID},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uint8});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uint8]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{TID},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{TID});
        %item = (__RULE__ => q{TID});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uint8]},
                  Parse::RecDescent::_tracefirst($text),
                  q{TID},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uint8($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uint8]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{TID},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uint8]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{TID},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uint8}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uint8]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{TID},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{TID},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{TID},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{TID},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{TID},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::response_text_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"response_text_head"};

    Parse::RecDescent::_trace(q{Trying rule: [response_text_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{response_text_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x93'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x93' response_text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_text_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_text_head});
        %item = (__RULE__ => q{response_text_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x93']},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_text_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x93"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [response_text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_text_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{response_text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::response_text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [response_text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_text_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [response_text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_text_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{response_text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_text_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x93' response_text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_text_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{response_text_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{response_text_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{response_text_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{response_text_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::content_location_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"content_location_value"};

    Parse::RecDescent::_trace(q{Trying rule: [content_location_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{content_location_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uri_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uri_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{content_location_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{content_location_value});
        %item = (__RULE__ => q{content_location_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uri_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{content_location_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uri_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uri_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{content_location_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uri_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{content_location_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uri_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uri_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_location_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{content_location_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{content_location_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{content_location_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{content_location_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::size_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"size_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [size_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{size_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x96'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x96' integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{size_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{size_parameter});
        %item = (__RULE__ => q{size_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x96']},
                      Parse::RecDescent::_tracefirst($text),
                      q{size_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x96"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{size_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{integer_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{size_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{size_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{size_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x96' integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{size_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{size_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{size_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{size_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{size_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::text_string
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"text_string"};

    Parse::RecDescent::_trace(q{Trying rule: [text_string]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{text_string},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{quote});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [quote TEXT end_of_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{text_string});
        %item = (__RULE__ => q{text_string});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [quote]},
                  Parse::RecDescent::_tracefirst($text),
                  q{text_string},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::quote, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [quote]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{text_string},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [quote]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{quote(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying repeated subrule: [TEXT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{text_string},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{TEXT})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::TEXT, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [TEXT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{text_string},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [TEXT]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{TEXT(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [end_of_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{text_string},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{end_of_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::end_of_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [end_of_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{text_string},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [end_of_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{end_of_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = scalar @{$item[2]} ? $item[2][0] : '';
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [quote TEXT end_of_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{text_string},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{text_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{text_string},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{text_string},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::status_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"status_value"};

    Parse::RecDescent::_trace(q{Trying rule: [status_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{EXPIRED, or RETRIEVED, or REJECTED, or DEFERRED, or UNRECOGNISED});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [EXPIRED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{status_value});
        %item = (__RULE__ => q{status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [EXPIRED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::EXPIRED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [EXPIRED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [EXPIRED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{EXPIRED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [EXPIRED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [RETRIEVED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{status_value});
        %item = (__RULE__ => q{status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [RETRIEVED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::RETRIEVED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [RETRIEVED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [RETRIEVED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{RETRIEVED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [RETRIEVED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [REJECTED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{status_value});
        %item = (__RULE__ => q{status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [REJECTED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::REJECTED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [REJECTED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [REJECTED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{REJECTED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [REJECTED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [DEFERRED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{status_value});
        %item = (__RULE__ => q{status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [DEFERRED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::DEFERRED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [DEFERRED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [DEFERRED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{DEFERRED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [DEFERRED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [UNRECOGNISED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{status_value});
        %item = (__RULE__ => q{status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [UNRECOGNISED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::UNRECOGNISED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [UNRECOGNISED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [UNRECOGNISED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{UNRECOGNISED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [UNRECOGNISED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{status_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{status_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{status_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::CHAR
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"CHAR"};

    Parse::RecDescent::_trace(q{Trying rule: [CHAR]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{CHAR},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x00-\\x7F]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x00-\\x7F]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{CHAR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{CHAR});
        %item = (__RULE__ => q{CHAR});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x00-\\x7F]/]}, Parse::RecDescent::_tracefirst($text),
                      q{CHAR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x00-\x7F])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x00-\\x7F]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{CHAR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{CHAR},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{CHAR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{CHAR},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{CHAR},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::length_
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"length_"};

    Parse::RecDescent::_trace(q{Trying rule: [length_]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{length_},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uintvar});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uintvar]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{length_},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{length_});
        %item = (__RULE__ => q{length_});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uintvar]},
                  Parse::RecDescent::_tracefirst($text),
                  q{length_},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uintvar($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uintvar]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{length_},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uintvar]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{length_},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uintvar}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uintvar]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{length_},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{length_},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{length_},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{length_},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{length_},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::filename_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"filename_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [filename_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{filename_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x98'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x98' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{filename_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{filename_parameter});
        %item = (__RULE__ => q{filename_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x98']},
                      Parse::RecDescent::_tracefirst($text),
                      q{filename_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x98"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{filename_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{filename_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{filename_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{filename_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x98' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{filename_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{filename_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{filename_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{filename_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{filename_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::type_related_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type_related_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [type_related_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{type_related_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x89'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x89' constrained_encoding]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{type_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_related_parameter});
        %item = (__RULE__ => q{type_related_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x89']},
                      Parse::RecDescent::_tracefirst($text),
                      q{type_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x89"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [constrained_encoding]},
                  Parse::RecDescent::_tracefirst($text),
                  q{type_related_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{constrained_encoding})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::constrained_encoding($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [constrained_encoding]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{type_related_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [constrained_encoding]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{type_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{constrained_encoding}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{type_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.2'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x89' constrained_encoding]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{type_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{type_related_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{type_related_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type_related_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{type_related_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Put_PostPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Put_PostPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Put_PostPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Put_PostPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x61'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x61']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Put_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Put_PostPDU});
        %item = (__RULE__ => q{Put_PostPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x61']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Put_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x61"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Put_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x61']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Put_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Put_PostPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Put_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Put_PostPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Put_PostPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::uint8
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"uint8"};

    Parse::RecDescent::_trace(q{Trying rule: [uint8]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{uint8},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{OCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [OCTET]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uint8},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{uint8});
        %item = (__RULE__ => q{uint8});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [OCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uint8},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::OCTET($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [OCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uint8},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [OCTET]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{uint8},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{OCTET}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{uint8},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = unpack 'C', $item[1]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [OCTET]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uint8},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{uint8},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{uint8},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{uint8},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{uint8},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::modification_date_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"modification_date_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [modification_date_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{modification_date_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x94'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x94' date_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{modification_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{modification_date_parameter});
        %item = (__RULE__ => q{modification_date_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x94']},
                      Parse::RecDescent::_tracefirst($text),
                      q{modification_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x94"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [date_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{modification_date_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{date_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::date_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [date_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{modification_date_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [date_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{modification_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{date_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{modification_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x94' date_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{modification_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{modification_date_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{modification_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{modification_date_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{modification_date_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ExtendedMethod_GetPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ExtendedMethod_GetPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [ExtendedMethod_GetPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ExtendedMethod_GetPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x50-\\x5f]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x50-\\x5f]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ExtendedMethod_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ExtendedMethod_GetPDU});
        %item = (__RULE__ => q{ExtendedMethod_GetPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x50-\\x5f]/]}, Parse::RecDescent::_tracefirst($text),
                      q{ExtendedMethod_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x50-\x5f])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ExtendedMethod_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x50-\\x5f]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ExtendedMethod_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ExtendedMethod_GetPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ExtendedMethod_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ExtendedMethod_GetPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ExtendedMethod_GetPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_send_req
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_send_req"};

    Parse::RecDescent::_trace(q{Trying rule: [m_send_req]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_send_req},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_send_req},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_send_req});
        %item = (__RULE__ => q{m_send_req});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_send_req},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_send_req},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_send_req},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_send_req},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_send_req},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_send_req},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_send_req},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_UNSUPPORTED_MESSAGE
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_UNSUPPORTED_MESSAGE"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_UNSUPPORTED_MESSAGE]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_UNSUPPORTED_MESSAGE},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x88'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x88']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_UNSUPPORTED_MESSAGE});
        %item = (__RULE__ => q{ERROR_UNSUPPORTED_MESSAGE});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x88']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x88"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x88']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_UNSUPPORTED_MESSAGE},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_UNSUPPORTED_MESSAGE},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_SERVICE_DENIED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_SERVICE_DENIED"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_SERVICE_DENIED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_SERVICE_DENIED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_SERVICE_DENIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_SERVICE_DENIED});
        %item = (__RULE__ => q{ERROR_SERVICE_DENIED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_SERVICE_DENIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_SERVICE_DENIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_SERVICE_DENIED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_SERVICE_DENIED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_SERVICE_DENIED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_SERVICE_DENIED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_SERVICE_DENIED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::path_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"path_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [path_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{path_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x9d'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x9d' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{path_parameter});
        %item = (__RULE__ => q{path_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x9d']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x9d"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x9d' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{path_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{path_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{path_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{path_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::any_charset
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"any_charset"};

    Parse::RecDescent::_trace(q{Trying rule: [any_charset]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{any_charset},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{any_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{any_charset});
        %item = (__RULE__ => q{any_charset});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{any_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{any_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = '*'; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{any_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{any_charset},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{any_charset},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{any_charset},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{any_charset},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::response_text_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"response_text_value"};

    Parse::RecDescent::_trace(q{Trying rule: [response_text_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{response_text_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{encoded_string_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [encoded_string_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_text_value});
        %item = (__RULE__ => q{response_text_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [encoded_string_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_text_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::encoded_string_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [encoded_string_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_text_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [encoded_string_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{encoded_string_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [encoded_string_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{response_text_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{response_text_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{response_text_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{response_text_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::YES
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"YES"};

    Parse::RecDescent::_trace(q{Trying rule: [YES]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{YES},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{YES},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{YES});
        %item = (__RULE__ => q{YES});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{YES},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{YES},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{YES},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{YES},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{YES},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{YES},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{YES},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::multipart_headers_len
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multipart_headers_len"};

    Parse::RecDescent::_trace(q{Trying rule: [multipart_headers_len]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{multipart_headers_len},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uintvar});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uintvar]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{multipart_headers_len},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multipart_headers_len});
        %item = (__RULE__ => q{multipart_headers_len});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uintvar]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart_headers_len},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uintvar($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uintvar]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart_headers_len},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uintvar]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_headers_len},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uintvar}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uintvar]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_headers_len},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{multipart_headers_len},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{multipart_headers_len},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multipart_headers_len},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{multipart_headers_len},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ALPHA
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ALPHA"};

    Parse::RecDescent::_trace(q{Trying rule: [ALPHA]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ALPHA},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[a-zA-Z]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[a-zA-Z]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ALPHA});
        %item = (__RULE__ => q{ALPHA});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[a-zA-Z]/]}, Parse::RecDescent::_tracefirst($text),
                      q{ALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[a-zA-Z])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[a-zA-Z]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ALPHA},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ALPHA},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ALPHA},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::LF
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"LF"};

    Parse::RecDescent::_trace(q{Trying rule: [LF]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{LF},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x0A'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x0A']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{LF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{LF});
        %item = (__RULE__ => q{LF});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x0A']},
                      Parse::RecDescent::_tracefirst($text),
                      q{LF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x0A"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x0A']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{LF},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{LF},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{LF},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{LF},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{LF},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::short_integer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"short_integer"};

    Parse::RecDescent::_trace(q{Trying rule: [short_integer]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{short_integer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{HIGHOCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HIGHOCTET]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{short_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{short_integer});
        %item = (__RULE__ => q{short_integer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [HIGHOCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{short_integer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::HIGHOCTET($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [HIGHOCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{short_integer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [HIGHOCTET]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{short_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HIGHOCTET}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{short_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = ord($item{HIGHOCTET}) & 0x7F; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [HIGHOCTET]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{short_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{short_integer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{short_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{short_integer},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{short_integer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::MAC_wbxml_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"MAC_wbxml_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [MAC_wbxml_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{MAC_wbxml_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x92'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x92' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MAC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{MAC_wbxml_parameter});
        %item = (__RULE__ => q{MAC_wbxml_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x92']},
                      Parse::RecDescent::_tracefirst($text),
                      q{MAC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x92"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MAC_wbxml_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MAC_wbxml_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MAC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{MAC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x92' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MAC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{MAC_wbxml_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{MAC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{MAC_wbxml_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{MAC_wbxml_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::UNRECOGNISED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"UNRECOGNISED"};

    Parse::RecDescent::_trace(q{Trying rule: [UNRECOGNISED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{UNRECOGNISED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x84'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x84']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{UNRECOGNISED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{UNRECOGNISED});
        %item = (__RULE__ => q{UNRECOGNISED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x84']},
                      Parse::RecDescent::_tracefirst($text),
                      q{UNRECOGNISED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x84"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{UNRECOGNISED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x84']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{UNRECOGNISED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{UNRECOGNISED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{UNRECOGNISED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{UNRECOGNISED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{UNRECOGNISED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::DIGIT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"DIGIT"};

    Parse::RecDescent::_trace(q{Trying rule: [DIGIT]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{DIGIT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/\\d/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/\\d/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{DIGIT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{DIGIT});
        %item = (__RULE__ => q{DIGIT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/\\d/]}, Parse::RecDescent::_tracefirst($text),
                      q{DIGIT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:\d)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/\\d/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{DIGIT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{DIGIT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{DIGIT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{DIGIT},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{DIGIT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_SENDING_ADDRESS_UNRESOLVED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_SENDING_ADDRESS_UNRESOLVED"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_SENDING_ADDRESS_UNRESOLVED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x84'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x84']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_SENDING_ADDRESS_UNRESOLVED});
        %item = (__RULE__ => q{ERROR_SENDING_ADDRESS_UNRESOLVED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x84']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x84"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x84']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_SENDING_ADDRESS_UNRESOLVED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::content_location_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"content_location_head"};

    Parse::RecDescent::_trace(q{Trying rule: [content_location_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{content_location_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x83'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x83' content_location_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{content_location_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{content_location_head});
        %item = (__RULE__ => q{content_location_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x83']},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_location_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x83"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [content_location_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{content_location_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{content_location_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_location_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_location_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{content_location_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_location_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{content_location_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_location_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_location_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x83' content_location_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_location_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{content_location_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{content_location_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{content_location_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{content_location_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_MESSAGE_NOT_FOUND
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_MESSAGE_NOT_FOUND"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_MESSAGE_NOT_FOUND]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_MESSAGE_NOT_FOUND},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x85'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x85']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_MESSAGE_NOT_FOUND});
        %item = (__RULE__ => q{ERROR_MESSAGE_NOT_FOUND});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x85']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x85"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x85']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_MESSAGE_NOT_FOUND},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_MESSAGE_NOT_FOUND},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::q_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"q_value"};

    Parse::RecDescent::_trace(q{Trying rule: [q_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{q_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{HIGHOCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HIGHOCTET CHAR]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{q_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{q_value});
        %item = (__RULE__ => q{q_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [HIGHOCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{q_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::HIGHOCTET, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [HIGHOCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{q_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [HIGHOCTET]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{q_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HIGHOCTET(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [CHAR]},
                  Parse::RecDescent::_tracefirst($text),
                  q{q_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{CHAR})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::CHAR($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [CHAR]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{q_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [CHAR]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{q_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CHAR}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{q_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $value = 0;
   $value = (ord($item[1][0]) & 0x7F) << 7 if scalar @{$item[1]};
   $value |= ord($item[2]);
   if ($value <= 100) {
      $return = ($value - 1) / 100;
   }
   else {
      $return = ($value - 100) / 1000;
   }
   if ($return >= 1) {
      $return = undef;
   }
   else {
      1;
   }
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [HIGHOCTET CHAR]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{q_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{q_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{q_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{q_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{q_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::secure_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"secure_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [secure_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{secure_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x90'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x90' no_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{secure_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{secure_parameter});
        %item = (__RULE__ => q{secure_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x90']},
                      Parse::RecDescent::_tracefirst($text),
                      q{secure_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x90"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [no_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{secure_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{no_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::no_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [no_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{secure_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [no_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{secure_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{no_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{secure_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.3'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x90' no_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{secure_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{secure_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{secure_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{secure_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{secure_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::HIGHOCTET
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"HIGHOCTET"};

    Parse::RecDescent::_trace(q{Trying rule: [HIGHOCTET]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{HIGHOCTET},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x80-\\xFF]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x80-\\xFF]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{HIGHOCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{HIGHOCTET});
        %item = (__RULE__ => q{HIGHOCTET});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x80-\\xFF]/]}, Parse::RecDescent::_tracefirst($text),
                      q{HIGHOCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x80-\xFF])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x80-\\xFF]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIGHOCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{HIGHOCTET},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{HIGHOCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{HIGHOCTET},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{HIGHOCTET},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::extension_media
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"extension_media"};

    Parse::RecDescent::_trace(q{Trying rule: [extension_media]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{extension_media},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{TEXT});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [TEXT end_of_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{extension_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{extension_media});
        %item = (__RULE__ => q{extension_media});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [TEXT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{extension_media},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::TEXT, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [TEXT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{extension_media},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [TEXT]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{extension_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{TEXT(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [end_of_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{extension_media},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{end_of_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::end_of_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [end_of_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{extension_media},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [end_of_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{extension_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{end_of_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{extension_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = scalar @{$item[1]} ? $item[1][0] : '';
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [TEXT end_of_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{extension_media},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{extension_media},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{extension_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{extension_media},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{extension_media},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::relative_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"relative_token"};

    Parse::RecDescent::_trace(q{Trying rule: [relative_token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{relative_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{relative_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{relative_token});
        %item = (__RULE__ => q{relative_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{relative_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{relative_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = 'relative'; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{relative_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{relative_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{relative_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{relative_token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{relative_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::no_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"no_value"};

    Parse::RecDescent::_trace(q{Trying rule: [no_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{no_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x00'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x00']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{no_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{no_value});
        %item = (__RULE__ => q{no_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x00']},
                      Parse::RecDescent::_tracefirst($text),
                      q{no_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x00"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{no_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = ''; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x00']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{no_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{no_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{no_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{no_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{no_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Redirect
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Redirect"};

    Parse::RecDescent::_trace(q{Trying rule: [Redirect]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Redirect},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x03'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x03']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Redirect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Redirect});
        %item = (__RULE__ => q{Redirect});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x03']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Redirect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x03"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Redirect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x03']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Redirect},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Redirect},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Redirect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Redirect},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Redirect},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::insert_address_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"insert_address_token"};

    Parse::RecDescent::_trace(q{Trying rule: [insert_address_token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{insert_address_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{insert_address_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{insert_address_token});
        %item = (__RULE__ => q{insert_address_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{insert_address_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{insert_address_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = 'insert-address'; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{insert_address_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{insert_address_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{insert_address_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{insert_address_token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{insert_address_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::application_specific_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"application_specific_value"};

    Parse::RecDescent::_trace(q{Trying rule: [application_specific_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{application_specific_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{text_string});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{application_specific_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{application_specific_value});
        %item = (__RULE__ => q{application_specific_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{application_specific_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{application_specific_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{application_specific_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{application_specific_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{application_specific_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{application_specific_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{application_specific_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{application_specific_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_token"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{CTL});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [CTL separator CHAR]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_token});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [CTL]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        $_savetext = $text;if (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::CTL($thisparser,$text,$repeating,1,sub { \@arg },undef)))
        {
            $text = $_savetext;
            Parse::RecDescent::_trace(q{<<...!Matched(reject) subrule: [CTL]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>...!Didn't match(keep) subrule: [CTL]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CTL}} = $_tok;
        push @item, $_tok;
        $text = $_savetext;
        }

        Parse::RecDescent::_trace(q{Trying subrule: [separator]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{separator})->at($text);
        $_savetext = $text;if (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::separator($thisparser,$text,$repeating,1,sub { \@arg },undef)))
        {
            $text = $_savetext;
            Parse::RecDescent::_trace(q{<<...!Matched(reject) subrule: [separator]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>...!Didn't match(keep) subrule: [separator]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{separator}} = $_tok;
        push @item, $_tok;
        $text = $_savetext;
        }

        Parse::RecDescent::_trace(q{Trying subrule: [CHAR]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{CHAR})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::CHAR($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [CHAR]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [CHAR]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CHAR}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [CTL separator CHAR]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::uint16
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"uint16"};

    Parse::RecDescent::_trace(q{Trying rule: [uint16]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{uint16},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{OCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [OCTET]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uint16},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{uint16});
        %item = (__RULE__ => q{uint16});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [OCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uint16},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::OCTET, 2, 2, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [OCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uint16},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [OCTET]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{uint16},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{OCTET(2)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{uint16},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = unpack 'n', join '', @{$item[1]}; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [OCTET]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uint16},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{uint16},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{uint16},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{uint16},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{uint16},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_non_CTL
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_non_CTL"};

    Parse::RecDescent::_trace(q{Trying rule: [_non_CTL]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_non_CTL},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[^\\x00-\\x1F\\x7F]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[^\\x00-\\x1F\\x7F]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_non_CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_non_CTL});
        %item = (__RULE__ => q{_non_CTL});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[^\\x00-\\x1F\\x7F]/]}, Parse::RecDescent::_tracefirst($text),
                      q{_non_CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[^\x00-\x1F\x7F])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[^\\x00-\\x1F\\x7F]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_non_CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_non_CTL},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_non_CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_non_CTL},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_non_CTL},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::MMS_MESSAGE
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"MMS_MESSAGE"};

    Parse::RecDescent::_trace(q{Trying rule: [MMS_MESSAGE]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{MMS_MESSAGE},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{M_Retrieve_Conf_message});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [M_Retrieve_Conf_message]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{MMS_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{MMS_MESSAGE});
        %item = (__RULE__ => q{MMS_MESSAGE});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [M_Retrieve_Conf_message]},
                  Parse::RecDescent::_tracefirst($text),
                  q{MMS_MESSAGE},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::M_Retrieve_Conf_message($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [M_Retrieve_Conf_message]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{MMS_MESSAGE},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [M_Retrieve_Conf_message]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{M_Retrieve_Conf_message}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = $item[1];
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [M_Retrieve_Conf_message]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{MMS_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{MMS_MESSAGE},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{MMS_MESSAGE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{MMS_MESSAGE},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{MMS_MESSAGE},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::HEADERS
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"HEADERS"};

    Parse::RecDescent::_trace(q{Trying rule: [HEADERS]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{HEADERS},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{message_type_head});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_type_head transaction_id_head MMS_version_head header content_type_head]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{HEADERS});
        %item = (__RULE__ => q{HEADERS});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_type_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{HEADERS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{HEADERS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [transaction_id_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{HEADERS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{transaction_id_head})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_head, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [transaction_id_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{HEADERS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [transaction_id_head]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{transaction_id_head(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [MMS_version_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{HEADERS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{MMS_version_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_version_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{HEADERS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_version_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_version_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{HEADERS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{header})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::header, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{HEADERS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [header]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{header(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [content_type_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{HEADERS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{content_type_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_type_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_type_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{HEADERS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_type_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_type_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my %headers;
   foreach my $header (@item[1,2,3,5], @{$item[4]}) {
      my ($name, $value) = @$header;
      $headers{$name} = $value;
   }
   $return = \%headers;
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [message_type_head transaction_id_head MMS_version_head header content_type_head]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{HEADERS},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{HEADERS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{HEADERS},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{HEADERS},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_short_integer_version
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_short_integer_version"};

    Parse::RecDescent::_trace(q{Trying rule: [_short_integer_version]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_short_integer_version},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{short_integer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [short_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_short_integer_version},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_short_integer_version});
        %item = (__RULE__ => q{_short_integer_version});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [short_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_short_integer_version},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_short_integer_version},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_short_integer_version},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_short_integer_version},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $version = $item{short_integer};
   $return = ($version >> 4) & 0x07;
   my $minor = $version & 0x0F;
   $return .= ".$minor" if $minor < 15;
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [short_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_short_integer_version},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_short_integer_version},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_short_integer_version},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_short_integer_version},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_short_integer_version},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_NETWORK_PROBLEM
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_NETWORK_PROBLEM"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_NETWORK_PROBLEM]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_NETWORK_PROBLEM},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x86'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x86']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_NETWORK_PROBLEM},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_NETWORK_PROBLEM});
        %item = (__RULE__ => q{ERROR_NETWORK_PROBLEM});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x86']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_NETWORK_PROBLEM},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x86"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_NETWORK_PROBLEM},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x86']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_NETWORK_PROBLEM},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_NETWORK_PROBLEM},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_NETWORK_PROBLEM},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_NETWORK_PROBLEM},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_NETWORK_PROBLEM},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::CTL
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"CTL"};

    Parse::RecDescent::_trace(q{Trying rule: [CTL]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{CTL},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x00-\\x1F\\x7F]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x00-\\x1F\\x7F]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{CTL});
        %item = (__RULE__ => q{CTL});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x00-\\x1F\\x7F]/]}, Parse::RecDescent::_tracefirst($text),
                      q{CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x00-\x1F\x7F])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x00-\\x1F\\x7F]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{CTL},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{CTL},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{CTL},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{CTL},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::well_known_media
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"well_known_media"};

    Parse::RecDescent::_trace(q{Trying rule: [well_known_media]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{well_known_media},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{integer_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{well_known_media});
        %item = (__RULE__ => q{well_known_media});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{well_known_media},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{well_known_media},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{well_known_media},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{well_known_media},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{well_known_media},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{well_known_media},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Unassigned
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Unassigned"};

    Parse::RecDescent::_trace(q{Trying rule: [Unassigned]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Unassigned},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x10-\\x3f]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x10-\\x3f]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Unassigned},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Unassigned});
        %item = (__RULE__ => q{Unassigned});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x10-\\x3f]/]}, Parse::RecDescent::_tracefirst($text),
                      q{Unassigned},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x10-\x3f])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Unassigned},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x10-\\x3f]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Unassigned},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Unassigned},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Unassigned},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Unassigned},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Unassigned},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_size_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_size_value"};

    Parse::RecDescent::_trace(q{Trying rule: [message_size_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_size_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{long_integer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [long_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_size_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_size_value});
        %item = (__RULE__ => q{message_size_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [long_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_size_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::long_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [long_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_size_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [long_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_size_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{long_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [long_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_size_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_size_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_size_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_size_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_size_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::quote
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"quote"};

    Parse::RecDescent::_trace(q{Trying rule: [quote]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{quote},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x7F'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x7F']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{quote},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{quote});
        %item = (__RULE__ => q{quote});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x7F']},
                      Parse::RecDescent::_tracefirst($text),
                      q{quote},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x7F"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x7F']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{quote},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{quote},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{quote},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{quote},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{quote},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::content_general_form
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"content_general_form"};

    Parse::RecDescent::_trace(q{Trying rule: [content_general_form]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{content_general_form},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value_length});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value_length]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{content_general_form},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{content_general_form});
        %item = (__RULE__ => q{content_general_form});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{content_general_form},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::value_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{content_general_form},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{content_general_form},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_general_form},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $len = $item[1];
   if ($len <= length $text) {
      my $ctdata = substr $text, 0, $len;
      $text = substr $text, $len;
      $return = $thisparser->_media_type($ctdata);
      defined($return)|| undef;
   }
   else { undef }
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value_length]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{content_general_form},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{content_general_form},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{content_general_form},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{content_general_form},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{content_general_form},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::response_status_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"response_status_value"};

    Parse::RecDescent::_trace(q{Trying rule: [response_status_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{OK, or ERROR_UNSPECIFIED, or ERROR_SERVICE_DENIED, or ERROR_MESSAGE_FORMAT_CORRUPT, or ERROR_SENDING_ADDRESS_UNRESOLVED, or ERROR_MESSAGE_NOT_FOUND, or ERROR_NETWORK_PROBLEM, or ERROR_CONTENT_NOT_ACCEPTED, or ERROR_UNSUPPORTED_MESSAGE});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [OK]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [OK]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::OK($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [OK]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [OK]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{OK}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [OK]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_UNSPECIFIED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_UNSPECIFIED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_UNSPECIFIED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_UNSPECIFIED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_UNSPECIFIED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_UNSPECIFIED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_UNSPECIFIED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_SERVICE_DENIED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_SERVICE_DENIED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_SERVICE_DENIED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_SERVICE_DENIED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_SERVICE_DENIED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_SERVICE_DENIED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_SERVICE_DENIED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_MESSAGE_FORMAT_CORRUPT]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_MESSAGE_FORMAT_CORRUPT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_MESSAGE_FORMAT_CORRUPT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_MESSAGE_FORMAT_CORRUPT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_MESSAGE_FORMAT_CORRUPT]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_MESSAGE_FORMAT_CORRUPT}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_MESSAGE_FORMAT_CORRUPT]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_SENDING_ADDRESS_UNRESOLVED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_SENDING_ADDRESS_UNRESOLVED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_SENDING_ADDRESS_UNRESOLVED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_SENDING_ADDRESS_UNRESOLVED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_SENDING_ADDRESS_UNRESOLVED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_SENDING_ADDRESS_UNRESOLVED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_SENDING_ADDRESS_UNRESOLVED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_MESSAGE_NOT_FOUND]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_MESSAGE_NOT_FOUND]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_MESSAGE_NOT_FOUND($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_MESSAGE_NOT_FOUND]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_MESSAGE_NOT_FOUND]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_MESSAGE_NOT_FOUND}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_MESSAGE_NOT_FOUND]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_NETWORK_PROBLEM]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_NETWORK_PROBLEM]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_NETWORK_PROBLEM($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_NETWORK_PROBLEM]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_NETWORK_PROBLEM]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_NETWORK_PROBLEM}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_NETWORK_PROBLEM]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_CONTENT_NOT_ACCEPTED]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_CONTENT_NOT_ACCEPTED]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_CONTENT_NOT_ACCEPTED($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_CONTENT_NOT_ACCEPTED]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_CONTENT_NOT_ACCEPTED]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_CONTENT_NOT_ACCEPTED}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_CONTENT_NOT_ACCEPTED]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ERROR_UNSUPPORTED_MESSAGE]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{response_status_value});
        %item = (__RULE__ => q{response_status_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ERROR_UNSUPPORTED_MESSAGE]},
                  Parse::RecDescent::_tracefirst($text),
                  q{response_status_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_UNSUPPORTED_MESSAGE($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ERROR_UNSUPPORTED_MESSAGE]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{response_status_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ERROR_UNSUPPORTED_MESSAGE]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ERROR_UNSUPPORTED_MESSAGE}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ERROR_UNSUPPORTED_MESSAGE]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{response_status_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{response_status_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{response_status_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{response_status_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::report_allowed_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"report_allowed_head"};

    Parse::RecDescent::_trace(q{Trying rule: [report_allowed_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{report_allowed_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x91'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x91' report_allowed_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{report_allowed_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{report_allowed_head});
        %item = (__RULE__ => q{report_allowed_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x91']},
                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x91"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [report_allowed_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{report_allowed_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{report_allowed_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::report_allowed_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [report_allowed_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{report_allowed_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [report_allowed_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{report_allowed_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x91' report_allowed_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{report_allowed_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{report_allowed_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{report_allowed_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{report_allowed_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::HIDE
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"HIDE"};

    Parse::RecDescent::_trace(q{Trying rule: [HIDE]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{HIDE},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{HIDE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{HIDE});
        %item = (__RULE__ => q{HIDE});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIDE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIDE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIDE},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{HIDE},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{HIDE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{HIDE},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{HIDE},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::HIGH
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"HIGH"};

    Parse::RecDescent::_trace(q{Trying rule: [HIGH]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{HIGH},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{HIGH},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{HIGH});
        %item = (__RULE__ => q{HIGH});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIGH},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIGH},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{HIGH},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{HIGH},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{HIGH},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{HIGH},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{HIGH},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::multipart
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multipart"};

    Parse::RecDescent::_trace(q{Trying rule: [multipart]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{multipart},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{multipart_header});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [multipart_header multipart_entry]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{multipart},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multipart});
        %item = (__RULE__ => q{multipart});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [multipart_header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::multipart_header($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [multipart_header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [multipart_header]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multipart_header}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [multipart_entry]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{multipart_entry})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::multipart_entry, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [multipart_entry]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [multipart_entry]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multipart_entry(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{>>Matched production: [multipart_header multipart_entry]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{multipart},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{multipart},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multipart},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{multipart},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::filename_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"filename_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [filename_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{filename_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x86'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x86' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{filename_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{filename_deprecated_parameter});
        %item = (__RULE__ => q{filename_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x86']},
                      Parse::RecDescent::_tracefirst($text),
                      q{filename_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x86"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{filename_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{filename_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{filename_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{filename_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x86' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{filename_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{filename_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{filename_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{filename_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{filename_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Disconnect
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Disconnect"};

    Parse::RecDescent::_trace(q{Trying rule: [Disconnect]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Disconnect},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x05'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x05']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Disconnect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Disconnect});
        %item = (__RULE__ => q{Disconnect});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x05']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Disconnect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x05"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Disconnect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x05']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Disconnect},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Disconnect},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Disconnect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Disconnect},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Disconnect},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::OK
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"OK"};

    Parse::RecDescent::_trace(q{Trying rule: [OK]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{OK},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{OK},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{OK});
        %item = (__RULE__ => q{OK});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{OK},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{OK},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{OK},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{OK},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{OK},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{OK},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{OK},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::uintvar
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"uintvar"};

    Parse::RecDescent::_trace(q{Trying rule: [uintvar]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{uintvar},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{HIGHOCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HIGHOCTET CHAR]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uintvar},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{uintvar});
        %item = (__RULE__ => q{uintvar});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [HIGHOCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uintvar},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::HIGHOCTET, 0, 4, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [HIGHOCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uintvar},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [HIGHOCTET]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{uintvar},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HIGHOCTET(0..4)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [CHAR]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uintvar},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{CHAR})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::CHAR($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [CHAR]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uintvar},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [CHAR]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{uintvar},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{CHAR}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{uintvar},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = 0;
   foreach my $high ( @{$item[1]} ) {
      $return |= ord($high) & 0x7F;
      $return <<= 7;
   }
   $return |= ord($item{CHAR});
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [HIGHOCTET CHAR]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uintvar},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{uintvar},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{uintvar},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{uintvar},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{uintvar},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::CR
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"CR"};

    Parse::RecDescent::_trace(q{Trying rule: [CR]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{CR},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x0D'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x0D']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{CR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{CR});
        %item = (__RULE__ => q{CR});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x0D']},
                      Parse::RecDescent::_tracefirst($text),
                      q{CR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x0D"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x0D']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{CR},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{CR},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{CR},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{CR},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{CR},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::short_length
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"short_length"};

    Parse::RecDescent::_trace(q{Trying rule: [short_length]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{short_length},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{uint8});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uint8]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{short_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{short_length});
        %item = (__RULE__ => q{short_length});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uint8]},
                  Parse::RecDescent::_tracefirst($text),
                  q{short_length},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uint8($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uint8]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{short_length},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uint8]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{short_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uint8}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{short_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   if ($item[1] <= 30) {
      $return = $item[1];
      1;
   }
   else { undef } # Reject
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [uint8]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{short_length},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{short_length},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{short_length},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{short_length},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{short_length},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::cc_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"cc_head"};

    Parse::RecDescent::_trace(q{Trying rule: [cc_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{cc_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82' cc_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{cc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{cc_head});
        %item = (__RULE__ => q{cc_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{cc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [cc_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{cc_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{cc_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::cc_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [cc_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{cc_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [cc_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{cc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{cc_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{cc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82' cc_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{cc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{cc_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{cc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{cc_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{cc_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::encoded_string_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"encoded_string_value"};

    Parse::RecDescent::_trace(q{Trying rule: [encoded_string_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{encoded_string_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_charset_part});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_charset_part text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{encoded_string_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{encoded_string_value});
        %item = (__RULE__ => q{encoded_string_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [_charset_part]},
                  Parse::RecDescent::_tracefirst($text),
                  q{encoded_string_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::_charset_part, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [_charset_part]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{encoded_string_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [_charset_part]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{encoded_string_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_charset_part(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{encoded_string_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{encoded_string_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{encoded_string_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{encoded_string_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = { text => $item{text_string} };
   if (scalar @{$item[1]} > 0) {
      $return->{charset} = $item[1][0];
   }
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [_charset_part text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{encoded_string_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{encoded_string_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{encoded_string_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{encoded_string_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{encoded_string_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::name_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"name_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [name_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{name_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x85'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x85' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{name_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{name_deprecated_parameter});
        %item = (__RULE__ => q{name_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x85']},
                      Parse::RecDescent::_tracefirst($text),
                      q{name_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x85"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{name_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{name_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{name_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{name_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x85' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{name_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{name_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{name_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{name_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{name_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::expiry_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"expiry_head"};

    Parse::RecDescent::_trace(q{Trying rule: [expiry_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{expiry_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x88'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x88' expiry_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{expiry_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{expiry_head});
        %item = (__RULE__ => q{expiry_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x88']},
                      Parse::RecDescent::_tracefirst($text),
                      q{expiry_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x88"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [expiry_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{expiry_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{expiry_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::expiry_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [expiry_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{expiry_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [expiry_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{expiry_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{expiry_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{expiry_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x88' expiry_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{expiry_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{expiry_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{expiry_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{expiry_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{expiry_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::length_quote
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"length_quote"};

    Parse::RecDescent::_trace(q{Trying rule: [length_quote]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{length_quote},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x1F'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x1F']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{length_quote},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{length_quote});
        %item = (__RULE__ => q{length_quote});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x1F']},
                      Parse::RecDescent::_tracefirst($text),
                      q{length_quote},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x1F"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x1F']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{length_quote},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{length_quote},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{length_quote},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{length_quote},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{length_quote},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{typed_parameter, or untyped_parameter});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [typed_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{parameter});
        %item = (__RULE__ => q{parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [typed_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::typed_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [typed_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [typed_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{typed_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [typed_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [untyped_parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{parameter});
        %item = (__RULE__ => q{parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [untyped_parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::untyped_parameter($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [untyped_parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [untyped_parameter]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{untyped_parameter}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [untyped_parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_notification_ind
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_notification_ind"};

    Parse::RecDescent::_trace(q{Trying rule: [m_notification_ind]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_notification_ind},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_notification_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_notification_ind});
        %item = (__RULE__ => q{m_notification_ind});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_notification_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_notification_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_notification_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_notification_ind},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_notification_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_notification_ind},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_notification_ind},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::bcc_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"bcc_head"};

    Parse::RecDescent::_trace(q{Trying rule: [bcc_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{bcc_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81' bcc_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{bcc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{bcc_head});
        %item = (__RULE__ => q{bcc_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{bcc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [bcc_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{bcc_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{bcc_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::bcc_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [bcc_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{bcc_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [bcc_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{bcc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{bcc_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{bcc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81' bcc_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{bcc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{bcc_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{bcc_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{bcc_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{bcc_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_charset_part
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_charset_part"};

    Parse::RecDescent::_trace(q{Trying rule: [_charset_part]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_charset_part},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value_length});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value_length]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_charset_part},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_charset_part});
        %item = (__RULE__ => q{_charset_part});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_charset_part},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::value_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_charset_part},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_charset_part},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_charset_part},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $len = $item[1];
   if ($len > 0 && $len <= length $text) {
      $return = substr $text, 0, $len;
      $text = substr $text, $len;
   }
   else { undef }
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value_length]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_charset_part},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_charset_part},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_charset_part},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_charset_part},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_charset_part},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::PDU_type
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"PDU_type"};

    Parse::RecDescent::_trace(q{Trying rule: [PDU_type]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{Reserved, or Connect, or ConnectReply, or Redirect, or Reply, or Disconnect, or Push, or ConfirmedPush, or Suspend, or Resume, or Unassigned, or Get, or Options_GetPDU, or Head_GetPDU, or Delete_GetPDU, or Trace_GetPDU, or Unassigned_GetPDU, or ExtendedMethod_GetPDU, or Post, or Put_PostPDU, or Unassigned_PostPDU, or ExtendedMethod_PostPDU, or DataFragmentPDU});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Reserved]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Reserved]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Reserved($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Reserved]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Reserved]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Reserved}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Reserved]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Connect]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Connect]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Connect($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Connect]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Connect]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Connect}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Connect]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ConnectReply]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ConnectReply]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ConnectReply($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ConnectReply]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ConnectReply]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ConnectReply}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ConnectReply]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Redirect]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Redirect]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Redirect($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Redirect]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Redirect]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Redirect}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Redirect]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Reply]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Reply]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Reply($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Reply]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Reply]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Reply}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Reply]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Disconnect]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Disconnect]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Disconnect($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Disconnect]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Disconnect]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Disconnect}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Disconnect]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Push]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Push]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Push($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Push]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Push]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Push}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Push]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ConfirmedPush]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ConfirmedPush]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ConfirmedPush($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ConfirmedPush]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ConfirmedPush]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ConfirmedPush}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ConfirmedPush]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Suspend]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Suspend]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Suspend($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Suspend]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Suspend]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Suspend}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Suspend]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Resume]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Resume]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Resume($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Resume]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Resume]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Resume}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Resume]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Unassigned]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Unassigned]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Unassigned($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Unassigned]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Unassigned]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Unassigned}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Unassigned]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Get]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[11];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Get]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Get($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Get]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Get]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Get}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Get]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Options_GetPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[12];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Options_GetPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Options_GetPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Options_GetPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Options_GetPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Options_GetPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Options_GetPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Head_GetPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[13];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Head_GetPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Head_GetPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Head_GetPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Head_GetPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Head_GetPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Head_GetPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Delete_GetPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[14];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Delete_GetPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Delete_GetPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Delete_GetPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Delete_GetPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Delete_GetPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Delete_GetPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Trace_GetPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[15];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Trace_GetPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Trace_GetPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Trace_GetPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Trace_GetPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Trace_GetPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Trace_GetPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Unassigned_GetPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[16];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Unassigned_GetPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Unassigned_GetPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Unassigned_GetPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Unassigned_GetPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Unassigned_GetPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Unassigned_GetPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ExtendedMethod_GetPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[17];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ExtendedMethod_GetPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ExtendedMethod_GetPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ExtendedMethod_GetPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ExtendedMethod_GetPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ExtendedMethod_GetPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ExtendedMethod_GetPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Post]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[18];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Post]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Post($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Post]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Post]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Post}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Post]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Put_PostPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[19];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Put_PostPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Put_PostPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Put_PostPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Put_PostPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Put_PostPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Put_PostPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [Unassigned_PostPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[20];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [Unassigned_PostPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::Unassigned_PostPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [Unassigned_PostPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [Unassigned_PostPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{Unassigned_PostPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [Unassigned_PostPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ExtendedMethod_PostPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[21];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ExtendedMethod_PostPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ExtendedMethod_PostPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ExtendedMethod_PostPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ExtendedMethod_PostPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ExtendedMethod_PostPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ExtendedMethod_PostPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [DataFragmentPDU]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[22];
        $text = $_[1];
        my $_savetext;
        @item = (q{PDU_type});
        %item = (__RULE__ => q{PDU_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [DataFragmentPDU]},
                  Parse::RecDescent::_tracefirst($text),
                  q{PDU_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::DataFragmentPDU($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [DataFragmentPDU]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{PDU_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [DataFragmentPDU]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{DataFragmentPDU}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [DataFragmentPDU]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{PDU_type},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{PDU_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{PDU_type},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{PDU_type},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::delivery_report_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"delivery_report_value"};

    Parse::RecDescent::_trace(q{Trying rule: [delivery_report_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{delivery_report_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{YES, or NO});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [YES]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{delivery_report_value});
        %item = (__RULE__ => q{delivery_report_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [YES]},
                  Parse::RecDescent::_tracefirst($text),
                  q{delivery_report_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::YES($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [YES]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{delivery_report_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [YES]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{YES}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [YES]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [NO]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{delivery_report_value});
        %item = (__RULE__ => q{delivery_report_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [NO]},
                  Parse::RecDescent::_tracefirst($text),
                  q{delivery_report_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::NO($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [NO]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{delivery_report_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [NO]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{NO}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [NO]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{delivery_report_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{delivery_report_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{delivery_report_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{delivery_report_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_media_type
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_media_type"};

    Parse::RecDescent::_trace(q{Trying rule: [_media_type]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_trans_well_known_media, or extension_media});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_trans_well_known_media, or extension_media parameter]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_media_type});
        %item = (__RULE__ => q{_media_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_alternation_1_of_production_1_of_rule__media_type]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule__media_type($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_alternation_1_of_production_1_of_rule__media_type]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_media_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_alternation_1_of_production_1_of_rule__media_type]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule__media_type}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [parameter]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{parameter})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::parameter, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [parameter]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_media_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [parameter]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{_media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{parameter(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $media_type = $item[1];
   if (defined $media_type) {
      my @parameters = map { # param_encode() defined in g-startup.pl
         $_->{name} . ' = ' . param_encode($_->{value});
      } @{$item[2]};
      my %parameters = map { $_->{name} => $_->{value} } @{$item[2]};
      my $text = join '; ', $media_type, @parameters;
      $return = {
         text => $text,
         media_type => $media_type,
         parameters => \%parameters,
      };
      1;
   }
   else {undef}
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [_trans_well_known_media, or extension_media parameter]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_media_type},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_media_type},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_media_type},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule__media_type
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule__media_type"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule__media_type]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule__media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_trans_well_known_media, or extension_media});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_trans_well_known_media]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule__media_type});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule__media_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_trans_well_known_media]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule__media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_trans_well_known_media($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_trans_well_known_media]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule__media_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_trans_well_known_media]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_trans_well_known_media}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_trans_well_known_media]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [extension_media]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule__media_type});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule__media_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [extension_media]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule__media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::extension_media($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [extension_media]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule__media_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [extension_media]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{extension_media}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [extension_media]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule__media_type},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule__media_type},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_type_head"};

    Parse::RecDescent::_trace(q{Trying rule: [message_type_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_type_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{message_type_head_code});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_type_head_code message_type_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_type_head});
        %item = (__RULE__ => q{message_type_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_type_head_code]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head_code($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_head_code]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_head_code]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_head_code}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [message_type_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_type_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{message_type_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_type_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [message_type_head_code message_type_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_type_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_type_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_type_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_type_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::report_allowed_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"report_allowed_value"};

    Parse::RecDescent::_trace(q{Trying rule: [report_allowed_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{report_allowed_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{YES, or NO});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [YES]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{report_allowed_value});
        %item = (__RULE__ => q{report_allowed_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [YES]},
                  Parse::RecDescent::_tracefirst($text),
                  q{report_allowed_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::YES($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [YES]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{report_allowed_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [YES]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{YES}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [YES]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [NO]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{report_allowed_value});
        %item = (__RULE__ => q{report_allowed_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [NO]},
                  Parse::RecDescent::_tracefirst($text),
                  q{report_allowed_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::NO($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [NO]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{report_allowed_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [NO]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{NO}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [NO]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{report_allowed_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{report_allowed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{report_allowed_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{report_allowed_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::creation_date_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"creation_date_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [creation_date_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{creation_date_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x93'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x93' date_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{creation_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{creation_date_parameter});
        %item = (__RULE__ => q{creation_date_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x93']},
                      Parse::RecDescent::_tracefirst($text),
                      q{creation_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x93"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [date_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{creation_date_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{date_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::date_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [date_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{creation_date_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [date_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{creation_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{date_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{creation_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x93' date_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{creation_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{creation_date_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{creation_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{creation_date_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{creation_date_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::RFC2616_QUOTE
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"RFC2616_QUOTE"};

    Parse::RecDescent::_trace(q{Trying rule: [RFC2616_QUOTE]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{RFC2616_QUOTE},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x22'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x22']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{RFC2616_QUOTE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{RFC2616_QUOTE});
        %item = (__RULE__ => q{RFC2616_QUOTE});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x22']},
                      Parse::RecDescent::_tracefirst($text),
                      q{RFC2616_QUOTE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x22"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x22']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{RFC2616_QUOTE},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{RFC2616_QUOTE},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{RFC2616_QUOTE},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{RFC2616_QUOTE},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{RFC2616_QUOTE},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::comment_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"comment_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [comment_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{comment_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x9b'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x9b' text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{comment_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{comment_parameter});
        %item = (__RULE__ => q{comment_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x9b']},
                      Parse::RecDescent::_tracefirst($text),
                      q{comment_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x9b"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{comment_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{comment_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{comment_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{comment_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x9b' text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{comment_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{comment_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{comment_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{comment_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{comment_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::octet
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"octet"};

    Parse::RecDescent::_trace(q{Trying rule: [octet]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{octet},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{OCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [OCTET]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{octet},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{octet});
        %item = (__RULE__ => q{octet});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [OCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{octet},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::OCTET($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [OCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{octet},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [OCTET]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{octet},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{OCTET}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [OCTET]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{octet},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{octet},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{octet},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{octet},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{octet},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Push
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Push"};

    Parse::RecDescent::_trace(q{Trying rule: [Push]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Push},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x06'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x06']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Push},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Push});
        %item = (__RULE__ => q{Push});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x06']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Push},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x06"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Push},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x06']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Push},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Push},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Push},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Push},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Push},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::start_info_related_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"start_info_related_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [start_info_related_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{start_info_related_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8b'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8b' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{start_info_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{start_info_related_deprecated_parameter});
        %item = (__RULE__ => q{start_info_related_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8b']},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8b"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{start_info_related_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{start_info_related_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.2'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8b' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{start_info_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{start_info_related_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{start_info_related_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{start_info_related_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{start_info_related_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::REJECTED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"REJECTED"};

    Parse::RecDescent::_trace(q{Trying rule: [REJECTED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{REJECTED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x82'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x82']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{REJECTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{REJECTED});
        %item = (__RULE__ => q{REJECTED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x82']},
                      Parse::RecDescent::_tracefirst($text),
                      q{REJECTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x82"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{REJECTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x82']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{REJECTED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{REJECTED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{REJECTED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{REJECTED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{REJECTED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Connect
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Connect"};

    Parse::RecDescent::_trace(q{Trying rule: [Connect]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Connect},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x01'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x01']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Connect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Connect});
        %item = (__RULE__ => q{Connect});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x01']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Connect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x01"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Connect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x01']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Connect},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Connect},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Connect},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Connect},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Connect},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Suspend
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Suspend"};

    Parse::RecDescent::_trace(q{Trying rule: [Suspend]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Suspend},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x08'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x08']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Suspend},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Suspend});
        %item = (__RULE__ => q{Suspend});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x08']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Suspend},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x08"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Suspend},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x08']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Suspend},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Suspend},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Suspend},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Suspend},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Suspend},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_LWS
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_LWS"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_LWS]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_LWS},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{SP, or HT});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [SP]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_LWS});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_LWS});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [SP]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_LWS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::SP($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [SP]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_LWS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [SP]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{SP}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [SP]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HT]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_LWS});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_LWS});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [HT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_LWS},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::HT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [HT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_LWS},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [HT]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HT}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [HT]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_LWS},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_LWS},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Unassigned_PostPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Unassigned_PostPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Unassigned_PostPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Unassigned_PostPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x62-\\x6f]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x62-\\x6f]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Unassigned_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Unassigned_PostPDU});
        %item = (__RULE__ => q{Unassigned_PostPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x62-\\x6f]/]}, Parse::RecDescent::_tracefirst($text),
                      q{Unassigned_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x62-\x6f])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Unassigned_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x62-\\x6f]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Unassigned_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Unassigned_PostPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Unassigned_PostPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Unassigned_PostPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Unassigned_PostPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ERROR_MESSAGE_FORMAT_CORRUPT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ERROR_MESSAGE_FORMAT_CORRUPT"};

    Parse::RecDescent::_trace(q{Trying rule: [ERROR_MESSAGE_FORMAT_CORRUPT]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ERROR_MESSAGE_FORMAT_CORRUPT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x83'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x83']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ERROR_MESSAGE_FORMAT_CORRUPT});
        %item = (__RULE__ => q{ERROR_MESSAGE_FORMAT_CORRUPT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x83']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x83"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x83']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ERROR_MESSAGE_FORMAT_CORRUPT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ERROR_MESSAGE_FORMAT_CORRUPT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_well_known_charset_wcode
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_well_known_charset_wcode"};

    Parse::RecDescent::_trace(q{Trying rule: [_well_known_charset_wcode]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_well_known_charset_wcode},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{integer_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_well_known_charset_wcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_well_known_charset_wcode});
        %item = (__RULE__ => q{_well_known_charset_wcode});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_well_known_charset_wcode},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_well_known_charset_wcode},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_well_known_charset_wcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{_well_known_charset_wcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my %name_for = (
      0x07ea => 'big5',
      0x03e8 => 'iso-10646-ucs-2',
      0x04 => 'iso-8859-1',
      0x05 => 'iso-8859-2',
      0x06 => 'iso-8859-3',
      0x07 => 'iso-8859-4',
      0x08 => 'iso-8859-5',
      0x09 => 'iso-8859-6',
      0x0a => 'iso-8859-7',
      0x0b => 'iso-8859-8',
      0x0c => 'iso-8859-9',
      0x11 => 'shift_JIS',
      0x03 => 'us-ascii',
      0x6a => 'utf-8',
   );
   $return = $item[1];
   $return = $name_for{$return} if exists $name_for{$return};
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_well_known_charset_wcode},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_well_known_charset_wcode},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_well_known_charset_wcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_well_known_charset_wcode},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_well_known_charset_wcode},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::separator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"separator"};

    Parse::RecDescent::_trace(q{Trying rule: [separator]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{separator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'(', or ')', or '<', or '>', or '@', or ',', or ';', or ':', or '\\\\', or RFC2616_QUOTE, or '\\/', or '[', or ']', or '?', or '=', or '\{', or '\}', or SP, or HT});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['(']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['(']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "("; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['(']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [')']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [')']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = ")"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [')']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['<']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['<']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "<"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['<']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['>']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['>']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = ">"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['>']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['@']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['@']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "@"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['@']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [',']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [',']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = ","; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [',']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [';']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [';']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = ";"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [';']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [':']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [':']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = ":"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [':']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\\\']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\\\']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\\"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\\\']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [RFC2616_QUOTE]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [RFC2616_QUOTE]},
                  Parse::RecDescent::_tracefirst($text),
                  q{separator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::RFC2616_QUOTE($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [RFC2616_QUOTE]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{separator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [RFC2616_QUOTE]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{RFC2616_QUOTE}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [RFC2616_QUOTE]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\/']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\/']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\/"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\/']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['[']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[11];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "["; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [']']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[12];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [']']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "]"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [']']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['?']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[13];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['?']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "?"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['?']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['=']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[14];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['=']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "="; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['=']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\{']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[15];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\{']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "{"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\{']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\}']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[16];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\}']},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "}"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\}']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [SP]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[17];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [SP]},
                  Parse::RecDescent::_tracefirst($text),
                  q{separator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::SP($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [SP]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{separator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [SP]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{SP}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [SP]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [HT]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[18];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [HT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{separator},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::HT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [HT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{separator},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [HT]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{HT}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [HT]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{separator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{separator},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{separator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::LOALPHA
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"LOALPHA"};

    Parse::RecDescent::_trace(q{Trying rule: [LOALPHA]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{LOALPHA},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[a-z]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[a-z]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{LOALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{LOALPHA});
        %item = (__RULE__ => q{LOALPHA});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[a-z]/]}, Parse::RecDescent::_tracefirst($text),
                      q{LOALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[a-z])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[a-z]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{LOALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{LOALPHA},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{LOALPHA},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{LOALPHA},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{LOALPHA},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::absolute_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"absolute_token"};

    Parse::RecDescent::_trace(q{Trying rule: [absolute_token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{absolute_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{absolute_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{absolute_token});
        %item = (__RULE__ => q{absolute_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{absolute_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{absolute_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = 'absolute'; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{absolute_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{absolute_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{absolute_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{absolute_token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{absolute_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::subject_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"subject_head"};

    Parse::RecDescent::_trace(q{Trying rule: [subject_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{subject_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x96'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x96' subject_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{subject_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{subject_head});
        %item = (__RULE__ => q{subject_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x96']},
                      Parse::RecDescent::_tracefirst($text),
                      q{subject_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x96"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [subject_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{subject_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{subject_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::subject_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [subject_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{subject_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [subject_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{subject_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{subject_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{subject_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x96' subject_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{subject_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{subject_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{subject_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{subject_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{subject_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::expiry_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"expiry_value"};

    Parse::RecDescent::_trace(q{Trying rule: [expiry_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{expiry_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_mixed_time_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_mixed_time_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{expiry_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{expiry_value});
        %item = (__RULE__ => q{expiry_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_mixed_time_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{expiry_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_mixed_time_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_mixed_time_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{expiry_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_mixed_time_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{expiry_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_mixed_time_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_mixed_time_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{expiry_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{expiry_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{expiry_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{expiry_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{expiry_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::media_type
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"media_type"};

    Parse::RecDescent::_trace(q{Trying rule: [media_type]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_media_type});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_media_type]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{media_type});
        %item = (__RULE__ => q{media_type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_media_type]},
                  Parse::RecDescent::_tracefirst($text),
                  q{media_type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_media_type($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_media_type]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{media_type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_media_type]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_media_type}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $media_type = $item[1] || {};
   $return = $media_type->{text};
   defined($return);
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [_media_type]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{media_type},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{media_type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{media_type},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{media_type},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_from_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_from_value"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_from_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{address_present_token, or insert_address_token});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [address_present_token]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_from_value});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_from_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_from_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [address_present_token]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [insert_address_token]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_from_value});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_from_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [insert_address_token]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_from_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::insert_address_token($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [insert_address_token]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_from_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [insert_address_token]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{insert_address_token}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [insert_address_token]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_from_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_from_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_send_conf
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_send_conf"};

    Parse::RecDescent::_trace(q{Trying rule: [m_send_conf]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_send_conf},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_send_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_send_conf});
        %item = (__RULE__ => q{m_send_conf});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_send_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_send_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_send_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_send_conf},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_send_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_send_conf},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_send_conf},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::delivery_time_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"delivery_time_value"};

    Parse::RecDescent::_trace(q{Trying rule: [delivery_time_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{delivery_time_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_mixed_time_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_mixed_time_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{delivery_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{delivery_time_value});
        %item = (__RULE__ => q{delivery_time_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_mixed_time_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{delivery_time_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_mixed_time_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_mixed_time_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{delivery_time_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_mixed_time_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_mixed_time_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_mixed_time_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{delivery_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{delivery_time_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{delivery_time_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{delivery_time_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{delivery_time_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::multipart_headers
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multipart_headers"};

    Parse::RecDescent::_trace(q{Trying rule: [multipart_headers]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{multipart_headers},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{content_type_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [content_type_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{multipart_headers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multipart_headers});
        %item = (__RULE__ => q{multipart_headers});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [content_type_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart_headers},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_type_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_type_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart_headers},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_type_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_headers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_type_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_headers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = {
      content_type => $item[1],
      other_headers => $text,
   };
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [content_type_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_headers},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{multipart_headers},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{multipart_headers},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multipart_headers},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{multipart_headers},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::class_identifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"class_identifier"};

    Parse::RecDescent::_trace(q{Trying rule: [class_identifier]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{class_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{PERSONAL, or ADVERTISEMENT, or INFORMATIONAL, or AUTO});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [PERSONAL]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{class_identifier});
        %item = (__RULE__ => q{class_identifier});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [PERSONAL]},
                  Parse::RecDescent::_tracefirst($text),
                  q{class_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::PERSONAL($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [PERSONAL]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{class_identifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [PERSONAL]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{PERSONAL}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [PERSONAL]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [ADVERTISEMENT]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{class_identifier});
        %item = (__RULE__ => q{class_identifier});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [ADVERTISEMENT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{class_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::ADVERTISEMENT($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ADVERTISEMENT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{class_identifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ADVERTISEMENT]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ADVERTISEMENT}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [ADVERTISEMENT]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [INFORMATIONAL]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{class_identifier});
        %item = (__RULE__ => q{class_identifier});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [INFORMATIONAL]},
                  Parse::RecDescent::_tracefirst($text),
                  q{class_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::INFORMATIONAL($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [INFORMATIONAL]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{class_identifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [INFORMATIONAL]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{INFORMATIONAL}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [INFORMATIONAL]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [AUTO]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{class_identifier});
        %item = (__RULE__ => q{class_identifier});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [AUTO]},
                  Parse::RecDescent::_tracefirst($text),
                  q{class_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::AUTO($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [AUTO]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{class_identifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [AUTO]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{AUTO}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [AUTO]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{class_identifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{class_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{class_identifier},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{class_identifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_id_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_id_value"};

    Parse::RecDescent::_trace(q{Trying rule: [message_id_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_id_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{text_string});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_id_value});
        %item = (__RULE__ => q{message_id_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_id_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_id_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_id_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_id_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_id_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_id_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"token"};

    Parse::RecDescent::_trace(q{Trying rule: [token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{CTL});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [CTL]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{token});
        %item = (__RULE__ => q{token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [CTL]},
                  Parse::RecDescent::_tracefirst($text),
                  q{token},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_token, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [CTL]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{token},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_token]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_token(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = join '', @{$item[1]};
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [CTL]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::long_integer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"long_integer"};

    Parse::RecDescent::_trace(q{Trying rule: [long_integer]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{long_integer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{short_length});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [short_length]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{long_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{long_integer});
        %item = (__RULE__ => q{long_integer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [short_length]},
                  Parse::RecDescent::_tracefirst($text),
                  q{long_integer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_length($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_length]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{long_integer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_length]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{long_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_length}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{long_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my $len = $item{short_length};
   if ($len >= 1 && $len <= 30 && $len <= length $text) {
      $return = 0;
      my $chunk = substr $text, 0, $len;
      $text = substr $text, $len;
      for my $char ( split //, $chunk ) {
         $return = ($return << 8) | ord $char;
      }
      1;
   }
   else { undef; } # Reject
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [short_length]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{long_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{long_integer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{long_integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{long_integer},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{long_integer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ConfirmedPush
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ConfirmedPush"};

    Parse::RecDescent::_trace(q{Trying rule: [ConfirmedPush]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ConfirmedPush},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x07'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x07']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ConfirmedPush},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ConfirmedPush});
        %item = (__RULE__ => q{ConfirmedPush});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x07']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ConfirmedPush},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x07"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ConfirmedPush},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x07']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ConfirmedPush},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ConfirmedPush},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ConfirmedPush},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ConfirmedPush},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ConfirmedPush},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::_alternation_1_of_production_1_of_rule_TEXT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_TEXT"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_TEXT]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_TEXT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{_non_CTL, or LWS});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [_non_CTL]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_TEXT});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_TEXT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [_non_CTL]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_TEXT},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::_non_CTL($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_non_CTL]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_TEXT},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_non_CTL]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_non_CTL}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [_non_CTL]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [LWS]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_TEXT});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_TEXT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [LWS]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_TEXT},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::LWS($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [LWS]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_TEXT},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [LWS]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{LWS}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [LWS]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_TEXT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_TEXT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_acknowledge_ind
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_acknowledge_ind"};

    Parse::RecDescent::_trace(q{Trying rule: [m_acknowledge_ind]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_acknowledge_ind},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x85'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x85']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_acknowledge_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_acknowledge_ind});
        %item = (__RULE__ => q{m_acknowledge_ind});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x85']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_acknowledge_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x85"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_acknowledge_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x85']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_acknowledge_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_acknowledge_ind},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_acknowledge_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_acknowledge_ind},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_acknowledge_ind},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::ADVERTISEMENT
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ADVERTISEMENT"};

    Parse::RecDescent::_trace(q{Trying rule: [ADVERTISEMENT]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ADVERTISEMENT},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ADVERTISEMENT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ADVERTISEMENT});
        %item = (__RULE__ => q{ADVERTISEMENT});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{ADVERTISEMENT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ADVERTISEMENT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ADVERTISEMENT},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ADVERTISEMENT},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ADVERTISEMENT},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ADVERTISEMENT},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ADVERTISEMENT},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::multipart_entry
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"multipart_entry"};

    Parse::RecDescent::_trace(q{Trying rule: [multipart_entry]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{multipart_entry},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{multipart_headers_len});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [multipart_headers_len multipart_data_len]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{multipart_entry},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{multipart_entry});
        %item = (__RULE__ => q{multipart_entry});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [multipart_headers_len]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart_entry},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::multipart_headers_len($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [multipart_headers_len]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart_entry},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [multipart_headers_len]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_entry},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multipart_headers_len}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [multipart_data_len]},
                  Parse::RecDescent::_tracefirst($text),
                  q{multipart_entry},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{multipart_data_len})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::multipart_data_len($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [multipart_data_len]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{multipart_entry},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [multipart_data_len]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_entry},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multipart_data_len}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_entry},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my ($hlen, $dlen) = @item[1,2];
   $return = {
      headers => $thisparser->multipart_headers(substr $text, 0, $hlen),
      data => substr($text, $hlen, $dlen),
   };
   $text = substr $text, $hlen + $dlen;
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [multipart_headers_len multipart_data_len]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{multipart_entry},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{multipart_entry},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{multipart_entry},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{multipart_entry},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{multipart_entry},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::sender_visibility_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"sender_visibility_head"};

    Parse::RecDescent::_trace(q{Trying rule: [sender_visibility_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{sender_visibility_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x94'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x94' sender_visibility_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{sender_visibility_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{sender_visibility_head});
        %item = (__RULE__ => q{sender_visibility_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x94']},
                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x94"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [sender_visibility_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{sender_visibility_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{sender_visibility_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::sender_visibility_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [sender_visibility_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{sender_visibility_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [sender_visibility_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{sender_visibility_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x94' sender_visibility_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{sender_visibility_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{sender_visibility_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{sender_visibility_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{sender_visibility_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{sender_visibility_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::type_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [type_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{type_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x83'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x83' integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{type_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type_parameter});
        %item = (__RULE__ => q{type_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x83']},
                      Parse::RecDescent::_tracefirst($text),
                      q{type_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x83"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{type_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{integer_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{type_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{type_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{type_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x83' integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{type_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{type_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{type_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{type_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::compact_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"compact_value"};

    Parse::RecDescent::_trace(q{Trying rule: [compact_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{integer_value, or date_value, or delta_seconds_value, or q_value, or version_value, or uri_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [integer_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{compact_value});
        %item = (__RULE__ => q{compact_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [integer_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::integer_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [integer_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{compact_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [integer_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{integer_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [integer_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [date_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{compact_value});
        %item = (__RULE__ => q{compact_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [date_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::date_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [date_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{compact_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [date_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{date_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [date_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [delta_seconds_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{compact_value});
        %item = (__RULE__ => q{compact_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [delta_seconds_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::delta_seconds_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [delta_seconds_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{compact_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [delta_seconds_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{delta_seconds_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [delta_seconds_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [q_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{compact_value});
        %item = (__RULE__ => q{compact_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [q_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::q_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [q_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{compact_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [q_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{q_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [q_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [version_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{compact_value});
        %item = (__RULE__ => q{compact_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [version_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::version_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [version_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{compact_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [version_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{version_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [version_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [uri_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{compact_value});
        %item = (__RULE__ => q{compact_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [uri_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{compact_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::uri_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [uri_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{compact_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [uri_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{uri_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [uri_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{compact_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{compact_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{compact_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{compact_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::header
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"header"};

    Parse::RecDescent::_trace(q{Trying rule: [header]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{header},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{MMS_header, or application_header});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [MMS_header]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{header});
        %item = (__RULE__ => q{header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [MMS_header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_header($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_header]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_header}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [MMS_header]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [application_header]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{header});
        %item = (__RULE__ => q{header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [application_header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::application_header($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [application_header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [application_header]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{application_header}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [application_header]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{header},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{header},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{header},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::constrained_encoding
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"constrained_encoding"};

    Parse::RecDescent::_trace(q{Trying rule: [constrained_encoding]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{constrained_encoding},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{extension_media, or short_integer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [extension_media]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{constrained_encoding});
        %item = (__RULE__ => q{constrained_encoding});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [extension_media]},
                  Parse::RecDescent::_tracefirst($text),
                  q{constrained_encoding},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::extension_media($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [extension_media]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{constrained_encoding},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [extension_media]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{extension_media}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [extension_media]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [short_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{constrained_encoding});
        %item = (__RULE__ => q{constrained_encoding});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [short_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{constrained_encoding},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{constrained_encoding},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [short_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{constrained_encoding},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{constrained_encoding},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{constrained_encoding},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{constrained_encoding},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::read_date_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"read_date_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [read_date_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{read_date_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x95'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x95' date_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{read_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{read_date_parameter});
        %item = (__RULE__ => q{read_date_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x95']},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x95"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [date_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{read_date_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{date_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::date_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [date_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{read_date_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [date_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{read_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{date_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x95' date_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{read_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{read_date_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{read_date_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{read_date_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{read_date_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::OCTET
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"OCTET"};

    Parse::RecDescent::_trace(q{Trying rule: [OCTET]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{OCTET},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x00-\\xFF]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x00-\\xFF]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{OCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{OCTET});
        %item = (__RULE__ => q{OCTET});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x00-\\xFF]/]}, Parse::RecDescent::_tracefirst($text),
                      q{OCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x00-\xFF])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x00-\\xFF]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{OCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{OCTET},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{OCTET},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{OCTET},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{OCTET},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::quoted_string
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"quoted_string"};

    Parse::RecDescent::_trace(q{Trying rule: [quoted_string]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{quoted_string},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x22'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x22' TEXT end_of_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{quoted_string});
        %item = (__RULE__ => q{quoted_string});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x22']},
                      Parse::RecDescent::_tracefirst($text),
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x22"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [TEXT]},
                  Parse::RecDescent::_tracefirst($text),
                  q{quoted_string},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{TEXT})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::TEXT, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [TEXT]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{quoted_string},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [TEXT]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{TEXT(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [end_of_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{quoted_string},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{end_of_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::end_of_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [end_of_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{quoted_string},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [end_of_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{end_of_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   $return = scalar @{$item[2]} ? $item[2][0] : '';
   1; 
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x22' TEXT end_of_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{quoted_string},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{quoted_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{quoted_string},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{quoted_string},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_delivery_ind
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_delivery_ind"};

    Parse::RecDescent::_trace(q{Trying rule: [m_delivery_ind]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_delivery_ind},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x86'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x86']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_delivery_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_delivery_ind});
        %item = (__RULE__ => q{m_delivery_ind});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x86']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_delivery_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x86"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_delivery_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x86']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_delivery_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_delivery_ind},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_delivery_ind},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_delivery_ind},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_delivery_ind},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Post
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Post"};

    Parse::RecDescent::_trace(q{Trying rule: [Post]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Post},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x60'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x60']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Post},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Post});
        %item = (__RULE__ => q{Post});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x60']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Post},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x60"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Post},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x60']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Post},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Post},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Post},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Post},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Post},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::M_Send_Req_message
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"M_Send_Req_message"};

    Parse::RecDescent::_trace(q{Trying rule: [M_Send_Req_message]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{message_type_head_code});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [message_type_head_code m_send_req transaction_id_head MMS_version_head header content_type_head multipart]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{M_Send_Req_message});
        %item = (__RULE__ => q{M_Send_Req_message});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [message_type_head_code]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_type_head_code($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_type_head_code]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_type_head_code]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_type_head_code}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [m_send_req]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{m_send_req})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::m_send_req($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [m_send_req]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [m_send_req]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{m_send_req}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [transaction_id_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{transaction_id_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [transaction_id_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [transaction_id_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{transaction_id_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [MMS_version_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{MMS_version_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::MMS_version_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [MMS_version_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [MMS_version_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{MMS_version_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [header]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{header})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::header, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [header]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [header]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{header(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [content_type_head]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{content_type_head})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::content_type_head($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [content_type_head]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [content_type_head]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{content_type_head}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [multipart]},
                  Parse::RecDescent::_tracefirst($text),
                  q{M_Send_Req_message},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{multipart})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::multipart($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [multipart]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{M_Send_Req_message},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [multipart]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{multipart}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
   my %headers;
   $headers{message_type_head} = 'm_send_req';
   foreach my $header (@item[4,6], $item[3], @{$item[5]}) {
      my ($name, $value) = @$header;
      $headers{$name} = $value;
   }
   $return = {
      headers => \%headers,
      body    => $item{multipart},
   };
   1;
};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [message_type_head_code m_send_req transaction_id_head MMS_version_head header content_type_head multipart]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{M_Send_Req_message},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{M_Send_Req_message},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{M_Send_Req_message},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{M_Send_Req_message},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::message_class_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"message_class_head"};

    Parse::RecDescent::_trace(q{Trying rule: [message_class_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{message_class_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8a'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8a' message_class_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{message_class_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{message_class_head});
        %item = (__RULE__ => q{message_class_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8a']},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8a"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [message_class_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{message_class_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{message_class_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::message_class_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [message_class_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{message_class_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [message_class_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{message_class_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8a' message_class_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{message_class_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{message_class_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{message_class_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{message_class_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{message_class_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::application_header
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"application_header"};

    Parse::RecDescent::_trace(q{Trying rule: [application_header]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{application_header},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{token_text});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [token_text application_specific_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{application_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{application_header});
        %item = (__RULE__ => q{application_header});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [token_text]},
                  Parse::RecDescent::_tracefirst($text),
                  q{application_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::token_text($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [token_text]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{application_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [token_text]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{application_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{token_text}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [application_specific_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{application_header},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{application_specific_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::application_specific_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [application_specific_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{application_header},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [application_specific_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{application_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{application_specific_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [token_text application_specific_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{application_header},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{application_header},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{application_header},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{application_header},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{application_header},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::date_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"date_head"};

    Parse::RecDescent::_trace(q{Trying rule: [date_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{date_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x85'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x85' date_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{date_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{date_head});
        %item = (__RULE__ => q{date_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x85']},
                      Parse::RecDescent::_tracefirst($text),
                      q{date_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x85"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [date_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{date_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{date_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::date_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [date_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{date_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [date_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{date_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{date_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{date_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x85' date_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{date_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{date_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{date_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{date_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{date_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Unassigned_GetPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Unassigned_GetPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Unassigned_GetPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Unassigned_GetPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[\\x45-\\x4f]/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[\\x45-\\x4f]/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Unassigned_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Unassigned_GetPDU});
        %item = (__RULE__ => q{Unassigned_GetPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[\\x45-\\x4f]/]}, Parse::RecDescent::_tracefirst($text),
                      q{Unassigned_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[\x45-\x4f])/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Unassigned_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[\\x45-\\x4f]/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Unassigned_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Unassigned_GetPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Unassigned_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Unassigned_GetPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Unassigned_GetPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::Options_GetPDU
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"Options_GetPDU"};

    Parse::RecDescent::_trace(q{Trying rule: [Options_GetPDU]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{Options_GetPDU},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x41'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x41']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{Options_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{Options_GetPDU});
        %item = (__RULE__ => q{Options_GetPDU});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x41']},
                      Parse::RecDescent::_tracefirst($text),
                      q{Options_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x41"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{Options_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x41']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{Options_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{Options_GetPDU},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{Options_GetPDU},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{Options_GetPDU},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{Options_GetPDU},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::SEC_wbxml_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"SEC_wbxml_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [SEC_wbxml_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{SEC_wbxml_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x91'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x91' short_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{SEC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{SEC_wbxml_parameter});
        %item = (__RULE__ => q{SEC_wbxml_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x91']},
                      Parse::RecDescent::_tracefirst($text),
                      q{SEC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x91"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [short_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{SEC_wbxml_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{short_integer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{SEC_wbxml_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{SEC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{SEC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.4'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x91' short_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{SEC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{SEC_wbxml_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{SEC_wbxml_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{SEC_wbxml_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{SEC_wbxml_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"transaction_id_head"};

    Parse::RecDescent::_trace(q{Trying rule: [transaction_id_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{transaction_id_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x98'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x98' transaction_id_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{transaction_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{transaction_id_head});
        %item = (__RULE__ => q{transaction_id_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x98']},
                      Parse::RecDescent::_tracefirst($text),
                      q{transaction_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x98"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [transaction_id_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{transaction_id_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{transaction_id_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::transaction_id_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [transaction_id_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{transaction_id_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [transaction_id_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{transaction_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{transaction_id_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{transaction_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x98' transaction_id_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{transaction_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{transaction_id_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{transaction_id_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{transaction_id_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{transaction_id_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::typed_value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"typed_value"};

    Parse::RecDescent::_trace(q{Trying rule: [typed_value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{typed_value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{compact_value, or text_value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [compact_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_value});
        %item = (__RULE__ => q{typed_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [compact_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::compact_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [compact_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [compact_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{compact_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [compact_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [text_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{typed_value});
        %item = (__RULE__ => q{typed_value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [text_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{typed_value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{typed_value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [text_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{typed_value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{typed_value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{typed_value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{typed_value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::token_text
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"token_text"};

    Parse::RecDescent::_trace(q{Trying rule: [token_text]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{token_text},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{token});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [token end_of_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{token_text},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{token_text});
        %item = (__RULE__ => q{token_text});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [token]},
                  Parse::RecDescent::_tracefirst($text),
                  q{token_text},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::token($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [token]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{token_text},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [token]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{token_text},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{token}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [end_of_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{token_text},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{end_of_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::end_of_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [end_of_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{token_text},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [end_of_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{token_text},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{end_of_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{token_text},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item{token}; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [token end_of_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{token_text},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{token_text},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{token_text},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{token_text},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{token_text},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::NO
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"NO"};

    Parse::RecDescent::_trace(q{Trying rule: [NO]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{NO},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{NO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{NO});
        %item = (__RULE__ => q{NO});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{NO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{NO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{NO},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{NO},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{NO},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{NO},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{NO},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::domain_deprecated_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"domain_deprecated_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [domain_deprecated_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{domain_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x8d'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x8d' text_string]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{domain_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{domain_deprecated_parameter});
        %item = (__RULE__ => q{domain_deprecated_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x8d']},
                      Parse::RecDescent::_tracefirst($text),
                      q{domain_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x8d"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [text_string]},
                  Parse::RecDescent::_tracefirst($text),
                  q{domain_deprecated_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{text_string})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::text_string($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [text_string]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{domain_deprecated_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [text_string]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{domain_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{text_string}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{domain_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.3'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x8d' text_string]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{domain_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{domain_deprecated_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{domain_deprecated_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{domain_deprecated_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{domain_deprecated_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::uint32
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"uint32"};

    Parse::RecDescent::_trace(q{Trying rule: [uint32]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{uint32},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{OCTET});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [OCTET]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{uint32},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{uint32});
        %item = (__RULE__ => q{uint32});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [OCTET]},
                  Parse::RecDescent::_tracefirst($text),
                  q{uint32},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::MMS::Parser::WorkHorse::OCTET, 4, 4, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [OCTET]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{uint32},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [OCTET]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{uint32},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{OCTET(4)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{uint32},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = unpack 'N', join '', @{$item[1]}; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [OCTET]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{uint32},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{uint32},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{uint32},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{uint32},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{uint32},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::padding_parameter
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"padding_parameter"};

    Parse::RecDescent::_trace(q{Trying rule: [padding_parameter]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{padding_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x88'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x88' short_integer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{padding_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{padding_parameter});
        %item = (__RULE__ => q{padding_parameter});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x88']},
                      Parse::RecDescent::_tracefirst($text),
                      q{padding_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x88"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [short_integer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{padding_parameter},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{short_integer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::short_integer($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [short_integer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{padding_parameter},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [short_integer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{padding_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{short_integer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{padding_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = build_parameter(@item, '1.1'); 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x88' short_integer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{padding_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{padding_parameter},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{padding_parameter},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{padding_parameter},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{padding_parameter},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::to_head
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"to_head"};

    Parse::RecDescent::_trace(q{Trying rule: [to_head]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{to_head},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x97'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x97' to_value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{to_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{to_head});
        %item = (__RULE__ => q{to_head});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x97']},
                      Parse::RecDescent::_tracefirst($text),
                      q{to_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x97"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [to_value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{to_head},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{to_value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::MMS::Parser::WorkHorse::to_value($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [to_value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{to_head},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [to_value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{to_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{to_value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{to_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = [ @item[0,2] ]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x97' to_value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{to_head},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{to_head},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{to_head},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{to_head},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{to_head},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::RETRIEVED
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"RETRIEVED"};

    Parse::RecDescent::_trace(q{Trying rule: [RETRIEVED]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{RETRIEVED},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x81'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x81']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{RETRIEVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{RETRIEVED});
        %item = (__RULE__ => q{RETRIEVED});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x81']},
                      Parse::RecDescent::_tracefirst($text),
                      q{RETRIEVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x81"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{RETRIEVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x81']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{RETRIEVED},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{RETRIEVED},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{RETRIEVED},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{RETRIEVED},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{RETRIEVED},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::address_present_token
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"address_present_token"};

    Parse::RecDescent::_trace(q{Trying rule: [address_present_token]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{address_present_token},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x80'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x80']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{address_present_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{address_present_token});
        %item = (__RULE__ => q{address_present_token});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x80']},
                      Parse::RecDescent::_tracefirst($text),
                      q{address_present_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x80"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{address_present_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = 'address-present'; 1; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x80']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{address_present_token},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{address_present_token},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{address_present_token},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{address_present_token},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{address_present_token},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::MMS::Parser::WorkHorse::m_retrieve_conf
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"m_retrieve_conf"};

    Parse::RecDescent::_trace(q{Trying rule: [m_retrieve_conf]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{m_retrieve_conf},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\\x84'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\\x84']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{m_retrieve_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{m_retrieve_conf});
        %item = (__RULE__ => q{m_retrieve_conf});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\\x84']},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_retrieve_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "\x84"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_retrieve_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $return = $item[0]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\\x84']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{m_retrieve_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{m_retrieve_conf},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{m_retrieve_conf},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{m_retrieve_conf},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{m_retrieve_conf},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}
}
package MMS::Parser::WorkHorse; sub new { my $self = bless( {
                 'localvars' => '',
                 'startcode' => '',
                 'namespace' => 'Parse::RecDescent::MMS::Parser::WorkHorse',
                 '_AUTOTREE' => undef,
                 'rules' => {
                              'content_type_head' => bless( {
                                                              'name' => 'content_type_head',
                                                              'calls' => [
                                                                           'content_type_value'
                                                                         ],
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'error' => undef,
                                                                                    'number' => 0,
                                                                                    'strcount' => 1,
                                                                                    'dircount' => 0,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'actcount' => 1,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'description' => '\'\\\\x84\'',
                                                                                                          'line' => 641,
                                                                                                          'pattern' => '\\x84',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'content_type_value',
                                                                                                          'line' => 641,
                                                                                                          'implicit' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'line' => 642,
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ]
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'line' => 641,
                                                              'opcount' => 0,
                                                              'changed' => 0,
                                                              'impcount' => 0
                                                            }, 'Parse::RecDescent::Rule' ),
                              'multipart_header' => bless( {
                                                             'changed' => 0,
                                                             'impcount' => 0,
                                                             'line' => 515,
                                                             'opcount' => 0,
                                                             'vars' => '',
                                                             'prods' => [
                                                                          bless( {
                                                                                   'number' => 0,
                                                                                   'strcount' => 0,
                                                                                   'error' => undef,
                                                                                   'line' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'patcount' => 0,
                                                                                   'dircount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'line' => 515,
                                                                                                         'implicit' => undef,
                                                                                                         'subrule' => 'uintvar',
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'actcount' => 0
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'name' => 'multipart_header',
                                                             'calls' => [
                                                                          'uintvar'
                                                                        ]
                                                           }, 'Parse::RecDescent::Rule' ),
                              'message_id_head' => bless( {
                                                            'impcount' => 0,
                                                            'changed' => 0,
                                                            'opcount' => 0,
                                                            'line' => 655,
                                                            'prods' => [
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 655,
                                                                                                        'description' => '\'\\\\x8b\'',
                                                                                                        'pattern' => '\\x8b',
                                                                                                        'hashname' => '__STRING1__'
                                                                                                      }, 'Parse::RecDescent::InterpLit' ),
                                                                                               bless( {
                                                                                                        'subrule' => 'message_id_value',
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 655,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                        'hashname' => '__ACTION1__',
                                                                                                        'line' => 656
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ],
                                                                                  'actcount' => 1,
                                                                                  'uncommit' => undef,
                                                                                  'line' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'number' => 0,
                                                                                  'strcount' => 1,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'vars' => '',
                                                            'calls' => [
                                                                         'message_id_value'
                                                                       ],
                                                            'name' => 'message_id_head'
                                                          }, 'Parse::RecDescent::Rule' ),
                              'value_length' => bless( {
                                                         'line' => 275,
                                                         'opcount' => 0,
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'name' => 'value_length',
                                                         'calls' => [
                                                                      'short_length',
                                                                      'long_length'
                                                                    ],
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'error' => undef,
                                                                               'number' => 0,
                                                                               'strcount' => 0,
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0,
                                                                               'dircount' => 0,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'matchrule' => 0,
                                                                                                     'subrule' => 'short_length',
                                                                                                     'implicit' => undef,
                                                                                                     'line' => 276
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'actcount' => 0
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'implicit' => undef,
                                                                                                     'line' => 276,
                                                                                                     'lookahead' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'matchrule' => 0,
                                                                                                     'subrule' => 'long_length'
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'actcount' => 0,
                                                                               'error' => undef,
                                                                               'number' => 1,
                                                                               'strcount' => 0,
                                                                               'uncommit' => undef,
                                                                               'line' => 276,
                                                                               'patcount' => 0,
                                                                               'dircount' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'start_info_related_parameter' => bless( {
                                                                         'impcount' => 0,
                                                                         'changed' => 0,
                                                                         'opcount' => 0,
                                                                         'line' => 419,
                                                                         'prods' => [
                                                                                      bless( {
                                                                                               'dircount' => 0,
                                                                                               'uncommit' => undef,
                                                                                               'line' => undef,
                                                                                               'patcount' => 0,
                                                                                               'error' => undef,
                                                                                               'number' => 0,
                                                                                               'strcount' => 1,
                                                                                               'actcount' => 1,
                                                                                               'items' => [
                                                                                                            bless( {
                                                                                                                     'lookahead' => 0,
                                                                                                                     'hashname' => '__STRING1__',
                                                                                                                     'pattern' => '\\x9a',
                                                                                                                     'description' => '\'\\\\x9a\'',
                                                                                                                     'line' => 419
                                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                                            bless( {
                                                                                                                     'subrule' => 'text_value',
                                                                                                                     'matchrule' => 0,
                                                                                                                     'argcode' => undef,
                                                                                                                     'lookahead' => 0,
                                                                                                                     'line' => 419,
                                                                                                                     'implicit' => undef
                                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                                            bless( {
                                                                                                                     'line' => 420,
                                                                                                                     'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                                     'hashname' => '__ACTION1__',
                                                                                                                     'lookahead' => 0
                                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                                          ]
                                                                                             }, 'Parse::RecDescent::Production' )
                                                                                    ],
                                                                         'vars' => '',
                                                                         'calls' => [
                                                                                      'text_value'
                                                                                    ],
                                                                         'name' => 'start_info_related_parameter'
                                                                       }, 'Parse::RecDescent::Rule' ),
                              '_mixed_time_value' => bless( {
                                                              'calls' => [
                                                                           'value_length',
                                                                           '_mtv_token',
                                                                           'long_integer'
                                                                         ],
                                                              'name' => '_mixed_time_value',
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'implicit' => undef,
                                                                                                          'line' => 709,
                                                                                                          'subrule' => 'value_length',
                                                                                                          'lookahead' => 0,
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'subrule' => '_mtv_token',
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 709,
                                                                                                          'implicit' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'implicit' => undef,
                                                                                                          'line' => 709,
                                                                                                          'subrule' => 'long_integer',
                                                                                                          'lookahead' => 0,
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'line' => 709,
                                                                                                          'code' => '{ 
   $return = { type => $item{_mtv_token}, value => $item{long_integer} };
   1;
}',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'dircount' => 0,
                                                                                    'error' => undef,
                                                                                    'strcount' => 0,
                                                                                    'number' => 0
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'opcount' => 0,
                                                              'line' => 708,
                                                              'impcount' => 0,
                                                              'changed' => 0
                                                            }, 'Parse::RecDescent::Rule' ),
                              'field_name' => bless( {
                                                       'vars' => '',
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'token_text',
                                                                                                   'line' => 507,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => undef,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 507,
                                                                                                   'implicit' => undef,
                                                                                                   'subrule' => 'well_known_field_name',
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'strcount' => 0,
                                                                             'number' => 1,
                                                                             'error' => undef,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 507,
                                                                             'dircount' => 0
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'name' => 'field_name',
                                                       'calls' => [
                                                                    'token_text',
                                                                    'well_known_field_name'
                                                                  ],
                                                       'changed' => 0,
                                                       'impcount' => 0,
                                                       'line' => 507,
                                                       'opcount' => 0
                                                     }, 'Parse::RecDescent::Rule' ),
                              '_address_value' => bless( {
                                                           'opcount' => 0,
                                                           'line' => 684,
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'calls' => [
                                                                        'encoded_string_value'
                                                                      ],
                                                           'name' => '_address_value',
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'dircount' => 0,
                                                                                 'patcount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'line' => undef,
                                                                                 'error' => undef,
                                                                                 'strcount' => 0,
                                                                                 'number' => 0,
                                                                                 'actcount' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'implicit' => undef,
                                                                                                       'line' => 685,
                                                                                                       'lookahead' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'matchrule' => 0,
                                                                                                       'subrule' => 'encoded_string_value'
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'line' => 685,
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'code' => '{
   # Will make more formal later
   my %return = %{$item[1]};
   my $v = $item[1]{text};
   if ($v =~ m{\\A (.+) /TYPE= (\\w+) \\z}mxs) {
      $return{address} = $1;
      $return{TYPE}    = $2;
   }
   else { # email
      $return{address} = $v;
   }
   $return = \\%return;
   1;
}',
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ]
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ]
                                                         }, 'Parse::RecDescent::Rule' ),
                              'from_head' => bless( {
                                                      'calls' => [
                                                                   'from_value'
                                                                 ],
                                                      'name' => 'from_head',
                                                      'vars' => '',
                                                      'prods' => [
                                                                   bless( {
                                                                            'strcount' => 1,
                                                                            'number' => 0,
                                                                            'error' => undef,
                                                                            'dircount' => 0,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => undef,
                                                                            'actcount' => 1,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => '\\x89',
                                                                                                  'description' => '\'\\\\x89\'',
                                                                                                  'line' => 651
                                                                                                }, 'Parse::RecDescent::InterpLit' ),
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'subrule' => 'from_value',
                                                                                                  'implicit' => undef,
                                                                                                  'line' => 651
                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                         bless( {
                                                                                                  'line' => 652,
                                                                                                  'hashname' => '__ACTION1__',
                                                                                                  'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'opcount' => 0,
                                                      'line' => 651,
                                                      'impcount' => 0,
                                                      'changed' => 0
                                                    }, 'Parse::RecDescent::Rule' ),
                              'Resume' => bless( {
                                                   'calls' => [],
                                                   'name' => 'Resume',
                                                   'prods' => [
                                                                bless( {
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'hashname' => '__STRING1__',
                                                                                               'description' => '\'\\\\x09\'',
                                                                                               'line' => 215,
                                                                                               'pattern' => '\\x09',
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::InterpLit' ),
                                                                                      bless( {
                                                                                               'code' => '{ $return = $item[0]; 1; }',
                                                                                               'hashname' => '__ACTION1__',
                                                                                               'line' => 215,
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                    ],
                                                                         'actcount' => 1,
                                                                         'line' => undef,
                                                                         'uncommit' => undef,
                                                                         'patcount' => 0,
                                                                         'dircount' => 0,
                                                                         'error' => undef,
                                                                         'number' => 0,
                                                                         'strcount' => 1
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ],
                                                   'vars' => '',
                                                   'opcount' => 0,
                                                   'line' => 215,
                                                   'impcount' => 0,
                                                   'changed' => 0
                                                 }, 'Parse::RecDescent::Rule' ),
                              'EXPIRED' => bless( {
                                                    'calls' => [],
                                                    'name' => 'EXPIRED',
                                                    'vars' => '',
                                                    'prods' => [
                                                                 bless( {
                                                                          'actcount' => 1,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'line' => 798,
                                                                                                'description' => '\'\\\\x80\'',
                                                                                                'pattern' => '\\x80',
                                                                                                'hashname' => '__STRING1__',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                       bless( {
                                                                                                'line' => 798,
                                                                                                'code' => '{ $return = $item[0]; 1; }',
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'number' => 0,
                                                                          'strcount' => 1,
                                                                          'dircount' => 0,
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'patcount' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'opcount' => 0,
                                                    'line' => 798,
                                                    'impcount' => 0,
                                                    'changed' => 0
                                                  }, 'Parse::RecDescent::Rule' ),
                              'differences_parameter' => bless( {
                                                                  'calls' => [
                                                                               'field_name'
                                                                             ],
                                                                  'name' => 'differences_parameter',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'line' => undef,
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 0,
                                                                                        'dircount' => 0,
                                                                                        'error' => undef,
                                                                                        'number' => 0,
                                                                                        'strcount' => 1,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'hashname' => '__STRING1__',
                                                                                                              'description' => '\'\\\\x87\'',
                                                                                                              'line' => 381,
                                                                                                              'pattern' => '\\x87'
                                                                                                            }, 'Parse::RecDescent::InterpLit' ),
                                                                                                     bless( {
                                                                                                              'line' => 381,
                                                                                                              'implicit' => undef,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'lookahead' => 0,
                                                                                                              'subrule' => 'field_name'
                                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'line' => 382,
                                                                                                              'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                              'hashname' => '__ACTION1__'
                                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                                   ],
                                                                                        'actcount' => 1
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'vars' => '',
                                                                  'opcount' => 0,
                                                                  'line' => 381,
                                                                  'impcount' => 0,
                                                                  'changed' => 0
                                                                }, 'Parse::RecDescent::Rule' ),
                              'level_parameter' => bless( {
                                                            'changed' => 0,
                                                            'impcount' => 0,
                                                            'line' => 373,
                                                            'opcount' => 0,
                                                            'vars' => '',
                                                            'prods' => [
                                                                         bless( {
                                                                                  'actcount' => 1,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 373,
                                                                                                        'description' => '\'\\\\x82\'',
                                                                                                        'pattern' => '\\x82',
                                                                                                        'hashname' => '__STRING1__'
                                                                                                      }, 'Parse::RecDescent::InterpLit' ),
                                                                                               bless( {
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'version_value',
                                                                                                        'line' => 373,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'hashname' => '__ACTION1__',
                                                                                                        'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                        'line' => 374
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => undef,
                                                                                  'error' => undef,
                                                                                  'strcount' => 1,
                                                                                  'number' => 0
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'name' => 'level_parameter',
                                                            'calls' => [
                                                                         'version_value'
                                                                       ]
                                                          }, 'Parse::RecDescent::Rule' ),
                              'path_deprecated_parameter' => bless( {
                                                                      'changed' => 0,
                                                                      'impcount' => 0,
                                                                      'line' => 397,
                                                                      'opcount' => 0,
                                                                      'vars' => '',
                                                                      'prods' => [
                                                                                   bless( {
                                                                                            'actcount' => 1,
                                                                                            'items' => [
                                                                                                         bless( {
                                                                                                                  'line' => 397,
                                                                                                                  'description' => '\'\\\\x8f\'',
                                                                                                                  'pattern' => '\\x8f',
                                                                                                                  'hashname' => '__STRING1__',
                                                                                                                  'lookahead' => 0
                                                                                                                }, 'Parse::RecDescent::InterpLit' ),
                                                                                                         bless( {
                                                                                                                  'implicit' => undef,
                                                                                                                  'line' => 397,
                                                                                                                  'lookahead' => 0,
                                                                                                                  'argcode' => undef,
                                                                                                                  'matchrule' => 0,
                                                                                                                  'subrule' => 'text_string'
                                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                                         bless( {
                                                                                                                  'lookahead' => 0,
                                                                                                                  'line' => 398,
                                                                                                                  'code' => '{ $return = build_parameter(@item, \'1.3\'); 1; }',
                                                                                                                  'hashname' => '__ACTION1__'
                                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                                       ],
                                                                                            'dircount' => 0,
                                                                                            'line' => undef,
                                                                                            'patcount' => 0,
                                                                                            'uncommit' => undef,
                                                                                            'error' => undef,
                                                                                            'number' => 0,
                                                                                            'strcount' => 1
                                                                                          }, 'Parse::RecDescent::Production' )
                                                                                 ],
                                                                      'name' => 'path_deprecated_parameter',
                                                                      'calls' => [
                                                                                   'text_string'
                                                                                 ]
                                                                    }, 'Parse::RecDescent::Rule' ),
                              'MMS_header' => bless( {
                                                       'calls' => [
                                                                    'bcc_head',
                                                                    'cc_head',
                                                                    'content_location_head',
                                                                    'date_head',
                                                                    'delivery_report_head',
                                                                    'delivery_time_head',
                                                                    'expiry_head',
                                                                    'from_head',
                                                                    'message_class_head',
                                                                    'message_id_head',
                                                                    'message_type_head',
                                                                    'message_size_head',
                                                                    'MMS_version_head',
                                                                    'priority_head',
                                                                    'read_reply_head',
                                                                    'report_allowed_head',
                                                                    'response_status_head',
                                                                    'response_text_head',
                                                                    'sender_visibility_head',
                                                                    'status_head',
                                                                    'subject_head',
                                                                    'to_head'
                                                                  ],
                                                       'name' => 'MMS_header',
                                                       'prods' => [
                                                                    bless( {
                                                                             'line' => undef,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'bcc_head',
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 612
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'dircount' => 0,
                                                                             'line' => 613,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 1,
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 613,
                                                                                                   'implicit' => undef,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'cc_head'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ]
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'strcount' => 0,
                                                                             'number' => 2,
                                                                             'error' => undef,
                                                                             'patcount' => 0,
                                                                             'line' => 614,
                                                                             'uncommit' => undef,
                                                                             'dircount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'content_location_head',
                                                                                                   'line' => 614,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'date_head',
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 615
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'line' => 615,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 3
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'number' => 4,
                                                                             'strcount' => 0,
                                                                             'error' => undef,
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'line' => 616,
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 616,
                                                                                                   'subrule' => 'delivery_report_head',
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ]
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 5,
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'line' => 617,
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'subrule' => 'delivery_time_head',
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 617
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ]
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'subrule' => 'expiry_head',
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 618
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 618,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 6
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 619,
                                                                                                   'implicit' => undef,
                                                                                                   'subrule' => 'from_head',
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 619,
                                                                             'patcount' => 0,
                                                                             'error' => undef,
                                                                             'number' => 7,
                                                                             'strcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'subrule' => 'message_class_head',
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 620
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'patcount' => 0,
                                                                             'line' => 620,
                                                                             'uncommit' => undef,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'number' => 8,
                                                                             'strcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'message_id_head',
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'line' => 621,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'error' => undef,
                                                                             'number' => 9,
                                                                             'strcount' => 0,
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 621,
                                                                             'patcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'message_type_head',
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 622
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'line' => 622,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'number' => 10,
                                                                             'strcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 623,
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'subrule' => 'message_size_head'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'strcount' => 0,
                                                                             'number' => 11,
                                                                             'error' => undef,
                                                                             'dircount' => 0,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 623
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 12,
                                                                             'uncommit' => undef,
                                                                             'line' => 624,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 624,
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'subrule' => 'MMS_version_head'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'strcount' => 0,
                                                                             'number' => 13,
                                                                             'error' => undef,
                                                                             'dircount' => 0,
                                                                             'patcount' => 0,
                                                                             'line' => 625,
                                                                             'uncommit' => undef,
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 625,
                                                                                                   'implicit' => undef,
                                                                                                   'subrule' => 'priority_head',
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ]
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'number' => 14,
                                                                             'strcount' => 0,
                                                                             'error' => undef,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'line' => 626,
                                                                             'dircount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'read_reply_head',
                                                                                                   'line' => 626,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 627,
                                                                                                   'subrule' => 'report_allowed_head',
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'dircount' => 0,
                                                                             'line' => 627,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'number' => 15,
                                                                             'strcount' => 0,
                                                                             'error' => undef
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'subrule' => 'response_status_head',
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 628
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 628,
                                                                             'patcount' => 0,
                                                                             'strcount' => 0,
                                                                             'number' => 16,
                                                                             'error' => undef
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'dircount' => 0,
                                                                             'line' => 629,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 17,
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 629,
                                                                                                   'subrule' => 'response_text_head',
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ]
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'strcount' => 0,
                                                                             'number' => 18,
                                                                             'error' => undef,
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 630,
                                                                             'patcount' => 0,
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 630,
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'subrule' => 'sender_visibility_head'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ]
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 631,
                                                                                                   'lookahead' => 0,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'subrule' => 'status_head'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 631,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'number' => 19,
                                                                             'strcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'strcount' => 0,
                                                                             'number' => 20,
                                                                             'error' => undef,
                                                                             'line' => 632,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 632,
                                                                                                   'implicit' => undef,
                                                                                                   'subrule' => 'subject_head',
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 633,
                                                                                                   'implicit' => undef,
                                                                                                   'subrule' => 'to_head',
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'number' => 21,
                                                                             'strcount' => 0,
                                                                             'error' => undef,
                                                                             'line' => 633,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'vars' => '',
                                                       'opcount' => 0,
                                                       'line' => 612,
                                                       'impcount' => 0,
                                                       'changed' => 0
                                                     }, 'Parse::RecDescent::Rule' ),
                              'Reserved' => bless( {
                                                     'impcount' => 0,
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'line' => 206,
                                                     'prods' => [
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'line' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 1,
                                                                           'number' => 0,
                                                                           'strcount' => 0,
                                                                           'error' => undef,
                                                                           'actcount' => 1,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'rdelim' => '/',
                                                                                                 'description' => '/[\\\\x00\\\\x81-\\\\xff]/',
                                                                                                 'ldelim' => '/',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 206,
                                                                                                 'pattern' => '[\\x00\\x81-\\xff]',
                                                                                                 'mod' => '',
                                                                                                 'hashname' => '__PATTERN1__'
                                                                                               }, 'Parse::RecDescent::Token' ),
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 206,
                                                                                                 'code' => '{ $return = $item[0]; 1; }',
                                                                                                 'hashname' => '__ACTION1__'
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'vars' => '',
                                                     'calls' => [],
                                                     'name' => 'Reserved'
                                                   }, 'Parse::RecDescent::Rule' ),
                              'start_related_deprecated_parameter' => bless( {
                                                                               'impcount' => 0,
                                                                               'changed' => 0,
                                                                               'opcount' => 0,
                                                                               'line' => 387,
                                                                               'vars' => '',
                                                                               'prods' => [
                                                                                            bless( {
                                                                                                     'items' => [
                                                                                                                  bless( {
                                                                                                                           'description' => '\'\\\\x8a\'',
                                                                                                                           'line' => 387,
                                                                                                                           'pattern' => '\\x8a',
                                                                                                                           'hashname' => '__STRING1__',
                                                                                                                           'lookahead' => 0
                                                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                                                  bless( {
                                                                                                                           'subrule' => 'text_string',
                                                                                                                           'argcode' => undef,
                                                                                                                           'matchrule' => 0,
                                                                                                                           'lookahead' => 0,
                                                                                                                           'line' => 387,
                                                                                                                           'implicit' => undef
                                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                                  bless( {
                                                                                                                           'lookahead' => 0,
                                                                                                                           'line' => 388,
                                                                                                                           'hashname' => '__ACTION1__',
                                                                                                                           'code' => '{ $return = build_parameter(@item, \'1.2\'); 1; }'
                                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                                ],
                                                                                                     'actcount' => 1,
                                                                                                     'uncommit' => undef,
                                                                                                     'line' => undef,
                                                                                                     'patcount' => 0,
                                                                                                     'dircount' => 0,
                                                                                                     'error' => undef,
                                                                                                     'number' => 0,
                                                                                                     'strcount' => 1
                                                                                                   }, 'Parse::RecDescent::Production' )
                                                                                          ],
                                                                               'calls' => [
                                                                                            'text_string'
                                                                                          ],
                                                                               'name' => 'start_related_deprecated_parameter'
                                                                             }, 'Parse::RecDescent::Rule' ),
                              'uri_value' => bless( {
                                                      'name' => 'uri_value',
                                                      'calls' => [
                                                                   'text_string'
                                                                 ],
                                                      'prods' => [
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'argcode' => undef,
                                                                                                  'matchrule' => 0,
                                                                                                  'lookahead' => 0,
                                                                                                  'subrule' => 'text_string',
                                                                                                  'line' => 330,
                                                                                                  'implicit' => undef
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => undef,
                                                                            'error' => undef,
                                                                            'number' => 0,
                                                                            'strcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'number' => 1,
                                                                            'strcount' => 0,
                                                                            'error' => undef,
                                                                            'line' => undef,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'dircount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'implicit' => undef,
                                                                                                  'line' => 702,
                                                                                                  'subrule' => 'text_string',
                                                                                                  'lookahead' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'matchrule' => 0
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'vars' => '',
                                                      'line' => 329,
                                                      'opcount' => 0,
                                                      'changed' => 0,
                                                      'impcount' => 0
                                                    }, 'Parse::RecDescent::Rule' ),
                              'subject_value' => bless( {
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'line' => 804,
                                                                                                      'implicit' => undef,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => 'encoded_string_value'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'actcount' => 0,
                                                                                'error' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 0,
                                                                                'line' => undef,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'dircount' => 0
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'name' => 'subject_value',
                                                          'calls' => [
                                                                       'encoded_string_value'
                                                                     ],
                                                          'changed' => 0,
                                                          'impcount' => 0,
                                                          'line' => 803,
                                                          'opcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'comment_deprecated_parameter' => bless( {
                                                                         'calls' => [
                                                                                      'text_string'
                                                                                    ],
                                                                         'name' => 'comment_deprecated_parameter',
                                                                         'prods' => [
                                                                                      bless( {
                                                                                               'number' => 0,
                                                                                               'strcount' => 1,
                                                                                               'error' => undef,
                                                                                               'patcount' => 0,
                                                                                               'uncommit' => undef,
                                                                                               'line' => undef,
                                                                                               'dircount' => 0,
                                                                                               'items' => [
                                                                                                            bless( {
                                                                                                                     'lookahead' => 0,
                                                                                                                     'hashname' => '__STRING1__',
                                                                                                                     'line' => 391,
                                                                                                                     'description' => '\'\\\\x8c\'',
                                                                                                                     'pattern' => '\\x8c'
                                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                                            bless( {
                                                                                                                     'line' => 391,
                                                                                                                     'implicit' => undef,
                                                                                                                     'argcode' => undef,
                                                                                                                     'matchrule' => 0,
                                                                                                                     'lookahead' => 0,
                                                                                                                     'subrule' => 'text_string'
                                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                                            bless( {
                                                                                                                     'lookahead' => 0,
                                                                                                                     'code' => '{ $return = build_parameter(@item, \'1.3\'); 1; }',
                                                                                                                     'hashname' => '__ACTION1__',
                                                                                                                     'line' => 392
                                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                                          ],
                                                                                               'actcount' => 1
                                                                                             }, 'Parse::RecDescent::Production' )
                                                                                    ],
                                                                         'vars' => '',
                                                                         'opcount' => 0,
                                                                         'line' => 391,
                                                                         'impcount' => 0,
                                                                         'changed' => 0
                                                                       }, 'Parse::RecDescent::Rule' ),
                              'charset_parameter' => bless( {
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'dircount' => 0,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'strcount' => 1,
                                                                                    'number' => 0,
                                                                                    'error' => undef,
                                                                                    'actcount' => 1,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'line' => 371,
                                                                                                          'description' => '\'\\\\x81\'',
                                                                                                          'pattern' => '\\x81',
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'well_known_charset',
                                                                                                          'line' => 371,
                                                                                                          'implicit' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'line' => 372
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ]
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'calls' => [
                                                                           'well_known_charset'
                                                                         ],
                                                              'name' => 'charset_parameter',
                                                              'impcount' => 0,
                                                              'changed' => 0,
                                                              'opcount' => 0,
                                                              'line' => 371
                                                            }, 'Parse::RecDescent::Rule' ),
                              '_mtv_token' => bless( {
                                                       'vars' => '',
                                                       'prods' => [
                                                                    bless( {
                                                                             'uncommit' => undef,
                                                                             'line' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'absolute_token',
                                                                                                   'line' => 713,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'relative_token',
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 713
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'line' => 713,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 1
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'calls' => [
                                                                    'absolute_token',
                                                                    'relative_token'
                                                                  ],
                                                       'name' => '_mtv_token',
                                                       'impcount' => 0,
                                                       'changed' => 0,
                                                       'opcount' => 0,
                                                       'line' => 713
                                                     }, 'Parse::RecDescent::Rule' ),
                              'read_reply_head' => bless( {
                                                            'vars' => '',
                                                            'prods' => [
                                                                         bless( {
                                                                                  'actcount' => 1,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'pattern' => '\\x90',
                                                                                                        'description' => '\'\\\\x90\'',
                                                                                                        'line' => 666,
                                                                                                        'hashname' => '__STRING1__'
                                                                                                      }, 'Parse::RecDescent::InterpLit' ),
                                                                                               bless( {
                                                                                                        'line' => 666,
                                                                                                        'implicit' => undef,
                                                                                                        'subrule' => 'read_reply_value',
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0
                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                               bless( {
                                                                                                        'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                        'hashname' => '__ACTION1__',
                                                                                                        'line' => 667,
                                                                                                        'lookahead' => 0
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ],
                                                                                  'strcount' => 1,
                                                                                  'number' => 0,
                                                                                  'error' => undef,
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => undef,
                                                                                  'patcount' => 0
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'name' => 'read_reply_head',
                                                            'calls' => [
                                                                         'read_reply_value'
                                                                       ],
                                                            'changed' => 0,
                                                            'impcount' => 0,
                                                            'line' => 666,
                                                            'opcount' => 0
                                                          }, 'Parse::RecDescent::Rule' ),
                              'name_parameter' => bless( {
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'opcount' => 0,
                                                           'line' => 413,
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'number' => 0,
                                                                                 'strcount' => 1,
                                                                                 'error' => undef,
                                                                                 'dircount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'patcount' => 0,
                                                                                 'line' => undef,
                                                                                 'actcount' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'hashname' => '__STRING1__',
                                                                                                       'pattern' => '\\x97',
                                                                                                       'line' => 413,
                                                                                                       'description' => '\'\\\\x97\''
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'subrule' => 'text_value',
                                                                                                       'lookahead' => 0,
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'implicit' => undef,
                                                                                                       'line' => 413
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'line' => 414,
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ]
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'calls' => [
                                                                        'text_value'
                                                                      ],
                                                           'name' => 'name_parameter'
                                                         }, 'Parse::RecDescent::Rule' ),
                              'ConnectReply' => bless( {
                                                         'name' => 'ConnectReply',
                                                         'calls' => [],
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'hashname' => '__STRING1__',
                                                                                                     'line' => 208,
                                                                                                     'description' => '\'\\\\x02\'',
                                                                                                     'pattern' => '\\x02',
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'line' => 208,
                                                                                                     'code' => '{ $return = $item[0]; 1; }',
                                                                                                     'hashname' => '__ACTION1__'
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ],
                                                                               'actcount' => 1,
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0,
                                                                               'dircount' => 0,
                                                                               'strcount' => 1,
                                                                               'number' => 0,
                                                                               'error' => undef
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'line' => 208,
                                                         'opcount' => 0,
                                                         'changed' => 0,
                                                         'impcount' => 0
                                                       }, 'Parse::RecDescent::Rule' ),
                              'MMS_version_head' => bless( {
                                                             'vars' => '',
                                                             'prods' => [
                                                                          bless( {
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'hashname' => '__STRING1__',
                                                                                                         'line' => 660,
                                                                                                         'description' => '\'\\\\x8d\'',
                                                                                                         'pattern' => '\\x8d',
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::InterpLit' ),
                                                                                                bless( {
                                                                                                         'line' => 660,
                                                                                                         'implicit' => undef,
                                                                                                         'subrule' => 'MMS_version_value',
                                                                                                         'matchrule' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::Subrule' ),
                                                                                                bless( {
                                                                                                         'lookahead' => 0,
                                                                                                         'line' => 661,
                                                                                                         'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                         'hashname' => '__ACTION1__'
                                                                                                       }, 'Parse::RecDescent::Action' )
                                                                                              ],
                                                                                   'actcount' => 1,
                                                                                   'strcount' => 1,
                                                                                   'number' => 0,
                                                                                   'error' => undef,
                                                                                   'line' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'patcount' => 0,
                                                                                   'dircount' => 0
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'name' => 'MMS_version_head',
                                                             'calls' => [
                                                                          'MMS_version_value'
                                                                        ],
                                                             'changed' => 0,
                                                             'impcount' => 0,
                                                             'line' => 660,
                                                             'opcount' => 0
                                                           }, 'Parse::RecDescent::Rule' ),
                              'transaction_id_value' => bless( {
                                                                 'name' => 'transaction_id_value',
                                                                 'calls' => [
                                                                              'text_string'
                                                                            ],
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'actcount' => 0,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'line' => 806,
                                                                                                             'implicit' => undef,
                                                                                                             'matchrule' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'lookahead' => 0,
                                                                                                             'subrule' => 'text_string'
                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                  ],
                                                                                       'number' => 0,
                                                                                       'strcount' => 0,
                                                                                       'error' => undef,
                                                                                       'dircount' => 0,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'line' => undef
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'vars' => '',
                                                                 'line' => 806,
                                                                 'opcount' => 0,
                                                                 'changed' => 0,
                                                                 'impcount' => 0
                                                               }, 'Parse::RecDescent::Rule' ),
                              'Delete_GetPDU' => bless( {
                                                          'calls' => [],
                                                          'name' => 'Delete_GetPDU',
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'strcount' => 1,
                                                                                'number' => 0,
                                                                                'error' => undef,
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'uncommit' => undef,
                                                                                'dircount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'pattern' => '\\x43',
                                                                                                      'line' => 220,
                                                                                                      'description' => '\'\\\\x43\'',
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'code' => '{ $return = $item[0]; 1; }',
                                                                                                      'line' => 220
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'actcount' => 1
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'opcount' => 0,
                                                          'line' => 220,
                                                          'impcount' => 0,
                                                          'changed' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'version_value' => bless( {
                                                          'opcount' => 0,
                                                          'line' => 319,
                                                          'impcount' => 0,
                                                          'changed' => 0,
                                                          'calls' => [
                                                                       '_short_integer_version',
                                                                       'text_string'
                                                                     ],
                                                          'name' => 'version_value',
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'subrule' => '_short_integer_version',
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 320,
                                                                                                      'implicit' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'dircount' => 0,
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'uncommit' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 0,
                                                                                'error' => undef
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => 'text_string',
                                                                                                      'line' => 320,
                                                                                                      'implicit' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'dircount' => 0,
                                                                                'patcount' => 0,
                                                                                'line' => 320,
                                                                                'uncommit' => undef,
                                                                                'error' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 1
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => ''
                                                        }, 'Parse::RecDescent::Rule' ),
                              'DEFERRED' => bless( {
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'number' => 0,
                                                                           'strcount' => 1,
                                                                           'dircount' => 0,
                                                                           'line' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'actcount' => 1,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 801,
                                                                                                 'description' => '\'\\\\x83\'',
                                                                                                 'pattern' => '\\x83',
                                                                                                 'hashname' => '__STRING1__'
                                                                                               }, 'Parse::RecDescent::InterpLit' ),
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'code' => '{ $return = $item[0]; 1; }',
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'line' => 801
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'name' => 'DEFERRED',
                                                     'calls' => [],
                                                     'changed' => 0,
                                                     'impcount' => 0,
                                                     'line' => 801,
                                                     'opcount' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'ct_constrained_media' => bless( {
                                                                 'opcount' => 0,
                                                                 'line' => 442,
                                                                 'impcount' => 0,
                                                                 'changed' => 0,
                                                                 'calls' => [
                                                                              'constrained_media'
                                                                            ],
                                                                 'name' => 'ct_constrained_media',
                                                                 'vars' => '',
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'actcount' => 1,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'implicit' => undef,
                                                                                                             'line' => 442,
                                                                                                             'subrule' => 'constrained_media',
                                                                                                             'lookahead' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'matchrule' => 0
                                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                                    bless( {
                                                                                                             'lookahead' => 0,
                                                                                                             'hashname' => '__ACTION1__',
                                                                                                             'code' => '{
   $return = { text => $item[1], media_type => $item[1], parameters => {} };
   1;
}',
                                                                                                             'line' => 442
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ],
                                                                                       'error' => undef,
                                                                                       'strcount' => 0,
                                                                                       'number' => 0,
                                                                                       'dircount' => 0,
                                                                                       'uncommit' => undef,
                                                                                       'line' => undef,
                                                                                       'patcount' => 0
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ]
                                                               }, 'Parse::RecDescent::Rule' ),
                              'q_parameter' => bless( {
                                                        'changed' => 0,
                                                        'impcount' => 0,
                                                        'line' => 368,
                                                        'opcount' => 0,
                                                        'prods' => [
                                                                     bless( {
                                                                              'dircount' => 0,
                                                                              'patcount' => 0,
                                                                              'uncommit' => undef,
                                                                              'line' => undef,
                                                                              'number' => 0,
                                                                              'strcount' => 1,
                                                                              'error' => undef,
                                                                              'actcount' => 1,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'line' => 369,
                                                                                                    'description' => '\'\\\\x80\'',
                                                                                                    'pattern' => '\\x80',
                                                                                                    'hashname' => '__STRING1__',
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'subrule' => 'q_value',
                                                                                                    'matchrule' => 0,
                                                                                                    'argcode' => undef,
                                                                                                    'lookahead' => 0,
                                                                                                    'line' => 369,
                                                                                                    'implicit' => undef
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'line' => 370,
                                                                                                    'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                    'hashname' => '__ACTION1__'
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ]
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'name' => 'q_parameter',
                                                        'calls' => [
                                                                     'q_value'
                                                                   ]
                                                      }, 'Parse::RecDescent::Rule' ),
                              'response_status_head' => bless( {
                                                                 'impcount' => 0,
                                                                 'changed' => 0,
                                                                 'opcount' => 0,
                                                                 'line' => 670,
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'line' => undef,
                                                                                       'dircount' => 0,
                                                                                       'strcount' => 1,
                                                                                       'number' => 0,
                                                                                       'error' => undef,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'pattern' => '\\x92',
                                                                                                             'description' => '\'\\\\x92\'',
                                                                                                             'line' => 670,
                                                                                                             'hashname' => '__STRING1__',
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                                    bless( {
                                                                                                             'line' => 670,
                                                                                                             'implicit' => undef,
                                                                                                             'argcode' => undef,
                                                                                                             'matchrule' => 0,
                                                                                                             'lookahead' => 0,
                                                                                                             'subrule' => 'response_status_value'
                                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                                    bless( {
                                                                                                             'hashname' => '__ACTION1__',
                                                                                                             'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                             'line' => 671,
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ],
                                                                                       'actcount' => 1
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'vars' => '',
                                                                 'calls' => [
                                                                              'response_status_value'
                                                                            ],
                                                                 'name' => 'response_status_head'
                                                               }, 'Parse::RecDescent::Rule' ),
                              'sender_visibility_value' => bless( {
                                                                    'impcount' => 0,
                                                                    'changed' => 0,
                                                                    'opcount' => 0,
                                                                    'line' => 793,
                                                                    'vars' => '',
                                                                    'prods' => [
                                                                                 bless( {
                                                                                          'strcount' => 0,
                                                                                          'number' => 0,
                                                                                          'error' => undef,
                                                                                          'dircount' => 0,
                                                                                          'patcount' => 0,
                                                                                          'line' => undef,
                                                                                          'uncommit' => undef,
                                                                                          'actcount' => 0,
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'implicit' => undef,
                                                                                                                'line' => 793,
                                                                                                                'subrule' => 'HIDE',
                                                                                                                'lookahead' => 0,
                                                                                                                'matchrule' => 0,
                                                                                                                'argcode' => undef
                                                                                                              }, 'Parse::RecDescent::Subrule' )
                                                                                                     ]
                                                                                        }, 'Parse::RecDescent::Production' ),
                                                                                 bless( {
                                                                                          'number' => 1,
                                                                                          'strcount' => 0,
                                                                                          'error' => undef,
                                                                                          'line' => 793,
                                                                                          'uncommit' => undef,
                                                                                          'patcount' => 0,
                                                                                          'dircount' => 0,
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'subrule' => 'SHOW',
                                                                                                                'argcode' => undef,
                                                                                                                'matchrule' => 0,
                                                                                                                'lookahead' => 0,
                                                                                                                'line' => 793,
                                                                                                                'implicit' => undef
                                                                                                              }, 'Parse::RecDescent::Subrule' )
                                                                                                     ],
                                                                                          'actcount' => 0
                                                                                        }, 'Parse::RecDescent::Production' )
                                                                               ],
                                                                    'calls' => [
                                                                                 'HIDE',
                                                                                 'SHOW'
                                                                               ],
                                                                    'name' => 'sender_visibility_value'
                                                                  }, 'Parse::RecDescent::Rule' ),
                              'text_value' => bless( {
                                                       'calls' => [
                                                                    'no_value',
                                                                    'token_text',
                                                                    'quoted_string'
                                                                  ],
                                                       'name' => 'text_value',
                                                       'vars' => '',
                                                       'prods' => [
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'no_value',
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 294
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 0,
                                                                             'dircount' => 0,
                                                                             'line' => undef,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'actcount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 294,
                                                                                                   'implicit' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'token_text'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => 294,
                                                                             'patcount' => 0,
                                                                             'error' => undef,
                                                                             'number' => 1,
                                                                             'strcount' => 0
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'strcount' => 0,
                                                                             'number' => 2,
                                                                             'error' => undef,
                                                                             'line' => 294,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'dircount' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'quoted_string',
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'lookahead' => 0,
                                                                                                   'line' => 294,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'opcount' => 0,
                                                       'line' => 293,
                                                       'impcount' => 0,
                                                       'changed' => 0
                                                     }, 'Parse::RecDescent::Rule' ),
                              'read_reply_value' => bless( {
                                                             'name' => 'read_reply_value',
                                                             'calls' => [
                                                                          'YES',
                                                                          'NO'
                                                                        ],
                                                             'vars' => '',
                                                             'prods' => [
                                                                          bless( {
                                                                                   'patcount' => 0,
                                                                                   'line' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'dircount' => 0,
                                                                                   'error' => undef,
                                                                                   'number' => 0,
                                                                                   'strcount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'subrule' => 'YES',
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'lookahead' => 0,
                                                                                                         'line' => 771,
                                                                                                         'implicit' => undef
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'actcount' => 0
                                                                                 }, 'Parse::RecDescent::Production' ),
                                                                          bless( {
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'line' => 771,
                                                                                                         'implicit' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'lookahead' => 0,
                                                                                                         'subrule' => 'NO'
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'actcount' => 0,
                                                                                   'error' => undef,
                                                                                   'strcount' => 0,
                                                                                   'number' => 1,
                                                                                   'line' => 771,
                                                                                   'uncommit' => undef,
                                                                                   'patcount' => 0,
                                                                                   'dircount' => 0
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'line' => 770,
                                                             'opcount' => 0,
                                                             'changed' => 0,
                                                             'impcount' => 0
                                                           }, 'Parse::RecDescent::Rule' ),
                              'AUTO' => bless( {
                                                 'calls' => [],
                                                 'name' => 'AUTO',
                                                 'prods' => [
                                                              bless( {
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 748,
                                                                                             'description' => '\'\\\\x83\'',
                                                                                             'pattern' => '\\x83',
                                                                                             'hashname' => '__STRING1__'
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 748,
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{ $return = $item[0]; 1; }'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 1,
                                                                       'patcount' => 0,
                                                                       'line' => undef,
                                                                       'uncommit' => undef,
                                                                       'dircount' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'vars' => '',
                                                 'opcount' => 0,
                                                 'line' => 748,
                                                 'impcount' => 0,
                                                 'changed' => 0
                                               }, 'Parse::RecDescent::Rule' ),
                              'long_length' => bless( {
                                                        'changed' => 0,
                                                        'impcount' => 0,
                                                        'line' => 289,
                                                        'opcount' => 0,
                                                        'prods' => [
                                                                     bless( {
                                                                              'patcount' => 0,
                                                                              'line' => undef,
                                                                              'uncommit' => undef,
                                                                              'dircount' => 0,
                                                                              'error' => undef,
                                                                              'number' => 0,
                                                                              'strcount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'subrule' => 'length_quote',
                                                                                                    'argcode' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'line' => 289,
                                                                                                    'implicit' => undef
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'subrule' => 'length_',
                                                                                                    'lookahead' => 0,
                                                                                                    'matchrule' => 0,
                                                                                                    'argcode' => undef,
                                                                                                    'implicit' => undef,
                                                                                                    'line' => 289
                                                                                                  }, 'Parse::RecDescent::Subrule' )
                                                                                         ],
                                                                              'actcount' => 0
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'name' => 'long_length',
                                                        'calls' => [
                                                                     'length_quote',
                                                                     'length_'
                                                                   ]
                                                      }, 'Parse::RecDescent::Rule' ),
                              'delivery_time_head' => bless( {
                                                               'opcount' => 0,
                                                               'line' => 647,
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'calls' => [
                                                                            'delivery_time_value'
                                                                          ],
                                                               'name' => 'delivery_time_head',
                                                               'vars' => '',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'line' => undef,
                                                                                     'dircount' => 0,
                                                                                     'number' => 0,
                                                                                     'strcount' => 1,
                                                                                     'error' => undef,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 647,
                                                                                                           'description' => '\'\\\\x87\'',
                                                                                                           'pattern' => '\\x87',
                                                                                                           'hashname' => '__STRING1__'
                                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                                  bless( {
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'lookahead' => 0,
                                                                                                           'subrule' => 'delivery_time_value',
                                                                                                           'line' => 647,
                                                                                                           'implicit' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 648,
                                                                                                           'hashname' => '__ACTION1__',
                                                                                                           'code' => '{ $return = [ @item[0,2] ]; 1; }'
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ],
                                                                                     'actcount' => 1
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ]
                                                             }, 'Parse::RecDescent::Rule' ),
                              'delta_seconds_value' => bless( {
                                                                'calls' => [
                                                                             'integer_value'
                                                                           ],
                                                                'name' => 'delta_seconds_value',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'error' => undef,
                                                                                      'number' => 0,
                                                                                      'strcount' => 0,
                                                                                      'dircount' => 0,
                                                                                      'patcount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'line' => undef,
                                                                                      'actcount' => 0,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'line' => 300,
                                                                                                            'implicit' => undef,
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'lookahead' => 0,
                                                                                                            'subrule' => 'integer_value'
                                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                                 ]
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ],
                                                                'vars' => '',
                                                                'opcount' => 0,
                                                                'line' => 299,
                                                                'impcount' => 0,
                                                                'changed' => 0
                                                              }, 'Parse::RecDescent::Rule' ),
                              'ExtendedMethod_PostPDU' => bless( {
                                                                   'changed' => 0,
                                                                   'impcount' => 0,
                                                                   'line' => 227,
                                                                   'opcount' => 0,
                                                                   'prods' => [
                                                                                bless( {
                                                                                         'items' => [
                                                                                                      bless( {
                                                                                                               'description' => '/[\\\\x70-\\\\x7f]/',
                                                                                                               'rdelim' => '/',
                                                                                                               'line' => 227,
                                                                                                               'pattern' => '[\\x70-\\x7f]',
                                                                                                               'mod' => '',
                                                                                                               'hashname' => '__PATTERN1__',
                                                                                                               'ldelim' => '/',
                                                                                                               'lookahead' => 0
                                                                                                             }, 'Parse::RecDescent::Token' ),
                                                                                                      bless( {
                                                                                                               'hashname' => '__ACTION1__',
                                                                                                               'code' => '{ $return = $item[0]; 1; }',
                                                                                                               'line' => 227,
                                                                                                               'lookahead' => 0
                                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                                    ],
                                                                                         'actcount' => 1,
                                                                                         'error' => undef,
                                                                                         'number' => 0,
                                                                                         'strcount' => 0,
                                                                                         'patcount' => 1,
                                                                                         'uncommit' => undef,
                                                                                         'line' => undef,
                                                                                         'dircount' => 0
                                                                                       }, 'Parse::RecDescent::Production' )
                                                                              ],
                                                                   'vars' => '',
                                                                   'name' => 'ExtendedMethod_PostPDU',
                                                                   'calls' => []
                                                                 }, 'Parse::RecDescent::Rule' ),
                              'untyped_parameter' => bless( {
                                                              'calls' => [
                                                                           'token_text',
                                                                           'untyped_value'
                                                                         ],
                                                              'name' => 'untyped_parameter',
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'token_text',
                                                                                                          'line' => 434,
                                                                                                          'implicit' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'untyped_value',
                                                                                                          'line' => 434,
                                                                                                          'implicit' => undef
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 434,
                                                                                                          'code' => '{
   $return = { name => $item[1], value => $item[2] };
   1;
}',
                                                                                                          'hashname' => '__ACTION1__'
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'dircount' => 0,
                                                                                    'error' => undef,
                                                                                    'strcount' => 0,
                                                                                    'number' => 0
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'opcount' => 0,
                                                              'line' => 433,
                                                              'impcount' => 0,
                                                              'changed' => 0
                                                            }, 'Parse::RecDescent::Rule' ),
                              'message_size_head' => bless( {
                                                              'impcount' => 0,
                                                              'changed' => 0,
                                                              'opcount' => 0,
                                                              'line' => 662,
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'actcount' => 1,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'pattern' => '\\x8e',
                                                                                                          'line' => 662,
                                                                                                          'description' => '\'\\\\x8e\''
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'line' => 662,
                                                                                                          'implicit' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'message_size_value'
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 663,
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'code' => '{ $return = [ @item[0,2] ]; 1; }'
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'error' => undef,
                                                                                    'number' => 0,
                                                                                    'strcount' => 1,
                                                                                    'dircount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'line' => undef
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'calls' => [
                                                                           'message_size_value'
                                                                         ],
                                                              'name' => 'message_size_head'
                                                            }, 'Parse::RecDescent::Rule' ),
                              'message_class_value' => bless( {
                                                                'calls' => [
                                                                             'class_identifier',
                                                                             'token_text'
                                                                           ],
                                                                'name' => 'message_class_value',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'actcount' => 0,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'line' => 743,
                                                                                                            'implicit' => undef,
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'lookahead' => 0,
                                                                                                            'subrule' => 'class_identifier'
                                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                                 ],
                                                                                      'error' => undef,
                                                                                      'number' => 0,
                                                                                      'strcount' => 0,
                                                                                      'dircount' => 0,
                                                                                      'patcount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'line' => undef
                                                                                    }, 'Parse::RecDescent::Production' ),
                                                                             bless( {
                                                                                      'actcount' => 0,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'implicit' => undef,
                                                                                                            'line' => 743,
                                                                                                            'lookahead' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'matchrule' => 0,
                                                                                                            'subrule' => 'token_text'
                                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                                 ],
                                                                                      'number' => 1,
                                                                                      'strcount' => 0,
                                                                                      'error' => undef,
                                                                                      'dircount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'line' => 743,
                                                                                      'patcount' => 0
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ],
                                                                'vars' => '',
                                                                'opcount' => 0,
                                                                'line' => 742,
                                                                'impcount' => 0,
                                                                'changed' => 0
                                                              }, 'Parse::RecDescent::Rule' ),
                              'message_type_head_code' => bless( {
                                                                   'line' => 657,
                                                                   'opcount' => 0,
                                                                   'changed' => 0,
                                                                   'impcount' => 0,
                                                                   'name' => 'message_type_head_code',
                                                                   'calls' => [],
                                                                   'prods' => [
                                                                                bless( {
                                                                                         'strcount' => 1,
                                                                                         'number' => 0,
                                                                                         'error' => undef,
                                                                                         'uncommit' => undef,
                                                                                         'patcount' => 0,
                                                                                         'line' => undef,
                                                                                         'dircount' => 0,
                                                                                         'items' => [
                                                                                                      bless( {
                                                                                                               'lookahead' => 0,
                                                                                                               'pattern' => '\\x8c',
                                                                                                               'description' => '\'\\\\x8c\'',
                                                                                                               'line' => 657,
                                                                                                               'hashname' => '__STRING1__'
                                                                                                             }, 'Parse::RecDescent::InterpLit' ),
                                                                                                      bless( {
                                                                                                               'lookahead' => 0,
                                                                                                               'code' => '{ $return = $item[1]; 1; }',
                                                                                                               'hashname' => '__ACTION1__',
                                                                                                               'line' => 657
                                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                                    ],
                                                                                         'actcount' => 1
                                                                                       }, 'Parse::RecDescent::Production' )
                                                                              ],
                                                                   'vars' => ''
                                                                 }, 'Parse::RecDescent::Rule' ),
                              'from_value' => bless( {
                                                       'opcount' => 0,
                                                       'line' => 734,
                                                       'impcount' => 1,
                                                       'changed' => 0,
                                                       'calls' => [
                                                                    'value_length',
                                                                    '_alternation_1_of_production_1_of_rule_from_value'
                                                                  ],
                                                       'name' => 'from_value',
                                                       'vars' => '',
                                                       'prods' => [
                                                                    bless( {
                                                                             'actcount' => 1,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 734,
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'subrule' => 'value_length'
                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                          bless( {
                                                                                                   'line' => 735,
                                                                                                   'implicit' => 'address_present_token, or insert_address_token',
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => '_alternation_1_of_production_1_of_rule_from_value'
                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                          bless( {
                                                                                                   'code' => '{
   $return = $item[2];
   defined($return) || undef;
}',
                                                                                                   'hashname' => '__ACTION1__',
                                                                                                   'line' => 736,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                        ],
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 0,
                                                                             'dircount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => undef,
                                                                             'patcount' => 0
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ]
                                                     }, 'Parse::RecDescent::Rule' ),
                              'Head_GetPDU' => bless( {
                                                        'calls' => [],
                                                        'name' => 'Head_GetPDU',
                                                        'prods' => [
                                                                     bless( {
                                                                              'patcount' => 0,
                                                                              'uncommit' => undef,
                                                                              'line' => undef,
                                                                              'dircount' => 0,
                                                                              'strcount' => 1,
                                                                              'number' => 0,
                                                                              'error' => undef,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'description' => '\'\\\\x42\'',
                                                                                                    'line' => 219,
                                                                                                    'pattern' => '\\x42',
                                                                                                    'hashname' => '__STRING1__',
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'code' => '{ $return = $item[0]; 1; }',
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'line' => 219,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'opcount' => 0,
                                                        'line' => 219,
                                                        'impcount' => 0,
                                                        'changed' => 0
                                                      }, 'Parse::RecDescent::Rule' ),
                              'integer_value' => bless( {
                                                          'calls' => [
                                                                       'short_integer',
                                                                       'long_integer'
                                                                     ],
                                                          'name' => 'integer_value',
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 296,
                                                                                                      'subrule' => 'short_integer',
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'number' => 0,
                                                                                'strcount' => 0,
                                                                                'error' => undef,
                                                                                'dircount' => 0,
                                                                                'patcount' => 0,
                                                                                'uncommit' => undef,
                                                                                'line' => undef
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 296,
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'subrule' => 'long_integer'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'strcount' => 0,
                                                                                'number' => 1,
                                                                                'error' => undef,
                                                                                'dircount' => 0,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'line' => 296
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => '',
                                                          'opcount' => 0,
                                                          'line' => 295,
                                                          'impcount' => 0,
                                                          'changed' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'end_of_string' => bless( {
                                                          'impcount' => 0,
                                                          'changed' => 0,
                                                          'opcount' => 0,
                                                          'line' => 270,
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'pattern' => '\\x00',
                                                                                                      'description' => '\'\\\\x00\'',
                                                                                                      'line' => 271,
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::InterpLit' )
                                                                                           ],
                                                                                'dircount' => 0,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'error' => undef,
                                                                                'number' => 0,
                                                                                'strcount' => 1
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'calls' => [],
                                                          'name' => 'end_of_string'
                                                        }, 'Parse::RecDescent::Rule' ),
                              'bcc_value' => bless( {
                                                      'impcount' => 0,
                                                      'changed' => 0,
                                                      'opcount' => 0,
                                                      'line' => 699,
                                                      'vars' => '',
                                                      'prods' => [
                                                                   bless( {
                                                                            'error' => undef,
                                                                            'strcount' => 0,
                                                                            'number' => 0,
                                                                            'dircount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => undef,
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'subrule' => '_address_value',
                                                                                                  'implicit' => undef,
                                                                                                  'line' => 699
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'calls' => [
                                                                   '_address_value'
                                                                 ],
                                                      'name' => 'bcc_value'
                                                    }, 'Parse::RecDescent::Rule' ),
                              'well_known_charset' => bless( {
                                                               'calls' => [
                                                                            'any_charset',
                                                                            '_well_known_charset_wcode'
                                                                          ],
                                                               'name' => 'well_known_charset',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'patcount' => 0,
                                                                                     'line' => undef,
                                                                                     'uncommit' => undef,
                                                                                     'dircount' => 0,
                                                                                     'error' => undef,
                                                                                     'number' => 0,
                                                                                     'strcount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'subrule' => 'any_charset',
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 484
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 484,
                                                                                                           'subrule' => '_well_known_charset_wcode',
                                                                                                           'lookahead' => 0,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'line' => 484,
                                                                                     'dircount' => 0,
                                                                                     'strcount' => 0,
                                                                                     'number' => 1,
                                                                                     'error' => undef
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'opcount' => 0,
                                                               'line' => 483,
                                                               'impcount' => 0,
                                                               'changed' => 0
                                                             }, 'Parse::RecDescent::Rule' ),
                              'well_known_field_name' => bless( {
                                                                  'calls' => [
                                                                               'short_integer'
                                                                             ],
                                                                  'name' => 'well_known_field_name',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'subrule' => 'short_integer',
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 508
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'dircount' => 0,
                                                                                        'line' => undef,
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 0,
                                                                                        'number' => 0,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'vars' => '',
                                                                  'opcount' => 0,
                                                                  'line' => 508,
                                                                  'impcount' => 0,
                                                                  'changed' => 0
                                                                }, 'Parse::RecDescent::Rule' ),
                              'CRLF' => bless( {
                                                 'line' => 158,
                                                 'opcount' => 0,
                                                 'changed' => 0,
                                                 'impcount' => 0,
                                                 'name' => 'CRLF',
                                                 'calls' => [
                                                              'CR',
                                                              'LF'
                                                            ],
                                                 'vars' => '',
                                                 'prods' => [
                                                              bless( {
                                                                       'line' => undef,
                                                                       'uncommit' => undef,
                                                                       'patcount' => 0,
                                                                       'dircount' => 0,
                                                                       'error' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 0,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'line' => 159,
                                                                                             'implicit' => undef,
                                                                                             'argcode' => undef,
                                                                                             'matchrule' => 0,
                                                                                             'lookahead' => 0,
                                                                                             'subrule' => 'CR'
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'line' => 159,
                                                                                             'subrule' => 'LF',
                                                                                             'lookahead' => 0,
                                                                                             'argcode' => undef,
                                                                                             'matchrule' => 0
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'line' => 159,
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{ $return = "\\r\\n"; 1; }',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'actcount' => 1
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ]
                                               }, 'Parse::RecDescent::Rule' ),
                              'M_Notification_Ind_message' => bless( {
                                                                       'opcount' => 0,
                                                                       'line' => 552,
                                                                       'impcount' => 0,
                                                                       'changed' => 0,
                                                                       'calls' => [
                                                                                    'message_type_head_code',
                                                                                    'm_notification_ind',
                                                                                    'transaction_id_head',
                                                                                    'MMS_version_head',
                                                                                    'header'
                                                                                  ],
                                                                       'name' => 'M_Notification_Ind_message',
                                                                       'prods' => [
                                                                                    bless( {
                                                                                             'error' => undef,
                                                                                             'number' => 0,
                                                                                             'strcount' => 0,
                                                                                             'uncommit' => undef,
                                                                                             'patcount' => 0,
                                                                                             'line' => undef,
                                                                                             'dircount' => 0,
                                                                                             'items' => [
                                                                                                          bless( {
                                                                                                                   'subrule' => 'message_type_head_code',
                                                                                                                   'matchrule' => 0,
                                                                                                                   'argcode' => undef,
                                                                                                                   'lookahead' => 0,
                                                                                                                   'line' => 553,
                                                                                                                   'implicit' => undef
                                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                                          bless( {
                                                                                                                   'subrule' => 'm_notification_ind',
                                                                                                                   'matchrule' => 0,
                                                                                                                   'argcode' => undef,
                                                                                                                   'lookahead' => 0,
                                                                                                                   'line' => 553,
                                                                                                                   'implicit' => undef
                                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                                          bless( {
                                                                                                                   'line' => 554,
                                                                                                                   'implicit' => undef,
                                                                                                                   'subrule' => 'transaction_id_head',
                                                                                                                   'argcode' => undef,
                                                                                                                   'matchrule' => 0,
                                                                                                                   'lookahead' => 0
                                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                                          bless( {
                                                                                                                   'lookahead' => 0,
                                                                                                                   'argcode' => undef,
                                                                                                                   'matchrule' => 0,
                                                                                                                   'subrule' => 'MMS_version_head',
                                                                                                                   'implicit' => undef,
                                                                                                                   'line' => 555
                                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                                          bless( {
                                                                                                                   'subrule' => 'header',
                                                                                                                   'argcode' => undef,
                                                                                                                   'repspec' => 's?',
                                                                                                                   'expected' => undef,
                                                                                                                   'max' => 100000000,
                                                                                                                   'lookahead' => 0,
                                                                                                                   'matchrule' => 0,
                                                                                                                   'min' => 0,
                                                                                                                   'line' => 556
                                                                                                                 }, 'Parse::RecDescent::Repetition' ),
                                                                                                          bless( {
                                                                                                                   'lookahead' => 0,
                                                                                                                   'code' => '{
   my %retval;
   $retval{message_type_head} = \'m_notification_ind\';
   foreach my $header (@item[3,4], @{$item[5]}) {
      next unless ref($header) eq \'ARRAY\';
      my ($name, $value) = @$header;
      $name =~ s/_head\\z//;
      $retval{$name} = $value;
   }
   $return = \\%retval;
   1;
}',
                                                                                                                   'hashname' => '__ACTION1__',
                                                                                                                   'line' => 556
                                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                                        ],
                                                                                             'actcount' => 1
                                                                                           }, 'Parse::RecDescent::Production' )
                                                                                  ],
                                                                       'vars' => ''
                                                                     }, 'Parse::RecDescent::Rule' ),
                              'untyped_value' => bless( {
                                                          'calls' => [
                                                                       'integer_value',
                                                                       'text_value'
                                                                     ],
                                                          'name' => 'untyped_value',
                                                          'prods' => [
                                                                       bless( {
                                                                                'uncommit' => undef,
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'dircount' => 0,
                                                                                'number' => 0,
                                                                                'strcount' => 0,
                                                                                'error' => undef,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 439,
                                                                                                      'subrule' => 'integer_value',
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'actcount' => 0
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'error' => undef,
                                                                                'number' => 1,
                                                                                'strcount' => 0,
                                                                                'patcount' => 0,
                                                                                'uncommit' => undef,
                                                                                'line' => 439,
                                                                                'dircount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 439,
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'subrule' => 'text_value'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'actcount' => 0
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => '',
                                                          'opcount' => 0,
                                                          'line' => 438,
                                                          'impcount' => 0,
                                                          'changed' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'HEX' => bless( {
                                                'changed' => 0,
                                                'impcount' => 0,
                                                'line' => 170,
                                                'opcount' => 0,
                                                'prods' => [
                                                             bless( {
                                                                      'actcount' => 0,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'line' => 171,
                                                                                            'pattern' => '[a-fA-F0-9]',
                                                                                            'mod' => '',
                                                                                            'hashname' => '__PATTERN1__',
                                                                                            'ldelim' => '/',
                                                                                            'lookahead' => 0,
                                                                                            'description' => '/[a-fA-F0-9]/',
                                                                                            'rdelim' => '/'
                                                                                          }, 'Parse::RecDescent::Token' )
                                                                                 ],
                                                                      'dircount' => 0,
                                                                      'uncommit' => undef,
                                                                      'patcount' => 1,
                                                                      'line' => undef,
                                                                      'error' => undef,
                                                                      'number' => 0,
                                                                      'strcount' => 0
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'vars' => '',
                                                'name' => 'HEX',
                                                'calls' => []
                                              }, 'Parse::RecDescent::Rule' ),
                              'Trace_GetPDU' => bless( {
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'line' => 221,
                                                         'opcount' => 0,
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'pattern' => '\\x44',
                                                                                                     'description' => '\'\\\\x44\'',
                                                                                                     'line' => 221,
                                                                                                     'hashname' => '__STRING1__'
                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                            bless( {
                                                                                                     'line' => 221,
                                                                                                     'hashname' => '__ACTION1__',
                                                                                                     'code' => '{ $return = $item[0]; 1; }',
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ],
                                                                               'actcount' => 1,
                                                                               'strcount' => 1,
                                                                               'number' => 0,
                                                                               'error' => undef,
                                                                               'uncommit' => undef,
                                                                               'line' => undef,
                                                                               'patcount' => 0,
                                                                               'dircount' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'name' => 'Trace_GetPDU',
                                                         'calls' => []
                                                       }, 'Parse::RecDescent::Rule' ),
                              'M_Retrieve_Conf_message' => bless( {
                                                                    'line' => 569,
                                                                    'opcount' => 0,
                                                                    'changed' => 0,
                                                                    'impcount' => 0,
                                                                    'name' => 'M_Retrieve_Conf_message',
                                                                    'calls' => [
                                                                                 'message_type_head_code',
                                                                                 'm_retrieve_conf',
                                                                                 'transaction_id_head',
                                                                                 'MMS_version_head',
                                                                                 'header',
                                                                                 'content_type_head',
                                                                                 'multipart'
                                                                               ],
                                                                    'prods' => [
                                                                                 bless( {
                                                                                          'strcount' => 0,
                                                                                          'number' => 0,
                                                                                          'error' => undef,
                                                                                          'dircount' => 0,
                                                                                          'uncommit' => undef,
                                                                                          'patcount' => 0,
                                                                                          'line' => undef,
                                                                                          'actcount' => 1,
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'subrule' => 'message_type_head_code',
                                                                                                                'matchrule' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'lookahead' => 0,
                                                                                                                'line' => 570,
                                                                                                                'implicit' => undef
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'subrule' => 'm_retrieve_conf',
                                                                                                                'lookahead' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'matchrule' => 0,
                                                                                                                'implicit' => undef,
                                                                                                                'line' => 570
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'min' => 0,
                                                                                                                'line' => 571,
                                                                                                                'max' => 1,
                                                                                                                'matchrule' => 0,
                                                                                                                'lookahead' => 0,
                                                                                                                'repspec' => '?',
                                                                                                                'expected' => undef,
                                                                                                                'subrule' => 'transaction_id_head',
                                                                                                                'argcode' => undef
                                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                                       bless( {
                                                                                                                'lookahead' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'matchrule' => 0,
                                                                                                                'subrule' => 'MMS_version_head',
                                                                                                                'implicit' => undef,
                                                                                                                'line' => 572
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'subrule' => 'header',
                                                                                                                'argcode' => undef,
                                                                                                                'repspec' => 's',
                                                                                                                'expected' => undef,
                                                                                                                'max' => 100000000,
                                                                                                                'matchrule' => 0,
                                                                                                                'lookahead' => 0,
                                                                                                                'min' => 1,
                                                                                                                'line' => 573
                                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                                       bless( {
                                                                                                                'line' => 574,
                                                                                                                'implicit' => undef,
                                                                                                                'argcode' => undef,
                                                                                                                'matchrule' => 0,
                                                                                                                'lookahead' => 0,
                                                                                                                'subrule' => 'content_type_head'
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'lookahead' => 0,
                                                                                                                'matchrule' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'subrule' => 'multipart',
                                                                                                                'implicit' => undef,
                                                                                                                'line' => 575
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'line' => 575,
                                                                                                                'code' => '{
   my %headers;
   $headers{message_type_head} = \'m_retrieve_conf\';
   foreach my $header (@item[4,6], @{$item[3]}, @{$item[5]}) {
      my ($name, $value) = @$header;
      $headers{$name} = $value;
   }
   $return = {
      headers => \\%headers,
      body    => $item{multipart},
   };
   1;
}',
                                                                                                                'hashname' => '__ACTION1__',
                                                                                                                'lookahead' => 0
                                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                                     ]
                                                                                        }, 'Parse::RecDescent::Production' )
                                                                               ],
                                                                    'vars' => ''
                                                                  }, 'Parse::RecDescent::Rule' ),
                              'Reply' => bless( {
                                                  'impcount' => 0,
                                                  'changed' => 0,
                                                  'opcount' => 0,
                                                  'line' => 210,
                                                  'vars' => '',
                                                  'prods' => [
                                                               bless( {
                                                                        'actcount' => 1,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'hashname' => '__STRING1__',
                                                                                              'line' => 210,
                                                                                              'description' => '\'\\\\x04\'',
                                                                                              'pattern' => '\\x04'
                                                                                            }, 'Parse::RecDescent::InterpLit' ),
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'code' => '{ $return = $item[0]; 1; }',
                                                                                              'line' => 210
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'strcount' => 1,
                                                                        'number' => 0,
                                                                        'dircount' => 0,
                                                                        'line' => undef,
                                                                        'uncommit' => undef,
                                                                        'patcount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'calls' => [],
                                                  'name' => 'Reply'
                                                }, 'Parse::RecDescent::Rule' ),
                              'constrained_media' => bless( {
                                                              'impcount' => 0,
                                                              'changed' => 0,
                                                              'opcount' => 0,
                                                              'line' => 509,
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'actcount' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'implicit' => undef,
                                                                                                          'line' => 509,
                                                                                                          'lookahead' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'subrule' => 'constrained_encoding'
                                                                                                        }, 'Parse::RecDescent::Subrule' )
                                                                                               ],
                                                                                    'dircount' => 0,
                                                                                    'patcount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'line' => undef,
                                                                                    'error' => undef,
                                                                                    'strcount' => 0,
                                                                                    'number' => 0
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'calls' => [
                                                                           'constrained_encoding'
                                                                         ],
                                                              'name' => 'constrained_media'
                                                            }, 'Parse::RecDescent::Rule' ),
                              'delivery_report_head' => bless( {
                                                                 'changed' => 0,
                                                                 'impcount' => 0,
                                                                 'line' => 645,
                                                                 'opcount' => 0,
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'dircount' => 0,
                                                                                       'line' => undef,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'strcount' => 1,
                                                                                       'number' => 0,
                                                                                       'error' => undef,
                                                                                       'actcount' => 1,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'line' => 645,
                                                                                                             'description' => '\'\\\\x86\'',
                                                                                                             'pattern' => '\\x86',
                                                                                                             'hashname' => '__STRING1__',
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                                    bless( {
                                                                                                             'subrule' => 'delivery_report_value',
                                                                                                             'matchrule' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'lookahead' => 0,
                                                                                                             'line' => 645,
                                                                                                             'implicit' => undef
                                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                                    bless( {
                                                                                                             'lookahead' => 0,
                                                                                                             'line' => 646,
                                                                                                             'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                             'hashname' => '__ACTION1__'
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ]
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'vars' => '',
                                                                 'name' => 'delivery_report_head',
                                                                 'calls' => [
                                                                              'delivery_report_value'
                                                                            ]
                                                               }, 'Parse::RecDescent::Rule' ),
                              'SHOW' => bless( {
                                                 'calls' => [],
                                                 'name' => 'SHOW',
                                                 'vars' => '',
                                                 'prods' => [
                                                              bless( {
                                                                       'actcount' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'hashname' => '__STRING1__',
                                                                                             'description' => '\'\\\\x81\'',
                                                                                             'line' => 795,
                                                                                             'pattern' => '\\x81'
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 795,
                                                                                             'code' => '{ $return = $item[0]; 1; }',
                                                                                             'hashname' => '__ACTION1__'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'error' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 1,
                                                                       'dircount' => 0,
                                                                       'patcount' => 0,
                                                                       'uncommit' => undef,
                                                                       'line' => undef
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'opcount' => 0,
                                                 'line' => 795,
                                                 'impcount' => 0,
                                                 'changed' => 0
                                               }, 'Parse::RecDescent::Rule' ),
                              'cc_value' => bless( {
                                                     'impcount' => 0,
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'line' => 700,
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'patcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => undef,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 0,
                                                                           'strcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 700,
                                                                                                 'implicit' => undef,
                                                                                                 'subrule' => '_address_value',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'calls' => [
                                                                  '_address_value'
                                                                ],
                                                     'name' => 'cc_value'
                                                   }, 'Parse::RecDescent::Rule' ),
                              'start_related_parameter' => bless( {
                                                                    'name' => 'start_related_parameter',
                                                                    'calls' => [
                                                                                 'text_value'
                                                                               ],
                                                                    'vars' => '',
                                                                    'prods' => [
                                                                                 bless( {
                                                                                          'patcount' => 0,
                                                                                          'line' => undef,
                                                                                          'uncommit' => undef,
                                                                                          'dircount' => 0,
                                                                                          'number' => 0,
                                                                                          'strcount' => 1,
                                                                                          'error' => undef,
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'lookahead' => 0,
                                                                                                                'pattern' => '\\x99',
                                                                                                                'line' => 417,
                                                                                                                'description' => '\'\\\\x99\'',
                                                                                                                'hashname' => '__STRING1__'
                                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                                       bless( {
                                                                                                                'implicit' => undef,
                                                                                                                'line' => 417,
                                                                                                                'subrule' => 'text_value',
                                                                                                                'lookahead' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'matchrule' => 0
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                                'hashname' => '__ACTION1__',
                                                                                                                'line' => 418,
                                                                                                                'lookahead' => 0
                                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                                     ],
                                                                                          'actcount' => 1
                                                                                        }, 'Parse::RecDescent::Production' )
                                                                               ],
                                                                    'line' => 417,
                                                                    'opcount' => 0,
                                                                    'changed' => 0,
                                                                    'impcount' => 0
                                                                  }, 'Parse::RecDescent::Rule' ),
                              'Get' => bless( {
                                                'line' => 217,
                                                'opcount' => 0,
                                                'changed' => 0,
                                                'impcount' => 0,
                                                'name' => 'Get',
                                                'calls' => [],
                                                'prods' => [
                                                             bless( {
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'lookahead' => 0,
                                                                                            'description' => '\'\\\\x40\'',
                                                                                            'line' => 217,
                                                                                            'pattern' => '\\x40',
                                                                                            'hashname' => '__STRING1__'
                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                   bless( {
                                                                                            'lookahead' => 0,
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'code' => '{ $return = $item[0]; 1; }',
                                                                                            'line' => 217
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ],
                                                                      'actcount' => 1,
                                                                      'line' => undef,
                                                                      'uncommit' => undef,
                                                                      'patcount' => 0,
                                                                      'dircount' => 0,
                                                                      'number' => 0,
                                                                      'strcount' => 1,
                                                                      'error' => undef
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'vars' => ''
                                              }, 'Parse::RecDescent::Rule' ),
                              'INFORMATIONAL' => bless( {
                                                          'calls' => [],
                                                          'name' => 'INFORMATIONAL',
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'pattern' => '\\x82',
                                                                                                      'line' => 747,
                                                                                                      'description' => '\'\\\\x82\''
                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'code' => '{ $return = $item[0]; 1; }',
                                                                                                      'line' => 747
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'dircount' => 0,
                                                                                'uncommit' => undef,
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'error' => undef,
                                                                                'strcount' => 1,
                                                                                'number' => 0
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'opcount' => 0,
                                                          'line' => 747,
                                                          'impcount' => 0,
                                                          'changed' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'priority_head' => bless( {
                                                          'name' => 'priority_head',
                                                          'calls' => [
                                                                       'priority_value'
                                                                     ],
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'dircount' => 0,
                                                                                'uncommit' => undef,
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'number' => 0,
                                                                                'strcount' => 1,
                                                                                'error' => undef,
                                                                                'actcount' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'pattern' => '\\x8f',
                                                                                                      'description' => '\'\\\\x8f\'',
                                                                                                      'line' => 664,
                                                                                                      'hashname' => '__STRING1__'
                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                             bless( {
                                                                                                      'subrule' => 'priority_value',
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 664,
                                                                                                      'implicit' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'line' => 665,
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ]
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'line' => 664,
                                                          'opcount' => 0,
                                                          'changed' => 0,
                                                          'impcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'message_type_value' => bless( {
                                                               'name' => 'message_type_value',
                                                               'calls' => [
                                                                            'm_send_req',
                                                                            'm_send_conf',
                                                                            'm_notification_ind',
                                                                            'm_notifyresp_ind',
                                                                            'm_retrieve_conf',
                                                                            'm_acknowledge_ind',
                                                                            'm_delivery_ind'
                                                                          ],
                                                               'prods' => [
                                                                            bless( {
                                                                                     'actcount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 752,
                                                                                                           'implicit' => undef,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'lookahead' => 0,
                                                                                                           'subrule' => 'm_send_req'
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'error' => undef,
                                                                                     'number' => 0,
                                                                                     'strcount' => 0,
                                                                                     'dircount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => undef,
                                                                                     'patcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 752,
                                                                                                           'implicit' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'subrule' => 'm_send_conf'
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0,
                                                                                     'strcount' => 0,
                                                                                     'number' => 1,
                                                                                     'error' => undef,
                                                                                     'line' => 752,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'patcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => 752,
                                                                                     'dircount' => 0,
                                                                                     'strcount' => 0,
                                                                                     'number' => 2,
                                                                                     'error' => undef,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'subrule' => 'm_notification_ind',
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 752,
                                                                                                           'implicit' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'actcount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'subrule' => 'm_notifyresp_ind',
                                                                                                           'lookahead' => 0,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 753
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'number' => 3,
                                                                                     'strcount' => 0,
                                                                                     'error' => undef,
                                                                                     'dircount' => 0,
                                                                                     'patcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => 753
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'actcount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 753,
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'subrule' => 'm_retrieve_conf'
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'dircount' => 0,
                                                                                     'line' => 753,
                                                                                     'patcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'strcount' => 0,
                                                                                     'number' => 4,
                                                                                     'error' => undef
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 753,
                                                                                                           'implicit' => undef,
                                                                                                           'subrule' => 'm_acknowledge_ind',
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0,
                                                                                     'line' => 753,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0,
                                                                                     'error' => undef,
                                                                                     'number' => 5,
                                                                                     'strcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'actcount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 754,
                                                                                                           'implicit' => undef,
                                                                                                           'subrule' => 'm_delivery_ind',
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'error' => undef,
                                                                                     'strcount' => 0,
                                                                                     'number' => 6,
                                                                                     'dircount' => 0,
                                                                                     'line' => 754,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'line' => 751,
                                                               'opcount' => 0,
                                                               'changed' => 0,
                                                               'impcount' => 0
                                                             }, 'Parse::RecDescent::Rule' ),
                              'multipart_data_len' => bless( {
                                                               'changed' => 0,
                                                               'impcount' => 0,
                                                               'line' => 526,
                                                               'opcount' => 0,
                                                               'prods' => [
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 526,
                                                                                                           'implicit' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'subrule' => 'uintvar'
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0,
                                                                                     'line' => undef,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0,
                                                                                     'error' => undef,
                                                                                     'number' => 0,
                                                                                     'strcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'name' => 'multipart_data_len',
                                                               'calls' => [
                                                                            'uintvar'
                                                                          ]
                                                             }, 'Parse::RecDescent::Rule' ),
                              'LWS' => bless( {
                                                'name' => 'LWS',
                                                'calls' => [
                                                             'CRLF',
                                                             '_alternation_1_of_production_1_of_rule_LWS'
                                                           ],
                                                'prods' => [
                                                             bless( {
                                                                      'actcount' => 1,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'max' => 1,
                                                                                            'lookahead' => 0,
                                                                                            'matchrule' => 0,
                                                                                            'min' => 0,
                                                                                            'line' => 160,
                                                                                            'subrule' => 'CRLF',
                                                                                            'argcode' => undef,
                                                                                            'repspec' => '?',
                                                                                            'expected' => undef
                                                                                          }, 'Parse::RecDescent::Repetition' ),
                                                                                   bless( {
                                                                                            'line' => 160,
                                                                                            'min' => 1,
                                                                                            'lookahead' => 0,
                                                                                            'matchrule' => 0,
                                                                                            'max' => 100000000,
                                                                                            'expected' => 'SP, or HT',
                                                                                            'repspec' => '1..',
                                                                                            'argcode' => undef,
                                                                                            'subrule' => '_alternation_1_of_production_1_of_rule_LWS'
                                                                                          }, 'Parse::RecDescent::Repetition' ),
                                                                                   bless( {
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'code' => '{
   $return = join \'\', @{$item[1]}, @{$item[2]};
   1;
}',
                                                                                            'line' => 160,
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ],
                                                                      'error' => undef,
                                                                      'strcount' => 0,
                                                                      'number' => 0,
                                                                      'dircount' => 0,
                                                                      'uncommit' => undef,
                                                                      'line' => undef,
                                                                      'patcount' => 0
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'vars' => '',
                                                'line' => 160,
                                                'opcount' => 0,
                                                'changed' => 0,
                                                'impcount' => 1
                                              }, 'Parse::RecDescent::Rule' ),
                              'uintvar_integer' => bless( {
                                                            'prods' => [
                                                                         bless( {
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => undef,
                                                                                  'patcount' => 0,
                                                                                  'error' => undef,
                                                                                  'number' => 0,
                                                                                  'strcount' => 0,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'uintvar',
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 265,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'vars' => '',
                                                            'calls' => [
                                                                         'uintvar'
                                                                       ],
                                                            'name' => 'uintvar_integer',
                                                            'impcount' => 0,
                                                            'changed' => 0,
                                                            'opcount' => 0,
                                                            'line' => 264
                                                          }, 'Parse::RecDescent::Rule' ),
                              '_trans_well_known_media' => bless( {
                                                                    'vars' => '',
                                                                    'prods' => [
                                                                                 bless( {
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'subrule' => 'well_known_media',
                                                                                                                'matchrule' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'lookahead' => 0,
                                                                                                                'line' => 478,
                                                                                                                'implicit' => undef
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'code' => '{
   # media_type_for() defined in g-startup.pl
   $return = media_type_for($item{well_known_media});
   1;
}',
                                                                                                                'hashname' => '__ACTION1__',
                                                                                                                'line' => 478,
                                                                                                                'lookahead' => 0
                                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                                     ],
                                                                                          'actcount' => 1,
                                                                                          'uncommit' => undef,
                                                                                          'line' => undef,
                                                                                          'patcount' => 0,
                                                                                          'dircount' => 0,
                                                                                          'error' => undef,
                                                                                          'strcount' => 0,
                                                                                          'number' => 0
                                                                                        }, 'Parse::RecDescent::Production' )
                                                                               ],
                                                                    'calls' => [
                                                                                 'well_known_media'
                                                                               ],
                                                                    'name' => '_trans_well_known_media',
                                                                    'impcount' => 0,
                                                                    'changed' => 0,
                                                                    'opcount' => 0,
                                                                    'line' => 478
                                                                  }, 'Parse::RecDescent::Rule' ),
                              'priority_value' => bless( {
                                                           'prods' => [
                                                                        bless( {
                                                                                 'dircount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'line' => undef,
                                                                                 'patcount' => 0,
                                                                                 'error' => undef,
                                                                                 'strcount' => 0,
                                                                                 'number' => 0,
                                                                                 'actcount' => 0,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'implicit' => undef,
                                                                                                       'line' => 766,
                                                                                                       'lookahead' => 0,
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'subrule' => 'LOW'
                                                                                                     }, 'Parse::RecDescent::Subrule' )
                                                                                            ]
                                                                               }, 'Parse::RecDescent::Production' ),
                                                                        bless( {
                                                                                 'error' => undef,
                                                                                 'strcount' => 0,
                                                                                 'number' => 1,
                                                                                 'dircount' => 0,
                                                                                 'line' => 766,
                                                                                 'patcount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'actcount' => 0,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'subrule' => 'NORMAL',
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'lookahead' => 0,
                                                                                                       'line' => 766,
                                                                                                       'implicit' => undef
                                                                                                     }, 'Parse::RecDescent::Subrule' )
                                                                                            ]
                                                                               }, 'Parse::RecDescent::Production' ),
                                                                        bless( {
                                                                                 'actcount' => 0,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'line' => 766,
                                                                                                       'implicit' => undef,
                                                                                                       'argcode' => undef,
                                                                                                       'matchrule' => 0,
                                                                                                       'lookahead' => 0,
                                                                                                       'subrule' => 'HIGH'
                                                                                                     }, 'Parse::RecDescent::Subrule' )
                                                                                            ],
                                                                                 'error' => undef,
                                                                                 'number' => 2,
                                                                                 'strcount' => 0,
                                                                                 'dircount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'line' => 766,
                                                                                 'patcount' => 0
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'vars' => '',
                                                           'calls' => [
                                                                        'LOW',
                                                                        'NORMAL',
                                                                        'HIGH'
                                                                      ],
                                                           'name' => 'priority_value',
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'opcount' => 0,
                                                           'line' => 766
                                                         }, 'Parse::RecDescent::Rule' ),
                              'typed_parameter' => bless( {
                                                            'opcount' => 0,
                                                            'line' => 337,
                                                            'impcount' => 0,
                                                            'changed' => 0,
                                                            'calls' => [
                                                                         'q_parameter',
                                                                         'charset_parameter',
                                                                         'level_parameter',
                                                                         'type_parameter',
                                                                         'name_deprecated_parameter',
                                                                         'filename_deprecated_parameter',
                                                                         'differences_parameter',
                                                                         'padding_parameter',
                                                                         'type_related_parameter',
                                                                         'start_related_deprecated_parameter',
                                                                         'start_info_related_deprecated_parameter',
                                                                         'comment_deprecated_parameter',
                                                                         'domain_deprecated_parameter',
                                                                         'max_age_parameter',
                                                                         'path_deprecated_parameter',
                                                                         'secure_parameter',
                                                                         'SEC_wbxml_parameter',
                                                                         'MAC_wbxml_parameter',
                                                                         'creation_date_parameter',
                                                                         'modification_date_parameter',
                                                                         'read_date_parameter',
                                                                         'size_parameter',
                                                                         'name_parameter',
                                                                         'filename_parameter',
                                                                         'start_related_parameter',
                                                                         'start_info_related_parameter',
                                                                         'comment_parameter',
                                                                         'domain_parameter',
                                                                         'path_parameter'
                                                                       ],
                                                            'name' => 'typed_parameter',
                                                            'vars' => '',
                                                            'prods' => [
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'subrule' => 'q_parameter',
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 338
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0,
                                                                                  'number' => 0,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'line' => undef,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 339,
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 1,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'charset_parameter',
                                                                                                        'line' => 339,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 340,
                                                                                                        'subrule' => 'level_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 340,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'number' => 2,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'type_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 341
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 341,
                                                                                  'patcount' => 0,
                                                                                  'strcount' => 0,
                                                                                  'number' => 3,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 342,
                                                                                                        'subrule' => 'name_deprecated_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 342,
                                                                                  'strcount' => 0,
                                                                                  'number' => 4,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 343,
                                                                                                        'implicit' => undef,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'filename_deprecated_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'number' => 5,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'dircount' => 0,
                                                                                  'line' => 343,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'strcount' => 0,
                                                                                  'number' => 6,
                                                                                  'error' => undef,
                                                                                  'line' => 344,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 344,
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'subrule' => 'differences_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 345,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'number' => 7,
                                                                                  'strcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 345,
                                                                                                        'subrule' => 'padding_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 8,
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 346,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'type_related_parameter',
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 346,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'strcount' => 0,
                                                                                  'number' => 9,
                                                                                  'error' => undef,
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 347,
                                                                                  'patcount' => 0,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'subrule' => 'start_related_deprecated_parameter',
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 347
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'line' => 348,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'strcount' => 0,
                                                                                  'number' => 10,
                                                                                  'error' => undef,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'start_info_related_deprecated_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 348
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'subrule' => 'comment_deprecated_parameter',
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 349
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 349,
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 11
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'subrule' => 'domain_deprecated_parameter',
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 350
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0,
                                                                                  'line' => 350,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'dircount' => 0,
                                                                                  'strcount' => 0,
                                                                                  'number' => 12,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 351,
                                                                                                        'subrule' => 'max_age_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'line' => 351,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'strcount' => 0,
                                                                                  'number' => 13,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 352,
                                                                                                        'implicit' => undef,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'path_deprecated_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'number' => 14,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'dircount' => 0,
                                                                                  'line' => 352,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'uncommit' => undef,
                                                                                  'line' => 353,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'number' => 15,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'secure_parameter',
                                                                                                        'line' => 353,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 354,
                                                                                                        'subrule' => 'SEC_wbxml_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 354,
                                                                                  'strcount' => 0,
                                                                                  'number' => 16,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 355,
                                                                                                        'implicit' => undef,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'MAC_wbxml_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0,
                                                                                  'line' => 355,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'number' => 17,
                                                                                  'strcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'creation_date_parameter',
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 356,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 356,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 18
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 357,
                                                                                  'number' => 19,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'modification_date_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 357
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 358,
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 20,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 358,
                                                                                                        'implicit' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'read_date_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'dircount' => 0,
                                                                                  'line' => 359,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 21,
                                                                                  'error' => undef,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 359,
                                                                                                        'implicit' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'size_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 360,
                                                                                                        'implicit' => undef,
                                                                                                        'subrule' => 'name_parameter',
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 360,
                                                                                  'error' => undef,
                                                                                  'number' => 22,
                                                                                  'strcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 361,
                                                                                  'dircount' => 0,
                                                                                  'number' => 23,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'filename_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 361
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'strcount' => 0,
                                                                                  'number' => 24,
                                                                                  'error' => undef,
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 362,
                                                                                  'patcount' => 0,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 362,
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'subrule' => 'start_related_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 363,
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'subrule' => 'start_info_related_parameter'
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => 363,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 25
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 364,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'strcount' => 0,
                                                                                  'number' => 26,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'comment_parameter',
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 364,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'number' => 27,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef,
                                                                                  'line' => 365,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 365,
                                                                                                        'subrule' => 'domain_parameter',
                                                                                                        'lookahead' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ],
                                                                                  'actcount' => 0
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => 366,
                                                                                  'strcount' => 0,
                                                                                  'number' => 28,
                                                                                  'error' => undef,
                                                                                  'actcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'subrule' => 'path_parameter',
                                                                                                        'line' => 366,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ]
                                                          }, 'Parse::RecDescent::Rule' ),
                              'm_notifyresp_ind' => bless( {
                                                             'line' => 758,
                                                             'opcount' => 0,
                                                             'changed' => 0,
                                                             'impcount' => 0,
                                                             'name' => 'm_notifyresp_ind',
                                                             'calls' => [],
                                                             'vars' => '',
                                                             'prods' => [
                                                                          bless( {
                                                                                   'number' => 0,
                                                                                   'strcount' => 1,
                                                                                   'error' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'patcount' => 0,
                                                                                   'line' => undef,
                                                                                   'dircount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'description' => '\'\\\\x83\'',
                                                                                                         'line' => 758,
                                                                                                         'pattern' => '\\x83',
                                                                                                         'hashname' => '__STRING1__',
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::InterpLit' ),
                                                                                                bless( {
                                                                                                         'lookahead' => 0,
                                                                                                         'hashname' => '__ACTION1__',
                                                                                                         'code' => '{ $return = $item[0]; }',
                                                                                                         'line' => 758
                                                                                                       }, 'Parse::RecDescent::Action' )
                                                                                              ],
                                                                                   'actcount' => 1
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ]
                                                           }, 'Parse::RecDescent::Rule' ),
                              'LOW' => bless( {
                                                'opcount' => 0,
                                                'line' => 767,
                                                'impcount' => 0,
                                                'changed' => 0,
                                                'calls' => [],
                                                'name' => 'LOW',
                                                'vars' => '',
                                                'prods' => [
                                                             bless( {
                                                                      'actcount' => 1,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'hashname' => '__STRING1__',
                                                                                            'description' => '\'\\\\x80\'',
                                                                                            'line' => 767,
                                                                                            'pattern' => '\\x80',
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                   bless( {
                                                                                            'code' => '{ $return = $item[0]; 1; }',
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'line' => 767,
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ],
                                                                      'dircount' => 0,
                                                                      'patcount' => 0,
                                                                      'uncommit' => undef,
                                                                      'line' => undef,
                                                                      'number' => 0,
                                                                      'strcount' => 1,
                                                                      'error' => undef
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ]
                                              }, 'Parse::RecDescent::Rule' ),
                              'status_head' => bless( {
                                                        'name' => 'status_head',
                                                        'calls' => [
                                                                     'status_value'
                                                                   ],
                                                        'vars' => '',
                                                        'prods' => [
                                                                     bless( {
                                                                              'number' => 0,
                                                                              'strcount' => 1,
                                                                              'error' => undef,
                                                                              'patcount' => 0,
                                                                              'line' => undef,
                                                                              'uncommit' => undef,
                                                                              'dircount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'line' => 676,
                                                                                                    'description' => '\'\\\\x95\'',
                                                                                                    'pattern' => '\\x95',
                                                                                                    'hashname' => '__STRING1__'
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'line' => 676,
                                                                                                    'implicit' => undef,
                                                                                                    'argcode' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'subrule' => 'status_value'
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'line' => 677,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'line' => 676,
                                                        'opcount' => 0,
                                                        'changed' => 0,
                                                        'impcount' => 0
                                                      }, 'Parse::RecDescent::Rule' ),
                              'NORMAL' => bless( {
                                                   'prods' => [
                                                                bless( {
                                                                         'line' => undef,
                                                                         'patcount' => 0,
                                                                         'uncommit' => undef,
                                                                         'dircount' => 0,
                                                                         'strcount' => 1,
                                                                         'number' => 0,
                                                                         'error' => undef,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'pattern' => '\\x81',
                                                                                               'description' => '\'\\\\x81\'',
                                                                                               'line' => 768,
                                                                                               'hashname' => '__STRING1__',
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::InterpLit' ),
                                                                                      bless( {
                                                                                               'line' => 768,
                                                                                               'code' => '{ $return = $item[0]; 1; }',
                                                                                               'hashname' => '__ACTION1__',
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                    ],
                                                                         'actcount' => 1
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ],
                                                   'vars' => '',
                                                   'calls' => [],
                                                   'name' => 'NORMAL',
                                                   'impcount' => 0,
                                                   'changed' => 0,
                                                   'opcount' => 0,
                                                   'line' => 768
                                                 }, 'Parse::RecDescent::Rule' ),
                              'HT' => bless( {
                                               'prods' => [
                                                            bless( {
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__STRING1__',
                                                                                           'pattern' => '\\x09',
                                                                                           'description' => '\'\\\\x09\'',
                                                                                           'line' => 156
                                                                                         }, 'Parse::RecDescent::InterpLit' )
                                                                                ],
                                                                     'actcount' => 0,
                                                                     'line' => undef,
                                                                     'patcount' => 0,
                                                                     'uncommit' => undef,
                                                                     'dircount' => 0,
                                                                     'strcount' => 1,
                                                                     'number' => 0,
                                                                     'error' => undef
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'vars' => '',
                                               'calls' => [],
                                               'name' => 'HT',
                                               'impcount' => 0,
                                               'changed' => 0,
                                               'opcount' => 0,
                                               'line' => 156
                                             }, 'Parse::RecDescent::Rule' ),
                              'domain_parameter' => bless( {
                                                             'impcount' => 0,
                                                             'changed' => 0,
                                                             'opcount' => 0,
                                                             'line' => 423,
                                                             'prods' => [
                                                                          bless( {
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'hashname' => '__STRING1__',
                                                                                                         'line' => 423,
                                                                                                         'description' => '\'\\\\x9c\'',
                                                                                                         'pattern' => '\\x9c',
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::InterpLit' ),
                                                                                                bless( {
                                                                                                         'subrule' => 'text_value',
                                                                                                         'lookahead' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'implicit' => undef,
                                                                                                         'line' => 423
                                                                                                       }, 'Parse::RecDescent::Subrule' ),
                                                                                                bless( {
                                                                                                         'lookahead' => 0,
                                                                                                         'line' => 424,
                                                                                                         'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                         'hashname' => '__ACTION1__'
                                                                                                       }, 'Parse::RecDescent::Action' )
                                                                                              ],
                                                                                   'actcount' => 1,
                                                                                   'number' => 0,
                                                                                   'strcount' => 1,
                                                                                   'error' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'line' => undef,
                                                                                   'patcount' => 0,
                                                                                   'dircount' => 0
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'vars' => '',
                                                             'calls' => [
                                                                          'text_value'
                                                                        ],
                                                             'name' => 'domain_parameter'
                                                           }, 'Parse::RecDescent::Rule' ),
                              'TEXT' => bless( {
                                                 'impcount' => 1,
                                                 'changed' => 0,
                                                 'opcount' => 0,
                                                 'line' => 166,
                                                 'prods' => [
                                                              bless( {
                                                                       'error' => undef,
                                                                       'strcount' => 0,
                                                                       'number' => 0,
                                                                       'dircount' => 0,
                                                                       'uncommit' => undef,
                                                                       'patcount' => 0,
                                                                       'line' => undef,
                                                                       'actcount' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'subrule' => '_alternation_1_of_production_1_of_rule_TEXT',
                                                                                             'argcode' => undef,
                                                                                             'repspec' => 's',
                                                                                             'expected' => '_non_CTL, or LWS',
                                                                                             'max' => 100000000,
                                                                                             'matchrule' => 0,
                                                                                             'lookahead' => 0,
                                                                                             'min' => 1,
                                                                                             'line' => 166
                                                                                           }, 'Parse::RecDescent::Repetition' ),
                                                                                    bless( {
                                                                                             'line' => 166,
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{
   $return = join \'\', @{$item[1]};
   1;
}',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ]
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'vars' => '',
                                                 'calls' => [
                                                              '_alternation_1_of_production_1_of_rule_TEXT'
                                                            ],
                                                 'name' => 'TEXT'
                                               }, 'Parse::RecDescent::Rule' ),
                              'to_value' => bless( {
                                                     'changed' => 0,
                                                     'impcount' => 0,
                                                     'line' => 805,
                                                     'opcount' => 0,
                                                     'prods' => [
                                                                  bless( {
                                                                           'number' => 0,
                                                                           'strcount' => 0,
                                                                           'error' => undef,
                                                                           'dircount' => 0,
                                                                           'line' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'subrule' => '_address_value',
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 805
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'vars' => '',
                                                     'name' => 'to_value',
                                                     'calls' => [
                                                                  '_address_value'
                                                                ]
                                                   }, 'Parse::RecDescent::Rule' ),
                              'ERROR_CONTENT_NOT_ACCEPTED' => bless( {
                                                                       'name' => 'ERROR_CONTENT_NOT_ACCEPTED',
                                                                       'calls' => [],
                                                                       'prods' => [
                                                                                    bless( {
                                                                                             'error' => undef,
                                                                                             'strcount' => 1,
                                                                                             'number' => 0,
                                                                                             'uncommit' => undef,
                                                                                             'patcount' => 0,
                                                                                             'line' => undef,
                                                                                             'dircount' => 0,
                                                                                             'items' => [
                                                                                                          bless( {
                                                                                                                   'pattern' => '\\x87',
                                                                                                                   'description' => '\'\\\\x87\'',
                                                                                                                   'line' => 789,
                                                                                                                   'hashname' => '__STRING1__',
                                                                                                                   'lookahead' => 0
                                                                                                                 }, 'Parse::RecDescent::InterpLit' ),
                                                                                                          bless( {
                                                                                                                   'line' => 789,
                                                                                                                   'code' => '{ $return = $item[0]; 1; }',
                                                                                                                   'hashname' => '__ACTION1__',
                                                                                                                   'lookahead' => 0
                                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                                        ],
                                                                                             'actcount' => 1
                                                                                           }, 'Parse::RecDescent::Production' )
                                                                                  ],
                                                                       'vars' => '',
                                                                       'line' => 789,
                                                                       'opcount' => 0,
                                                                       'changed' => 0,
                                                                       'impcount' => 0
                                                                     }, 'Parse::RecDescent::Rule' ),
                              'PERSONAL' => bless( {
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 745,
                                                                                                 'description' => '\'\\\\x80\'',
                                                                                                 'pattern' => '\\x80',
                                                                                                 'hashname' => '__STRING1__'
                                                                                               }, 'Parse::RecDescent::InterpLit' ),
                                                                                        bless( {
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{ $return = $item[0]; 1; }',
                                                                                                 'line' => 745,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'actcount' => 1,
                                                                           'error' => undef,
                                                                           'strcount' => 1,
                                                                           'number' => 0,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'line' => undef,
                                                                           'dircount' => 0
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'name' => 'PERSONAL',
                                                     'calls' => [],
                                                     'changed' => 0,
                                                     'impcount' => 0,
                                                     'line' => 745,
                                                     'opcount' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'content_type_value' => bless( {
                                                               'opcount' => 0,
                                                               'line' => 440,
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'calls' => [
                                                                            'ct_constrained_media',
                                                                            'content_general_form'
                                                                          ],
                                                               'name' => 'content_type_value',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 441,
                                                                                                           'subrule' => 'ct_constrained_media',
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0,
                                                                                     'strcount' => 0,
                                                                                     'number' => 0,
                                                                                     'error' => undef,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'line' => undef,
                                                                                     'dircount' => 0
                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                            bless( {
                                                                                     'error' => undef,
                                                                                     'strcount' => 0,
                                                                                     'number' => 1,
                                                                                     'line' => 441,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 441,
                                                                                                           'subrule' => 'content_general_form',
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => ''
                                                             }, 'Parse::RecDescent::Rule' ),
                              'DataFragmentPDU' => bless( {
                                                            'prods' => [
                                                                         bless( {
                                                                                  'actcount' => 1,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'hashname' => '__STRING1__',
                                                                                                        'pattern' => '\\x80',
                                                                                                        'description' => '\'\\\\x80\'',
                                                                                                        'line' => 228,
                                                                                                        'lookahead' => 0
                                                                                                      }, 'Parse::RecDescent::InterpLit' ),
                                                                                               bless( {
                                                                                                        'line' => 228,
                                                                                                        'hashname' => '__ACTION1__',
                                                                                                        'code' => '{ $return = $item[0]; 1; }',
                                                                                                        'lookahead' => 0
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ],
                                                                                  'dircount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'line' => undef,
                                                                                  'error' => undef,
                                                                                  'strcount' => 1,
                                                                                  'number' => 0
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'vars' => '',
                                                            'name' => 'DataFragmentPDU',
                                                            'calls' => [],
                                                            'changed' => 0,
                                                            'impcount' => 0,
                                                            'line' => 228,
                                                            'opcount' => 0
                                                          }, 'Parse::RecDescent::Rule' ),
                              'max_age_parameter' => bless( {
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'actcount' => 1,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'pattern' => '\\x8e',
                                                                                                          'description' => '\'\\\\x8e\'',
                                                                                                          'line' => 395
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'line' => 395,
                                                                                                          'implicit' => undef,
                                                                                                          'subrule' => 'delta_seconds_value',
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 396,
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'code' => '{ $return = build_parameter(@item, \'1.3\'); 1; }'
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'number' => 0,
                                                                                    'strcount' => 1,
                                                                                    'error' => undef,
                                                                                    'dircount' => 0,
                                                                                    'patcount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'line' => undef
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'name' => 'max_age_parameter',
                                                              'calls' => [
                                                                           'delta_seconds_value'
                                                                         ],
                                                              'changed' => 0,
                                                              'impcount' => 0,
                                                              'line' => 395,
                                                              'opcount' => 0
                                                            }, 'Parse::RecDescent::Rule' ),
                              'ERROR_UNSPECIFIED' => bless( {
                                                              'impcount' => 0,
                                                              'changed' => 0,
                                                              'opcount' => 0,
                                                              'line' => 783,
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'number' => 0,
                                                                                    'strcount' => 1,
                                                                                    'error' => undef,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'dircount' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'pattern' => '\\x81',
                                                                                                          'line' => 783,
                                                                                                          'description' => '\'\\\\x81\''
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'code' => '{ $return = $item[0]; 1; }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'line' => 783,
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'calls' => [],
                                                              'name' => 'ERROR_UNSPECIFIED'
                                                            }, 'Parse::RecDescent::Rule' ),
                              'date_value' => bless( {
                                                       'opcount' => 0,
                                                       'line' => 297,
                                                       'impcount' => 0,
                                                       'changed' => 0,
                                                       'calls' => [
                                                                    'long_integer'
                                                                  ],
                                                       'name' => 'date_value',
                                                       'vars' => '',
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 298,
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'subrule' => 'long_integer'
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'actcount' => 0,
                                                                             'line' => undef,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'number' => 0,
                                                                             'strcount' => 0,
                                                                             'error' => undef
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ]
                                                     }, 'Parse::RecDescent::Rule' ),
                              'UPALPHA' => bless( {
                                                    'changed' => 0,
                                                    'impcount' => 0,
                                                    'line' => 148,
                                                    'opcount' => 0,
                                                    'prods' => [
                                                                 bless( {
                                                                          'number' => 0,
                                                                          'strcount' => 0,
                                                                          'error' => undef,
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'patcount' => 1,
                                                                          'dircount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'description' => '/[A-Z]/',
                                                                                                'rdelim' => '/',
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'mod' => '',
                                                                                                'pattern' => '[A-Z]',
                                                                                                'line' => 148,
                                                                                                'lookahead' => 0,
                                                                                                'ldelim' => '/'
                                                                                              }, 'Parse::RecDescent::Token' )
                                                                                     ],
                                                                          'actcount' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => '',
                                                    'name' => 'UPALPHA',
                                                    'calls' => []
                                                  }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value' => bless( {
                                                                                                                                     'impcount' => 0,
                                                                                                                                     'changed' => 0,
                                                                                                                                     'opcount' => 0,
                                                                                                                                     'line' => 807,
                                                                                                                                     'vars' => '',
                                                                                                                                     'prods' => [
                                                                                                                                                  bless( {
                                                                                                                                                           'items' => [
                                                                                                                                                                        bless( {
                                                                                                                                                                                 'matchrule' => 0,
                                                                                                                                                                                 'argcode' => undef,
                                                                                                                                                                                 'lookahead' => 0,
                                                                                                                                                                                 'subrule' => 'address_present_token',
                                                                                                                                                                                 'line' => 807,
                                                                                                                                                                                 'implicit' => undef
                                                                                                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                                                                                                        bless( {
                                                                                                                                                                                 'subrule' => '_address_value',
                                                                                                                                                                                 'argcode' => undef,
                                                                                                                                                                                 'matchrule' => 0,
                                                                                                                                                                                 'lookahead' => 0,
                                                                                                                                                                                 'line' => 807,
                                                                                                                                                                                 'implicit' => undef
                                                                                                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                                                                                                      ],
                                                                                                                                                           'actcount' => 0,
                                                                                                                                                           'error' => undef,
                                                                                                                                                           'strcount' => 0,
                                                                                                                                                           'number' => 0,
                                                                                                                                                           'patcount' => 0,
                                                                                                                                                           'line' => undef,
                                                                                                                                                           'uncommit' => undef,
                                                                                                                                                           'dircount' => 0
                                                                                                                                                         }, 'Parse::RecDescent::Production' )
                                                                                                                                                ],
                                                                                                                                     'calls' => [
                                                                                                                                                  'address_present_token',
                                                                                                                                                  '_address_value'
                                                                                                                                                ],
                                                                                                                                     'name' => '_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value'
                                                                                                                                   }, 'Parse::RecDescent::Rule' ),
                              'MMS_version_value' => bless( {
                                                              'prods' => [
                                                                           bless( {
                                                                                    'dircount' => 0,
                                                                                    'line' => undef,
                                                                                    'patcount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'strcount' => 0,
                                                                                    'number' => 0,
                                                                                    'error' => undef,
                                                                                    'actcount' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'line' => 765,
                                                                                                          'implicit' => undef,
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => '_short_integer_version'
                                                                                                        }, 'Parse::RecDescent::Subrule' )
                                                                                               ]
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'vars' => '',
                                                              'name' => 'MMS_version_value',
                                                              'calls' => [
                                                                           '_short_integer_version'
                                                                         ],
                                                              'changed' => 0,
                                                              'impcount' => 0,
                                                              'line' => 764,
                                                              'opcount' => 0
                                                            }, 'Parse::RecDescent::Rule' ),
                              'SP' => bless( {
                                               'changed' => 0,
                                               'impcount' => 0,
                                               'line' => 155,
                                               'opcount' => 0,
                                               'prods' => [
                                                            bless( {
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__STRING1__',
                                                                                           'pattern' => '\\x20',
                                                                                           'line' => 155,
                                                                                           'description' => '\'\\\\x20\''
                                                                                         }, 'Parse::RecDescent::InterpLit' )
                                                                                ],
                                                                     'actcount' => 0,
                                                                     'strcount' => 1,
                                                                     'number' => 0,
                                                                     'error' => undef,
                                                                     'line' => undef,
                                                                     'uncommit' => undef,
                                                                     'patcount' => 0,
                                                                     'dircount' => 0
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'vars' => '',
                                               'name' => 'SP',
                                               'calls' => []
                                             }, 'Parse::RecDescent::Rule' ),
                              'TID' => bless( {
                                                'impcount' => 0,
                                                'changed' => 0,
                                                'opcount' => 0,
                                                'line' => 197,
                                                'vars' => '',
                                                'prods' => [
                                                             bless( {
                                                                      'actcount' => 0,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'subrule' => 'uint8',
                                                                                            'matchrule' => 0,
                                                                                            'argcode' => undef,
                                                                                            'lookahead' => 0,
                                                                                            'line' => 197,
                                                                                            'implicit' => undef
                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                 ],
                                                                      'dircount' => 0,
                                                                      'patcount' => 0,
                                                                      'uncommit' => undef,
                                                                      'line' => undef,
                                                                      'strcount' => 0,
                                                                      'number' => 0,
                                                                      'error' => undef
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'calls' => [
                                                             'uint8'
                                                           ],
                                                'name' => 'TID'
                                              }, 'Parse::RecDescent::Rule' ),
                              'response_text_head' => bless( {
                                                               'calls' => [
                                                                            'response_text_value'
                                                                          ],
                                                               'name' => 'response_text_head',
                                                               'vars' => '',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'strcount' => 1,
                                                                                     'number' => 0,
                                                                                     'error' => undef,
                                                                                     'dircount' => 0,
                                                                                     'patcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => undef,
                                                                                     'actcount' => 1,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'hashname' => '__STRING1__',
                                                                                                           'pattern' => '\\x93',
                                                                                                           'line' => 672,
                                                                                                           'description' => '\'\\\\x93\''
                                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                                  bless( {
                                                                                                           'subrule' => 'response_text_value',
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 672,
                                                                                                           'implicit' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 673,
                                                                                                           'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                           'hashname' => '__ACTION1__'
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ]
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'opcount' => 0,
                                                               'line' => 672,
                                                               'impcount' => 0,
                                                               'changed' => 0
                                                             }, 'Parse::RecDescent::Rule' ),
                              'content_location_value' => bless( {
                                                                   'changed' => 0,
                                                                   'impcount' => 0,
                                                                   'line' => 701,
                                                                   'opcount' => 0,
                                                                   'prods' => [
                                                                                bless( {
                                                                                         'items' => [
                                                                                                      bless( {
                                                                                                               'lookahead' => 0,
                                                                                                               'matchrule' => 0,
                                                                                                               'argcode' => undef,
                                                                                                               'subrule' => 'uri_value',
                                                                                                               'implicit' => undef,
                                                                                                               'line' => 701
                                                                                                             }, 'Parse::RecDescent::Subrule' )
                                                                                                    ],
                                                                                         'actcount' => 0,
                                                                                         'line' => undef,
                                                                                         'uncommit' => undef,
                                                                                         'patcount' => 0,
                                                                                         'dircount' => 0,
                                                                                         'number' => 0,
                                                                                         'strcount' => 0,
                                                                                         'error' => undef
                                                                                       }, 'Parse::RecDescent::Production' )
                                                                              ],
                                                                   'vars' => '',
                                                                   'name' => 'content_location_value',
                                                                   'calls' => [
                                                                                'uri_value'
                                                                              ]
                                                                 }, 'Parse::RecDescent::Rule' ),
                              'size_parameter' => bless( {
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'opcount' => 0,
                                                           'line' => 411,
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'actcount' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'hashname' => '__STRING1__',
                                                                                                       'pattern' => '\\x96',
                                                                                                       'description' => '\'\\\\x96\'',
                                                                                                       'line' => 411,
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'line' => 411,
                                                                                                       'implicit' => undef,
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'lookahead' => 0,
                                                                                                       'subrule' => 'integer_value'
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'line' => 412,
                                                                                                       'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ],
                                                                                 'dircount' => 0,
                                                                                 'patcount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'line' => undef,
                                                                                 'strcount' => 1,
                                                                                 'number' => 0,
                                                                                 'error' => undef
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'calls' => [
                                                                        'integer_value'
                                                                      ],
                                                           'name' => 'size_parameter'
                                                         }, 'Parse::RecDescent::Rule' ),
                              'text_string' => bless( {
                                                        'changed' => 0,
                                                        'impcount' => 0,
                                                        'line' => 229,
                                                        'opcount' => 0,
                                                        'prods' => [
                                                                     bless( {
                                                                              'strcount' => 0,
                                                                              'number' => 0,
                                                                              'error' => undef,
                                                                              'uncommit' => undef,
                                                                              'patcount' => 0,
                                                                              'line' => undef,
                                                                              'dircount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'max' => 1,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'min' => 0,
                                                                                                    'line' => 230,
                                                                                                    'subrule' => 'quote',
                                                                                                    'argcode' => undef,
                                                                                                    'repspec' => '?',
                                                                                                    'expected' => undef
                                                                                                  }, 'Parse::RecDescent::Repetition' ),
                                                                                           bless( {
                                                                                                    'line' => 230,
                                                                                                    'min' => 0,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'max' => 1,
                                                                                                    'expected' => undef,
                                                                                                    'repspec' => '?',
                                                                                                    'argcode' => undef,
                                                                                                    'subrule' => 'TEXT'
                                                                                                  }, 'Parse::RecDescent::Repetition' ),
                                                                                           bless( {
                                                                                                    'line' => 230,
                                                                                                    'implicit' => undef,
                                                                                                    'subrule' => 'end_of_string',
                                                                                                    'argcode' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'code' => '{
   $return = scalar @{$item[2]} ? $item[2][0] : \'\';
   1;
}',
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'line' => 230,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'name' => 'text_string',
                                                        'calls' => [
                                                                     'quote',
                                                                     'TEXT',
                                                                     'end_of_string'
                                                                   ]
                                                      }, 'Parse::RecDescent::Rule' ),
                              'status_value' => bless( {
                                                         'name' => 'status_value',
                                                         'calls' => [
                                                                      'EXPIRED',
                                                                      'RETRIEVED',
                                                                      'REJECTED',
                                                                      'DEFERRED',
                                                                      'UNRECOGNISED'
                                                                    ],
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'dircount' => 0,
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0,
                                                                               'strcount' => 0,
                                                                               'number' => 0,
                                                                               'error' => undef,
                                                                               'actcount' => 0,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'subrule' => 'EXPIRED',
                                                                                                     'matchrule' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'lookahead' => 0,
                                                                                                     'line' => 797,
                                                                                                     'implicit' => undef
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ]
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'matchrule' => 0,
                                                                                                     'subrule' => 'RETRIEVED',
                                                                                                     'implicit' => undef,
                                                                                                     'line' => 797
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'actcount' => 0,
                                                                               'patcount' => 0,
                                                                               'uncommit' => undef,
                                                                               'line' => 797,
                                                                               'dircount' => 0,
                                                                               'error' => undef,
                                                                               'number' => 1,
                                                                               'strcount' => 0
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'actcount' => 0,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'matchrule' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'lookahead' => 0,
                                                                                                     'subrule' => 'REJECTED',
                                                                                                     'line' => 797,
                                                                                                     'implicit' => undef
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'dircount' => 0,
                                                                               'patcount' => 0,
                                                                               'uncommit' => undef,
                                                                               'line' => 797,
                                                                               'error' => undef,
                                                                               'strcount' => 0,
                                                                               'number' => 2
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'actcount' => 0,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'implicit' => undef,
                                                                                                     'line' => 797,
                                                                                                     'lookahead' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'matchrule' => 0,
                                                                                                     'subrule' => 'DEFERRED'
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'dircount' => 0,
                                                                               'uncommit' => undef,
                                                                               'line' => 797,
                                                                               'patcount' => 0,
                                                                               'error' => undef,
                                                                               'strcount' => 0,
                                                                               'number' => 3
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'actcount' => 0,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'implicit' => undef,
                                                                                                     'line' => 797,
                                                                                                     'lookahead' => 0,
                                                                                                     'matchrule' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'subrule' => 'UNRECOGNISED'
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'error' => undef,
                                                                               'strcount' => 0,
                                                                               'number' => 4,
                                                                               'dircount' => 0,
                                                                               'line' => 797,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'line' => 796,
                                                         'opcount' => 0,
                                                         'changed' => 0,
                                                         'impcount' => 0
                                                       }, 'Parse::RecDescent::Rule' ),
                              'CHAR' => bless( {
                                                 'line' => 147,
                                                 'opcount' => 0,
                                                 'changed' => 0,
                                                 'impcount' => 0,
                                                 'name' => 'CHAR',
                                                 'calls' => [],
                                                 'prods' => [
                                                              bless( {
                                                                       'strcount' => 0,
                                                                       'number' => 0,
                                                                       'error' => undef,
                                                                       'uncommit' => undef,
                                                                       'line' => undef,
                                                                       'patcount' => 1,
                                                                       'dircount' => 0,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'ldelim' => '/',
                                                                                             'hashname' => '__PATTERN1__',
                                                                                             'mod' => '',
                                                                                             'pattern' => '[\\x00-\\x7F]',
                                                                                             'line' => 147,
                                                                                             'rdelim' => '/',
                                                                                             'description' => '/[\\\\x00-\\\\x7F]/'
                                                                                           }, 'Parse::RecDescent::Token' )
                                                                                  ],
                                                                       'actcount' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'vars' => ''
                                               }, 'Parse::RecDescent::Rule' ),
                              'length_' => bless( {
                                                    'line' => 287,
                                                    'opcount' => 0,
                                                    'changed' => 0,
                                                    'impcount' => 0,
                                                    'name' => 'length_',
                                                    'calls' => [
                                                                 'uintvar'
                                                               ],
                                                    'prods' => [
                                                                 bless( {
                                                                          'dircount' => 0,
                                                                          'line' => undef,
                                                                          'uncommit' => undef,
                                                                          'patcount' => 0,
                                                                          'error' => undef,
                                                                          'number' => 0,
                                                                          'strcount' => 0,
                                                                          'actcount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'line' => 288,
                                                                                                'implicit' => undef,
                                                                                                'subrule' => 'uintvar',
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Subrule' )
                                                                                     ]
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => ''
                                                  }, 'Parse::RecDescent::Rule' ),
                              'filename_parameter' => bless( {
                                                               'prods' => [
                                                                            bless( {
                                                                                     'strcount' => 1,
                                                                                     'number' => 0,
                                                                                     'error' => undef,
                                                                                     'line' => undef,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 415,
                                                                                                           'description' => '\'\\\\x98\'',
                                                                                                           'pattern' => '\\x98',
                                                                                                           'hashname' => '__STRING1__',
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 415,
                                                                                                           'subrule' => 'text_value',
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'hashname' => '__ACTION1__',
                                                                                                           'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                           'line' => 416,
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ],
                                                                                     'actcount' => 1
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'calls' => [
                                                                            'text_value'
                                                                          ],
                                                               'name' => 'filename_parameter',
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'opcount' => 0,
                                                               'line' => 415
                                                             }, 'Parse::RecDescent::Rule' ),
                              'type_related_parameter' => bless( {
                                                                   'name' => 'type_related_parameter',
                                                                   'calls' => [
                                                                                'constrained_encoding'
                                                                              ],
                                                                   'prods' => [
                                                                                bless( {
                                                                                         'items' => [
                                                                                                      bless( {
                                                                                                               'lookahead' => 0,
                                                                                                               'hashname' => '__STRING1__',
                                                                                                               'line' => 385,
                                                                                                               'description' => '\'\\\\x89\'',
                                                                                                               'pattern' => '\\x89'
                                                                                                             }, 'Parse::RecDescent::InterpLit' ),
                                                                                                      bless( {
                                                                                                               'lookahead' => 0,
                                                                                                               'argcode' => undef,
                                                                                                               'matchrule' => 0,
                                                                                                               'subrule' => 'constrained_encoding',
                                                                                                               'implicit' => undef,
                                                                                                               'line' => 385
                                                                                                             }, 'Parse::RecDescent::Subrule' ),
                                                                                                      bless( {
                                                                                                               'line' => 386,
                                                                                                               'hashname' => '__ACTION1__',
                                                                                                               'code' => '{ $return = build_parameter(@item, \'1.2\'); 1; }',
                                                                                                               'lookahead' => 0
                                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                                    ],
                                                                                         'actcount' => 1,
                                                                                         'uncommit' => undef,
                                                                                         'line' => undef,
                                                                                         'patcount' => 0,
                                                                                         'dircount' => 0,
                                                                                         'error' => undef,
                                                                                         'strcount' => 1,
                                                                                         'number' => 0
                                                                                       }, 'Parse::RecDescent::Production' )
                                                                              ],
                                                                   'vars' => '',
                                                                   'line' => 385,
                                                                   'opcount' => 0,
                                                                   'changed' => 0,
                                                                   'impcount' => 0
                                                                 }, 'Parse::RecDescent::Rule' ),
                              'Put_PostPDU' => bless( {
                                                        'prods' => [
                                                                     bless( {
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'line' => 225,
                                                                                                    'description' => '\'\\\\x61\'',
                                                                                                    'pattern' => '\\x61',
                                                                                                    'hashname' => '__STRING1__',
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'code' => '{ $return = $item[0]; 1; }',
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'line' => 225
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1,
                                                                              'patcount' => 0,
                                                                              'line' => undef,
                                                                              'uncommit' => undef,
                                                                              'dircount' => 0,
                                                                              'strcount' => 1,
                                                                              'number' => 0,
                                                                              'error' => undef
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'name' => 'Put_PostPDU',
                                                        'calls' => [],
                                                        'changed' => 0,
                                                        'impcount' => 0,
                                                        'line' => 225,
                                                        'opcount' => 0
                                                      }, 'Parse::RecDescent::Rule' ),
                              'uint8' => bless( {
                                                  'impcount' => 0,
                                                  'changed' => 0,
                                                  'opcount' => 0,
                                                  'line' => 185,
                                                  'vars' => '',
                                                  'prods' => [
                                                               bless( {
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'line' => 185,
                                                                                              'subrule' => 'OCTET',
                                                                                              'lookahead' => 0,
                                                                                              'argcode' => undef,
                                                                                              'matchrule' => 0
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'code' => '{ $return = unpack \'C\', $item[1]; 1; }',
                                                                                              'line' => 185
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'actcount' => 1,
                                                                        'strcount' => 0,
                                                                        'number' => 0,
                                                                        'error' => undef,
                                                                        'patcount' => 0,
                                                                        'line' => undef,
                                                                        'uncommit' => undef,
                                                                        'dircount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'calls' => [
                                                               'OCTET'
                                                             ],
                                                  'name' => 'uint8'
                                                }, 'Parse::RecDescent::Rule' ),
                              'modification_date_parameter' => bless( {
                                                                        'impcount' => 0,
                                                                        'changed' => 0,
                                                                        'opcount' => 0,
                                                                        'line' => 407,
                                                                        'vars' => '',
                                                                        'prods' => [
                                                                                     bless( {
                                                                                              'actcount' => 1,
                                                                                              'items' => [
                                                                                                           bless( {
                                                                                                                    'lookahead' => 0,
                                                                                                                    'pattern' => '\\x94',
                                                                                                                    'description' => '\'\\\\x94\'',
                                                                                                                    'line' => 407,
                                                                                                                    'hashname' => '__STRING1__'
                                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                                           bless( {
                                                                                                                    'implicit' => undef,
                                                                                                                    'line' => 407,
                                                                                                                    'subrule' => 'date_value',
                                                                                                                    'lookahead' => 0,
                                                                                                                    'argcode' => undef,
                                                                                                                    'matchrule' => 0
                                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                                           bless( {
                                                                                                                    'line' => 408,
                                                                                                                    'hashname' => '__ACTION1__',
                                                                                                                    'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                                    'lookahead' => 0
                                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                                         ],
                                                                                              'strcount' => 1,
                                                                                              'number' => 0,
                                                                                              'error' => undef,
                                                                                              'dircount' => 0,
                                                                                              'line' => undef,
                                                                                              'uncommit' => undef,
                                                                                              'patcount' => 0
                                                                                            }, 'Parse::RecDescent::Production' )
                                                                                   ],
                                                                        'calls' => [
                                                                                     'date_value'
                                                                                   ],
                                                                        'name' => 'modification_date_parameter'
                                                                      }, 'Parse::RecDescent::Rule' ),
                              'ExtendedMethod_GetPDU' => bless( {
                                                                  'vars' => '',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 1,
                                                                                        'line' => undef,
                                                                                        'dircount' => 0,
                                                                                        'number' => 0,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'description' => '/[\\\\x50-\\\\x5f]/',
                                                                                                              'rdelim' => '/',
                                                                                                              'mod' => '',
                                                                                                              'hashname' => '__PATTERN1__',
                                                                                                              'line' => 223,
                                                                                                              'pattern' => '[\\x50-\\x5f]',
                                                                                                              'ldelim' => '/',
                                                                                                              'lookahead' => 0
                                                                                                            }, 'Parse::RecDescent::Token' ),
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'line' => 223,
                                                                                                              'hashname' => '__ACTION1__',
                                                                                                              'code' => '{ $return = $item[0]; 1; }'
                                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                                   ],
                                                                                        'actcount' => 1
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'name' => 'ExtendedMethod_GetPDU',
                                                                  'calls' => [],
                                                                  'changed' => 0,
                                                                  'impcount' => 0,
                                                                  'line' => 223,
                                                                  'opcount' => 0
                                                                }, 'Parse::RecDescent::Rule' ),
                              'm_send_req' => bless( {
                                                       'impcount' => 0,
                                                       'changed' => 0,
                                                       'opcount' => 0,
                                                       'line' => 755,
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'hashname' => '__STRING1__',
                                                                                                   'pattern' => '\\x80',
                                                                                                   'description' => '\'\\\\x80\'',
                                                                                                   'line' => 755,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::InterpLit' ),
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'line' => 755,
                                                                                                   'code' => '{ $return = $item[0]; }',
                                                                                                   'hashname' => '__ACTION1__'
                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                        ],
                                                                             'actcount' => 1,
                                                                             'error' => undef,
                                                                             'strcount' => 1,
                                                                             'number' => 0,
                                                                             'line' => undef,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'vars' => '',
                                                       'calls' => [],
                                                       'name' => 'm_send_req'
                                                     }, 'Parse::RecDescent::Rule' ),
                              'ERROR_UNSUPPORTED_MESSAGE' => bless( {
                                                                      'changed' => 0,
                                                                      'impcount' => 0,
                                                                      'line' => 790,
                                                                      'opcount' => 0,
                                                                      'prods' => [
                                                                                   bless( {
                                                                                            'dircount' => 0,
                                                                                            'line' => undef,
                                                                                            'patcount' => 0,
                                                                                            'uncommit' => undef,
                                                                                            'number' => 0,
                                                                                            'strcount' => 1,
                                                                                            'error' => undef,
                                                                                            'actcount' => 1,
                                                                                            'items' => [
                                                                                                         bless( {
                                                                                                                  'pattern' => '\\x88',
                                                                                                                  'line' => 790,
                                                                                                                  'description' => '\'\\\\x88\'',
                                                                                                                  'hashname' => '__STRING1__',
                                                                                                                  'lookahead' => 0
                                                                                                                }, 'Parse::RecDescent::InterpLit' ),
                                                                                                         bless( {
                                                                                                                  'line' => 790,
                                                                                                                  'hashname' => '__ACTION1__',
                                                                                                                  'code' => '{ $return = $item[0]; 1; }',
                                                                                                                  'lookahead' => 0
                                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                                       ]
                                                                                          }, 'Parse::RecDescent::Production' )
                                                                                 ],
                                                                      'vars' => '',
                                                                      'name' => 'ERROR_UNSUPPORTED_MESSAGE',
                                                                      'calls' => []
                                                                    }, 'Parse::RecDescent::Rule' ),
                              'ERROR_SERVICE_DENIED' => bless( {
                                                                 'opcount' => 0,
                                                                 'line' => 784,
                                                                 'impcount' => 0,
                                                                 'changed' => 0,
                                                                 'calls' => [],
                                                                 'name' => 'ERROR_SERVICE_DENIED',
                                                                 'vars' => '',
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'uncommit' => undef,
                                                                                       'line' => undef,
                                                                                       'patcount' => 0,
                                                                                       'dircount' => 0,
                                                                                       'number' => 0,
                                                                                       'strcount' => 1,
                                                                                       'error' => undef,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'lookahead' => 0,
                                                                                                             'pattern' => '\\x82',
                                                                                                             'description' => '\'\\\\x82\'',
                                                                                                             'line' => 784,
                                                                                                             'hashname' => '__STRING1__'
                                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                                    bless( {
                                                                                                             'code' => '{ $return = $item[0]; 1; }',
                                                                                                             'hashname' => '__ACTION1__',
                                                                                                             'line' => 784,
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ],
                                                                                       'actcount' => 1
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ]
                                                               }, 'Parse::RecDescent::Rule' ),
                              'path_parameter' => bless( {
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'error' => undef,
                                                                                 'number' => 0,
                                                                                 'strcount' => 1,
                                                                                 'line' => undef,
                                                                                 'uncommit' => undef,
                                                                                 'patcount' => 0,
                                                                                 'dircount' => 0,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'line' => 425,
                                                                                                       'description' => '\'\\\\x9d\'',
                                                                                                       'pattern' => '\\x9d',
                                                                                                       'hashname' => '__STRING1__'
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'subrule' => 'text_value',
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'lookahead' => 0,
                                                                                                       'line' => 425,
                                                                                                       'implicit' => undef
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'line' => 426,
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ],
                                                                                 'actcount' => 1
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'name' => 'path_parameter',
                                                           'calls' => [
                                                                        'text_value'
                                                                      ],
                                                           'changed' => 0,
                                                           'impcount' => 0,
                                                           'line' => 425,
                                                           'opcount' => 0
                                                         }, 'Parse::RecDescent::Rule' ),
                              'any_charset' => bless( {
                                                        'changed' => 0,
                                                        'impcount' => 0,
                                                        'line' => 506,
                                                        'opcount' => 0,
                                                        'prods' => [
                                                                     bless( {
                                                                              'error' => undef,
                                                                              'strcount' => 1,
                                                                              'number' => 0,
                                                                              'uncommit' => undef,
                                                                              'line' => undef,
                                                                              'patcount' => 0,
                                                                              'dircount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'description' => '\'\\\\x80\'',
                                                                                                    'line' => 506,
                                                                                                    'pattern' => '\\x80',
                                                                                                    'hashname' => '__STRING1__',
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'code' => '{ $return = \'*\'; 1; }',
                                                                                                    'line' => 506,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'name' => 'any_charset',
                                                        'calls' => []
                                                      }, 'Parse::RecDescent::Rule' ),
                              'response_text_value' => bless( {
                                                                'name' => 'response_text_value',
                                                                'calls' => [
                                                                             'encoded_string_value'
                                                                           ],
                                                                'prods' => [
                                                                             bless( {
                                                                                      'line' => undef,
                                                                                      'uncommit' => undef,
                                                                                      'patcount' => 0,
                                                                                      'dircount' => 0,
                                                                                      'number' => 0,
                                                                                      'strcount' => 0,
                                                                                      'error' => undef,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'implicit' => undef,
                                                                                                            'line' => 792,
                                                                                                            'subrule' => 'encoded_string_value',
                                                                                                            'lookahead' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'matchrule' => 0
                                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                                 ],
                                                                                      'actcount' => 0
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ],
                                                                'vars' => '',
                                                                'line' => 791,
                                                                'opcount' => 0,
                                                                'changed' => 0,
                                                                'impcount' => 0
                                                              }, 'Parse::RecDescent::Rule' ),
                              'YES' => bless( {
                                                'name' => 'YES',
                                                'calls' => [],
                                                'vars' => '',
                                                'prods' => [
                                                             bless( {
                                                                      'number' => 0,
                                                                      'strcount' => 1,
                                                                      'error' => undef,
                                                                      'dircount' => 0,
                                                                      'uncommit' => undef,
                                                                      'line' => undef,
                                                                      'patcount' => 0,
                                                                      'actcount' => 1,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'hashname' => '__STRING1__',
                                                                                            'line' => 706,
                                                                                            'description' => '\'\\\\x80\'',
                                                                                            'pattern' => '\\x80',
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                   bless( {
                                                                                            'line' => 706,
                                                                                            'code' => '{ $return = $item[0]; 1; }',
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ]
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'line' => 706,
                                                'opcount' => 0,
                                                'changed' => 0,
                                                'impcount' => 0
                                              }, 'Parse::RecDescent::Rule' ),
                              'multipart_headers_len' => bless( {
                                                                  'calls' => [
                                                                               'uintvar'
                                                                             ],
                                                                  'name' => 'multipart_headers_len',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'lookahead' => 0,
                                                                                                              'subrule' => 'uintvar',
                                                                                                              'line' => 525,
                                                                                                              'implicit' => undef
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'actcount' => 0,
                                                                                        'strcount' => 0,
                                                                                        'number' => 0,
                                                                                        'error' => undef,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'line' => undef,
                                                                                        'dircount' => 0
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'vars' => '',
                                                                  'opcount' => 0,
                                                                  'line' => 525,
                                                                  'impcount' => 0,
                                                                  'changed' => 0
                                                                }, 'Parse::RecDescent::Rule' ),
                              'ALPHA' => bless( {
                                                  'opcount' => 0,
                                                  'line' => 150,
                                                  'impcount' => 0,
                                                  'changed' => 0,
                                                  'calls' => [],
                                                  'name' => 'ALPHA',
                                                  'prods' => [
                                                               bless( {
                                                                        'error' => undef,
                                                                        'strcount' => 0,
                                                                        'number' => 0,
                                                                        'uncommit' => undef,
                                                                        'patcount' => 1,
                                                                        'line' => undef,
                                                                        'dircount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'rdelim' => '/',
                                                                                              'description' => '/[a-zA-Z]/',
                                                                                              'ldelim' => '/',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 150,
                                                                                              'pattern' => '[a-zA-Z]',
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'mod' => ''
                                                                                            }, 'Parse::RecDescent::Token' )
                                                                                   ],
                                                                        'actcount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'vars' => ''
                                                }, 'Parse::RecDescent::Rule' ),
                              'LF' => bless( {
                                               'opcount' => 0,
                                               'line' => 154,
                                               'impcount' => 0,
                                               'changed' => 0,
                                               'calls' => [],
                                               'name' => 'LF',
                                               'vars' => '',
                                               'prods' => [
                                                            bless( {
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__STRING1__',
                                                                                           'pattern' => '\\x0A',
                                                                                           'line' => 154,
                                                                                           'description' => '\'\\\\x0A\''
                                                                                         }, 'Parse::RecDescent::InterpLit' )
                                                                                ],
                                                                     'actcount' => 0,
                                                                     'patcount' => 0,
                                                                     'line' => undef,
                                                                     'uncommit' => undef,
                                                                     'dircount' => 0,
                                                                     'error' => undef,
                                                                     'number' => 0,
                                                                     'strcount' => 1
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ]
                                             }, 'Parse::RecDescent::Rule' ),
                              'short_integer' => bless( {
                                                          'name' => 'short_integer',
                                                          'calls' => [
                                                                       'HIGHOCTET'
                                                                     ],
                                                          'prods' => [
                                                                       bless( {
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'line' => 247,
                                                                                                      'implicit' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => 'HIGHOCTET'
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'line' => 247,
                                                                                                      'code' => '{ $return = ord($item{HIGHOCTET}) & 0x7F; 1; }',
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'actcount' => 1,
                                                                                'strcount' => 0,
                                                                                'number' => 0,
                                                                                'error' => undef,
                                                                                'uncommit' => undef,
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'dircount' => 0
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => '',
                                                          'line' => 246,
                                                          'opcount' => 0,
                                                          'changed' => 0,
                                                          'impcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'MAC_wbxml_parameter' => bless( {
                                                                'vars' => '',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'uncommit' => undef,
                                                                                      'line' => undef,
                                                                                      'patcount' => 0,
                                                                                      'dircount' => 0,
                                                                                      'error' => undef,
                                                                                      'number' => 0,
                                                                                      'strcount' => 1,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'pattern' => '\\x92',
                                                                                                            'line' => 403,
                                                                                                            'description' => '\'\\\\x92\'',
                                                                                                            'hashname' => '__STRING1__',
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                                   bless( {
                                                                                                            'implicit' => undef,
                                                                                                            'line' => 403,
                                                                                                            'subrule' => 'text_value',
                                                                                                            'lookahead' => 0,
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef
                                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                                   bless( {
                                                                                                            'lookahead' => 0,
                                                                                                            'hashname' => '__ACTION1__',
                                                                                                            'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                            'line' => 404
                                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                                 ],
                                                                                      'actcount' => 1
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ],
                                                                'calls' => [
                                                                             'text_value'
                                                                           ],
                                                                'name' => 'MAC_wbxml_parameter',
                                                                'impcount' => 0,
                                                                'changed' => 0,
                                                                'opcount' => 0,
                                                                'line' => 403
                                                              }, 'Parse::RecDescent::Rule' ),
                              'UNRECOGNISED' => bless( {
                                                         'line' => 802,
                                                         'opcount' => 0,
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'name' => 'UNRECOGNISED',
                                                         'calls' => [],
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'actcount' => 1,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'hashname' => '__STRING1__',
                                                                                                     'pattern' => '\\x84',
                                                                                                     'description' => '\'\\\\x84\'',
                                                                                                     'line' => 802,
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'hashname' => '__ACTION1__',
                                                                                                     'code' => '{ $return = $item[0]; 1; }',
                                                                                                     'line' => 802
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ],
                                                                               'dircount' => 0,
                                                                               'line' => undef,
                                                                               'patcount' => 0,
                                                                               'uncommit' => undef,
                                                                               'error' => undef,
                                                                               'number' => 0,
                                                                               'strcount' => 1
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'DIGIT' => bless( {
                                                  'name' => 'DIGIT',
                                                  'calls' => [],
                                                  'prods' => [
                                                               bless( {
                                                                        'actcount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'rdelim' => '/',
                                                                                              'description' => '/\\\\d/',
                                                                                              'lookahead' => 0,
                                                                                              'ldelim' => '/',
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'mod' => '',
                                                                                              'pattern' => '\\d',
                                                                                              'line' => 151
                                                                                            }, 'Parse::RecDescent::Token' )
                                                                                   ],
                                                                        'dircount' => 0,
                                                                        'line' => undef,
                                                                        'uncommit' => undef,
                                                                        'patcount' => 1,
                                                                        'number' => 0,
                                                                        'strcount' => 0,
                                                                        'error' => undef
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'vars' => '',
                                                  'line' => 151,
                                                  'opcount' => 0,
                                                  'changed' => 0,
                                                  'impcount' => 0
                                                }, 'Parse::RecDescent::Rule' ),
                              'ERROR_SENDING_ADDRESS_UNRESOLVED' => bless( {
                                                                             'changed' => 0,
                                                                             'impcount' => 0,
                                                                             'line' => 786,
                                                                             'opcount' => 0,
                                                                             'vars' => '',
                                                                             'prods' => [
                                                                                          bless( {
                                                                                                   'actcount' => 1,
                                                                                                   'items' => [
                                                                                                                bless( {
                                                                                                                         'lookahead' => 0,
                                                                                                                         'description' => '\'\\\\x84\'',
                                                                                                                         'line' => 786,
                                                                                                                         'pattern' => '\\x84',
                                                                                                                         'hashname' => '__STRING1__'
                                                                                                                       }, 'Parse::RecDescent::InterpLit' ),
                                                                                                                bless( {
                                                                                                                         'hashname' => '__ACTION1__',
                                                                                                                         'code' => '{ $return = $item[0]; 1; }',
                                                                                                                         'line' => 786,
                                                                                                                         'lookahead' => 0
                                                                                                                       }, 'Parse::RecDescent::Action' )
                                                                                                              ],
                                                                                                   'dircount' => 0,
                                                                                                   'uncommit' => undef,
                                                                                                   'line' => undef,
                                                                                                   'patcount' => 0,
                                                                                                   'error' => undef,
                                                                                                   'strcount' => 1,
                                                                                                   'number' => 0
                                                                                                 }, 'Parse::RecDescent::Production' )
                                                                                        ],
                                                                             'name' => 'ERROR_SENDING_ADDRESS_UNRESOLVED',
                                                                             'calls' => []
                                                                           }, 'Parse::RecDescent::Rule' ),
                              'content_location_head' => bless( {
                                                                  'name' => 'content_location_head',
                                                                  'calls' => [
                                                                               'content_location_value'
                                                                             ],
                                                                  'vars' => '',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'line' => undef,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'dircount' => 0,
                                                                                        'error' => undef,
                                                                                        'strcount' => 1,
                                                                                        'number' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'pattern' => '\\x83',
                                                                                                              'description' => '\'\\\\x83\'',
                                                                                                              'line' => 639,
                                                                                                              'hashname' => '__STRING1__',
                                                                                                              'lookahead' => 0
                                                                                                            }, 'Parse::RecDescent::InterpLit' ),
                                                                                                     bless( {
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 639,
                                                                                                              'subrule' => 'content_location_value',
                                                                                                              'lookahead' => 0,
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef
                                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'line' => 640,
                                                                                                              'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                              'hashname' => '__ACTION1__'
                                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                                   ],
                                                                                        'actcount' => 1
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'line' => 639,
                                                                  'opcount' => 0,
                                                                  'changed' => 0,
                                                                  'impcount' => 0
                                                                }, 'Parse::RecDescent::Rule' ),
                              'ERROR_MESSAGE_NOT_FOUND' => bless( {
                                                                    'name' => 'ERROR_MESSAGE_NOT_FOUND',
                                                                    'calls' => [],
                                                                    'prods' => [
                                                                                 bless( {
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'hashname' => '__STRING1__',
                                                                                                                'description' => '\'\\\\x85\'',
                                                                                                                'line' => 787,
                                                                                                                'pattern' => '\\x85',
                                                                                                                'lookahead' => 0
                                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                                       bless( {
                                                                                                                'lookahead' => 0,
                                                                                                                'code' => '{ $return = $item[0]; 1; }',
                                                                                                                'hashname' => '__ACTION1__',
                                                                                                                'line' => 787
                                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                                     ],
                                                                                          'actcount' => 1,
                                                                                          'patcount' => 0,
                                                                                          'uncommit' => undef,
                                                                                          'line' => undef,
                                                                                          'dircount' => 0,
                                                                                          'error' => undef,
                                                                                          'number' => 0,
                                                                                          'strcount' => 1
                                                                                        }, 'Parse::RecDescent::Production' )
                                                                               ],
                                                                    'vars' => '',
                                                                    'line' => 787,
                                                                    'opcount' => 0,
                                                                    'changed' => 0,
                                                                    'impcount' => 0
                                                                  }, 'Parse::RecDescent::Rule' ),
                              'q_value' => bless( {
                                                    'name' => 'q_value',
                                                    'calls' => [
                                                                 'HIGHOCTET',
                                                                 'CHAR'
                                                               ],
                                                    'prods' => [
                                                                 bless( {
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'dircount' => 0,
                                                                          'number' => 0,
                                                                          'strcount' => 0,
                                                                          'error' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'subrule' => 'HIGHOCTET',
                                                                                                'argcode' => undef,
                                                                                                'repspec' => '?',
                                                                                                'expected' => undef,
                                                                                                'max' => 1,
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'min' => 0,
                                                                                                'line' => 302
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'subrule' => 'CHAR',
                                                                                                'argcode' => undef,
                                                                                                'matchrule' => 0,
                                                                                                'lookahead' => 0,
                                                                                                'line' => 302,
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{
   my $value = 0;
   $value = (ord($item[1][0]) & 0x7F) << 7 if scalar @{$item[1]};
   $value |= ord($item[2]);
   if ($value <= 100) {
      $return = ($value - 1) / 100;
   }
   else {
      $return = ($value - 100) / 1000;
   }
   if ($return >= 1) {
      $return = undef;
   }
   else {
      1;
   }
}',
                                                                                                'line' => 302
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => '',
                                                    'line' => 301,
                                                    'opcount' => 0,
                                                    'changed' => 0,
                                                    'impcount' => 0
                                                  }, 'Parse::RecDescent::Rule' ),
                              'secure_parameter' => bless( {
                                                             'calls' => [
                                                                          'no_value'
                                                                        ],
                                                             'name' => 'secure_parameter',
                                                             'vars' => '',
                                                             'prods' => [
                                                                          bless( {
                                                                                   'dircount' => 0,
                                                                                   'uncommit' => undef,
                                                                                   'line' => undef,
                                                                                   'patcount' => 0,
                                                                                   'error' => undef,
                                                                                   'strcount' => 1,
                                                                                   'number' => 0,
                                                                                   'actcount' => 1,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'description' => '\'\\\\x90\'',
                                                                                                         'line' => 399,
                                                                                                         'pattern' => '\\x90',
                                                                                                         'hashname' => '__STRING1__',
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::InterpLit' ),
                                                                                                bless( {
                                                                                                         'line' => 399,
                                                                                                         'implicit' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'lookahead' => 0,
                                                                                                         'subrule' => 'no_value'
                                                                                                       }, 'Parse::RecDescent::Subrule' ),
                                                                                                bless( {
                                                                                                         'lookahead' => 0,
                                                                                                         'hashname' => '__ACTION1__',
                                                                                                         'code' => '{ $return = build_parameter(@item, \'1.3\'); 1; }',
                                                                                                         'line' => 400
                                                                                                       }, 'Parse::RecDescent::Action' )
                                                                                              ]
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'opcount' => 0,
                                                             'line' => 399,
                                                             'impcount' => 0,
                                                             'changed' => 0
                                                           }, 'Parse::RecDescent::Rule' ),
                              'HIGHOCTET' => bless( {
                                                      'opcount' => 0,
                                                      'line' => 180,
                                                      'impcount' => 0,
                                                      'changed' => 0,
                                                      'calls' => [],
                                                      'name' => 'HIGHOCTET',
                                                      'prods' => [
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'ldelim' => '/',
                                                                                                  'hashname' => '__PATTERN1__',
                                                                                                  'mod' => '',
                                                                                                  'pattern' => '[\\x80-\\xFF]',
                                                                                                  'line' => 181,
                                                                                                  'rdelim' => '/',
                                                                                                  'description' => '/[\\\\x80-\\\\xFF]/'
                                                                                                }, 'Parse::RecDescent::Token' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'line' => undef,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 1,
                                                                            'error' => undef,
                                                                            'strcount' => 0,
                                                                            'number' => 0
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'vars' => ''
                                                    }, 'Parse::RecDescent::Rule' ),
                              'extension_media' => bless( {
                                                            'line' => 241,
                                                            'opcount' => 0,
                                                            'changed' => 0,
                                                            'impcount' => 0,
                                                            'name' => 'extension_media',
                                                            'calls' => [
                                                                         'TEXT',
                                                                         'end_of_string'
                                                                       ],
                                                            'vars' => '',
                                                            'prods' => [
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'min' => 0,
                                                                                                        'line' => 242,
                                                                                                        'max' => 1,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'repspec' => '?',
                                                                                                        'expected' => undef,
                                                                                                        'subrule' => 'TEXT',
                                                                                                        'argcode' => undef
                                                                                                      }, 'Parse::RecDescent::Repetition' ),
                                                                                               bless( {
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 242,
                                                                                                        'subrule' => 'end_of_string',
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                               bless( {
                                                                                                        'hashname' => '__ACTION1__',
                                                                                                        'code' => '{
   $return = scalar @{$item[1]} ? $item[1][0] : \'\';
   1;
}',
                                                                                                        'line' => 242,
                                                                                                        'lookahead' => 0
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ],
                                                                                  'actcount' => 1,
                                                                                  'line' => undef,
                                                                                  'uncommit' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'number' => 0,
                                                                                  'strcount' => 0,
                                                                                  'error' => undef
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ]
                                                          }, 'Parse::RecDescent::Rule' ),
                              'relative_token' => bless( {
                                                           'prods' => [
                                                                        bless( {
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'line' => 715,
                                                                                                       'description' => '\'\\\\x81\'',
                                                                                                       'pattern' => '\\x81',
                                                                                                       'hashname' => '__STRING1__'
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'code' => '{ $return = \'relative\'; 1; }',
                                                                                                       'line' => 715
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ],
                                                                                 'actcount' => 1,
                                                                                 'line' => undef,
                                                                                 'uncommit' => undef,
                                                                                 'patcount' => 0,
                                                                                 'dircount' => 0,
                                                                                 'error' => undef,
                                                                                 'strcount' => 1,
                                                                                 'number' => 0
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'vars' => '',
                                                           'calls' => [],
                                                           'name' => 'relative_token',
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'opcount' => 0,
                                                           'line' => 715
                                                         }, 'Parse::RecDescent::Rule' ),
                              'no_value' => bless( {
                                                     'calls' => [],
                                                     'name' => 'no_value',
                                                     'prods' => [
                                                                  bless( {
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'line' => undef,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 0,
                                                                           'strcount' => 1,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 292,
                                                                                                 'description' => '\'\\\\x00\'',
                                                                                                 'pattern' => '\\x00',
                                                                                                 'hashname' => '__STRING1__'
                                                                                               }, 'Parse::RecDescent::InterpLit' ),
                                                                                        bless( {
                                                                                                 'line' => 292,
                                                                                                 'code' => '{ $return = \'\'; 1; }',
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'actcount' => 1
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'vars' => '',
                                                     'opcount' => 0,
                                                     'line' => 291,
                                                     'impcount' => 0,
                                                     'changed' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'Redirect' => bless( {
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'line' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'strcount' => 1,
                                                                           'number' => 0,
                                                                           'error' => undef,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'description' => '\'\\\\x03\'',
                                                                                                 'line' => 209,
                                                                                                 'pattern' => '\\x03',
                                                                                                 'hashname' => '__STRING1__',
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::InterpLit' ),
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 209,
                                                                                                 'code' => '{ $return = $item[0]; 1; }',
                                                                                                 'hashname' => '__ACTION1__'
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'actcount' => 1
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'calls' => [],
                                                     'name' => 'Redirect',
                                                     'impcount' => 0,
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'line' => 209
                                                   }, 'Parse::RecDescent::Rule' ),
                              'insert_address_token' => bless( {
                                                                 'name' => 'insert_address_token',
                                                                 'calls' => [],
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'hashname' => '__STRING1__',
                                                                                                             'pattern' => '\\x81',
                                                                                                             'line' => 741,
                                                                                                             'description' => '\'\\\\x81\'',
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                                    bless( {
                                                                                                             'code' => '{ $return = \'insert-address\'; 1; }',
                                                                                                             'hashname' => '__ACTION1__',
                                                                                                             'line' => 741,
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ],
                                                                                       'actcount' => 1,
                                                                                       'patcount' => 0,
                                                                                       'uncommit' => undef,
                                                                                       'line' => undef,
                                                                                       'dircount' => 0,
                                                                                       'error' => undef,
                                                                                       'number' => 0,
                                                                                       'strcount' => 1
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'vars' => '',
                                                                 'line' => 741,
                                                                 'opcount' => 0,
                                                                 'changed' => 0,
                                                                 'impcount' => 0
                                                               }, 'Parse::RecDescent::Rule' ),
                              'application_specific_value' => bless( {
                                                                       'prods' => [
                                                                                    bless( {
                                                                                             'dircount' => 0,
                                                                                             'line' => undef,
                                                                                             'uncommit' => undef,
                                                                                             'patcount' => 0,
                                                                                             'number' => 0,
                                                                                             'strcount' => 0,
                                                                                             'error' => undef,
                                                                                             'actcount' => 0,
                                                                                             'items' => [
                                                                                                          bless( {
                                                                                                                   'subrule' => 'text_string',
                                                                                                                   'matchrule' => 0,
                                                                                                                   'argcode' => undef,
                                                                                                                   'lookahead' => 0,
                                                                                                                   'line' => 611,
                                                                                                                   'implicit' => undef
                                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                                        ]
                                                                                           }, 'Parse::RecDescent::Production' )
                                                                                  ],
                                                                       'vars' => '',
                                                                       'calls' => [
                                                                                    'text_string'
                                                                                  ],
                                                                       'name' => 'application_specific_value',
                                                                       'impcount' => 0,
                                                                       'changed' => 0,
                                                                       'opcount' => 0,
                                                                       'line' => 610
                                                                     }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule_token' => bless( {
                                                                                         'name' => '_alternation_1_of_production_1_of_rule_token',
                                                                                         'calls' => [
                                                                                                      'CTL',
                                                                                                      'separator',
                                                                                                      'CHAR'
                                                                                                    ],
                                                                                         'vars' => '',
                                                                                         'prods' => [
                                                                                                      bless( {
                                                                                                               'uncommit' => undef,
                                                                                                               'line' => undef,
                                                                                                               'patcount' => 0,
                                                                                                               'dircount' => 0,
                                                                                                               'strcount' => 0,
                                                                                                               'number' => 0,
                                                                                                               'error' => undef,
                                                                                                               'items' => [
                                                                                                                            bless( {
                                                                                                                                     'subrule' => 'CTL',
                                                                                                                                     'matchrule' => 0,
                                                                                                                                     'argcode' => undef,
                                                                                                                                     'lookahead' => -1,
                                                                                                                                     'line' => 807,
                                                                                                                                     'implicit' => undef
                                                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                                                            bless( {
                                                                                                                                     'implicit' => undef,
                                                                                                                                     'line' => 807,
                                                                                                                                     'subrule' => 'separator',
                                                                                                                                     'lookahead' => -1,
                                                                                                                                     'argcode' => undef,
                                                                                                                                     'matchrule' => 0
                                                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                                                            bless( {
                                                                                                                                     'subrule' => 'CHAR',
                                                                                                                                     'lookahead' => 0,
                                                                                                                                     'argcode' => undef,
                                                                                                                                     'matchrule' => 0,
                                                                                                                                     'implicit' => undef,
                                                                                                                                     'line' => 807
                                                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                                                          ],
                                                                                                               'actcount' => 0
                                                                                                             }, 'Parse::RecDescent::Production' )
                                                                                                    ],
                                                                                         'line' => 807,
                                                                                         'opcount' => 0,
                                                                                         'changed' => 0,
                                                                                         'impcount' => 0
                                                                                       }, 'Parse::RecDescent::Rule' ),
                              'uint16' => bless( {
                                                   'opcount' => 0,
                                                   'line' => 186,
                                                   'impcount' => 0,
                                                   'changed' => 0,
                                                   'calls' => [
                                                                'OCTET'
                                                              ],
                                                   'name' => 'uint16',
                                                   'prods' => [
                                                                bless( {
                                                                         'dircount' => 0,
                                                                         'line' => undef,
                                                                         'patcount' => 0,
                                                                         'uncommit' => undef,
                                                                         'number' => 0,
                                                                         'strcount' => 0,
                                                                         'error' => undef,
                                                                         'actcount' => 1,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'lookahead' => 0,
                                                                                               'matchrule' => 0,
                                                                                               'max' => 2,
                                                                                               'line' => 186,
                                                                                               'min' => 2,
                                                                                               'argcode' => undef,
                                                                                               'subrule' => 'OCTET',
                                                                                               'expected' => undef,
                                                                                               'repspec' => '2'
                                                                                             }, 'Parse::RecDescent::Repetition' ),
                                                                                      bless( {
                                                                                               'line' => 186,
                                                                                               'code' => '{ $return = unpack \'n\', join \'\', @{$item[1]}; 1; }',
                                                                                               'hashname' => '__ACTION1__',
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                    ]
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ],
                                                   'vars' => ''
                                                 }, 'Parse::RecDescent::Rule' ),
                              '_non_CTL' => bless( {
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 165,
                                                                                                 'pattern' => '[^\\x00-\\x1F\\x7F]',
                                                                                                 'hashname' => '__PATTERN1__',
                                                                                                 'mod' => '',
                                                                                                 'ldelim' => '/',
                                                                                                 'lookahead' => 0,
                                                                                                 'description' => '/[^\\\\x00-\\\\x1F\\\\x7F]/',
                                                                                                 'rdelim' => '/'
                                                                                               }, 'Parse::RecDescent::Token' )
                                                                                      ],
                                                                           'strcount' => 0,
                                                                           'number' => 0,
                                                                           'error' => undef,
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => undef,
                                                                           'patcount' => 1
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'name' => '_non_CTL',
                                                     'calls' => [],
                                                     'changed' => 0,
                                                     'impcount' => 0,
                                                     'line' => 164,
                                                     'opcount' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'MMS_MESSAGE' => bless( {
                                                        'vars' => '',
                                                        'prods' => [
                                                                     bless( {
                                                                              'error' => undef,
                                                                              'number' => 0,
                                                                              'strcount' => 0,
                                                                              'dircount' => 0,
                                                                              'line' => undef,
                                                                              'uncommit' => undef,
                                                                              'patcount' => 0,
                                                                              'actcount' => 1,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'line' => 603,
                                                                                                    'implicit' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'argcode' => undef,
                                                                                                    'lookahead' => 0,
                                                                                                    'subrule' => 'M_Retrieve_Conf_message'
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'code' => '{
   $return = $item[1];
   1;
}',
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'line' => 603
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ]
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'calls' => [
                                                                     'M_Retrieve_Conf_message'
                                                                   ],
                                                        'name' => 'MMS_MESSAGE',
                                                        'impcount' => 0,
                                                        'changed' => 0,
                                                        'opcount' => 0,
                                                        'line' => 603
                                                      }, 'Parse::RecDescent::Rule' ),
                              'HEADERS' => bless( {
                                                    'name' => 'HEADERS',
                                                    'calls' => [
                                                                 'message_type_head',
                                                                 'transaction_id_head',
                                                                 'MMS_version_head',
                                                                 'header',
                                                                 'content_type_head'
                                                               ],
                                                    'prods' => [
                                                                 bless( {
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'subrule' => 'message_type_head',
                                                                                                'lookahead' => 0,
                                                                                                'argcode' => undef,
                                                                                                'matchrule' => 0,
                                                                                                'implicit' => undef,
                                                                                                'line' => 590
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'max' => 1,
                                                                                                'matchrule' => 0,
                                                                                                'lookahead' => 0,
                                                                                                'min' => 0,
                                                                                                'line' => 591,
                                                                                                'subrule' => 'transaction_id_head',
                                                                                                'argcode' => undef,
                                                                                                'repspec' => '?',
                                                                                                'expected' => undef
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'subrule' => 'MMS_version_head',
                                                                                                'implicit' => undef,
                                                                                                'line' => 592
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'expected' => undef,
                                                                                                'repspec' => 's',
                                                                                                'argcode' => undef,
                                                                                                'subrule' => 'header',
                                                                                                'line' => 593,
                                                                                                'min' => 1,
                                                                                                'matchrule' => 0,
                                                                                                'lookahead' => 0,
                                                                                                'max' => 100000000
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'lookahead' => 0,
                                                                                                'subrule' => 'content_type_head',
                                                                                                'line' => 594,
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'line' => 594,
                                                                                                'code' => '{
   my %headers;
   foreach my $header (@item[1,2,3,5], @{$item[4]}) {
      my ($name, $value) = @$header;
      $headers{$name} = $value;
   }
   $return = \\%headers;
   1;
}',
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'actcount' => 1,
                                                                          'error' => undef,
                                                                          'strcount' => 0,
                                                                          'number' => 0,
                                                                          'line' => undef,
                                                                          'uncommit' => undef,
                                                                          'patcount' => 0,
                                                                          'dircount' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => '',
                                                    'line' => 589,
                                                    'opcount' => 0,
                                                    'changed' => 0,
                                                    'impcount' => 0
                                                  }, 'Parse::RecDescent::Rule' ),
                              '_short_integer_version' => bless( {
                                                                   'changed' => 0,
                                                                   'impcount' => 0,
                                                                   'line' => 321,
                                                                   'opcount' => 0,
                                                                   'vars' => '',
                                                                   'prods' => [
                                                                                bless( {
                                                                                         'items' => [
                                                                                                      bless( {
                                                                                                               'subrule' => 'short_integer',
                                                                                                               'matchrule' => 0,
                                                                                                               'argcode' => undef,
                                                                                                               'lookahead' => 0,
                                                                                                               'line' => 322,
                                                                                                               'implicit' => undef
                                                                                                             }, 'Parse::RecDescent::Subrule' ),
                                                                                                      bless( {
                                                                                                               'code' => '{
   my $version = $item{short_integer};
   $return = ($version >> 4) & 0x07;
   my $minor = $version & 0x0F;
   $return .= ".$minor" if $minor < 15;
   1;
}',
                                                                                                               'hashname' => '__ACTION1__',
                                                                                                               'line' => 322,
                                                                                                               'lookahead' => 0
                                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                                    ],
                                                                                         'actcount' => 1,
                                                                                         'error' => undef,
                                                                                         'strcount' => 0,
                                                                                         'number' => 0,
                                                                                         'line' => undef,
                                                                                         'uncommit' => undef,
                                                                                         'patcount' => 0,
                                                                                         'dircount' => 0
                                                                                       }, 'Parse::RecDescent::Production' )
                                                                              ],
                                                                   'name' => '_short_integer_version',
                                                                   'calls' => [
                                                                                'short_integer'
                                                                              ]
                                                                 }, 'Parse::RecDescent::Rule' ),
                              'ERROR_NETWORK_PROBLEM' => bless( {
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'strcount' => 1,
                                                                                        'number' => 0,
                                                                                        'error' => undef,
                                                                                        'dircount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 0,
                                                                                        'line' => undef,
                                                                                        'actcount' => 1,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'line' => 788,
                                                                                                              'description' => '\'\\\\x86\'',
                                                                                                              'pattern' => '\\x86',
                                                                                                              'hashname' => '__STRING1__',
                                                                                                              'lookahead' => 0
                                                                                                            }, 'Parse::RecDescent::InterpLit' ),
                                                                                                     bless( {
                                                                                                              'line' => 788,
                                                                                                              'code' => '{ $return = $item[0]; 1; }',
                                                                                                              'hashname' => '__ACTION1__',
                                                                                                              'lookahead' => 0
                                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                                   ]
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'vars' => '',
                                                                  'calls' => [],
                                                                  'name' => 'ERROR_NETWORK_PROBLEM',
                                                                  'impcount' => 0,
                                                                  'changed' => 0,
                                                                  'opcount' => 0,
                                                                  'line' => 788
                                                                }, 'Parse::RecDescent::Rule' ),
                              'CTL' => bless( {
                                                'impcount' => 0,
                                                'changed' => 0,
                                                'opcount' => 0,
                                                'line' => 152,
                                                'prods' => [
                                                             bless( {
                                                                      'error' => undef,
                                                                      'strcount' => 0,
                                                                      'number' => 0,
                                                                      'dircount' => 0,
                                                                      'line' => undef,
                                                                      'uncommit' => undef,
                                                                      'patcount' => 1,
                                                                      'actcount' => 0,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'pattern' => '[\\x00-\\x1F\\x7F]',
                                                                                            'line' => 152,
                                                                                            'hashname' => '__PATTERN1__',
                                                                                            'mod' => '',
                                                                                            'lookahead' => 0,
                                                                                            'ldelim' => '/',
                                                                                            'description' => '/[\\\\x00-\\\\x1F\\\\x7F]/',
                                                                                            'rdelim' => '/'
                                                                                          }, 'Parse::RecDescent::Token' )
                                                                                 ]
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'vars' => '',
                                                'calls' => [],
                                                'name' => 'CTL'
                                              }, 'Parse::RecDescent::Rule' ),
                              'well_known_media' => bless( {
                                                             'impcount' => 0,
                                                             'changed' => 0,
                                                             'opcount' => 0,
                                                             'line' => 510,
                                                             'vars' => '',
                                                             'prods' => [
                                                                          bless( {
                                                                                   'dircount' => 0,
                                                                                   'patcount' => 0,
                                                                                   'line' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'error' => undef,
                                                                                   'number' => 0,
                                                                                   'strcount' => 0,
                                                                                   'actcount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'line' => 510,
                                                                                                         'implicit' => undef,
                                                                                                         'subrule' => 'integer_value',
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'lookahead' => 0
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ]
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'calls' => [
                                                                          'integer_value'
                                                                        ],
                                                             'name' => 'well_known_media'
                                                           }, 'Parse::RecDescent::Rule' ),
                              'Unassigned' => bless( {
                                                       'impcount' => 0,
                                                       'changed' => 0,
                                                       'opcount' => 0,
                                                       'line' => 216,
                                                       'prods' => [
                                                                    bless( {
                                                                             'patcount' => 1,
                                                                             'line' => undef,
                                                                             'uncommit' => undef,
                                                                             'dircount' => 0,
                                                                             'error' => undef,
                                                                             'strcount' => 0,
                                                                             'number' => 0,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'ldelim' => '/',
                                                                                                   'lookahead' => 0,
                                                                                                   'line' => 216,
                                                                                                   'pattern' => '[\\x10-\\x3f]',
                                                                                                   'mod' => '',
                                                                                                   'hashname' => '__PATTERN1__',
                                                                                                   'rdelim' => '/',
                                                                                                   'description' => '/[\\\\x10-\\\\x3f]/'
                                                                                                 }, 'Parse::RecDescent::Token' ),
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'code' => '{ $return = $item[0]; 1; }',
                                                                                                   'hashname' => '__ACTION1__',
                                                                                                   'line' => 216
                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                        ],
                                                                             'actcount' => 1
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'vars' => '',
                                                       'calls' => [],
                                                       'name' => 'Unassigned'
                                                     }, 'Parse::RecDescent::Rule' ),
                              'message_size_value' => bless( {
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'opcount' => 0,
                                                               'line' => 762,
                                                               'prods' => [
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 763,
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'subrule' => 'long_integer'
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ],
                                                                                     'actcount' => 0,
                                                                                     'error' => undef,
                                                                                     'number' => 0,
                                                                                     'strcount' => 0,
                                                                                     'line' => undef,
                                                                                     'uncommit' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'calls' => [
                                                                            'long_integer'
                                                                          ],
                                                               'name' => 'message_size_value'
                                                             }, 'Parse::RecDescent::Rule' ),
                              'quote' => bless( {
                                                  'changed' => 0,
                                                  'impcount' => 0,
                                                  'line' => 268,
                                                  'opcount' => 0,
                                                  'prods' => [
                                                               bless( {
                                                                        'patcount' => 0,
                                                                        'uncommit' => undef,
                                                                        'line' => undef,
                                                                        'dircount' => 0,
                                                                        'strcount' => 1,
                                                                        'number' => 0,
                                                                        'error' => undef,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'pattern' => '\\x7F',
                                                                                              'line' => 269,
                                                                                              'description' => '\'\\\\x7F\'',
                                                                                              'hashname' => '__STRING1__',
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::InterpLit' )
                                                                                   ],
                                                                        'actcount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'vars' => '',
                                                  'name' => 'quote',
                                                  'calls' => []
                                                }, 'Parse::RecDescent::Rule' ),
                              'content_general_form' => bless( {
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'actcount' => 1,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'matchrule' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'lookahead' => 0,
                                                                                                             'subrule' => 'value_length',
                                                                                                             'line' => 446,
                                                                                                             'implicit' => undef
                                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                                    bless( {
                                                                                                             'lookahead' => 0,
                                                                                                             'hashname' => '__ACTION1__',
                                                                                                             'code' => '{
   my $len = $item[1];
   if ($len <= length $text) {
      my $ctdata = substr $text, 0, $len;
      $text = substr $text, $len;
      $return = $thisparser->_media_type($ctdata);
      defined($return)|| undef;
   }
   else { undef }
}',
                                                                                                             'line' => 446
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ],
                                                                                       'dircount' => 0,
                                                                                       'line' => undef,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'error' => undef,
                                                                                       'number' => 0,
                                                                                       'strcount' => 0
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'vars' => '',
                                                                 'name' => 'content_general_form',
                                                                 'calls' => [
                                                                              'value_length'
                                                                            ],
                                                                 'changed' => 0,
                                                                 'impcount' => 0,
                                                                 'line' => 446,
                                                                 'opcount' => 0
                                                               }, 'Parse::RecDescent::Rule' ),
                              'response_status_value' => bless( {
                                                                  'impcount' => 0,
                                                                  'changed' => 0,
                                                                  'opcount' => 0,
                                                                  'line' => 773,
                                                                  'vars' => '',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 773,
                                                                                                              'lookahead' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'subrule' => 'OK'
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'error' => undef,
                                                                                        'strcount' => 0,
                                                                                        'number' => 0,
                                                                                        'dircount' => 0,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'line' => undef
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'dircount' => 0,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'line' => 774,
                                                                                        'number' => 1,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'subrule' => 'ERROR_UNSPECIFIED',
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 774
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ]
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'number' => 2,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'uncommit' => undef,
                                                                                        'line' => 775,
                                                                                        'patcount' => 0,
                                                                                        'dircount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'line' => 775,
                                                                                                              'implicit' => undef,
                                                                                                              'subrule' => 'ERROR_SERVICE_DENIED',
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'lookahead' => 0
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'actcount' => 0
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'number' => 3,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'dircount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 0,
                                                                                        'line' => 776,
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'lookahead' => 0,
                                                                                                              'subrule' => 'ERROR_MESSAGE_FORMAT_CORRUPT',
                                                                                                              'line' => 776,
                                                                                                              'implicit' => undef
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ]
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'dircount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 0,
                                                                                        'line' => 777,
                                                                                        'error' => undef,
                                                                                        'number' => 4,
                                                                                        'strcount' => 0,
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 777,
                                                                                                              'lookahead' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'subrule' => 'ERROR_SENDING_ADDRESS_UNRESOLVED'
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ]
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'subrule' => 'ERROR_MESSAGE_NOT_FOUND',
                                                                                                              'lookahead' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 778
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'actcount' => 0,
                                                                                        'number' => 5,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'patcount' => 0,
                                                                                        'line' => 778,
                                                                                        'uncommit' => undef,
                                                                                        'dircount' => 0
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'dircount' => 0,
                                                                                        'line' => 779,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'number' => 6,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'line' => 779,
                                                                                                              'implicit' => undef,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'lookahead' => 0,
                                                                                                              'subrule' => 'ERROR_NETWORK_PROBLEM'
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ]
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'subrule' => 'ERROR_CONTENT_NOT_ACCEPTED',
                                                                                                              'lookahead' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 780
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'actcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'line' => 780,
                                                                                        'patcount' => 0,
                                                                                        'dircount' => 0,
                                                                                        'error' => undef,
                                                                                        'number' => 7,
                                                                                        'strcount' => 0
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'line' => 781,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'dircount' => 0,
                                                                                        'error' => undef,
                                                                                        'number' => 8,
                                                                                        'strcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'line' => 781,
                                                                                                              'implicit' => undef,
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'lookahead' => 0,
                                                                                                              'subrule' => 'ERROR_UNSUPPORTED_MESSAGE'
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'actcount' => 0
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'calls' => [
                                                                               'OK',
                                                                               'ERROR_UNSPECIFIED',
                                                                               'ERROR_SERVICE_DENIED',
                                                                               'ERROR_MESSAGE_FORMAT_CORRUPT',
                                                                               'ERROR_SENDING_ADDRESS_UNRESOLVED',
                                                                               'ERROR_MESSAGE_NOT_FOUND',
                                                                               'ERROR_NETWORK_PROBLEM',
                                                                               'ERROR_CONTENT_NOT_ACCEPTED',
                                                                               'ERROR_UNSUPPORTED_MESSAGE'
                                                                             ],
                                                                  'name' => 'response_status_value'
                                                                }, 'Parse::RecDescent::Rule' ),
                              'report_allowed_head' => bless( {
                                                                'line' => 668,
                                                                'opcount' => 0,
                                                                'changed' => 0,
                                                                'impcount' => 0,
                                                                'name' => 'report_allowed_head',
                                                                'calls' => [
                                                                             'report_allowed_value'
                                                                           ],
                                                                'vars' => '',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'actcount' => 1,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'description' => '\'\\\\x91\'',
                                                                                                            'line' => 668,
                                                                                                            'pattern' => '\\x91',
                                                                                                            'hashname' => '__STRING1__',
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                                   bless( {
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'lookahead' => 0,
                                                                                                            'subrule' => 'report_allowed_value',
                                                                                                            'line' => 668,
                                                                                                            'implicit' => undef
                                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                                   bless( {
                                                                                                            'hashname' => '__ACTION1__',
                                                                                                            'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                            'line' => 669,
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                                 ],
                                                                                      'dircount' => 0,
                                                                                      'patcount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'line' => undef,
                                                                                      'number' => 0,
                                                                                      'strcount' => 1,
                                                                                      'error' => undef
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ]
                                                              }, 'Parse::RecDescent::Rule' ),
                              'HIDE' => bless( {
                                                 'prods' => [
                                                              bless( {
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'pattern' => '\\x80',
                                                                                             'line' => 794,
                                                                                             'description' => '\'\\\\x80\'',
                                                                                             'hashname' => '__STRING1__'
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'code' => '{ $return = $item[0]; 1; }',
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'line' => 794,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'actcount' => 1,
                                                                       'number' => 0,
                                                                       'strcount' => 1,
                                                                       'error' => undef,
                                                                       'patcount' => 0,
                                                                       'line' => undef,
                                                                       'uncommit' => undef,
                                                                       'dircount' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'vars' => '',
                                                 'calls' => [],
                                                 'name' => 'HIDE',
                                                 'impcount' => 0,
                                                 'changed' => 0,
                                                 'opcount' => 0,
                                                 'line' => 794
                                               }, 'Parse::RecDescent::Rule' ),
                              'HIGH' => bless( {
                                                 'changed' => 0,
                                                 'impcount' => 0,
                                                 'line' => 769,
                                                 'opcount' => 0,
                                                 'prods' => [
                                                              bless( {
                                                                       'actcount' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'hashname' => '__STRING1__',
                                                                                             'line' => 769,
                                                                                             'description' => '\'\\\\x82\'',
                                                                                             'pattern' => '\\x82',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'line' => 769,
                                                                                             'code' => '{ $return = $item[0]; 1; }',
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'dircount' => 0,
                                                                       'line' => undef,
                                                                       'patcount' => 0,
                                                                       'uncommit' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 1,
                                                                       'error' => undef
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'vars' => '',
                                                 'name' => 'HIGH',
                                                 'calls' => []
                                               }, 'Parse::RecDescent::Rule' ),
                              'multipart' => bless( {
                                                      'name' => 'multipart',
                                                      'calls' => [
                                                                   'multipart_header',
                                                                   'multipart_entry'
                                                                 ],
                                                      'vars' => '',
                                                      'prods' => [
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'line' => 514,
                                                                                                  'implicit' => undef,
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'lookahead' => 0,
                                                                                                  'subrule' => 'multipart_header'
                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                         bless( {
                                                                                                  'repspec' => 's',
                                                                                                  'expected' => undef,
                                                                                                  'subrule' => 'multipart_entry',
                                                                                                  'argcode' => undef,
                                                                                                  'min' => 1,
                                                                                                  'line' => 514,
                                                                                                  'max' => 100000000,
                                                                                                  'matchrule' => 0,
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::Repetition' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'line' => undef,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'strcount' => 0,
                                                                            'number' => 0,
                                                                            'error' => undef
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'line' => 513,
                                                      'opcount' => 0,
                                                      'changed' => 0,
                                                      'impcount' => 0
                                                    }, 'Parse::RecDescent::Rule' ),
                              'filename_deprecated_parameter' => bless( {
                                                                          'impcount' => 0,
                                                                          'changed' => 0,
                                                                          'opcount' => 0,
                                                                          'line' => 379,
                                                                          'prods' => [
                                                                                       bless( {
                                                                                                'error' => undef,
                                                                                                'number' => 0,
                                                                                                'strcount' => 1,
                                                                                                'dircount' => 0,
                                                                                                'uncommit' => undef,
                                                                                                'line' => undef,
                                                                                                'patcount' => 0,
                                                                                                'actcount' => 1,
                                                                                                'items' => [
                                                                                                             bless( {
                                                                                                                      'hashname' => '__STRING1__',
                                                                                                                      'pattern' => '\\x86',
                                                                                                                      'line' => 379,
                                                                                                                      'description' => '\'\\\\x86\'',
                                                                                                                      'lookahead' => 0
                                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                                             bless( {
                                                                                                                      'subrule' => 'text_string',
                                                                                                                      'argcode' => undef,
                                                                                                                      'matchrule' => 0,
                                                                                                                      'lookahead' => 0,
                                                                                                                      'line' => 379,
                                                                                                                      'implicit' => undef
                                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                                             bless( {
                                                                                                                      'line' => 380,
                                                                                                                      'hashname' => '__ACTION1__',
                                                                                                                      'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                                      'lookahead' => 0
                                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                                           ]
                                                                                              }, 'Parse::RecDescent::Production' )
                                                                                     ],
                                                                          'vars' => '',
                                                                          'calls' => [
                                                                                       'text_string'
                                                                                     ],
                                                                          'name' => 'filename_deprecated_parameter'
                                                                        }, 'Parse::RecDescent::Rule' ),
                              'Disconnect' => bless( {
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'hashname' => '__STRING1__',
                                                                                                   'pattern' => '\\x05',
                                                                                                   'line' => 211,
                                                                                                   'description' => '\'\\\\x05\''
                                                                                                 }, 'Parse::RecDescent::InterpLit' ),
                                                                                          bless( {
                                                                                                   'lookahead' => 0,
                                                                                                   'code' => '{ $return = $item[0]; 1; }',
                                                                                                   'hashname' => '__ACTION1__',
                                                                                                   'line' => 211
                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                        ],
                                                                             'actcount' => 1,
                                                                             'uncommit' => undef,
                                                                             'line' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'number' => 0,
                                                                             'strcount' => 1,
                                                                             'error' => undef
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'vars' => '',
                                                       'name' => 'Disconnect',
                                                       'calls' => [],
                                                       'changed' => 0,
                                                       'impcount' => 0,
                                                       'line' => 211,
                                                       'opcount' => 0
                                                     }, 'Parse::RecDescent::Rule' ),
                              'OK' => bless( {
                                               'vars' => '',
                                               'prods' => [
                                                            bless( {
                                                                     'uncommit' => undef,
                                                                     'line' => undef,
                                                                     'patcount' => 0,
                                                                     'dircount' => 0,
                                                                     'error' => undef,
                                                                     'strcount' => 1,
                                                                     'number' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'hashname' => '__STRING1__',
                                                                                           'pattern' => '\\x80',
                                                                                           'description' => '\'\\\\x80\'',
                                                                                           'line' => 782,
                                                                                           'lookahead' => 0
                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'line' => 782,
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'code' => '{ $return = $item[0]; 1; }'
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'actcount' => 1
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'name' => 'OK',
                                               'calls' => [],
                                               'changed' => 0,
                                               'impcount' => 0,
                                               'line' => 782,
                                               'opcount' => 0
                                             }, 'Parse::RecDescent::Rule' ),
                              'uintvar' => bless( {
                                                    'vars' => '',
                                                    'prods' => [
                                                                 bless( {
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'dircount' => 0,
                                                                          'strcount' => 0,
                                                                          'number' => 0,
                                                                          'error' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'subrule' => 'HIGHOCTET',
                                                                                                'argcode' => undef,
                                                                                                'repspec' => '0..4',
                                                                                                'expected' => undef,
                                                                                                'max' => 4,
                                                                                                'matchrule' => 0,
                                                                                                'lookahead' => 0,
                                                                                                'min' => 0,
                                                                                                'line' => 188
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'subrule' => 'CHAR',
                                                                                                'implicit' => undef,
                                                                                                'line' => 188
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 188,
                                                                                                'code' => '{
   $return = 0;
   foreach my $high ( @{$item[1]} ) {
      $return |= ord($high) & 0x7F;
      $return <<= 7;
   }
   $return |= ord($item{CHAR});
   1;
}',
                                                                                                'hashname' => '__ACTION1__'
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'name' => 'uintvar',
                                                    'calls' => [
                                                                 'HIGHOCTET',
                                                                 'CHAR'
                                                               ],
                                                    'changed' => 0,
                                                    'impcount' => 0,
                                                    'line' => 188,
                                                    'opcount' => 0
                                                  }, 'Parse::RecDescent::Rule' ),
                              'CR' => bless( {
                                               'name' => 'CR',
                                               'calls' => [],
                                               'vars' => '',
                                               'prods' => [
                                                            bless( {
                                                                     'actcount' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__STRING1__',
                                                                                           'description' => '\'\\\\x0D\'',
                                                                                           'line' => 153,
                                                                                           'pattern' => '\\x0D'
                                                                                         }, 'Parse::RecDescent::InterpLit' )
                                                                                ],
                                                                     'dircount' => 0,
                                                                     'patcount' => 0,
                                                                     'line' => undef,
                                                                     'uncommit' => undef,
                                                                     'error' => undef,
                                                                     'number' => 0,
                                                                     'strcount' => 1
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'line' => 153,
                                               'opcount' => 0,
                                               'changed' => 0,
                                               'impcount' => 0
                                             }, 'Parse::RecDescent::Rule' ),
                              'short_length' => bless( {
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'line' => 277,
                                                         'opcount' => 0,
                                                         'prods' => [
                                                                      bless( {
                                                                               'dircount' => 0,
                                                                               'patcount' => 0,
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'number' => 0,
                                                                               'strcount' => 0,
                                                                               'error' => undef,
                                                                               'actcount' => 1,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'subrule' => 'uint8',
                                                                                                     'matchrule' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'lookahead' => 0,
                                                                                                     'line' => 278,
                                                                                                     'implicit' => undef
                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'hashname' => '__ACTION1__',
                                                                                                     'code' => '{
   if ($item[1] <= 30) {
      $return = $item[1];
      1;
   }
   else { undef } # Reject
}',
                                                                                                     'line' => 278
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ]
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'vars' => '',
                                                         'name' => 'short_length',
                                                         'calls' => [
                                                                      'uint8'
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'cc_head' => bless( {
                                                    'name' => 'cc_head',
                                                    'calls' => [
                                                                 'cc_value'
                                                               ],
                                                    'prods' => [
                                                                 bless( {
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'pattern' => '\\x82',
                                                                                                'description' => '\'\\\\x82\'',
                                                                                                'line' => 637,
                                                                                                'hashname' => '__STRING1__',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                       bless( {
                                                                                                'subrule' => 'cc_value',
                                                                                                'argcode' => undef,
                                                                                                'matchrule' => 0,
                                                                                                'lookahead' => 0,
                                                                                                'line' => 637,
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                'line' => 638
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'actcount' => 1,
                                                                          'strcount' => 1,
                                                                          'number' => 0,
                                                                          'error' => undef,
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'dircount' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => '',
                                                    'line' => 637,
                                                    'opcount' => 0,
                                                    'changed' => 0,
                                                    'impcount' => 0
                                                  }, 'Parse::RecDescent::Rule' ),
                              'encoded_string_value' => bless( {
                                                                 'vars' => '',
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'dircount' => 0,
                                                                                       'line' => undef,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'number' => 0,
                                                                                       'strcount' => 0,
                                                                                       'error' => undef,
                                                                                       'actcount' => 1,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'line' => 718,
                                                                                                             'min' => 0,
                                                                                                             'matchrule' => 0,
                                                                                                             'lookahead' => 0,
                                                                                                             'max' => 1,
                                                                                                             'expected' => undef,
                                                                                                             'repspec' => '?',
                                                                                                             'argcode' => undef,
                                                                                                             'subrule' => '_charset_part'
                                                                                                           }, 'Parse::RecDescent::Repetition' ),
                                                                                                    bless( {
                                                                                                             'implicit' => undef,
                                                                                                             'line' => 718,
                                                                                                             'lookahead' => 0,
                                                                                                             'matchrule' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'subrule' => 'text_string'
                                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                                    bless( {
                                                                                                             'code' => '{
   $return = { text => $item{text_string} };
   if (scalar @{$item[1]} > 0) {
      $return->{charset} = $item[1][0];
   }
   1;
}',
                                                                                                             'hashname' => '__ACTION1__',
                                                                                                             'line' => 718,
                                                                                                             'lookahead' => 0
                                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                                  ]
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'calls' => [
                                                                              '_charset_part',
                                                                              'text_string'
                                                                            ],
                                                                 'name' => 'encoded_string_value',
                                                                 'impcount' => 0,
                                                                 'changed' => 0,
                                                                 'opcount' => 0,
                                                                 'line' => 717
                                                               }, 'Parse::RecDescent::Rule' ),
                              'name_deprecated_parameter' => bless( {
                                                                      'name' => 'name_deprecated_parameter',
                                                                      'calls' => [
                                                                                   'text_string'
                                                                                 ],
                                                                      'prods' => [
                                                                                   bless( {
                                                                                            'error' => undef,
                                                                                            'strcount' => 1,
                                                                                            'number' => 0,
                                                                                            'line' => undef,
                                                                                            'uncommit' => undef,
                                                                                            'patcount' => 0,
                                                                                            'dircount' => 0,
                                                                                            'items' => [
                                                                                                         bless( {
                                                                                                                  'lookahead' => 0,
                                                                                                                  'description' => '\'\\\\x85\'',
                                                                                                                  'line' => 377,
                                                                                                                  'pattern' => '\\x85',
                                                                                                                  'hashname' => '__STRING1__'
                                                                                                                }, 'Parse::RecDescent::InterpLit' ),
                                                                                                         bless( {
                                                                                                                  'line' => 377,
                                                                                                                  'implicit' => undef,
                                                                                                                  'matchrule' => 0,
                                                                                                                  'argcode' => undef,
                                                                                                                  'lookahead' => 0,
                                                                                                                  'subrule' => 'text_string'
                                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                                         bless( {
                                                                                                                  'lookahead' => 0,
                                                                                                                  'line' => 378,
                                                                                                                  'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                                  'hashname' => '__ACTION1__'
                                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                                       ],
                                                                                            'actcount' => 1
                                                                                          }, 'Parse::RecDescent::Production' )
                                                                                 ],
                                                                      'vars' => '',
                                                                      'line' => 377,
                                                                      'opcount' => 0,
                                                                      'changed' => 0,
                                                                      'impcount' => 0
                                                                    }, 'Parse::RecDescent::Rule' ),
                              'expiry_head' => bless( {
                                                        'prods' => [
                                                                     bless( {
                                                                              'uncommit' => undef,
                                                                              'patcount' => 0,
                                                                              'line' => undef,
                                                                              'dircount' => 0,
                                                                              'number' => 0,
                                                                              'strcount' => 1,
                                                                              'error' => undef,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'description' => '\'\\\\x88\'',
                                                                                                    'line' => 649,
                                                                                                    'pattern' => '\\x88',
                                                                                                    'hashname' => '__STRING1__'
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'argcode' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'subrule' => 'expiry_value',
                                                                                                    'line' => 649,
                                                                                                    'implicit' => undef
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                    'line' => 650
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'name' => 'expiry_head',
                                                        'calls' => [
                                                                     'expiry_value'
                                                                   ],
                                                        'changed' => 0,
                                                        'impcount' => 0,
                                                        'line' => 649,
                                                        'opcount' => 0
                                                      }, 'Parse::RecDescent::Rule' ),
                              'length_quote' => bless( {
                                                         'calls' => [],
                                                         'name' => 'length_quote',
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0,
                                                                               'dircount' => 0,
                                                                               'strcount' => 1,
                                                                               'number' => 0,
                                                                               'error' => undef,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'pattern' => '\\x1F',
                                                                                                     'description' => '\'\\\\x1F\'',
                                                                                                     'line' => 286,
                                                                                                     'hashname' => '__STRING1__',
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::InterpLit' )
                                                                                          ],
                                                                               'actcount' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'opcount' => 0,
                                                         'line' => 285,
                                                         'impcount' => 0,
                                                         'changed' => 0
                                                       }, 'Parse::RecDescent::Rule' ),
                              'parameter' => bless( {
                                                      'name' => 'parameter',
                                                      'calls' => [
                                                                   'typed_parameter',
                                                                   'untyped_parameter'
                                                                 ],
                                                      'vars' => '',
                                                      'prods' => [
                                                                   bless( {
                                                                            'error' => undef,
                                                                            'number' => 0,
                                                                            'strcount' => 0,
                                                                            'dircount' => 0,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => undef,
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'subrule' => 'typed_parameter',
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'lookahead' => 0,
                                                                                                  'line' => 335,
                                                                                                  'implicit' => undef
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'implicit' => undef,
                                                                                                  'line' => 335,
                                                                                                  'subrule' => 'untyped_parameter',
                                                                                                  'lookahead' => 0,
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ],
                                                                            'number' => 1,
                                                                            'strcount' => 0,
                                                                            'error' => undef,
                                                                            'dircount' => 0,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => 335
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'line' => 334,
                                                      'opcount' => 0,
                                                      'changed' => 0,
                                                      'impcount' => 0
                                                    }, 'Parse::RecDescent::Rule' ),
                              'm_notification_ind' => bless( {
                                                               'prods' => [
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'pattern' => '\\x82',
                                                                                                           'description' => '\'\\\\x82\'',
                                                                                                           'line' => 757,
                                                                                                           'hashname' => '__STRING1__',
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'hashname' => '__ACTION1__',
                                                                                                           'code' => '{ $return = $item[0]; }',
                                                                                                           'line' => 757
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ],
                                                                                     'actcount' => 1,
                                                                                     'patcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => undef,
                                                                                     'dircount' => 0,
                                                                                     'strcount' => 1,
                                                                                     'number' => 0,
                                                                                     'error' => undef
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'calls' => [],
                                                               'name' => 'm_notification_ind',
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'opcount' => 0,
                                                               'line' => 757
                                                             }, 'Parse::RecDescent::Rule' ),
                              'bcc_head' => bless( {
                                                     'calls' => [
                                                                  'bcc_value'
                                                                ],
                                                     'name' => 'bcc_head',
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'strcount' => 1,
                                                                           'number' => 0,
                                                                           'line' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'pattern' => '\\x81',
                                                                                                 'description' => '\'\\\\x81\'',
                                                                                                 'line' => 635,
                                                                                                 'hashname' => '__STRING1__'
                                                                                               }, 'Parse::RecDescent::InterpLit' ),
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 635,
                                                                                                 'lookahead' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'subrule' => 'bcc_value'
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'line' => 636,
                                                                                                 'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'actcount' => 1
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'opcount' => 0,
                                                     'line' => 634,
                                                     'impcount' => 0,
                                                     'changed' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              '_charset_part' => bless( {
                                                          'opcount' => 0,
                                                          'line' => 725,
                                                          'impcount' => 0,
                                                          'changed' => 0,
                                                          'calls' => [
                                                                       'value_length'
                                                                     ],
                                                          'name' => '_charset_part',
                                                          'prods' => [
                                                                       bless( {
                                                                                'dircount' => 0,
                                                                                'line' => undef,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'error' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 0,
                                                                                'actcount' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'line' => 725,
                                                                                                      'implicit' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => 'value_length'
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 725,
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'code' => '{
   my $len = $item[1];
   if ($len > 0 && $len <= length $text) {
      $return = substr $text, 0, $len;
      $text = substr $text, $len;
   }
   else { undef }
}'
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ]
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => ''
                                                        }, 'Parse::RecDescent::Rule' ),
                              'PDU_type' => bless( {
                                                     'impcount' => 0,
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'line' => 198,
                                                     'prods' => [
                                                                  bless( {
                                                                           'line' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 198,
                                                                                                 'implicit' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'Reserved'
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 198,
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'subrule' => 'Connect'
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0,
                                                                           'patcount' => 0,
                                                                           'line' => 198,
                                                                           'uncommit' => undef,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 1,
                                                                           'strcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'line' => 198,
                                                                           'error' => undef,
                                                                           'number' => 2,
                                                                           'strcount' => 0,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'ConnectReply',
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 198
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 3,
                                                                           'uncommit' => undef,
                                                                           'line' => 198,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 198,
                                                                                                 'implicit' => undef,
                                                                                                 'subrule' => 'Redirect',
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 4,
                                                                           'uncommit' => undef,
                                                                           'line' => 198,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'Reply',
                                                                                                 'line' => 198,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 5,
                                                                           'dircount' => 0,
                                                                           'line' => 199,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'Disconnect',
                                                                                                 'line' => 199,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'patcount' => 0,
                                                                           'line' => 199,
                                                                           'uncommit' => undef,
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 6,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'Push',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 199,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'line' => 199,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 7,
                                                                           'strcount' => 0,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 199,
                                                                                                 'implicit' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'ConfirmedPush'
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => 199,
                                                                           'patcount' => 0,
                                                                           'strcount' => 0,
                                                                           'number' => 8,
                                                                           'error' => undef,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'Suspend',
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 199,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 199,
                                                                                                 'implicit' => undef,
                                                                                                 'subrule' => 'Resume',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'line' => 199,
                                                                           'dircount' => 0,
                                                                           'strcount' => 0,
                                                                           'number' => 9,
                                                                           'error' => undef
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 200,
                                                                                                 'implicit' => undef,
                                                                                                 'subrule' => 'Unassigned',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => 200,
                                                                           'patcount' => 0,
                                                                           'number' => 10,
                                                                           'strcount' => 0,
                                                                           'error' => undef
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 201,
                                                                                                 'implicit' => undef,
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'Get'
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => 201,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 11,
                                                                           'strcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'number' => 12,
                                                                           'strcount' => 0,
                                                                           'error' => undef,
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => 201,
                                                                           'patcount' => 0,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'Options_GetPDU',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 201,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'number' => 13,
                                                                           'strcount' => 0,
                                                                           'error' => undef,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'line' => 201,
                                                                           'dircount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 201,
                                                                                                 'lookahead' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'subrule' => 'Head_GetPDU'
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'Delete_GetPDU',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 201,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'line' => 201,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 14,
                                                                           'strcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 201,
                                                                                                 'subrule' => 'Trace_GetPDU',
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'dircount' => 0,
                                                                           'line' => 201,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'number' => 15,
                                                                           'strcount' => 0,
                                                                           'error' => undef
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'line' => 202,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 16,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'Unassigned_GetPDU',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 202,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 17,
                                                                           'uncommit' => undef,
                                                                           'line' => 202,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 202,
                                                                                                 'implicit' => undef,
                                                                                                 'subrule' => 'ExtendedMethod_GetPDU',
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'Post',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 203,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'dircount' => 0,
                                                                           'line' => 203,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'strcount' => 0,
                                                                           'number' => 18,
                                                                           'error' => undef
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'line' => 203,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'number' => 19,
                                                                           'strcount' => 0,
                                                                           'error' => undef,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 203,
                                                                                                 'subrule' => 'Put_PostPDU',
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'Unassigned_PostPDU',
                                                                                                 'line' => 204,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'actcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => 204,
                                                                           'patcount' => 0,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'number' => 20,
                                                                           'strcount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'line' => 204,
                                                                           'uncommit' => undef,
                                                                           'patcount' => 0,
                                                                           'error' => undef,
                                                                           'strcount' => 0,
                                                                           'number' => 21,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'ExtendedMethod_PostPDU',
                                                                                                 'line' => 204,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'strcount' => 0,
                                                                           'number' => 22,
                                                                           'error' => undef,
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => 205,
                                                                           'patcount' => 0,
                                                                           'actcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'subrule' => 'DataFragmentPDU',
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 205
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'vars' => '',
                                                     'calls' => [
                                                                  'Reserved',
                                                                  'Connect',
                                                                  'ConnectReply',
                                                                  'Redirect',
                                                                  'Reply',
                                                                  'Disconnect',
                                                                  'Push',
                                                                  'ConfirmedPush',
                                                                  'Suspend',
                                                                  'Resume',
                                                                  'Unassigned',
                                                                  'Get',
                                                                  'Options_GetPDU',
                                                                  'Head_GetPDU',
                                                                  'Delete_GetPDU',
                                                                  'Trace_GetPDU',
                                                                  'Unassigned_GetPDU',
                                                                  'ExtendedMethod_GetPDU',
                                                                  'Post',
                                                                  'Put_PostPDU',
                                                                  'Unassigned_PostPDU',
                                                                  'ExtendedMethod_PostPDU',
                                                                  'DataFragmentPDU'
                                                                ],
                                                     'name' => 'PDU_type'
                                                   }, 'Parse::RecDescent::Rule' ),
                              'delivery_report_value' => bless( {
                                                                  'vars' => '',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'number' => 0,
                                                                                        'strcount' => 0,
                                                                                        'error' => undef,
                                                                                        'dircount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'patcount' => 0,
                                                                                        'line' => undef,
                                                                                        'actcount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'implicit' => undef,
                                                                                                              'line' => 705,
                                                                                                              'subrule' => 'YES',
                                                                                                              'lookahead' => 0,
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ]
                                                                                      }, 'Parse::RecDescent::Production' ),
                                                                               bless( {
                                                                                        'strcount' => 0,
                                                                                        'number' => 1,
                                                                                        'error' => undef,
                                                                                        'patcount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'line' => 705,
                                                                                        'dircount' => 0,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'subrule' => 'NO',
                                                                                                              'matchrule' => 0,
                                                                                                              'argcode' => undef,
                                                                                                              'lookahead' => 0,
                                                                                                              'line' => 705,
                                                                                                              'implicit' => undef
                                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                                   ],
                                                                                        'actcount' => 0
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ],
                                                                  'calls' => [
                                                                               'YES',
                                                                               'NO'
                                                                             ],
                                                                  'name' => 'delivery_report_value',
                                                                  'impcount' => 0,
                                                                  'changed' => 0,
                                                                  'opcount' => 0,
                                                                  'line' => 704
                                                                }, 'Parse::RecDescent::Rule' ),
                              '_media_type' => bless( {
                                                        'impcount' => 1,
                                                        'changed' => 0,
                                                        'opcount' => 0,
                                                        'line' => 456,
                                                        'vars' => '',
                                                        'prods' => [
                                                                     bless( {
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'subrule' => '_alternation_1_of_production_1_of_rule__media_type',
                                                                                                    'argcode' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'line' => 456,
                                                                                                    'implicit' => '_trans_well_known_media, or extension_media'
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'min' => 0,
                                                                                                    'line' => 456,
                                                                                                    'max' => 100000000,
                                                                                                    'matchrule' => 0,
                                                                                                    'lookahead' => 0,
                                                                                                    'repspec' => 's?',
                                                                                                    'expected' => undef,
                                                                                                    'subrule' => 'parameter',
                                                                                                    'argcode' => undef
                                                                                                  }, 'Parse::RecDescent::Repetition' ),
                                                                                           bless( {
                                                                                                    'line' => 456,
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'code' => '{
   my $media_type = $item[1];
   if (defined $media_type) {
      my @parameters = map { # param_encode() defined in g-startup.pl
         $_->{name} . \' = \' . param_encode($_->{value});
      } @{$item[2]};
      my %parameters = map { $_->{name} => $_->{value} } @{$item[2]};
      my $text = join \'; \', $media_type, @parameters;
      $return = {
         text => $text,
         media_type => $media_type,
         parameters => \\%parameters,
      };
      1;
   }
   else {undef}
}',
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'actcount' => 1,
                                                                              'error' => undef,
                                                                              'strcount' => 0,
                                                                              'number' => 0,
                                                                              'uncommit' => undef,
                                                                              'line' => undef,
                                                                              'patcount' => 0,
                                                                              'dircount' => 0
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'calls' => [
                                                                     '_alternation_1_of_production_1_of_rule__media_type',
                                                                     'parameter'
                                                                   ],
                                                        'name' => '_media_type'
                                                      }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule__media_type' => bless( {
                                                                                               'vars' => '',
                                                                                               'prods' => [
                                                                                                            bless( {
                                                                                                                     'error' => undef,
                                                                                                                     'number' => 0,
                                                                                                                     'strcount' => 0,
                                                                                                                     'uncommit' => undef,
                                                                                                                     'line' => undef,
                                                                                                                     'patcount' => 0,
                                                                                                                     'dircount' => 0,
                                                                                                                     'items' => [
                                                                                                                                  bless( {
                                                                                                                                           'implicit' => undef,
                                                                                                                                           'line' => 807,
                                                                                                                                           'lookahead' => 0,
                                                                                                                                           'argcode' => undef,
                                                                                                                                           'matchrule' => 0,
                                                                                                                                           'subrule' => '_trans_well_known_media'
                                                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                                                ],
                                                                                                                     'actcount' => 0
                                                                                                                   }, 'Parse::RecDescent::Production' ),
                                                                                                            bless( {
                                                                                                                     'items' => [
                                                                                                                                  bless( {
                                                                                                                                           'implicit' => undef,
                                                                                                                                           'line' => 807,
                                                                                                                                           'subrule' => 'extension_media',
                                                                                                                                           'lookahead' => 0,
                                                                                                                                           'matchrule' => 0,
                                                                                                                                           'argcode' => undef
                                                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                                                ],
                                                                                                                     'actcount' => 0,
                                                                                                                     'line' => 807,
                                                                                                                     'uncommit' => undef,
                                                                                                                     'patcount' => 0,
                                                                                                                     'dircount' => 0,
                                                                                                                     'error' => undef,
                                                                                                                     'number' => 1,
                                                                                                                     'strcount' => 0
                                                                                                                   }, 'Parse::RecDescent::Production' )
                                                                                                          ],
                                                                                               'name' => '_alternation_1_of_production_1_of_rule__media_type',
                                                                                               'calls' => [
                                                                                                            '_trans_well_known_media',
                                                                                                            'extension_media'
                                                                                                          ],
                                                                                               'changed' => 0,
                                                                                               'impcount' => 0,
                                                                                               'line' => 807,
                                                                                               'opcount' => 0
                                                                                             }, 'Parse::RecDescent::Rule' ),
                              'message_type_head' => bless( {
                                                              'line' => 658,
                                                              'opcount' => 0,
                                                              'changed' => 0,
                                                              'impcount' => 0,
                                                              'name' => 'message_type_head',
                                                              'calls' => [
                                                                           'message_type_head_code',
                                                                           'message_type_value'
                                                                         ],
                                                              'prods' => [
                                                                           bless( {
                                                                                    'error' => undef,
                                                                                    'number' => 0,
                                                                                    'strcount' => 0,
                                                                                    'patcount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'line' => undef,
                                                                                    'dircount' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'line' => 658,
                                                                                                          'implicit' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'message_type_head_code'
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'line' => 658,
                                                                                                          'implicit' => undef,
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0,
                                                                                                          'subrule' => 'message_type_value'
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'line' => 659,
                                                                                                          'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'vars' => ''
                                                            }, 'Parse::RecDescent::Rule' ),
                              'report_allowed_value' => bless( {
                                                                 'impcount' => 0,
                                                                 'changed' => 0,
                                                                 'opcount' => 0,
                                                                 'line' => 772,
                                                                 'vars' => '',
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'actcount' => 0,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'subrule' => 'YES',
                                                                                                             'matchrule' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'lookahead' => 0,
                                                                                                             'line' => 772,
                                                                                                             'implicit' => undef
                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                  ],
                                                                                       'number' => 0,
                                                                                       'strcount' => 0,
                                                                                       'error' => undef,
                                                                                       'dircount' => 0,
                                                                                       'line' => undef,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0
                                                                                     }, 'Parse::RecDescent::Production' ),
                                                                              bless( {
                                                                                       'actcount' => 0,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'subrule' => 'NO',
                                                                                                             'lookahead' => 0,
                                                                                                             'argcode' => undef,
                                                                                                             'matchrule' => 0,
                                                                                                             'implicit' => undef,
                                                                                                             'line' => 772
                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                  ],
                                                                                       'dircount' => 0,
                                                                                       'line' => 772,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'error' => undef,
                                                                                       'strcount' => 0,
                                                                                       'number' => 1
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'calls' => [
                                                                              'YES',
                                                                              'NO'
                                                                            ],
                                                                 'name' => 'report_allowed_value'
                                                               }, 'Parse::RecDescent::Rule' ),
                              'creation_date_parameter' => bless( {
                                                                    'prods' => [
                                                                                 bless( {
                                                                                          'items' => [
                                                                                                       bless( {
                                                                                                                'lookahead' => 0,
                                                                                                                'hashname' => '__STRING1__',
                                                                                                                'pattern' => '\\x93',
                                                                                                                'description' => '\'\\\\x93\'',
                                                                                                                'line' => 405
                                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                                       bless( {
                                                                                                                'matchrule' => 0,
                                                                                                                'argcode' => undef,
                                                                                                                'lookahead' => 0,
                                                                                                                'subrule' => 'date_value',
                                                                                                                'line' => 405,
                                                                                                                'implicit' => undef
                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                       bless( {
                                                                                                                'line' => 406,
                                                                                                                'hashname' => '__ACTION1__',
                                                                                                                'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                                'lookahead' => 0
                                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                                     ],
                                                                                          'actcount' => 1,
                                                                                          'uncommit' => undef,
                                                                                          'line' => undef,
                                                                                          'patcount' => 0,
                                                                                          'dircount' => 0,
                                                                                          'number' => 0,
                                                                                          'strcount' => 1,
                                                                                          'error' => undef
                                                                                        }, 'Parse::RecDescent::Production' )
                                                                               ],
                                                                    'vars' => '',
                                                                    'name' => 'creation_date_parameter',
                                                                    'calls' => [
                                                                                 'date_value'
                                                                               ],
                                                                    'changed' => 0,
                                                                    'impcount' => 0,
                                                                    'line' => 405,
                                                                    'opcount' => 0
                                                                  }, 'Parse::RecDescent::Rule' ),
                              'RFC2616_QUOTE' => bless( {
                                                          'impcount' => 0,
                                                          'changed' => 0,
                                                          'opcount' => 0,
                                                          'line' => 157,
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'pattern' => '\\x22',
                                                                                                      'line' => 157,
                                                                                                      'description' => '\'\\\\x22\'',
                                                                                                      'hashname' => '__STRING1__'
                                                                                                    }, 'Parse::RecDescent::InterpLit' )
                                                                                           ],
                                                                                'error' => undef,
                                                                                'strcount' => 1,
                                                                                'number' => 0,
                                                                                'dircount' => 0,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'line' => undef
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => '',
                                                          'calls' => [],
                                                          'name' => 'RFC2616_QUOTE'
                                                        }, 'Parse::RecDescent::Rule' ),
                              'comment_parameter' => bless( {
                                                              'changed' => 0,
                                                              'impcount' => 0,
                                                              'line' => 421,
                                                              'opcount' => 0,
                                                              'prods' => [
                                                                           bless( {
                                                                                    'dircount' => 0,
                                                                                    'patcount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'line' => undef,
                                                                                    'error' => undef,
                                                                                    'strcount' => 1,
                                                                                    'number' => 0,
                                                                                    'actcount' => 1,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'description' => '\'\\\\x9b\'',
                                                                                                          'line' => 421,
                                                                                                          'pattern' => '\\x9b',
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'line' => 421,
                                                                                                          'implicit' => undef,
                                                                                                          'subrule' => 'text_value',
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'line' => 422
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ]
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'vars' => '',
                                                              'name' => 'comment_parameter',
                                                              'calls' => [
                                                                           'text_value'
                                                                         ]
                                                            }, 'Parse::RecDescent::Rule' ),
                              'octet' => bless( {
                                                  'name' => 'octet',
                                                  'calls' => [
                                                               'OCTET'
                                                             ],
                                                  'prods' => [
                                                               bless( {
                                                                        'actcount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'line' => 184,
                                                                                              'implicit' => undef,
                                                                                              'subrule' => 'OCTET',
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => undef,
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'strcount' => 0,
                                                                        'number' => 0,
                                                                        'dircount' => 0,
                                                                        'uncommit' => undef,
                                                                        'line' => undef,
                                                                        'patcount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'vars' => '',
                                                  'line' => 183,
                                                  'opcount' => 0,
                                                  'changed' => 0,
                                                  'impcount' => 0
                                                }, 'Parse::RecDescent::Rule' ),
                              'Push' => bless( {
                                                 'changed' => 0,
                                                 'impcount' => 0,
                                                 'line' => 212,
                                                 'opcount' => 0,
                                                 'vars' => '',
                                                 'prods' => [
                                                              bless( {
                                                                       'error' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 1,
                                                                       'dircount' => 0,
                                                                       'line' => undef,
                                                                       'uncommit' => undef,
                                                                       'patcount' => 0,
                                                                       'actcount' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'pattern' => '\\x06',
                                                                                             'description' => '\'\\\\x06\'',
                                                                                             'line' => 212,
                                                                                             'hashname' => '__STRING1__'
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'line' => 212,
                                                                                             'code' => '{ $return = $item[0]; 1; }',
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ]
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'name' => 'Push',
                                                 'calls' => []
                                               }, 'Parse::RecDescent::Rule' ),
                              'start_info_related_deprecated_parameter' => bless( {
                                                                                    'vars' => '',
                                                                                    'prods' => [
                                                                                                 bless( {
                                                                                                          'items' => [
                                                                                                                       bless( {
                                                                                                                                'lookahead' => 0,
                                                                                                                                'hashname' => '__STRING1__',
                                                                                                                                'description' => '\'\\\\x8b\'',
                                                                                                                                'line' => 389,
                                                                                                                                'pattern' => '\\x8b'
                                                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                                                       bless( {
                                                                                                                                'subrule' => 'text_string',
                                                                                                                                'lookahead' => 0,
                                                                                                                                'argcode' => undef,
                                                                                                                                'matchrule' => 0,
                                                                                                                                'implicit' => undef,
                                                                                                                                'line' => 389
                                                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                                                       bless( {
                                                                                                                                'hashname' => '__ACTION1__',
                                                                                                                                'code' => '{ $return = build_parameter(@item, \'1.2\'); 1; }',
                                                                                                                                'line' => 390,
                                                                                                                                'lookahead' => 0
                                                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                                                     ],
                                                                                                          'actcount' => 1,
                                                                                                          'strcount' => 1,
                                                                                                          'number' => 0,
                                                                                                          'error' => undef,
                                                                                                          'line' => undef,
                                                                                                          'uncommit' => undef,
                                                                                                          'patcount' => 0,
                                                                                                          'dircount' => 0
                                                                                                        }, 'Parse::RecDescent::Production' )
                                                                                               ],
                                                                                    'calls' => [
                                                                                                 'text_string'
                                                                                               ],
                                                                                    'name' => 'start_info_related_deprecated_parameter',
                                                                                    'impcount' => 0,
                                                                                    'changed' => 0,
                                                                                    'opcount' => 0,
                                                                                    'line' => 389
                                                                                  }, 'Parse::RecDescent::Rule' ),
                              'REJECTED' => bless( {
                                                     'impcount' => 0,
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'line' => 800,
                                                     'prods' => [
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'number' => 0,
                                                                           'strcount' => 1,
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'line' => undef,
                                                                           'patcount' => 0,
                                                                           'actcount' => 1,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'hashname' => '__STRING1__',
                                                                                                 'line' => 800,
                                                                                                 'description' => '\'\\\\x82\'',
                                                                                                 'pattern' => '\\x82',
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::InterpLit' ),
                                                                                        bless( {
                                                                                                 'line' => 800,
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{ $return = $item[0]; 1; }',
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'vars' => '',
                                                     'calls' => [],
                                                     'name' => 'REJECTED'
                                                   }, 'Parse::RecDescent::Rule' ),
                              'Connect' => bless( {
                                                    'changed' => 0,
                                                    'impcount' => 0,
                                                    'line' => 207,
                                                    'opcount' => 0,
                                                    'prods' => [
                                                                 bless( {
                                                                          'dircount' => 0,
                                                                          'patcount' => 0,
                                                                          'line' => undef,
                                                                          'uncommit' => undef,
                                                                          'error' => undef,
                                                                          'number' => 0,
                                                                          'strcount' => 1,
                                                                          'actcount' => 1,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'hashname' => '__STRING1__',
                                                                                                'pattern' => '\\x01',
                                                                                                'line' => 207,
                                                                                                'description' => '\'\\\\x01\'',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{ $return = $item[0]; 1; }',
                                                                                                'line' => 207
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ]
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => '',
                                                    'name' => 'Connect',
                                                    'calls' => []
                                                  }, 'Parse::RecDescent::Rule' ),
                              'Suspend' => bless( {
                                                    'vars' => '',
                                                    'prods' => [
                                                                 bless( {
                                                                          'error' => undef,
                                                                          'strcount' => 1,
                                                                          'number' => 0,
                                                                          'patcount' => 0,
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'dircount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'pattern' => '\\x08',
                                                                                                'line' => 214,
                                                                                                'description' => '\'\\\\x08\'',
                                                                                                'hashname' => '__STRING1__',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                       bless( {
                                                                                                'line' => 214,
                                                                                                'code' => '{ $return = $item[0]; 1; }',
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'calls' => [],
                                                    'name' => 'Suspend',
                                                    'impcount' => 0,
                                                    'changed' => 0,
                                                    'opcount' => 0,
                                                    'line' => 214
                                                  }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule_LWS' => bless( {
                                                                                       'vars' => '',
                                                                                       'prods' => [
                                                                                                    bless( {
                                                                                                             'strcount' => 0,
                                                                                                             'number' => 0,
                                                                                                             'error' => undef,
                                                                                                             'line' => undef,
                                                                                                             'uncommit' => undef,
                                                                                                             'patcount' => 0,
                                                                                                             'dircount' => 0,
                                                                                                             'items' => [
                                                                                                                          bless( {
                                                                                                                                   'subrule' => 'SP',
                                                                                                                                   'lookahead' => 0,
                                                                                                                                   'matchrule' => 0,
                                                                                                                                   'argcode' => undef,
                                                                                                                                   'implicit' => undef,
                                                                                                                                   'line' => 807
                                                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                                                        ],
                                                                                                             'actcount' => 0
                                                                                                           }, 'Parse::RecDescent::Production' ),
                                                                                                    bless( {
                                                                                                             'error' => undef,
                                                                                                             'strcount' => 0,
                                                                                                             'number' => 1,
                                                                                                             'dircount' => 0,
                                                                                                             'patcount' => 0,
                                                                                                             'uncommit' => undef,
                                                                                                             'line' => 807,
                                                                                                             'actcount' => 0,
                                                                                                             'items' => [
                                                                                                                          bless( {
                                                                                                                                   'subrule' => 'HT',
                                                                                                                                   'lookahead' => 0,
                                                                                                                                   'matchrule' => 0,
                                                                                                                                   'argcode' => undef,
                                                                                                                                   'implicit' => undef,
                                                                                                                                   'line' => 807
                                                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                                                        ]
                                                                                                           }, 'Parse::RecDescent::Production' )
                                                                                                  ],
                                                                                       'name' => '_alternation_1_of_production_1_of_rule_LWS',
                                                                                       'calls' => [
                                                                                                    'SP',
                                                                                                    'HT'
                                                                                                  ],
                                                                                       'changed' => 0,
                                                                                       'impcount' => 0,
                                                                                       'line' => 807,
                                                                                       'opcount' => 0
                                                                                     }, 'Parse::RecDescent::Rule' ),
                              'Unassigned_PostPDU' => bless( {
                                                               'calls' => [],
                                                               'name' => 'Unassigned_PostPDU',
                                                               'vars' => '',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'uncommit' => undef,
                                                                                     'line' => undef,
                                                                                     'patcount' => 1,
                                                                                     'dircount' => 0,
                                                                                     'error' => undef,
                                                                                     'strcount' => 0,
                                                                                     'number' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'description' => '/[\\\\x62-\\\\x6f]/',
                                                                                                           'rdelim' => '/',
                                                                                                           'line' => 226,
                                                                                                           'pattern' => '[\\x62-\\x6f]',
                                                                                                           'hashname' => '__PATTERN1__',
                                                                                                           'mod' => '',
                                                                                                           'ldelim' => '/',
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::Token' ),
                                                                                                  bless( {
                                                                                                           'line' => 226,
                                                                                                           'code' => '{ $return = $item[0]; 1; }',
                                                                                                           'hashname' => '__ACTION1__',
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ],
                                                                                     'actcount' => 1
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'opcount' => 0,
                                                               'line' => 226,
                                                               'impcount' => 0,
                                                               'changed' => 0
                                                             }, 'Parse::RecDescent::Rule' ),
                              'ERROR_MESSAGE_FORMAT_CORRUPT' => bless( {
                                                                         'calls' => [],
                                                                         'name' => 'ERROR_MESSAGE_FORMAT_CORRUPT',
                                                                         'vars' => '',
                                                                         'prods' => [
                                                                                      bless( {
                                                                                               'error' => undef,
                                                                                               'strcount' => 1,
                                                                                               'number' => 0,
                                                                                               'uncommit' => undef,
                                                                                               'patcount' => 0,
                                                                                               'line' => undef,
                                                                                               'dircount' => 0,
                                                                                               'items' => [
                                                                                                            bless( {
                                                                                                                     'lookahead' => 0,
                                                                                                                     'hashname' => '__STRING1__',
                                                                                                                     'pattern' => '\\x83',
                                                                                                                     'description' => '\'\\\\x83\'',
                                                                                                                     'line' => 785
                                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                                            bless( {
                                                                                                                     'line' => 785,
                                                                                                                     'code' => '{ $return = $item[0]; 1; }',
                                                                                                                     'hashname' => '__ACTION1__',
                                                                                                                     'lookahead' => 0
                                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                                          ],
                                                                                               'actcount' => 1
                                                                                             }, 'Parse::RecDescent::Production' )
                                                                                    ],
                                                                         'opcount' => 0,
                                                                         'line' => 785,
                                                                         'impcount' => 0,
                                                                         'changed' => 0
                                                                       }, 'Parse::RecDescent::Rule' ),
                              '_well_known_charset_wcode' => bless( {
                                                                      'vars' => '',
                                                                      'prods' => [
                                                                                   bless( {
                                                                                            'error' => undef,
                                                                                            'number' => 0,
                                                                                            'strcount' => 0,
                                                                                            'line' => undef,
                                                                                            'uncommit' => undef,
                                                                                            'patcount' => 0,
                                                                                            'dircount' => 0,
                                                                                            'items' => [
                                                                                                         bless( {
                                                                                                                  'matchrule' => 0,
                                                                                                                  'argcode' => undef,
                                                                                                                  'lookahead' => 0,
                                                                                                                  'subrule' => 'integer_value',
                                                                                                                  'line' => 485,
                                                                                                                  'implicit' => undef
                                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                                         bless( {
                                                                                                                  'code' => '{
   my %name_for = (
      0x07ea => \'big5\',
      0x03e8 => \'iso-10646-ucs-2\',
      0x04 => \'iso-8859-1\',
      0x05 => \'iso-8859-2\',
      0x06 => \'iso-8859-3\',
      0x07 => \'iso-8859-4\',
      0x08 => \'iso-8859-5\',
      0x09 => \'iso-8859-6\',
      0x0a => \'iso-8859-7\',
      0x0b => \'iso-8859-8\',
      0x0c => \'iso-8859-9\',
      0x11 => \'shift_JIS\',
      0x03 => \'us-ascii\',
      0x6a => \'utf-8\',
   );
   $return = $item[1];
   $return = $name_for{$return} if exists $name_for{$return};
   1;
}',
                                                                                                                  'hashname' => '__ACTION1__',
                                                                                                                  'line' => 485,
                                                                                                                  'lookahead' => 0
                                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                                       ],
                                                                                            'actcount' => 1
                                                                                          }, 'Parse::RecDescent::Production' )
                                                                                 ],
                                                                      'name' => '_well_known_charset_wcode',
                                                                      'calls' => [
                                                                                   'integer_value'
                                                                                 ],
                                                                      'changed' => 0,
                                                                      'impcount' => 0,
                                                                      'line' => 485,
                                                                      'opcount' => 0
                                                                    }, 'Parse::RecDescent::Rule' ),
                              'separator' => bless( {
                                                      'line' => 172,
                                                      'opcount' => 0,
                                                      'changed' => 0,
                                                      'impcount' => 0,
                                                      'name' => 'separator',
                                                      'calls' => [
                                                                   'RFC2616_QUOTE',
                                                                   'SP',
                                                                   'HT'
                                                                 ],
                                                      'vars' => '',
                                                      'prods' => [
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => '(',
                                                                                                  'line' => 172,
                                                                                                  'description' => '\'(\'',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 0,
                                                                            'error' => undef
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'dircount' => 0,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => 172,
                                                                            'strcount' => 1,
                                                                            'number' => 1,
                                                                            'error' => undef,
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'pattern' => ')',
                                                                                                  'description' => '\')\'',
                                                                                                  'line' => 172,
                                                                                                  'hashname' => '__STRING1__'
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => 172,
                                                                            'dircount' => 0,
                                                                            'error' => undef,
                                                                            'number' => 2,
                                                                            'strcount' => 1,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'line' => 172,
                                                                                                  'description' => '\'<\'',
                                                                                                  'pattern' => '<'
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'error' => undef,
                                                                            'number' => 3,
                                                                            'strcount' => 1,
                                                                            'patcount' => 0,
                                                                            'line' => 172,
                                                                            'uncommit' => undef,
                                                                            'dircount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => '>',
                                                                                                  'line' => 172,
                                                                                                  'description' => '\'>\'',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'strcount' => 1,
                                                                            'number' => 4,
                                                                            'error' => undef,
                                                                            'line' => 172,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'dircount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => '@',
                                                                                                  'line' => 172,
                                                                                                  'description' => '\'@\'',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => ',',
                                                                                                  'line' => 173,
                                                                                                  'description' => '\',\'',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => 173,
                                                                            'error' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 5
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'line' => 173,
                                                                                                  'description' => '\';\'',
                                                                                                  'pattern' => ';',
                                                                                                  'hashname' => '__STRING1__'
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => 173,
                                                                            'patcount' => 0,
                                                                            'dircount' => 0,
                                                                            'error' => undef,
                                                                            'number' => 6,
                                                                            'strcount' => 1
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'line' => 173,
                                                                                                  'description' => '\':\'',
                                                                                                  'pattern' => ':',
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'line' => 173,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'error' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 7
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'pattern' => '\\\\',
                                                                                                  'line' => 173,
                                                                                                  'description' => '\'\\\\\\\\\'',
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'line' => 173,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'error' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 8
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'subrule' => 'RFC2616_QUOTE',
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'lookahead' => 0,
                                                                                                  'line' => 173,
                                                                                                  'implicit' => undef
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ],
                                                                            'actcount' => 0,
                                                                            'strcount' => 0,
                                                                            'number' => 9,
                                                                            'error' => undef,
                                                                            'uncommit' => undef,
                                                                            'line' => 173,
                                                                            'patcount' => 0,
                                                                            'dircount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'line' => 174,
                                                                                                  'description' => '\'\\\\/\'',
                                                                                                  'pattern' => '\\/',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => 174,
                                                                            'error' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 10
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'uncommit' => undef,
                                                                            'line' => 174,
                                                                            'patcount' => 0,
                                                                            'dircount' => 0,
                                                                            'error' => undef,
                                                                            'number' => 11,
                                                                            'strcount' => 1,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'line' => 174,
                                                                                                  'description' => '\'[\'',
                                                                                                  'pattern' => '['
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'line' => 174,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'dircount' => 0,
                                                                            'error' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 12,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'pattern' => ']',
                                                                                                  'line' => 174,
                                                                                                  'description' => '\']\'',
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => '?',
                                                                                                  'line' => 174,
                                                                                                  'description' => '\'?\''
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'actcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => 174,
                                                                            'dircount' => 0,
                                                                            'error' => undef,
                                                                            'number' => 13,
                                                                            'strcount' => 1
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'pattern' => '=',
                                                                                                  'description' => '\'=\'',
                                                                                                  'line' => 174,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => 174,
                                                                            'error' => undef,
                                                                            'strcount' => 1,
                                                                            'number' => 14
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'strcount' => 1,
                                                                            'number' => 15,
                                                                            'error' => undef,
                                                                            'dircount' => 0,
                                                                            'line' => 175,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'line' => 175,
                                                                                                  'description' => '\'\\{\'',
                                                                                                  'pattern' => '{',
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'strcount' => 1,
                                                                            'number' => 16,
                                                                            'error' => undef,
                                                                            'dircount' => 0,
                                                                            'line' => 175,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => '}',
                                                                                                  'line' => 175,
                                                                                                  'description' => '\'\\}\''
                                                                                                }, 'Parse::RecDescent::InterpLit' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'error' => undef,
                                                                            'strcount' => 0,
                                                                            'number' => 17,
                                                                            'uncommit' => undef,
                                                                            'patcount' => 0,
                                                                            'line' => 175,
                                                                            'dircount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'line' => 175,
                                                                                                  'implicit' => undef,
                                                                                                  'subrule' => 'SP',
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ],
                                                                            'actcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'number' => 18,
                                                                            'strcount' => 0,
                                                                            'error' => undef,
                                                                            'dircount' => 0,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => 175,
                                                                            'actcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef,
                                                                                                  'subrule' => 'HT',
                                                                                                  'implicit' => undef,
                                                                                                  'line' => 175
                                                                                                }, 'Parse::RecDescent::Subrule' )
                                                                                       ]
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ]
                                                    }, 'Parse::RecDescent::Rule' ),
                              'LOALPHA' => bless( {
                                                    'prods' => [
                                                                 bless( {
                                                                          'actcount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'description' => '/[a-z]/',
                                                                                                'rdelim' => '/',
                                                                                                'pattern' => '[a-z]',
                                                                                                'line' => 149,
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'mod' => '',
                                                                                                'lookahead' => 0,
                                                                                                'ldelim' => '/'
                                                                                              }, 'Parse::RecDescent::Token' )
                                                                                     ],
                                                                          'dircount' => 0,
                                                                          'patcount' => 1,
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'error' => undef,
                                                                          'strcount' => 0,
                                                                          'number' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'vars' => '',
                                                    'calls' => [],
                                                    'name' => 'LOALPHA',
                                                    'impcount' => 0,
                                                    'changed' => 0,
                                                    'opcount' => 0,
                                                    'line' => 149
                                                  }, 'Parse::RecDescent::Rule' ),
                              'absolute_token' => bless( {
                                                           'changed' => 0,
                                                           'impcount' => 0,
                                                           'line' => 714,
                                                           'opcount' => 0,
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'error' => undef,
                                                                                 'strcount' => 1,
                                                                                 'number' => 0,
                                                                                 'dircount' => 0,
                                                                                 'line' => undef,
                                                                                 'uncommit' => undef,
                                                                                 'patcount' => 0,
                                                                                 'actcount' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'hashname' => '__STRING1__',
                                                                                                       'description' => '\'\\\\x80\'',
                                                                                                       'line' => 714,
                                                                                                       'pattern' => '\\x80'
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'line' => 714,
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'code' => '{ $return = \'absolute\'; 1; }'
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ]
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'name' => 'absolute_token',
                                                           'calls' => []
                                                         }, 'Parse::RecDescent::Rule' ),
                              'subject_head' => bless( {
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'line' => 678,
                                                         'opcount' => 0,
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'actcount' => 1,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'description' => '\'\\\\x96\'',
                                                                                                     'line' => 678,
                                                                                                     'pattern' => '\\x96',
                                                                                                     'hashname' => '__STRING1__'
                                                                                                   }, 'Parse::RecDescent::InterpLit' ),
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'matchrule' => 0,
                                                                                                     'subrule' => 'subject_value',
                                                                                                     'implicit' => undef,
                                                                                                     'line' => 678
                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                            bless( {
                                                                                                     'lookahead' => 0,
                                                                                                     'line' => 679,
                                                                                                     'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                     'hashname' => '__ACTION1__'
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ],
                                                                               'dircount' => 0,
                                                                               'uncommit' => undef,
                                                                               'line' => undef,
                                                                               'patcount' => 0,
                                                                               'strcount' => 1,
                                                                               'number' => 0,
                                                                               'error' => undef
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'name' => 'subject_head',
                                                         'calls' => [
                                                                      'subject_value'
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'expiry_value' => bless( {
                                                         'prods' => [
                                                                      bless( {
                                                                               'dircount' => 0,
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0,
                                                                               'error' => undef,
                                                                               'strcount' => 0,
                                                                               'number' => 0,
                                                                               'actcount' => 0,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'subrule' => '_mixed_time_value',
                                                                                                     'argcode' => undef,
                                                                                                     'matchrule' => 0,
                                                                                                     'lookahead' => 0,
                                                                                                     'line' => 733,
                                                                                                     'implicit' => undef
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ]
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'vars' => '',
                                                         'name' => 'expiry_value',
                                                         'calls' => [
                                                                      '_mixed_time_value'
                                                                    ],
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'line' => 733,
                                                         'opcount' => 0
                                                       }, 'Parse::RecDescent::Rule' ),
                              'media_type' => bless( {
                                                       'vars' => '',
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'line' => 473,
                                                                                                   'implicit' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => '_media_type'
                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                          bless( {
                                                                                                   'line' => 473,
                                                                                                   'code' => '{
   my $media_type = $item[1] || {};
   $return = $media_type->{text};
   defined($return);
}',
                                                                                                   'hashname' => '__ACTION1__',
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                        ],
                                                                             'actcount' => 1,
                                                                             'error' => undef,
                                                                             'number' => 0,
                                                                             'strcount' => 0,
                                                                             'patcount' => 0,
                                                                             'uncommit' => undef,
                                                                             'line' => undef,
                                                                             'dircount' => 0
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'name' => 'media_type',
                                                       'calls' => [
                                                                    '_media_type'
                                                                  ],
                                                       'changed' => 0,
                                                       'impcount' => 0,
                                                       'line' => 473,
                                                       'opcount' => 0
                                                     }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule_from_value' => bless( {
                                                                                              'vars' => '',
                                                                                              'prods' => [
                                                                                                           bless( {
                                                                                                                    'dircount' => 0,
                                                                                                                    'patcount' => 0,
                                                                                                                    'uncommit' => undef,
                                                                                                                    'line' => undef,
                                                                                                                    'number' => 0,
                                                                                                                    'strcount' => 0,
                                                                                                                    'error' => undef,
                                                                                                                    'actcount' => 0,
                                                                                                                    'items' => [
                                                                                                                                 bless( {
                                                                                                                                          'subrule' => '_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value',
                                                                                                                                          'argcode' => undef,
                                                                                                                                          'matchrule' => 0,
                                                                                                                                          'lookahead' => 0,
                                                                                                                                          'line' => 806,
                                                                                                                                          'implicit' => 'address_present_token'
                                                                                                                                        }, 'Parse::RecDescent::Subrule' )
                                                                                                                               ]
                                                                                                                  }, 'Parse::RecDescent::Production' ),
                                                                                                           bless( {
                                                                                                                    'error' => undef,
                                                                                                                    'strcount' => 0,
                                                                                                                    'number' => 1,
                                                                                                                    'dircount' => 0,
                                                                                                                    'patcount' => 0,
                                                                                                                    'uncommit' => undef,
                                                                                                                    'line' => 807,
                                                                                                                    'actcount' => 0,
                                                                                                                    'items' => [
                                                                                                                                 bless( {
                                                                                                                                          'implicit' => undef,
                                                                                                                                          'line' => 807,
                                                                                                                                          'subrule' => 'insert_address_token',
                                                                                                                                          'lookahead' => 0,
                                                                                                                                          'argcode' => undef,
                                                                                                                                          'matchrule' => 0
                                                                                                                                        }, 'Parse::RecDescent::Subrule' )
                                                                                                                               ]
                                                                                                                  }, 'Parse::RecDescent::Production' )
                                                                                                         ],
                                                                                              'calls' => [
                                                                                                           '_alternation_1_of_production_1_of_rule__alternation_1_of_production_1_of_rule_from_value',
                                                                                                           'insert_address_token'
                                                                                                         ],
                                                                                              'name' => '_alternation_1_of_production_1_of_rule_from_value',
                                                                                              'impcount' => 0,
                                                                                              'changed' => 0,
                                                                                              'opcount' => 0,
                                                                                              'line' => 806
                                                                                            }, 'Parse::RecDescent::Rule' ),
                              'm_send_conf' => bless( {
                                                        'calls' => [],
                                                        'name' => 'm_send_conf',
                                                        'vars' => '',
                                                        'prods' => [
                                                                     bless( {
                                                                              'actcount' => 1,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'hashname' => '__STRING1__',
                                                                                                    'pattern' => '\\x81',
                                                                                                    'description' => '\'\\\\x81\'',
                                                                                                    'line' => 756,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                           bless( {
                                                                                                    'code' => '{ $return = $item[0]; }',
                                                                                                    'hashname' => '__ACTION1__',
                                                                                                    'line' => 756,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'strcount' => 1,
                                                                              'number' => 0,
                                                                              'error' => undef,
                                                                              'dircount' => 0,
                                                                              'uncommit' => undef,
                                                                              'line' => undef,
                                                                              'patcount' => 0
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'opcount' => 0,
                                                        'line' => 756,
                                                        'impcount' => 0,
                                                        'changed' => 0
                                                      }, 'Parse::RecDescent::Rule' ),
                              'delivery_time_value' => bless( {
                                                                'vars' => '',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'implicit' => undef,
                                                                                                            'line' => 716,
                                                                                                            'lookahead' => 0,
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'subrule' => '_mixed_time_value'
                                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                                 ],
                                                                                      'actcount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'patcount' => 0,
                                                                                      'line' => undef,
                                                                                      'dircount' => 0,
                                                                                      'error' => undef,
                                                                                      'number' => 0,
                                                                                      'strcount' => 0
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ],
                                                                'name' => 'delivery_time_value',
                                                                'calls' => [
                                                                             '_mixed_time_value'
                                                                           ],
                                                                'changed' => 0,
                                                                'impcount' => 0,
                                                                'line' => 716,
                                                                'opcount' => 0
                                                              }, 'Parse::RecDescent::Rule' ),
                              'multipart_headers' => bless( {
                                                              'changed' => 0,
                                                              'impcount' => 0,
                                                              'line' => 527,
                                                              'opcount' => 0,
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'line' => 527,
                                                                                                          'implicit' => undef,
                                                                                                          'subrule' => 'content_type_value',
                                                                                                          'argcode' => undef,
                                                                                                          'matchrule' => 0,
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'code' => '{
   $return = {
      content_type => $item[1],
      other_headers => $text,
   };
   1;
}',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'line' => 527,
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1,
                                                                                    'patcount' => 0,
                                                                                    'uncommit' => undef,
                                                                                    'line' => undef,
                                                                                    'dircount' => 0,
                                                                                    'error' => undef,
                                                                                    'strcount' => 0,
                                                                                    'number' => 0
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'name' => 'multipart_headers',
                                                              'calls' => [
                                                                           'content_type_value'
                                                                         ]
                                                            }, 'Parse::RecDescent::Rule' ),
                              'class_identifier' => bless( {
                                                             'line' => 744,
                                                             'opcount' => 0,
                                                             'changed' => 0,
                                                             'impcount' => 0,
                                                             'name' => 'class_identifier',
                                                             'calls' => [
                                                                          'PERSONAL',
                                                                          'ADVERTISEMENT',
                                                                          'INFORMATIONAL',
                                                                          'AUTO'
                                                                        ],
                                                             'prods' => [
                                                                          bless( {
                                                                                   'line' => undef,
                                                                                   'patcount' => 0,
                                                                                   'uncommit' => undef,
                                                                                   'dircount' => 0,
                                                                                   'number' => 0,
                                                                                   'strcount' => 0,
                                                                                   'error' => undef,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'subrule' => 'PERSONAL',
                                                                                                         'lookahead' => 0,
                                                                                                         'matchrule' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'implicit' => undef,
                                                                                                         'line' => 744
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'actcount' => 0
                                                                                 }, 'Parse::RecDescent::Production' ),
                                                                          bless( {
                                                                                   'actcount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'line' => 744,
                                                                                                         'implicit' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'lookahead' => 0,
                                                                                                         'subrule' => 'ADVERTISEMENT'
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'error' => undef,
                                                                                   'number' => 1,
                                                                                   'strcount' => 0,
                                                                                   'dircount' => 0,
                                                                                   'line' => 744,
                                                                                   'uncommit' => undef,
                                                                                   'patcount' => 0
                                                                                 }, 'Parse::RecDescent::Production' ),
                                                                          bless( {
                                                                                   'strcount' => 0,
                                                                                   'number' => 2,
                                                                                   'error' => undef,
                                                                                   'dircount' => 0,
                                                                                   'uncommit' => undef,
                                                                                   'line' => 744,
                                                                                   'patcount' => 0,
                                                                                   'actcount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'subrule' => 'INFORMATIONAL',
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'lookahead' => 0,
                                                                                                         'line' => 744,
                                                                                                         'implicit' => undef
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ]
                                                                                 }, 'Parse::RecDescent::Production' ),
                                                                          bless( {
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'implicit' => undef,
                                                                                                         'line' => 744,
                                                                                                         'subrule' => 'AUTO',
                                                                                                         'lookahead' => 0,
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'actcount' => 0,
                                                                                   'number' => 3,
                                                                                   'strcount' => 0,
                                                                                   'error' => undef,
                                                                                   'patcount' => 0,
                                                                                   'uncommit' => undef,
                                                                                   'line' => 744,
                                                                                   'dircount' => 0
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'vars' => ''
                                                           }, 'Parse::RecDescent::Rule' ),
                              'message_id_value' => bless( {
                                                             'prods' => [
                                                                          bless( {
                                                                                   'actcount' => 0,
                                                                                   'items' => [
                                                                                                bless( {
                                                                                                         'argcode' => undef,
                                                                                                         'matchrule' => 0,
                                                                                                         'lookahead' => 0,
                                                                                                         'subrule' => 'text_string',
                                                                                                         'line' => 750,
                                                                                                         'implicit' => undef
                                                                                                       }, 'Parse::RecDescent::Subrule' )
                                                                                              ],
                                                                                   'dircount' => 0,
                                                                                   'line' => undef,
                                                                                   'uncommit' => undef,
                                                                                   'patcount' => 0,
                                                                                   'error' => undef,
                                                                                   'strcount' => 0,
                                                                                   'number' => 0
                                                                                 }, 'Parse::RecDescent::Production' )
                                                                        ],
                                                             'vars' => '',
                                                             'name' => 'message_id_value',
                                                             'calls' => [
                                                                          'text_string'
                                                                        ],
                                                             'changed' => 0,
                                                             'impcount' => 0,
                                                             'line' => 749,
                                                             'opcount' => 0
                                                           }, 'Parse::RecDescent::Rule' ),
                              'token' => bless( {
                                                  'calls' => [
                                                               '_alternation_1_of_production_1_of_rule_token'
                                                             ],
                                                  'name' => 'token',
                                                  'vars' => '',
                                                  'prods' => [
                                                               bless( {
                                                                        'actcount' => 1,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'max' => 100000000,
                                                                                              'matchrule' => 0,
                                                                                              'lookahead' => 0,
                                                                                              'min' => 1,
                                                                                              'line' => 176,
                                                                                              'subrule' => '_alternation_1_of_production_1_of_rule_token',
                                                                                              'argcode' => undef,
                                                                                              'repspec' => 's',
                                                                                              'expected' => 'CTL'
                                                                                            }, 'Parse::RecDescent::Repetition' ),
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'code' => '{
   $return = join \'\', @{$item[1]};
   1;
}',
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'line' => 176
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'number' => 0,
                                                                        'strcount' => 0,
                                                                        'dircount' => 0,
                                                                        'line' => undef,
                                                                        'uncommit' => undef,
                                                                        'patcount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'opcount' => 0,
                                                  'line' => 176,
                                                  'impcount' => 1,
                                                  'changed' => 0
                                                }, 'Parse::RecDescent::Rule' ),
                              'long_integer' => bless( {
                                                         'line' => 248,
                                                         'opcount' => 0,
                                                         'changed' => 0,
                                                         'impcount' => 0,
                                                         'name' => 'long_integer',
                                                         'calls' => [
                                                                      'short_length'
                                                                    ],
                                                         'prods' => [
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'line' => 249,
                                                                                                     'implicit' => undef,
                                                                                                     'subrule' => 'short_length',
                                                                                                     'matchrule' => 0,
                                                                                                     'argcode' => undef,
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::Subrule' ),
                                                                                            bless( {
                                                                                                     'line' => 249,
                                                                                                     'code' => '{
   my $len = $item{short_length};
   if ($len >= 1 && $len <= 30 && $len <= length $text) {
      $return = 0;
      my $chunk = substr $text, 0, $len;
      $text = substr $text, $len;
      for my $char ( split //, $chunk ) {
         $return = ($return << 8) | ord $char;
      }
      1;
   }
   else { undef; } # Reject
}',
                                                                                                     'hashname' => '__ACTION1__',
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ],
                                                                               'actcount' => 1,
                                                                               'strcount' => 0,
                                                                               'number' => 0,
                                                                               'error' => undef,
                                                                               'line' => undef,
                                                                               'uncommit' => undef,
                                                                               'patcount' => 0,
                                                                               'dircount' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'vars' => ''
                                                       }, 'Parse::RecDescent::Rule' ),
                              'ConfirmedPush' => bless( {
                                                          'prods' => [
                                                                       bless( {
                                                                                'dircount' => 0,
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'uncommit' => undef,
                                                                                'error' => undef,
                                                                                'strcount' => 1,
                                                                                'number' => 0,
                                                                                'actcount' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'pattern' => '\\x07',
                                                                                                      'line' => 213,
                                                                                                      'description' => '\'\\\\x07\'',
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                             bless( {
                                                                                                      'line' => 213,
                                                                                                      'code' => '{ $return = $item[0]; 1; }',
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ]
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => '',
                                                          'name' => 'ConfirmedPush',
                                                          'calls' => [],
                                                          'changed' => 0,
                                                          'impcount' => 0,
                                                          'line' => 213,
                                                          'opcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule_TEXT' => bless( {
                                                                                        'line' => 807,
                                                                                        'opcount' => 0,
                                                                                        'changed' => 0,
                                                                                        'impcount' => 0,
                                                                                        'name' => '_alternation_1_of_production_1_of_rule_TEXT',
                                                                                        'calls' => [
                                                                                                     '_non_CTL',
                                                                                                     'LWS'
                                                                                                   ],
                                                                                        'prods' => [
                                                                                                     bless( {
                                                                                                              'actcount' => 0,
                                                                                                              'items' => [
                                                                                                                           bless( {
                                                                                                                                    'lookahead' => 0,
                                                                                                                                    'matchrule' => 0,
                                                                                                                                    'argcode' => undef,
                                                                                                                                    'subrule' => '_non_CTL',
                                                                                                                                    'implicit' => undef,
                                                                                                                                    'line' => 807
                                                                                                                                  }, 'Parse::RecDescent::Subrule' )
                                                                                                                         ],
                                                                                                              'dircount' => 0,
                                                                                                              'uncommit' => undef,
                                                                                                              'patcount' => 0,
                                                                                                              'line' => undef,
                                                                                                              'strcount' => 0,
                                                                                                              'number' => 0,
                                                                                                              'error' => undef
                                                                                                            }, 'Parse::RecDescent::Production' ),
                                                                                                     bless( {
                                                                                                              'dircount' => 0,
                                                                                                              'patcount' => 0,
                                                                                                              'line' => 807,
                                                                                                              'uncommit' => undef,
                                                                                                              'number' => 1,
                                                                                                              'strcount' => 0,
                                                                                                              'error' => undef,
                                                                                                              'actcount' => 0,
                                                                                                              'items' => [
                                                                                                                           bless( {
                                                                                                                                    'subrule' => 'LWS',
                                                                                                                                    'argcode' => undef,
                                                                                                                                    'matchrule' => 0,
                                                                                                                                    'lookahead' => 0,
                                                                                                                                    'line' => 807,
                                                                                                                                    'implicit' => undef
                                                                                                                                  }, 'Parse::RecDescent::Subrule' )
                                                                                                                         ]
                                                                                                            }, 'Parse::RecDescent::Production' )
                                                                                                   ],
                                                                                        'vars' => ''
                                                                                      }, 'Parse::RecDescent::Rule' ),
                              'm_acknowledge_ind' => bless( {
                                                              'line' => 760,
                                                              'opcount' => 0,
                                                              'changed' => 0,
                                                              'impcount' => 0,
                                                              'name' => 'm_acknowledge_ind',
                                                              'calls' => [],
                                                              'prods' => [
                                                                           bless( {
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'dircount' => 0,
                                                                                    'number' => 0,
                                                                                    'strcount' => 1,
                                                                                    'error' => undef,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'line' => 760,
                                                                                                          'description' => '\'\\\\x85\'',
                                                                                                          'pattern' => '\\x85'
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 760,
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'code' => '{ $return = $item[0]; }'
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'vars' => ''
                                                            }, 'Parse::RecDescent::Rule' ),
                              'ADVERTISEMENT' => bless( {
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'pattern' => '\\x81',
                                                                                                      'description' => '\'\\\\x81\'',
                                                                                                      'line' => 746,
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                             bless( {
                                                                                                      'code' => '{ $return = $item[0]; 1; }',
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'line' => 746,
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'error' => undef,
                                                                                'number' => 0,
                                                                                'strcount' => 1,
                                                                                'dircount' => 0,
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'uncommit' => undef
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'name' => 'ADVERTISEMENT',
                                                          'calls' => [],
                                                          'changed' => 0,
                                                          'impcount' => 0,
                                                          'line' => 746,
                                                          'opcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'multipart_entry' => bless( {
                                                            'name' => 'multipart_entry',
                                                            'calls' => [
                                                                         'multipart_headers_len',
                                                                         'multipart_data_len'
                                                                       ],
                                                            'vars' => '',
                                                            'prods' => [
                                                                         bless( {
                                                                                  'strcount' => 0,
                                                                                  'number' => 0,
                                                                                  'error' => undef,
                                                                                  'dircount' => 0,
                                                                                  'patcount' => 0,
                                                                                  'uncommit' => undef,
                                                                                  'line' => undef,
                                                                                  'actcount' => 1,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'subrule' => 'multipart_headers_len',
                                                                                                        'lookahead' => 0,
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => undef,
                                                                                                        'implicit' => undef,
                                                                                                        'line' => 516
                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                               bless( {
                                                                                                        'subrule' => 'multipart_data_len',
                                                                                                        'argcode' => undef,
                                                                                                        'matchrule' => 0,
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 516,
                                                                                                        'implicit' => undef
                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 516,
                                                                                                        'code' => '{
   my ($hlen, $dlen) = @item[1,2];
   $return = {
      headers => $thisparser->multipart_headers(substr $text, 0, $hlen),
      data => substr($text, $hlen, $dlen),
   };
   $text = substr $text, $hlen + $dlen;
   1;
}',
                                                                                                        'hashname' => '__ACTION1__'
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'line' => 516,
                                                            'opcount' => 0,
                                                            'changed' => 0,
                                                            'impcount' => 0
                                                          }, 'Parse::RecDescent::Rule' ),
                              'sender_visibility_head' => bless( {
                                                                   'changed' => 0,
                                                                   'impcount' => 0,
                                                                   'line' => 674,
                                                                   'opcount' => 0,
                                                                   'prods' => [
                                                                                bless( {
                                                                                         'error' => undef,
                                                                                         'number' => 0,
                                                                                         'strcount' => 1,
                                                                                         'uncommit' => undef,
                                                                                         'patcount' => 0,
                                                                                         'line' => undef,
                                                                                         'dircount' => 0,
                                                                                         'items' => [
                                                                                                      bless( {
                                                                                                               'hashname' => '__STRING1__',
                                                                                                               'line' => 674,
                                                                                                               'description' => '\'\\\\x94\'',
                                                                                                               'pattern' => '\\x94',
                                                                                                               'lookahead' => 0
                                                                                                             }, 'Parse::RecDescent::InterpLit' ),
                                                                                                      bless( {
                                                                                                               'subrule' => 'sender_visibility_value',
                                                                                                               'argcode' => undef,
                                                                                                               'matchrule' => 0,
                                                                                                               'lookahead' => 0,
                                                                                                               'line' => 674,
                                                                                                               'implicit' => undef
                                                                                                             }, 'Parse::RecDescent::Subrule' ),
                                                                                                      bless( {
                                                                                                               'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                               'hashname' => '__ACTION1__',
                                                                                                               'line' => 675,
                                                                                                               'lookahead' => 0
                                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                                    ],
                                                                                         'actcount' => 1
                                                                                       }, 'Parse::RecDescent::Production' )
                                                                              ],
                                                                   'vars' => '',
                                                                   'name' => 'sender_visibility_head',
                                                                   'calls' => [
                                                                                'sender_visibility_value'
                                                                              ]
                                                                 }, 'Parse::RecDescent::Rule' ),
                              'type_parameter' => bless( {
                                                           'line' => 375,
                                                           'opcount' => 0,
                                                           'changed' => 0,
                                                           'impcount' => 0,
                                                           'name' => 'type_parameter',
                                                           'calls' => [
                                                                        'integer_value'
                                                                      ],
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'actcount' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'hashname' => '__STRING1__',
                                                                                                       'description' => '\'\\\\x83\'',
                                                                                                       'line' => 375,
                                                                                                       'pattern' => '\\x83',
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => undef,
                                                                                                       'lookahead' => 0,
                                                                                                       'subrule' => 'integer_value',
                                                                                                       'line' => 375,
                                                                                                       'implicit' => undef
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'line' => 376
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ],
                                                                                 'number' => 0,
                                                                                 'strcount' => 1,
                                                                                 'error' => undef,
                                                                                 'dircount' => 0,
                                                                                 'patcount' => 0,
                                                                                 'line' => undef,
                                                                                 'uncommit' => undef
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ]
                                                         }, 'Parse::RecDescent::Rule' ),
                              'compact_value' => bless( {
                                                          'vars' => '',
                                                          'prods' => [
                                                                       bless( {
                                                                                'error' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 0,
                                                                                'dircount' => 0,
                                                                                'line' => undef,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'line' => 430,
                                                                                                      'implicit' => undef,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => 'integer_value'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ]
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'line' => 431,
                                                                                'patcount' => 0,
                                                                                'uncommit' => undef,
                                                                                'dircount' => 0,
                                                                                'error' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 431,
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'subrule' => 'date_value'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'actcount' => 0
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 431,
                                                                                                      'lookahead' => 0,
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'subrule' => 'delta_seconds_value'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'dircount' => 0,
                                                                                'uncommit' => undef,
                                                                                'line' => 431,
                                                                                'patcount' => 0,
                                                                                'error' => undef,
                                                                                'strcount' => 0,
                                                                                'number' => 2
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'dircount' => 0,
                                                                                'line' => 431,
                                                                                'uncommit' => undef,
                                                                                'patcount' => 0,
                                                                                'strcount' => 0,
                                                                                'number' => 3,
                                                                                'error' => undef,
                                                                                'actcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'line' => 431,
                                                                                                      'implicit' => undef,
                                                                                                      'subrule' => 'q_value',
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ]
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'patcount' => 0,
                                                                                'line' => 431,
                                                                                'uncommit' => undef,
                                                                                'dircount' => 0,
                                                                                'error' => undef,
                                                                                'number' => 4,
                                                                                'strcount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'subrule' => 'version_value',
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 431
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'actcount' => 0
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'strcount' => 0,
                                                                                'number' => 5,
                                                                                'error' => undef,
                                                                                'line' => 432,
                                                                                'patcount' => 0,
                                                                                'uncommit' => undef,
                                                                                'dircount' => 0,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 432,
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'subrule' => 'uri_value'
                                                                                                    }, 'Parse::RecDescent::Subrule' )
                                                                                           ],
                                                                                'actcount' => 0
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'calls' => [
                                                                       'integer_value',
                                                                       'date_value',
                                                                       'delta_seconds_value',
                                                                       'q_value',
                                                                       'version_value',
                                                                       'uri_value'
                                                                     ],
                                                          'name' => 'compact_value',
                                                          'impcount' => 0,
                                                          'changed' => 0,
                                                          'opcount' => 0,
                                                          'line' => 429
                                                        }, 'Parse::RecDescent::Rule' ),
                              'header' => bless( {
                                                   'prods' => [
                                                                bless( {
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'implicit' => undef,
                                                                                               'line' => 608,
                                                                                               'subrule' => 'MMS_header',
                                                                                               'lookahead' => 0,
                                                                                               'argcode' => undef,
                                                                                               'matchrule' => 0
                                                                                             }, 'Parse::RecDescent::Subrule' )
                                                                                    ],
                                                                         'actcount' => 0,
                                                                         'number' => 0,
                                                                         'strcount' => 0,
                                                                         'error' => undef,
                                                                         'patcount' => 0,
                                                                         'uncommit' => undef,
                                                                         'line' => undef,
                                                                         'dircount' => 0
                                                                       }, 'Parse::RecDescent::Production' ),
                                                                bless( {
                                                                         'actcount' => 0,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'subrule' => 'application_header',
                                                                                               'lookahead' => 0,
                                                                                               'argcode' => undef,
                                                                                               'matchrule' => 0,
                                                                                               'implicit' => undef,
                                                                                               'line' => 608
                                                                                             }, 'Parse::RecDescent::Subrule' )
                                                                                    ],
                                                                         'dircount' => 0,
                                                                         'patcount' => 0,
                                                                         'uncommit' => undef,
                                                                         'line' => 608,
                                                                         'error' => undef,
                                                                         'number' => 1,
                                                                         'strcount' => 0
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ],
                                                   'vars' => '',
                                                   'calls' => [
                                                                'MMS_header',
                                                                'application_header'
                                                              ],
                                                   'name' => 'header',
                                                   'impcount' => 0,
                                                   'changed' => 0,
                                                   'opcount' => 0,
                                                   'line' => 607
                                                 }, 'Parse::RecDescent::Rule' ),
                              'constrained_encoding' => bless( {
                                                                 'impcount' => 0,
                                                                 'changed' => 0,
                                                                 'opcount' => 0,
                                                                 'line' => 266,
                                                                 'vars' => '',
                                                                 'prods' => [
                                                                              bless( {
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'subrule' => 'extension_media',
                                                                                                             'argcode' => undef,
                                                                                                             'matchrule' => 0,
                                                                                                             'lookahead' => 0,
                                                                                                             'line' => 267,
                                                                                                             'implicit' => undef
                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                  ],
                                                                                       'actcount' => 0,
                                                                                       'error' => undef,
                                                                                       'strcount' => 0,
                                                                                       'number' => 0,
                                                                                       'line' => undef,
                                                                                       'uncommit' => undef,
                                                                                       'patcount' => 0,
                                                                                       'dircount' => 0
                                                                                     }, 'Parse::RecDescent::Production' ),
                                                                              bless( {
                                                                                       'actcount' => 0,
                                                                                       'items' => [
                                                                                                    bless( {
                                                                                                             'subrule' => 'short_integer',
                                                                                                             'argcode' => undef,
                                                                                                             'matchrule' => 0,
                                                                                                             'lookahead' => 0,
                                                                                                             'line' => 267,
                                                                                                             'implicit' => undef
                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                  ],
                                                                                       'dircount' => 0,
                                                                                       'line' => 267,
                                                                                       'patcount' => 0,
                                                                                       'uncommit' => undef,
                                                                                       'number' => 1,
                                                                                       'strcount' => 0,
                                                                                       'error' => undef
                                                                                     }, 'Parse::RecDescent::Production' )
                                                                            ],
                                                                 'calls' => [
                                                                              'extension_media',
                                                                              'short_integer'
                                                                            ],
                                                                 'name' => 'constrained_encoding'
                                                               }, 'Parse::RecDescent::Rule' ),
                              'read_date_parameter' => bless( {
                                                                'line' => 409,
                                                                'opcount' => 0,
                                                                'changed' => 0,
                                                                'impcount' => 0,
                                                                'name' => 'read_date_parameter',
                                                                'calls' => [
                                                                             'date_value'
                                                                           ],
                                                                'vars' => '',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'lookahead' => 0,
                                                                                                            'hashname' => '__STRING1__',
                                                                                                            'pattern' => '\\x95',
                                                                                                            'line' => 409,
                                                                                                            'description' => '\'\\\\x95\''
                                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                                   bless( {
                                                                                                            'subrule' => 'date_value',
                                                                                                            'lookahead' => 0,
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'implicit' => undef,
                                                                                                            'line' => 409
                                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                                   bless( {
                                                                                                            'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                            'hashname' => '__ACTION1__',
                                                                                                            'line' => 410,
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                                 ],
                                                                                      'actcount' => 1,
                                                                                      'line' => undef,
                                                                                      'uncommit' => undef,
                                                                                      'patcount' => 0,
                                                                                      'dircount' => 0,
                                                                                      'number' => 0,
                                                                                      'strcount' => 1,
                                                                                      'error' => undef
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ]
                                                              }, 'Parse::RecDescent::Rule' ),
                              'OCTET' => bless( {
                                                  'vars' => '',
                                                  'prods' => [
                                                               bless( {
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'mod' => '',
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'line' => 146,
                                                                                              'pattern' => '[\\x00-\\xFF]',
                                                                                              'ldelim' => '/',
                                                                                              'lookahead' => 0,
                                                                                              'description' => '/[\\\\x00-\\\\xFF]/',
                                                                                              'rdelim' => '/'
                                                                                            }, 'Parse::RecDescent::Token' )
                                                                                   ],
                                                                        'actcount' => 0,
                                                                        'strcount' => 0,
                                                                        'number' => 0,
                                                                        'error' => undef,
                                                                        'uncommit' => undef,
                                                                        'line' => undef,
                                                                        'patcount' => 1,
                                                                        'dircount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'calls' => [],
                                                  'name' => 'OCTET',
                                                  'impcount' => 0,
                                                  'changed' => 0,
                                                  'opcount' => 0,
                                                  'line' => 145
                                                }, 'Parse::RecDescent::Rule' ),
                              'quoted_string' => bless( {
                                                          'line' => 236,
                                                          'opcount' => 0,
                                                          'changed' => 0,
                                                          'impcount' => 0,
                                                          'name' => 'quoted_string',
                                                          'calls' => [
                                                                       'TEXT',
                                                                       'end_of_string'
                                                                     ],
                                                          'prods' => [
                                                                       bless( {
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'line' => 237,
                                                                                                      'description' => '\'\\\\x22\'',
                                                                                                      'pattern' => '\\x22'
                                                                                                    }, 'Parse::RecDescent::InterpLit' ),
                                                                                             bless( {
                                                                                                      'max' => 1,
                                                                                                      'matchrule' => 0,
                                                                                                      'lookahead' => 0,
                                                                                                      'min' => 0,
                                                                                                      'line' => 237,
                                                                                                      'subrule' => 'TEXT',
                                                                                                      'argcode' => undef,
                                                                                                      'repspec' => '?',
                                                                                                      'expected' => undef
                                                                                                    }, 'Parse::RecDescent::Repetition' ),
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 237,
                                                                                                      'subrule' => 'end_of_string',
                                                                                                      'lookahead' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 237,
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'code' => '{
   $return = scalar @{$item[2]} ? $item[2][0] : \'\';
   1; 
}'
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'actcount' => 1,
                                                                                'uncommit' => undef,
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'dircount' => 0,
                                                                                'strcount' => 1,
                                                                                'number' => 0,
                                                                                'error' => undef
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => ''
                                                        }, 'Parse::RecDescent::Rule' ),
                              'm_delivery_ind' => bless( {
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'line' => 761,
                                                                                                       'description' => '\'\\\\x86\'',
                                                                                                       'pattern' => '\\x86',
                                                                                                       'hashname' => '__STRING1__',
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'code' => '{ $return = $item[0]; }',
                                                                                                       'line' => 761,
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ],
                                                                                 'actcount' => 1,
                                                                                 'line' => undef,
                                                                                 'uncommit' => undef,
                                                                                 'patcount' => 0,
                                                                                 'dircount' => 0,
                                                                                 'error' => undef,
                                                                                 'number' => 0,
                                                                                 'strcount' => 1
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'calls' => [],
                                                           'name' => 'm_delivery_ind',
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'opcount' => 0,
                                                           'line' => 761
                                                         }, 'Parse::RecDescent::Rule' ),
                              'Post' => bless( {
                                                 'opcount' => 0,
                                                 'line' => 224,
                                                 'impcount' => 0,
                                                 'changed' => 0,
                                                 'calls' => [],
                                                 'name' => 'Post',
                                                 'prods' => [
                                                              bless( {
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'hashname' => '__STRING1__',
                                                                                             'pattern' => '\\x60',
                                                                                             'line' => 224,
                                                                                             'description' => '\'\\\\x60\'',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 224,
                                                                                             'code' => '{ $return = $item[0]; 1; }',
                                                                                             'hashname' => '__ACTION1__'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'actcount' => 1,
                                                                       'patcount' => 0,
                                                                       'uncommit' => undef,
                                                                       'line' => undef,
                                                                       'dircount' => 0,
                                                                       'error' => undef,
                                                                       'strcount' => 1,
                                                                       'number' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'vars' => ''
                                               }, 'Parse::RecDescent::Rule' ),
                              'M_Send_Req_message' => bless( {
                                                               'opcount' => 0,
                                                               'line' => 534,
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'calls' => [
                                                                            'message_type_head_code',
                                                                            'm_send_req',
                                                                            'transaction_id_head',
                                                                            'MMS_version_head',
                                                                            'header',
                                                                            'content_type_head',
                                                                            'multipart'
                                                                          ],
                                                               'name' => 'M_Send_Req_message',
                                                               'vars' => '',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'line' => 534,
                                                                                                           'implicit' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'subrule' => 'message_type_head_code'
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 534,
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'subrule' => 'm_send_req'
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 535,
                                                                                                           'subrule' => 'transaction_id_head',
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'subrule' => 'MMS_version_head',
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 536,
                                                                                                           'implicit' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'subrule' => 'header',
                                                                                                           'argcode' => undef,
                                                                                                           'repspec' => 's?',
                                                                                                           'expected' => undef,
                                                                                                           'max' => 100000000,
                                                                                                           'lookahead' => 0,
                                                                                                           'matchrule' => 0,
                                                                                                           'min' => 0,
                                                                                                           'line' => 537
                                                                                                         }, 'Parse::RecDescent::Repetition' ),
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 538,
                                                                                                           'subrule' => 'content_type_head',
                                                                                                           'lookahead' => 0,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'subrule' => 'multipart',
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'line' => 539,
                                                                                                           'implicit' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'line' => 539,
                                                                                                           'code' => '{
   my %headers;
   $headers{message_type_head} = \'m_send_req\';
   foreach my $header (@item[4,6], $item[3], @{$item[5]}) {
      my ($name, $value) = @$header;
      $headers{$name} = $value;
   }
   $return = {
      headers => \\%headers,
      body    => $item{multipart},
   };
   1;
}',
                                                                                                           'hashname' => '__ACTION1__',
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ],
                                                                                     'actcount' => 1,
                                                                                     'error' => undef,
                                                                                     'strcount' => 0,
                                                                                     'number' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => undef,
                                                                                     'patcount' => 0,
                                                                                     'dircount' => 0
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ]
                                                             }, 'Parse::RecDescent::Rule' ),
                              'message_class_head' => bless( {
                                                               'prods' => [
                                                                            bless( {
                                                                                     'error' => undef,
                                                                                     'strcount' => 1,
                                                                                     'number' => 0,
                                                                                     'patcount' => 0,
                                                                                     'uncommit' => undef,
                                                                                     'line' => undef,
                                                                                     'dircount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'hashname' => '__STRING1__',
                                                                                                           'pattern' => '\\x8a',
                                                                                                           'line' => 653,
                                                                                                           'description' => '\'\\\\x8a\'',
                                                                                                           'lookahead' => 0
                                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                                  bless( {
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'lookahead' => 0,
                                                                                                           'subrule' => 'message_class_value',
                                                                                                           'line' => 653,
                                                                                                           'implicit' => undef
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'lookahead' => 0,
                                                                                                           'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                           'hashname' => '__ACTION1__',
                                                                                                           'line' => 654
                                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                                ],
                                                                                     'actcount' => 1
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'vars' => '',
                                                               'calls' => [
                                                                            'message_class_value'
                                                                          ],
                                                               'name' => 'message_class_head',
                                                               'impcount' => 0,
                                                               'changed' => 0,
                                                               'opcount' => 0,
                                                               'line' => 653
                                                             }, 'Parse::RecDescent::Rule' ),
                              'application_header' => bless( {
                                                               'vars' => '',
                                                               'prods' => [
                                                                            bless( {
                                                                                     'error' => undef,
                                                                                     'number' => 0,
                                                                                     'strcount' => 0,
                                                                                     'dircount' => 0,
                                                                                     'patcount' => 0,
                                                                                     'line' => undef,
                                                                                     'uncommit' => undef,
                                                                                     'actcount' => 0,
                                                                                     'items' => [
                                                                                                  bless( {
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 609,
                                                                                                           'lookahead' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'matchrule' => 0,
                                                                                                           'subrule' => 'token_text'
                                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                                  bless( {
                                                                                                           'subrule' => 'application_specific_value',
                                                                                                           'lookahead' => 0,
                                                                                                           'matchrule' => 0,
                                                                                                           'argcode' => undef,
                                                                                                           'implicit' => undef,
                                                                                                           'line' => 609
                                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                                ]
                                                                                   }, 'Parse::RecDescent::Production' )
                                                                          ],
                                                               'name' => 'application_header',
                                                               'calls' => [
                                                                            'token_text',
                                                                            'application_specific_value'
                                                                          ],
                                                               'changed' => 0,
                                                               'impcount' => 0,
                                                               'line' => 609,
                                                               'opcount' => 0
                                                             }, 'Parse::RecDescent::Rule' ),
                              'date_head' => bless( {
                                                      'vars' => '',
                                                      'prods' => [
                                                                   bless( {
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'pattern' => '\\x85',
                                                                                                  'description' => '\'\\\\x85\'',
                                                                                                  'line' => 643,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::InterpLit' ),
                                                                                         bless( {
                                                                                                  'implicit' => undef,
                                                                                                  'line' => 643,
                                                                                                  'subrule' => 'date_value',
                                                                                                  'lookahead' => 0,
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => undef
                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__ACTION1__',
                                                                                                  'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                  'line' => 644
                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                       ],
                                                                            'actcount' => 1,
                                                                            'line' => undef,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'dircount' => 0,
                                                                            'error' => undef,
                                                                            'number' => 0,
                                                                            'strcount' => 1
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'name' => 'date_head',
                                                      'calls' => [
                                                                   'date_value'
                                                                 ],
                                                      'changed' => 0,
                                                      'impcount' => 0,
                                                      'line' => 643,
                                                      'opcount' => 0
                                                    }, 'Parse::RecDescent::Rule' ),
                              'Unassigned_GetPDU' => bless( {
                                                              'name' => 'Unassigned_GetPDU',
                                                              'calls' => [],
                                                              'vars' => '',
                                                              'prods' => [
                                                                           bless( {
                                                                                    'strcount' => 0,
                                                                                    'number' => 0,
                                                                                    'error' => undef,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 1,
                                                                                    'dircount' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'pattern' => '[\\x45-\\x4f]',
                                                                                                          'line' => 222,
                                                                                                          'mod' => '',
                                                                                                          'hashname' => '__PATTERN1__',
                                                                                                          'lookahead' => 0,
                                                                                                          'ldelim' => '/',
                                                                                                          'description' => '/[\\\\x45-\\\\x4f]/',
                                                                                                          'rdelim' => '/'
                                                                                                        }, 'Parse::RecDescent::Token' ),
                                                                                                 bless( {
                                                                                                          'line' => 222,
                                                                                                          'code' => '{ $return = $item[0]; 1; }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'line' => 222,
                                                              'opcount' => 0,
                                                              'changed' => 0,
                                                              'impcount' => 0
                                                            }, 'Parse::RecDescent::Rule' ),
                              'Options_GetPDU' => bless( {
                                                           'opcount' => 0,
                                                           'line' => 218,
                                                           'impcount' => 0,
                                                           'changed' => 0,
                                                           'calls' => [],
                                                           'name' => 'Options_GetPDU',
                                                           'vars' => '',
                                                           'prods' => [
                                                                        bless( {
                                                                                 'strcount' => 1,
                                                                                 'number' => 0,
                                                                                 'error' => undef,
                                                                                 'dircount' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'line' => undef,
                                                                                 'patcount' => 0,
                                                                                 'actcount' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'hashname' => '__STRING1__',
                                                                                                       'description' => '\'\\\\x41\'',
                                                                                                       'line' => 218,
                                                                                                       'pattern' => '\\x41',
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::InterpLit' ),
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'code' => '{ $return = $item[0]; 1; }',
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'line' => 218
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ]
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ]
                                                         }, 'Parse::RecDescent::Rule' ),
                              'SEC_wbxml_parameter' => bless( {
                                                                'opcount' => 0,
                                                                'line' => 401,
                                                                'impcount' => 0,
                                                                'changed' => 0,
                                                                'calls' => [
                                                                             'short_integer'
                                                                           ],
                                                                'name' => 'SEC_wbxml_parameter',
                                                                'vars' => '',
                                                                'prods' => [
                                                                             bless( {
                                                                                      'error' => undef,
                                                                                      'number' => 0,
                                                                                      'strcount' => 1,
                                                                                      'dircount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'line' => undef,
                                                                                      'patcount' => 0,
                                                                                      'actcount' => 1,
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'description' => '\'\\\\x91\'',
                                                                                                            'line' => 401,
                                                                                                            'pattern' => '\\x91',
                                                                                                            'hashname' => '__STRING1__',
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                                   bless( {
                                                                                                            'argcode' => undef,
                                                                                                            'matchrule' => 0,
                                                                                                            'lookahead' => 0,
                                                                                                            'subrule' => 'short_integer',
                                                                                                            'line' => 401,
                                                                                                            'implicit' => undef
                                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                                   bless( {
                                                                                                            'line' => 402,
                                                                                                            'code' => '{ $return = build_parameter(@item, \'1.4\'); 1; }',
                                                                                                            'hashname' => '__ACTION1__',
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                                 ]
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ]
                                                              }, 'Parse::RecDescent::Rule' ),
                              'transaction_id_head' => bless( {
                                                                'name' => 'transaction_id_head',
                                                                'calls' => [
                                                                             'transaction_id_value'
                                                                           ],
                                                                'prods' => [
                                                                             bless( {
                                                                                      'items' => [
                                                                                                   bless( {
                                                                                                            'lookahead' => 0,
                                                                                                            'hashname' => '__STRING1__',
                                                                                                            'pattern' => '\\x98',
                                                                                                            'line' => 682,
                                                                                                            'description' => '\'\\\\x98\''
                                                                                                          }, 'Parse::RecDescent::InterpLit' ),
                                                                                                   bless( {
                                                                                                            'line' => 682,
                                                                                                            'implicit' => undef,
                                                                                                            'matchrule' => 0,
                                                                                                            'argcode' => undef,
                                                                                                            'lookahead' => 0,
                                                                                                            'subrule' => 'transaction_id_value'
                                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                                   bless( {
                                                                                                            'hashname' => '__ACTION1__',
                                                                                                            'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                            'line' => 683,
                                                                                                            'lookahead' => 0
                                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                                 ],
                                                                                      'actcount' => 1,
                                                                                      'patcount' => 0,
                                                                                      'uncommit' => undef,
                                                                                      'line' => undef,
                                                                                      'dircount' => 0,
                                                                                      'number' => 0,
                                                                                      'strcount' => 1,
                                                                                      'error' => undef
                                                                                    }, 'Parse::RecDescent::Production' )
                                                                           ],
                                                                'vars' => '',
                                                                'line' => 682,
                                                                'opcount' => 0,
                                                                'changed' => 0,
                                                                'impcount' => 0
                                                              }, 'Parse::RecDescent::Rule' ),
                              'typed_value' => bless( {
                                                        'prods' => [
                                                                     bless( {
                                                                              'dircount' => 0,
                                                                              'uncommit' => undef,
                                                                              'patcount' => 0,
                                                                              'line' => undef,
                                                                              'error' => undef,
                                                                              'strcount' => 0,
                                                                              'number' => 0,
                                                                              'actcount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'implicit' => undef,
                                                                                                    'line' => 428,
                                                                                                    'subrule' => 'compact_value',
                                                                                                    'lookahead' => 0,
                                                                                                    'matchrule' => 0,
                                                                                                    'argcode' => undef
                                                                                                  }, 'Parse::RecDescent::Subrule' )
                                                                                         ]
                                                                            }, 'Parse::RecDescent::Production' ),
                                                                     bless( {
                                                                              'number' => 1,
                                                                              'strcount' => 0,
                                                                              'error' => undef,
                                                                              'uncommit' => undef,
                                                                              'line' => 428,
                                                                              'patcount' => 0,
                                                                              'dircount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'line' => 428,
                                                                                                    'implicit' => undef,
                                                                                                    'subrule' => 'text_value',
                                                                                                    'matchrule' => 0,
                                                                                                    'argcode' => undef,
                                                                                                    'lookahead' => 0
                                                                                                  }, 'Parse::RecDescent::Subrule' )
                                                                                         ],
                                                                              'actcount' => 0
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'vars' => '',
                                                        'calls' => [
                                                                     'compact_value',
                                                                     'text_value'
                                                                   ],
                                                        'name' => 'typed_value',
                                                        'impcount' => 0,
                                                        'changed' => 0,
                                                        'opcount' => 0,
                                                        'line' => 427
                                                      }, 'Parse::RecDescent::Rule' ),
                              'token_text' => bless( {
                                                       'opcount' => 0,
                                                       'line' => 234,
                                                       'impcount' => 0,
                                                       'changed' => 0,
                                                       'calls' => [
                                                                    'token',
                                                                    'end_of_string'
                                                                  ],
                                                       'name' => 'token_text',
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'subrule' => 'token',
                                                                                                   'lookahead' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'matchrule' => 0,
                                                                                                   'implicit' => undef,
                                                                                                   'line' => 235
                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                          bless( {
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'subrule' => 'end_of_string',
                                                                                                   'line' => 235,
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' ),
                                                                                          bless( {
                                                                                                   'hashname' => '__ACTION1__',
                                                                                                   'code' => '{ $return = $item{token}; 1; }',
                                                                                                   'line' => 235,
                                                                                                   'lookahead' => 0
                                                                                                 }, 'Parse::RecDescent::Action' )
                                                                                        ],
                                                                             'actcount' => 1,
                                                                             'line' => undef,
                                                                             'uncommit' => undef,
                                                                             'patcount' => 0,
                                                                             'dircount' => 0,
                                                                             'number' => 0,
                                                                             'strcount' => 0,
                                                                             'error' => undef
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ],
                                                       'vars' => ''
                                                     }, 'Parse::RecDescent::Rule' ),
                              'NO' => bless( {
                                               'line' => 707,
                                               'opcount' => 0,
                                               'changed' => 0,
                                               'impcount' => 0,
                                               'name' => 'NO',
                                               'calls' => [],
                                               'vars' => '',
                                               'prods' => [
                                                            bless( {
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'line' => 707,
                                                                                           'description' => '\'\\\\x81\'',
                                                                                           'pattern' => '\\x81',
                                                                                           'hashname' => '__STRING1__'
                                                                                         }, 'Parse::RecDescent::InterpLit' ),
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'code' => '{ $return = $item[0]; 1; }',
                                                                                           'line' => 707
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'actcount' => 1,
                                                                     'uncommit' => undef,
                                                                     'patcount' => 0,
                                                                     'line' => undef,
                                                                     'dircount' => 0,
                                                                     'number' => 0,
                                                                     'strcount' => 1,
                                                                     'error' => undef
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ]
                                             }, 'Parse::RecDescent::Rule' ),
                              'domain_deprecated_parameter' => bless( {
                                                                        'impcount' => 0,
                                                                        'changed' => 0,
                                                                        'opcount' => 0,
                                                                        'line' => 393,
                                                                        'prods' => [
                                                                                     bless( {
                                                                                              'actcount' => 1,
                                                                                              'items' => [
                                                                                                           bless( {
                                                                                                                    'lookahead' => 0,
                                                                                                                    'hashname' => '__STRING1__',
                                                                                                                    'line' => 393,
                                                                                                                    'description' => '\'\\\\x8d\'',
                                                                                                                    'pattern' => '\\x8d'
                                                                                                                  }, 'Parse::RecDescent::InterpLit' ),
                                                                                                           bless( {
                                                                                                                    'implicit' => undef,
                                                                                                                    'line' => 393,
                                                                                                                    'lookahead' => 0,
                                                                                                                    'matchrule' => 0,
                                                                                                                    'argcode' => undef,
                                                                                                                    'subrule' => 'text_string'
                                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                                           bless( {
                                                                                                                    'line' => 394,
                                                                                                                    'hashname' => '__ACTION1__',
                                                                                                                    'code' => '{ $return = build_parameter(@item, \'1.3\'); 1; }',
                                                                                                                    'lookahead' => 0
                                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                                         ],
                                                                                              'dircount' => 0,
                                                                                              'line' => undef,
                                                                                              'patcount' => 0,
                                                                                              'uncommit' => undef,
                                                                                              'strcount' => 1,
                                                                                              'number' => 0,
                                                                                              'error' => undef
                                                                                            }, 'Parse::RecDescent::Production' )
                                                                                   ],
                                                                        'vars' => '',
                                                                        'calls' => [
                                                                                     'text_string'
                                                                                   ],
                                                                        'name' => 'domain_deprecated_parameter'
                                                                      }, 'Parse::RecDescent::Rule' ),
                              'uint32' => bless( {
                                                   'calls' => [
                                                                'OCTET'
                                                              ],
                                                   'name' => 'uint32',
                                                   'prods' => [
                                                                bless( {
                                                                         'actcount' => 1,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'subrule' => 'OCTET',
                                                                                               'argcode' => undef,
                                                                                               'repspec' => '4',
                                                                                               'expected' => undef,
                                                                                               'max' => 4,
                                                                                               'matchrule' => 0,
                                                                                               'lookahead' => 0,
                                                                                               'min' => 4,
                                                                                               'line' => 187
                                                                                             }, 'Parse::RecDescent::Repetition' ),
                                                                                      bless( {
                                                                                               'line' => 187,
                                                                                               'hashname' => '__ACTION1__',
                                                                                               'code' => '{ $return = unpack \'N\', join \'\', @{$item[1]}; 1; }',
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                    ],
                                                                         'number' => 0,
                                                                         'strcount' => 0,
                                                                         'error' => undef,
                                                                         'dircount' => 0,
                                                                         'line' => undef,
                                                                         'patcount' => 0,
                                                                         'uncommit' => undef
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ],
                                                   'vars' => '',
                                                   'opcount' => 0,
                                                   'line' => 187,
                                                   'impcount' => 0,
                                                   'changed' => 0
                                                 }, 'Parse::RecDescent::Rule' ),
                              'padding_parameter' => bless( {
                                                              'impcount' => 0,
                                                              'changed' => 0,
                                                              'opcount' => 0,
                                                              'line' => 383,
                                                              'prods' => [
                                                                           bless( {
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'line' => 383,
                                                                                                          'description' => '\'\\\\x88\'',
                                                                                                          'pattern' => '\\x88'
                                                                                                        }, 'Parse::RecDescent::InterpLit' ),
                                                                                                 bless( {
                                                                                                          'lookahead' => 0,
                                                                                                          'matchrule' => 0,
                                                                                                          'argcode' => undef,
                                                                                                          'subrule' => 'short_integer',
                                                                                                          'implicit' => undef,
                                                                                                          'line' => 383
                                                                                                        }, 'Parse::RecDescent::Subrule' ),
                                                                                                 bless( {
                                                                                                          'line' => 384,
                                                                                                          'code' => '{ $return = build_parameter(@item, \'1.1\'); 1; }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'actcount' => 1,
                                                                                    'error' => undef,
                                                                                    'strcount' => 1,
                                                                                    'number' => 0,
                                                                                    'line' => undef,
                                                                                    'uncommit' => undef,
                                                                                    'patcount' => 0,
                                                                                    'dircount' => 0
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ],
                                                              'vars' => '',
                                                              'calls' => [
                                                                           'short_integer'
                                                                         ],
                                                              'name' => 'padding_parameter'
                                                            }, 'Parse::RecDescent::Rule' ),
                              'to_head' => bless( {
                                                    'vars' => '',
                                                    'prods' => [
                                                                 bless( {
                                                                          'dircount' => 0,
                                                                          'patcount' => 0,
                                                                          'uncommit' => undef,
                                                                          'line' => undef,
                                                                          'number' => 0,
                                                                          'strcount' => 1,
                                                                          'error' => undef,
                                                                          'actcount' => 1,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__STRING1__',
                                                                                                'pattern' => '\\x97',
                                                                                                'description' => '\'\\\\x97\'',
                                                                                                'line' => 680
                                                                                              }, 'Parse::RecDescent::InterpLit' ),
                                                                                       bless( {
                                                                                                'subrule' => 'to_value',
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'implicit' => undef,
                                                                                                'line' => 680
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{ $return = [ @item[0,2] ]; 1; }',
                                                                                                'line' => 681,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ]
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'calls' => [
                                                                 'to_value'
                                                               ],
                                                    'name' => 'to_head',
                                                    'impcount' => 0,
                                                    'changed' => 0,
                                                    'opcount' => 0,
                                                    'line' => 680
                                                  }, 'Parse::RecDescent::Rule' ),
                              'RETRIEVED' => bless( {
                                                      'prods' => [
                                                                   bless( {
                                                                            'actcount' => 1,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'line' => 799,
                                                                                                  'description' => '\'\\\\x81\'',
                                                                                                  'pattern' => '\\x81'
                                                                                                }, 'Parse::RecDescent::InterpLit' ),
                                                                                         bless( {
                                                                                                  'line' => 799,
                                                                                                  'code' => '{ $return = $item[0]; 1; }',
                                                                                                  'hashname' => '__ACTION1__',
                                                                                                  'lookahead' => 0
                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                       ],
                                                                            'dircount' => 0,
                                                                            'patcount' => 0,
                                                                            'uncommit' => undef,
                                                                            'line' => undef,
                                                                            'error' => undef,
                                                                            'number' => 0,
                                                                            'strcount' => 1
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'vars' => '',
                                                      'calls' => [],
                                                      'name' => 'RETRIEVED',
                                                      'impcount' => 0,
                                                      'changed' => 0,
                                                      'opcount' => 0,
                                                      'line' => 799
                                                    }, 'Parse::RecDescent::Rule' ),
                              'address_present_token' => bless( {
                                                                  'line' => 740,
                                                                  'opcount' => 0,
                                                                  'changed' => 0,
                                                                  'impcount' => 0,
                                                                  'name' => 'address_present_token',
                                                                  'calls' => [],
                                                                  'vars' => '',
                                                                  'prods' => [
                                                                               bless( {
                                                                                        'actcount' => 1,
                                                                                        'items' => [
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'hashname' => '__STRING1__',
                                                                                                              'line' => 740,
                                                                                                              'description' => '\'\\\\x80\'',
                                                                                                              'pattern' => '\\x80'
                                                                                                            }, 'Parse::RecDescent::InterpLit' ),
                                                                                                     bless( {
                                                                                                              'lookahead' => 0,
                                                                                                              'code' => '{ $return = \'address-present\'; 1; }',
                                                                                                              'hashname' => '__ACTION1__',
                                                                                                              'line' => 740
                                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                                   ],
                                                                                        'number' => 0,
                                                                                        'strcount' => 1,
                                                                                        'error' => undef,
                                                                                        'dircount' => 0,
                                                                                        'uncommit' => undef,
                                                                                        'line' => undef,
                                                                                        'patcount' => 0
                                                                                      }, 'Parse::RecDescent::Production' )
                                                                             ]
                                                                }, 'Parse::RecDescent::Rule' ),
                              'm_retrieve_conf' => bless( {
                                                            'prods' => [
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'hashname' => '__STRING1__',
                                                                                                        'description' => '\'\\\\x84\'',
                                                                                                        'line' => 759,
                                                                                                        'pattern' => '\\x84'
                                                                                                      }, 'Parse::RecDescent::InterpLit' ),
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'code' => '{ $return = $item[0]; }',
                                                                                                        'hashname' => '__ACTION1__',
                                                                                                        'line' => 759
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ],
                                                                                  'actcount' => 1,
                                                                                  'uncommit' => undef,
                                                                                  'line' => undef,
                                                                                  'patcount' => 0,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'strcount' => 1,
                                                                                  'number' => 0
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'vars' => '',
                                                            'calls' => [],
                                                            'name' => 'm_retrieve_conf',
                                                            'impcount' => 0,
                                                            'changed' => 0,
                                                            'opcount' => 0,
                                                            'line' => 759
                                                          }, 'Parse::RecDescent::Rule' )
                            },
                 '_check' => {
                               'thiscolumn' => '',
                               'thisoffset' => '',
                               'prevcolumn' => '',
                               'prevline' => '',
                               'itempos' => '',
                               'prevoffset' => ''
                             },
                 '_AUTOACTION' => undef
               }, 'Parse::RecDescent' );
}
